/* DocumentManager.c generated by valac 0.56.18, the Vala compiler
 * generated from DocumentManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2022 elementary LLC. (https://elementary.io),
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Jeremy Wootten <jeremy@elementaryos.org>
 */

#include "codecore.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SCRATCH_SERVICES_DOCUMENT_MANAGER_0_PROPERTY,
	SCRATCH_SERVICES_DOCUMENT_MANAGER_NUM_PROPERTIES
};
static GParamSpec* scratch_services_document_manager_properties[SCRATCH_SERVICES_DOCUMENT_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer scratch_services_document_manager_parent_class = NULL;
static GeeHashMultiMap* scratch_services_document_manager_project_restorable_docs_map;
static GeeHashMultiMap* scratch_services_document_manager_project_restorable_docs_map = NULL;
static GeeHashMultiMap* scratch_services_document_manager_project_open_docs_map;
static GeeHashMultiMap* scratch_services_document_manager_project_open_docs_map = NULL;
static ScratchServicesDocumentManager* scratch_services_document_manager_instance;
static ScratchServicesDocumentManager* scratch_services_document_manager_instance = NULL;

static void scratch_services_document_manager_finalize (GObject * obj);
static GType scratch_services_document_manager_get_type_once (void);

static gpointer
_g_object_ref0 (gpointer self)
{
#line 31 "../src/Services/DocumentManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 66 "DocumentManager.c"
}

ScratchServicesDocumentManager*
scratch_services_document_manager_get_instance (void)
{
	ScratchServicesDocumentManager* _tmp0_;
	ScratchServicesDocumentManager* _tmp2_;
	ScratchServicesDocumentManager* _tmp3_;
	ScratchServicesDocumentManager* result;
#line 27 "../src/Services/DocumentManager.vala"
	_tmp0_ = scratch_services_document_manager_instance;
#line 27 "../src/Services/DocumentManager.vala"
	if (_tmp0_ == NULL) {
#line 80 "DocumentManager.c"
		ScratchServicesDocumentManager* _tmp1_;
#line 28 "../src/Services/DocumentManager.vala"
		_tmp1_ = scratch_services_document_manager_new ();
#line 28 "../src/Services/DocumentManager.vala"
		_g_object_unref0 (scratch_services_document_manager_instance);
#line 28 "../src/Services/DocumentManager.vala"
		scratch_services_document_manager_instance = _tmp1_;
#line 88 "DocumentManager.c"
	}
#line 31 "../src/Services/DocumentManager.vala"
	_tmp2_ = scratch_services_document_manager_instance;
#line 31 "../src/Services/DocumentManager.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 31 "../src/Services/DocumentManager.vala"
	result = _tmp3_;
#line 31 "../src/Services/DocumentManager.vala"
	return result;
#line 98 "DocumentManager.c"
}

void
scratch_services_document_manager_make_restorable (ScratchServicesDocumentManager* self,
                                                   ScratchServicesDocument* doc)
{
	GeeHashMultiMap* _tmp0_;
	ScratchWidgetsSourceView* _tmp1_;
	ScratchFolderManagerProjectFolderItem* _tmp2_;
	ScratchFolderManagerProjectFolderItem* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
#line 39 "../src/Services/DocumentManager.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Services/DocumentManager.vala"
	g_return_if_fail (doc != NULL);
#line 40 "../src/Services/DocumentManager.vala"
	_tmp0_ = scratch_services_document_manager_project_restorable_docs_map;
#line 40 "../src/Services/DocumentManager.vala"
	_tmp1_ = doc->source_view;
#line 40 "../src/Services/DocumentManager.vala"
	_tmp2_ = scratch_widgets_source_view_get_project (_tmp1_);
#line 40 "../src/Services/DocumentManager.vala"
	_tmp3_ = _tmp2_;
#line 40 "../src/Services/DocumentManager.vala"
	_tmp4_ = scratch_folder_manager_item_get_path ((ScratchFolderManagerItem*) _tmp3_);
#line 40 "../src/Services/DocumentManager.vala"
	_tmp5_ = _tmp4_;
#line 40 "../src/Services/DocumentManager.vala"
	_tmp6_ = _tmp5_;
#line 40 "../src/Services/DocumentManager.vala"
	_tmp7_ = scratch_services_document_get_file (doc);
#line 40 "../src/Services/DocumentManager.vala"
	_tmp8_ = _tmp7_;
#line 40 "../src/Services/DocumentManager.vala"
	_tmp9_ = g_file_get_path (_tmp8_);
#line 40 "../src/Services/DocumentManager.vala"
	_tmp10_ = _tmp9_;
#line 40 "../src/Services/DocumentManager.vala"
	gee_multi_map_set ((GeeMultiMap*) _tmp0_, _tmp6_, _tmp10_);
#line 40 "../src/Services/DocumentManager.vala"
	_g_free0 (_tmp10_);
#line 40 "../src/Services/DocumentManager.vala"
	_g_free0 (_tmp6_);
#line 148 "DocumentManager.c"
}

void
scratch_services_document_manager_add_open_document (ScratchServicesDocumentManager* self,
                                                     ScratchServicesDocument* doc)
{
	ScratchWidgetsSourceView* _tmp0_;
	ScratchFolderManagerProjectFolderItem* _tmp1_;
	ScratchFolderManagerProjectFolderItem* _tmp2_;
	GeeHashMultiMap* _tmp3_;
	ScratchWidgetsSourceView* _tmp4_;
	ScratchFolderManagerProjectFolderItem* _tmp5_;
	ScratchFolderManagerProjectFolderItem* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
#line 43 "../src/Services/DocumentManager.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/Services/DocumentManager.vala"
	g_return_if_fail (doc != NULL);
#line 44 "../src/Services/DocumentManager.vala"
	_tmp0_ = doc->source_view;
#line 44 "../src/Services/DocumentManager.vala"
	_tmp1_ = scratch_widgets_source_view_get_project (_tmp0_);
#line 44 "../src/Services/DocumentManager.vala"
	_tmp2_ = _tmp1_;
#line 44 "../src/Services/DocumentManager.vala"
	if (_tmp2_ == NULL) {
#line 45 "../src/Services/DocumentManager.vala"
		return;
#line 183 "DocumentManager.c"
	}
#line 48 "../src/Services/DocumentManager.vala"
	_tmp3_ = scratch_services_document_manager_project_open_docs_map;
#line 48 "../src/Services/DocumentManager.vala"
	_tmp4_ = doc->source_view;
#line 48 "../src/Services/DocumentManager.vala"
	_tmp5_ = scratch_widgets_source_view_get_project (_tmp4_);
#line 48 "../src/Services/DocumentManager.vala"
	_tmp6_ = _tmp5_;
#line 48 "../src/Services/DocumentManager.vala"
	_tmp7_ = scratch_folder_manager_item_get_path ((ScratchFolderManagerItem*) _tmp6_);
#line 48 "../src/Services/DocumentManager.vala"
	_tmp8_ = _tmp7_;
#line 48 "../src/Services/DocumentManager.vala"
	_tmp9_ = _tmp8_;
#line 48 "../src/Services/DocumentManager.vala"
	_tmp10_ = scratch_services_document_get_file (doc);
#line 48 "../src/Services/DocumentManager.vala"
	_tmp11_ = _tmp10_;
#line 48 "../src/Services/DocumentManager.vala"
	_tmp12_ = g_file_get_path (_tmp11_);
#line 48 "../src/Services/DocumentManager.vala"
	_tmp13_ = _tmp12_;
#line 48 "../src/Services/DocumentManager.vala"
	gee_multi_map_set ((GeeMultiMap*) _tmp3_, _tmp9_, _tmp13_);
#line 48 "../src/Services/DocumentManager.vala"
	_g_free0 (_tmp13_);
#line 48 "../src/Services/DocumentManager.vala"
	_g_free0 (_tmp9_);
#line 213 "DocumentManager.c"
}

void
scratch_services_document_manager_remove_open_document (ScratchServicesDocumentManager* self,
                                                        ScratchServicesDocument* doc)
{
	ScratchWidgetsSourceView* _tmp0_;
	ScratchFolderManagerProjectFolderItem* _tmp1_;
	ScratchFolderManagerProjectFolderItem* _tmp2_;
	GeeHashMultiMap* _tmp3_;
	ScratchWidgetsSourceView* _tmp4_;
	ScratchFolderManagerProjectFolderItem* _tmp5_;
	ScratchFolderManagerProjectFolderItem* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
#line 51 "../src/Services/DocumentManager.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/Services/DocumentManager.vala"
	g_return_if_fail (doc != NULL);
#line 52 "../src/Services/DocumentManager.vala"
	_tmp0_ = doc->source_view;
#line 52 "../src/Services/DocumentManager.vala"
	_tmp1_ = scratch_widgets_source_view_get_project (_tmp0_);
#line 52 "../src/Services/DocumentManager.vala"
	_tmp2_ = _tmp1_;
#line 52 "../src/Services/DocumentManager.vala"
	if (_tmp2_ == NULL) {
#line 53 "../src/Services/DocumentManager.vala"
		return;
#line 248 "DocumentManager.c"
	}
#line 56 "../src/Services/DocumentManager.vala"
	_tmp3_ = scratch_services_document_manager_project_open_docs_map;
#line 56 "../src/Services/DocumentManager.vala"
	_tmp4_ = doc->source_view;
#line 56 "../src/Services/DocumentManager.vala"
	_tmp5_ = scratch_widgets_source_view_get_project (_tmp4_);
#line 56 "../src/Services/DocumentManager.vala"
	_tmp6_ = _tmp5_;
#line 56 "../src/Services/DocumentManager.vala"
	_tmp7_ = scratch_folder_manager_item_get_path ((ScratchFolderManagerItem*) _tmp6_);
#line 56 "../src/Services/DocumentManager.vala"
	_tmp8_ = _tmp7_;
#line 56 "../src/Services/DocumentManager.vala"
	_tmp9_ = _tmp8_;
#line 56 "../src/Services/DocumentManager.vala"
	_tmp10_ = scratch_services_document_get_file (doc);
#line 56 "../src/Services/DocumentManager.vala"
	_tmp11_ = _tmp10_;
#line 56 "../src/Services/DocumentManager.vala"
	_tmp12_ = g_file_get_path (_tmp11_);
#line 56 "../src/Services/DocumentManager.vala"
	_tmp13_ = _tmp12_;
#line 56 "../src/Services/DocumentManager.vala"
	gee_multi_map_remove ((GeeMultiMap*) _tmp3_, _tmp9_, _tmp13_);
#line 56 "../src/Services/DocumentManager.vala"
	_g_free0 (_tmp13_);
#line 56 "../src/Services/DocumentManager.vala"
	_g_free0 (_tmp9_);
#line 278 "DocumentManager.c"
}

void
scratch_services_document_manager_remove_project (ScratchServicesDocumentManager* self,
                                                  const gchar* project_path)
{
	GeeHashMultiMap* _tmp0_;
#line 59 "../src/Services/DocumentManager.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/Services/DocumentManager.vala"
	g_return_if_fail (project_path != NULL);
#line 60 "../src/Services/DocumentManager.vala"
	_tmp0_ = scratch_services_document_manager_project_restorable_docs_map;
#line 60 "../src/Services/DocumentManager.vala"
	gee_multi_map_remove_all ((GeeMultiMap*) _tmp0_, project_path);
#line 294 "DocumentManager.c"
}

GeeCollection*
scratch_services_document_manager_take_restorable_paths (ScratchServicesDocumentManager* self,
                                                         const gchar* project_path)
{
	GeeCollection* docs = NULL;
	GeeHashMultiMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeHashMultiMap* _tmp2_;
	GeeCollection* result;
#line 63 "../src/Services/DocumentManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 63 "../src/Services/DocumentManager.vala"
	g_return_val_if_fail (project_path != NULL, NULL);
#line 64 "../src/Services/DocumentManager.vala"
	_tmp0_ = scratch_services_document_manager_project_restorable_docs_map;
#line 64 "../src/Services/DocumentManager.vala"
	_tmp1_ = gee_multi_map_get ((GeeMultiMap*) _tmp0_, project_path);
#line 64 "../src/Services/DocumentManager.vala"
	docs = _tmp1_;
#line 65 "../src/Services/DocumentManager.vala"
	_tmp2_ = scratch_services_document_manager_project_restorable_docs_map;
#line 65 "../src/Services/DocumentManager.vala"
	gee_multi_map_remove_all ((GeeMultiMap*) _tmp2_, project_path);
#line 66 "../src/Services/DocumentManager.vala"
	result = docs;
#line 66 "../src/Services/DocumentManager.vala"
	return result;
#line 324 "DocumentManager.c"
}

guint
scratch_services_document_manager_restorable_for_project (ScratchServicesDocumentManager* self,
                                                          const gchar* project_path)
{
	GeeHashMultiMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	guint _tmp5_;
	guint result;
#line 69 "../src/Services/DocumentManager.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 69 "../src/Services/DocumentManager.vala"
	g_return_val_if_fail (project_path != NULL, 0U);
#line 70 "../src/Services/DocumentManager.vala"
	_tmp0_ = scratch_services_document_manager_project_restorable_docs_map;
#line 70 "../src/Services/DocumentManager.vala"
	_tmp1_ = gee_multi_map_get ((GeeMultiMap*) _tmp0_, project_path);
#line 70 "../src/Services/DocumentManager.vala"
	_tmp2_ = _tmp1_;
#line 70 "../src/Services/DocumentManager.vala"
	_tmp3_ = gee_collection_get_size (_tmp2_);
#line 70 "../src/Services/DocumentManager.vala"
	_tmp4_ = _tmp3_;
#line 70 "../src/Services/DocumentManager.vala"
	_tmp5_ = (guint) _tmp4_;
#line 70 "../src/Services/DocumentManager.vala"
	_g_object_unref0 (_tmp2_);
#line 70 "../src/Services/DocumentManager.vala"
	result = _tmp5_;
#line 70 "../src/Services/DocumentManager.vala"
	return result;
#line 360 "DocumentManager.c"
}

guint
scratch_services_document_manager_open_for_project (ScratchServicesDocumentManager* self,
                                                    const gchar* project_path)
{
	GeeHashMultiMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	guint _tmp5_;
	guint result;
#line 73 "../src/Services/DocumentManager.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 73 "../src/Services/DocumentManager.vala"
	g_return_val_if_fail (project_path != NULL, 0U);
#line 74 "../src/Services/DocumentManager.vala"
	_tmp0_ = scratch_services_document_manager_project_open_docs_map;
#line 74 "../src/Services/DocumentManager.vala"
	_tmp1_ = gee_multi_map_get ((GeeMultiMap*) _tmp0_, project_path);
#line 74 "../src/Services/DocumentManager.vala"
	_tmp2_ = _tmp1_;
#line 74 "../src/Services/DocumentManager.vala"
	_tmp3_ = gee_collection_get_size (_tmp2_);
#line 74 "../src/Services/DocumentManager.vala"
	_tmp4_ = _tmp3_;
#line 74 "../src/Services/DocumentManager.vala"
	_tmp5_ = (guint) _tmp4_;
#line 74 "../src/Services/DocumentManager.vala"
	_g_object_unref0 (_tmp2_);
#line 74 "../src/Services/DocumentManager.vala"
	result = _tmp5_;
#line 74 "../src/Services/DocumentManager.vala"
	return result;
#line 396 "DocumentManager.c"
}

ScratchServicesDocumentManager*
scratch_services_document_manager_construct (GType object_type)
{
	ScratchServicesDocumentManager * self = NULL;
#line 21 "../src/Services/DocumentManager.vala"
	self = (ScratchServicesDocumentManager*) g_object_new (object_type, NULL);
#line 21 "../src/Services/DocumentManager.vala"
	return self;
#line 407 "DocumentManager.c"
}

ScratchServicesDocumentManager*
scratch_services_document_manager_new (void)
{
#line 21 "../src/Services/DocumentManager.vala"
	return scratch_services_document_manager_construct (SCRATCH_SERVICES_TYPE_DOCUMENT_MANAGER);
#line 415 "DocumentManager.c"
}

static void
scratch_services_document_manager_class_init (ScratchServicesDocumentManagerClass * klass,
                                              gpointer klass_data)
{
	GeeHashMultiMap* _tmp0_;
	GeeHashMultiMap* _tmp1_;
#line 21 "../src/Services/DocumentManager.vala"
	scratch_services_document_manager_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Services/DocumentManager.vala"
	G_OBJECT_CLASS (klass)->finalize = scratch_services_document_manager_finalize;
#line 35 "../src/Services/DocumentManager.vala"
	_tmp0_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 35 "../src/Services/DocumentManager.vala"
	_g_object_unref0 (scratch_services_document_manager_project_restorable_docs_map);
#line 35 "../src/Services/DocumentManager.vala"
	scratch_services_document_manager_project_restorable_docs_map = _tmp0_;
#line 36 "../src/Services/DocumentManager.vala"
	_tmp1_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 36 "../src/Services/DocumentManager.vala"
	_g_object_unref0 (scratch_services_document_manager_project_open_docs_map);
#line 36 "../src/Services/DocumentManager.vala"
	scratch_services_document_manager_project_open_docs_map = _tmp1_;
#line 440 "DocumentManager.c"
}

static void
scratch_services_document_manager_instance_init (ScratchServicesDocumentManager * self,
                                                 gpointer klass)
{
}

static void
scratch_services_document_manager_finalize (GObject * obj)
{
	ScratchServicesDocumentManager * self;
#line 21 "../src/Services/DocumentManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_SERVICES_TYPE_DOCUMENT_MANAGER, ScratchServicesDocumentManager);
#line 21 "../src/Services/DocumentManager.vala"
	G_OBJECT_CLASS (scratch_services_document_manager_parent_class)->finalize (obj);
#line 457 "DocumentManager.c"
}

static GType
scratch_services_document_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScratchServicesDocumentManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scratch_services_document_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScratchServicesDocumentManager), 0, (GInstanceInitFunc) scratch_services_document_manager_instance_init, NULL };
	GType scratch_services_document_manager_type_id;
	scratch_services_document_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "ScratchServicesDocumentManager", &g_define_type_info, 0);
	return scratch_services_document_manager_type_id;
}

GType
scratch_services_document_manager_get_type (void)
{
	static volatile gsize scratch_services_document_manager_type_id__once = 0;
	if (g_once_init_enter (&scratch_services_document_manager_type_id__once)) {
		GType scratch_services_document_manager_type_id;
		scratch_services_document_manager_type_id = scratch_services_document_manager_get_type_once ();
		g_once_init_leave (&scratch_services_document_manager_type_id__once, scratch_services_document_manager_type_id);
	}
	return scratch_services_document_manager_type_id__once;
}

