/* Utils.c generated by valac 0.56.18, the Vala compiler
 * generated from Utils.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*
* Copyright (c) 2013 Mario Guerriero <mefrio.g@gmail.com>
*               2017 elementary LLC. <https://elementary.io>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "codecore.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <gee.h>
#include <glib-object.h>
#include <granite.h>
#include <gtk/gtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

gchar* scratch_utils_last_path = NULL;

static GVariant* _variant_new10 (gchar* value);
static GVariant* _variant_new11 (const gchar* value);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static GVariant* _variant_new12 (gchar* value);
static GVariant* _variant_new13 (const gchar* value);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../src/Utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 73 "Utils.c"
}

GSimpleAction*
scratch_utils_action_from_group (const gchar* action_name,
                                 GSimpleActionGroup* action_group)
{
	GAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* result;
#line 25 "../src/Utils.vala"
	g_return_val_if_fail (action_name != NULL, NULL);
#line 25 "../src/Utils.vala"
	g_return_val_if_fail (action_group != NULL, NULL);
#line 26 "../src/Utils.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) action_group, action_name);
#line 26 "../src/Utils.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction));
#line 26 "../src/Utils.vala"
	result = _tmp1_;
#line 26 "../src/Utils.vala"
	return result;
#line 95 "Utils.c"
}

gchar*
scratch_utils_pango_font_description_to_css (PangoFontDescription* font_descr)
{
	GString* sb = NULL;
	GString* _tmp0_;
	PangoFontMask mask = 0U;
	GString* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* result;
#line 32 "../src/Utils.vala"
	g_return_val_if_fail (font_descr != NULL, NULL);
#line 33 "../src/Utils.vala"
	_tmp0_ = g_string_new ("");
#line 33 "../src/Utils.vala"
	sb = _tmp0_;
#line 34 "../src/Utils.vala"
	mask = pango_font_description_get_set_fields (font_descr);
#line 35 "../src/Utils.vala"
	if ((mask & PANGO_FONT_MASK_FAMILY) == PANGO_FONT_MASK_FAMILY) {
#line 118 "Utils.c"
		const gchar* family = NULL;
		const gchar* _tmp1_;
		GString* _tmp2_;
		const gchar* _tmp3_;
#line 36 "../src/Utils.vala"
		_tmp1_ = pango_font_description_get_family (font_descr);
#line 36 "../src/Utils.vala"
		family = _tmp1_;
#line 37 "../src/Utils.vala"
		_tmp2_ = sb;
#line 37 "../src/Utils.vala"
		_tmp3_ = family;
#line 37 "../src/Utils.vala"
		g_string_append_printf (_tmp2_, "font-family: \"%s\";", _tmp3_);
#line 133 "Utils.c"
	}
#line 40 "../src/Utils.vala"
	if ((mask & PANGO_FONT_MASK_STYLE) == PANGO_FONT_MASK_STYLE) {
#line 137 "Utils.c"
		PangoStyle style = 0;
#line 41 "../src/Utils.vala"
		style = pango_font_description_get_style (font_descr);
#line 43 "../src/Utils.vala"
		switch (style) {
#line 43 "../src/Utils.vala"
			case PANGO_STYLE_NORMAL:
#line 145 "Utils.c"
			{
				GString* _tmp4_;
#line 45 "../src/Utils.vala"
				_tmp4_ = sb;
#line 45 "../src/Utils.vala"
				g_string_append (_tmp4_, "font-style: normal;");
#line 46 "../src/Utils.vala"
				break;
#line 154 "Utils.c"
			}
#line 43 "../src/Utils.vala"
			case PANGO_STYLE_ITALIC:
#line 158 "Utils.c"
			{
				GString* _tmp5_;
#line 49 "../src/Utils.vala"
				_tmp5_ = sb;
#line 49 "../src/Utils.vala"
				g_string_append (_tmp5_, "font-style: italic;");
#line 50 "../src/Utils.vala"
				break;
#line 167 "Utils.c"
			}
#line 43 "../src/Utils.vala"
			case PANGO_STYLE_OBLIQUE:
#line 171 "Utils.c"
			{
				GString* _tmp6_;
#line 53 "../src/Utils.vala"
				_tmp6_ = sb;
#line 53 "../src/Utils.vala"
				g_string_append (_tmp6_, "font-style: bold;");
#line 54 "../src/Utils.vala"
				break;
#line 180 "Utils.c"
			}
			default:
			{
#line 57 "../src/Utils.vala"
				break;
#line 186 "Utils.c"
			}
		}
	}
#line 61 "../src/Utils.vala"
	if ((mask & PANGO_FONT_MASK_VARIANT) == PANGO_FONT_MASK_VARIANT) {
#line 192 "Utils.c"
		PangoVariant variant = 0;
#line 62 "../src/Utils.vala"
		variant = pango_font_description_get_variant (font_descr);
#line 63 "../src/Utils.vala"
		switch (variant) {
#line 63 "../src/Utils.vala"
			case PANGO_VARIANT_NORMAL:
#line 200 "Utils.c"
			{
				GString* _tmp7_;
#line 65 "../src/Utils.vala"
				_tmp7_ = sb;
#line 65 "../src/Utils.vala"
				g_string_append (_tmp7_, "font-variant: normal;");
#line 66 "../src/Utils.vala"
				break;
#line 209 "Utils.c"
			}
#line 63 "../src/Utils.vala"
			case PANGO_VARIANT_SMALL_CAPS:
#line 213 "Utils.c"
			{
				GString* _tmp8_;
#line 69 "../src/Utils.vala"
				_tmp8_ = sb;
#line 69 "../src/Utils.vala"
				g_string_append (_tmp8_, "font-variant: small-caps");
#line 70 "../src/Utils.vala"
				break;
#line 222 "Utils.c"
			}
			default:
			{
#line 73 "../src/Utils.vala"
				break;
#line 228 "Utils.c"
			}
		}
	}
#line 77 "../src/Utils.vala"
	if ((mask & PANGO_FONT_MASK_WEIGHT) == PANGO_FONT_MASK_WEIGHT) {
#line 234 "Utils.c"
		gint weight = 0;
		GString* _tmp9_;
#line 78 "../src/Utils.vala"
		weight = CLAMP ((gint) ((pango_font_description_get_weight (font_descr) / 100) * 100), 100, 900);
#line 80 "../src/Utils.vala"
		_tmp9_ = sb;
#line 80 "../src/Utils.vala"
		g_string_append_printf (_tmp9_, "font-weight: %i;", weight);
#line 243 "Utils.c"
	}
#line 83 "../src/Utils.vala"
	if ((mask & PANGO_FONT_MASK_STRETCH) == PANGO_FONT_MASK_STRETCH) {
#line 247 "Utils.c"
		PangoStretch stretch = 0;
#line 84 "../src/Utils.vala"
		stretch = pango_font_description_get_stretch (font_descr);
#line 86 "../src/Utils.vala"
		switch (stretch) {
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_NORMAL:
#line 255 "Utils.c"
			{
				GString* _tmp10_;
#line 88 "../src/Utils.vala"
				_tmp10_ = sb;
#line 88 "../src/Utils.vala"
				g_string_append_printf (_tmp10_, "font-stretch: %s;", "normal");
#line 89 "../src/Utils.vala"
				break;
#line 264 "Utils.c"
			}
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_ULTRA_CONDENSED:
#line 268 "Utils.c"
			{
				GString* _tmp11_;
#line 92 "../src/Utils.vala"
				_tmp11_ = sb;
#line 92 "../src/Utils.vala"
				g_string_append_printf (_tmp11_, "font-stretch: %s;", "condensed");
#line 93 "../src/Utils.vala"
				break;
#line 277 "Utils.c"
			}
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_EXTRA_CONDENSED:
#line 281 "Utils.c"
			{
				GString* _tmp12_;
#line 96 "../src/Utils.vala"
				_tmp12_ = sb;
#line 96 "../src/Utils.vala"
				g_string_append_printf (_tmp12_, "font-stretch: %s;", "extra-condensed");
#line 97 "../src/Utils.vala"
				break;
#line 290 "Utils.c"
			}
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_CONDENSED:
#line 294 "Utils.c"
			{
				GString* _tmp13_;
#line 100 "../src/Utils.vala"
				_tmp13_ = sb;
#line 100 "../src/Utils.vala"
				g_string_append_printf (_tmp13_, "font-stretch: %s;", "condensed");
#line 101 "../src/Utils.vala"
				break;
#line 303 "Utils.c"
			}
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_SEMI_CONDENSED:
#line 307 "Utils.c"
			{
				GString* _tmp14_;
#line 104 "../src/Utils.vala"
				_tmp14_ = sb;
#line 104 "../src/Utils.vala"
				g_string_append_printf (_tmp14_, "font-stretch: %s;", "normal");
#line 105 "../src/Utils.vala"
				break;
#line 316 "Utils.c"
			}
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_SEMI_EXPANDED:
#line 320 "Utils.c"
			{
				GString* _tmp15_;
#line 108 "../src/Utils.vala"
				_tmp15_ = sb;
#line 108 "../src/Utils.vala"
				g_string_append_printf (_tmp15_, "font-stretch: %s;", "semi-expanded");
#line 109 "../src/Utils.vala"
				break;
#line 329 "Utils.c"
			}
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_EXPANDED:
#line 333 "Utils.c"
			{
				GString* _tmp16_;
#line 112 "../src/Utils.vala"
				_tmp16_ = sb;
#line 112 "../src/Utils.vala"
				g_string_append_printf (_tmp16_, "font-stretch: %s;", "expanded");
#line 113 "../src/Utils.vala"
				break;
#line 342 "Utils.c"
			}
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_EXTRA_EXPANDED:
#line 346 "Utils.c"
			{
				GString* _tmp17_;
#line 116 "../src/Utils.vala"
				_tmp17_ = sb;
#line 116 "../src/Utils.vala"
				g_string_append_printf (_tmp17_, "font-stretch: %s;", "extra-expanded");
#line 117 "../src/Utils.vala"
				break;
#line 355 "Utils.c"
			}
#line 86 "../src/Utils.vala"
			case PANGO_STRETCH_ULTRA_EXPANDED:
#line 359 "Utils.c"
			{
				GString* _tmp18_;
#line 120 "../src/Utils.vala"
				_tmp18_ = sb;
#line 120 "../src/Utils.vala"
				g_string_append_printf (_tmp18_, "font-stretch: %s;", "ultra-expanded");
#line 121 "../src/Utils.vala"
				break;
#line 368 "Utils.c"
			}
			default:
			{
#line 124 "../src/Utils.vala"
				break;
#line 374 "Utils.c"
			}
		}
	}
#line 129 "../src/Utils.vala"
	if ((mask & PANGO_FONT_MASK_SIZE) == PANGO_FONT_MASK_SIZE) {
#line 380 "Utils.c"
		gint font_size = 0;
		GString* _tmp19_;
#line 130 "../src/Utils.vala"
		font_size = pango_font_description_get_size (font_descr) / PANGO_SCALE;
#line 131 "../src/Utils.vala"
		_tmp19_ = sb;
#line 131 "../src/Utils.vala"
		g_string_append_printf (_tmp19_, "font-size: %dpt;", font_size);
#line 389 "Utils.c"
	}
#line 134 "../src/Utils.vala"
	_tmp20_ = sb;
#line 134 "../src/Utils.vala"
	_tmp21_ = _tmp20_->str;
#line 134 "../src/Utils.vala"
	_tmp22_ = g_strdup (_tmp21_);
#line 134 "../src/Utils.vala"
	result = _tmp22_;
#line 134 "../src/Utils.vala"
	_g_string_free0 (sb);
#line 134 "../src/Utils.vala"
	return result;
#line 403 "Utils.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 426 "Utils.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 435 "Utils.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 454 "Utils.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 458 "Utils.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 464 "Utils.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 474 "Utils.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 482 "Utils.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 486 "Utils.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 492 "Utils.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 502 "Utils.c"
}

gchar*
scratch_utils_replace_home_with_tilde (const gchar* path)
{
	gchar* home_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* result;
#line 137 "../src/Utils.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 138 "../src/Utils.vala"
	_tmp0_ = g_get_home_dir ();
#line 138 "../src/Utils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 138 "../src/Utils.vala"
	home_dir = _tmp1_;
#line 139 "../src/Utils.vala"
	_tmp2_ = home_dir;
#line 139 "../src/Utils.vala"
	if (g_str_has_prefix (path, _tmp2_)) {
#line 525 "Utils.c"
		const gchar* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 140 "../src/Utils.vala"
		_tmp3_ = home_dir;
#line 140 "../src/Utils.vala"
		_tmp4_ = strlen (_tmp3_);
#line 140 "../src/Utils.vala"
		_tmp5_ = _tmp4_;
#line 140 "../src/Utils.vala"
		_tmp6_ = string_substring (path, (glong) _tmp5_, (glong) -1);
#line 140 "../src/Utils.vala"
		_tmp7_ = _tmp6_;
#line 140 "../src/Utils.vala"
		_tmp8_ = g_strconcat ("~", _tmp7_, NULL);
#line 140 "../src/Utils.vala"
		_tmp9_ = _tmp8_;
#line 140 "../src/Utils.vala"
		_g_free0 (_tmp7_);
#line 140 "../src/Utils.vala"
		result = _tmp9_;
#line 140 "../src/Utils.vala"
		_g_free0 (home_dir);
#line 140 "../src/Utils.vala"
		return result;
#line 555 "Utils.c"
	} else {
		gchar* _tmp10_;
#line 142 "../src/Utils.vala"
		_tmp10_ = g_strdup (path);
#line 142 "../src/Utils.vala"
		result = _tmp10_;
#line 142 "../src/Utils.vala"
		_g_free0 (home_dir);
#line 142 "../src/Utils.vala"
		return result;
#line 566 "Utils.c"
	}
}

gboolean
scratch_utils_find_unique_path (GFile* f1,
                                GFile* f2,
                                gchar** path1,
                                gchar** path2)
{
	gchar* _vala_path1 = NULL;
	gchar* _vala_path2 = NULL;
	gboolean _tmp0_ = FALSE;
	GFile* f1_parent = NULL;
	GFile* _tmp3_;
	GFile* f2_parent = NULL;
	GFile* _tmp4_;
	GFile* _tmp22_;
	gchar* _tmp23_;
	GFile* _tmp24_;
	gchar* _tmp25_;
	gboolean result;
#line 146 "../src/Utils.vala"
	g_return_val_if_fail (f1 != NULL, FALSE);
#line 146 "../src/Utils.vala"
	g_return_val_if_fail (f2 != NULL, FALSE);
#line 147 "../src/Utils.vala"
	if (g_file_equal (f1, f2)) {
#line 148 "../src/Utils.vala"
		_g_free0 (_vala_path1);
#line 148 "../src/Utils.vala"
		_vala_path1 = NULL;
#line 149 "../src/Utils.vala"
		_g_free0 (_vala_path2);
#line 149 "../src/Utils.vala"
		_vala_path2 = NULL;
#line 150 "../src/Utils.vala"
		result = FALSE;
#line 150 "../src/Utils.vala"
		if (path1) {
#line 150 "../src/Utils.vala"
			*path1 = _vala_path1;
#line 608 "Utils.c"
		} else {
#line 150 "../src/Utils.vala"
			_g_free0 (_vala_path1);
#line 612 "Utils.c"
		}
#line 150 "../src/Utils.vala"
		if (path2) {
#line 150 "../src/Utils.vala"
			*path2 = _vala_path2;
#line 618 "Utils.c"
		} else {
#line 150 "../src/Utils.vala"
			_g_free0 (_vala_path2);
#line 622 "Utils.c"
		}
#line 150 "../src/Utils.vala"
		return result;
#line 626 "Utils.c"
	}
#line 153 "../src/Utils.vala"
	if (!g_file_has_parent (f1, NULL)) {
#line 153 "../src/Utils.vala"
		_tmp0_ = TRUE;
#line 632 "Utils.c"
	} else {
#line 153 "../src/Utils.vala"
		_tmp0_ = !g_file_has_parent (f2, NULL);
#line 636 "Utils.c"
	}
#line 153 "../src/Utils.vala"
	if (_tmp0_) {
#line 640 "Utils.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 154 "../src/Utils.vala"
		_tmp1_ = g_file_get_basename (f1);
#line 154 "../src/Utils.vala"
		_g_free0 (_vala_path1);
#line 154 "../src/Utils.vala"
		_vala_path1 = _tmp1_;
#line 155 "../src/Utils.vala"
		_tmp2_ = g_file_get_basename (f2);
#line 155 "../src/Utils.vala"
		_g_free0 (_vala_path2);
#line 155 "../src/Utils.vala"
		_vala_path2 = _tmp2_;
#line 156 "../src/Utils.vala"
		result = TRUE;
#line 156 "../src/Utils.vala"
		if (path1) {
#line 156 "../src/Utils.vala"
			*path1 = _vala_path1;
#line 661 "Utils.c"
		} else {
#line 156 "../src/Utils.vala"
			_g_free0 (_vala_path1);
#line 665 "Utils.c"
		}
#line 156 "../src/Utils.vala"
		if (path2) {
#line 156 "../src/Utils.vala"
			*path2 = _vala_path2;
#line 671 "Utils.c"
		} else {
#line 156 "../src/Utils.vala"
			_g_free0 (_vala_path2);
#line 675 "Utils.c"
		}
#line 156 "../src/Utils.vala"
		return result;
#line 679 "Utils.c"
	}
#line 159 "../src/Utils.vala"
	_tmp3_ = g_file_get_parent (f1);
#line 159 "../src/Utils.vala"
	f1_parent = _tmp3_;
#line 160 "../src/Utils.vala"
	_tmp4_ = g_file_get_parent (f2);
#line 160 "../src/Utils.vala"
	f2_parent = _tmp4_;
#line 162 "../src/Utils.vala"
	while (TRUE) {
#line 691 "Utils.c"
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gboolean _tmp11_;
		GFile* _tmp12_;
		GFile* _tmp15_;
		GFile* _tmp18_;
		GFile* _tmp19_;
		GFile* _tmp20_;
		GFile* _tmp21_;
#line 162 "../src/Utils.vala"
		_tmp5_ = f1_parent;
#line 162 "../src/Utils.vala"
		_tmp6_ = g_file_get_relative_path (_tmp5_, f1);
#line 162 "../src/Utils.vala"
		_tmp7_ = _tmp6_;
#line 162 "../src/Utils.vala"
		_tmp8_ = f2_parent;
#line 162 "../src/Utils.vala"
		_tmp9_ = g_file_get_relative_path (_tmp8_, f2);
#line 162 "../src/Utils.vala"
		_tmp10_ = _tmp9_;
#line 162 "../src/Utils.vala"
		_tmp11_ = !(g_strcmp0 (_tmp7_, _tmp10_) == 0);
#line 162 "../src/Utils.vala"
		_g_free0 (_tmp10_);
#line 162 "../src/Utils.vala"
		_g_free0 (_tmp7_);
#line 162 "../src/Utils.vala"
		if (_tmp11_) {
#line 162 "../src/Utils.vala"
			break;
#line 727 "Utils.c"
		}
#line 166 "../src/Utils.vala"
		_tmp12_ = f1_parent;
#line 166 "../src/Utils.vala"
		if (!g_file_has_parent (_tmp12_, NULL)) {
#line 733 "Utils.c"
			GFile* _tmp13_;
			GFile* _tmp14_;
#line 167 "../src/Utils.vala"
			_tmp13_ = f2_parent;
#line 167 "../src/Utils.vala"
			_tmp14_ = g_file_get_parent (_tmp13_);
#line 167 "../src/Utils.vala"
			_g_object_unref0 (f2_parent);
#line 167 "../src/Utils.vala"
			f2_parent = _tmp14_;
#line 168 "../src/Utils.vala"
			break;
#line 746 "Utils.c"
		}
#line 170 "../src/Utils.vala"
		_tmp15_ = f2_parent;
#line 170 "../src/Utils.vala"
		if (!g_file_has_parent (_tmp15_, NULL)) {
#line 752 "Utils.c"
			GFile* _tmp16_;
			GFile* _tmp17_;
#line 171 "../src/Utils.vala"
			_tmp16_ = f1_parent;
#line 171 "../src/Utils.vala"
			_tmp17_ = g_file_get_parent (_tmp16_);
#line 171 "../src/Utils.vala"
			_g_object_unref0 (f1_parent);
#line 171 "../src/Utils.vala"
			f1_parent = _tmp17_;
#line 172 "../src/Utils.vala"
			break;
#line 765 "Utils.c"
		}
#line 174 "../src/Utils.vala"
		_tmp18_ = f1_parent;
#line 174 "../src/Utils.vala"
		_tmp19_ = g_file_get_parent (_tmp18_);
#line 174 "../src/Utils.vala"
		_g_object_unref0 (f1_parent);
#line 174 "../src/Utils.vala"
		f1_parent = _tmp19_;
#line 175 "../src/Utils.vala"
		_tmp20_ = f2_parent;
#line 175 "../src/Utils.vala"
		_tmp21_ = g_file_get_parent (_tmp20_);
#line 175 "../src/Utils.vala"
		_g_object_unref0 (f2_parent);
#line 175 "../src/Utils.vala"
		f2_parent = _tmp21_;
#line 783 "Utils.c"
	}
#line 178 "../src/Utils.vala"
	_tmp22_ = f1_parent;
#line 178 "../src/Utils.vala"
	_tmp23_ = g_file_get_relative_path (_tmp22_, f1);
#line 178 "../src/Utils.vala"
	_g_free0 (_vala_path1);
#line 178 "../src/Utils.vala"
	_vala_path1 = _tmp23_;
#line 179 "../src/Utils.vala"
	_tmp24_ = f2_parent;
#line 179 "../src/Utils.vala"
	_tmp25_ = g_file_get_relative_path (_tmp24_, f2);
#line 179 "../src/Utils.vala"
	_g_free0 (_vala_path2);
#line 179 "../src/Utils.vala"
	_vala_path2 = _tmp25_;
#line 180 "../src/Utils.vala"
	result = TRUE;
#line 180 "../src/Utils.vala"
	_g_object_unref0 (f2_parent);
#line 180 "../src/Utils.vala"
	_g_object_unref0 (f1_parent);
#line 180 "../src/Utils.vala"
	if (path1) {
#line 180 "../src/Utils.vala"
		*path1 = _vala_path1;
#line 811 "Utils.c"
	} else {
#line 180 "../src/Utils.vala"
		_g_free0 (_vala_path1);
#line 815 "Utils.c"
	}
#line 180 "../src/Utils.vala"
	if (path2) {
#line 180 "../src/Utils.vala"
		*path2 = _vala_path2;
#line 821 "Utils.c"
	} else {
#line 180 "../src/Utils.vala"
		_g_free0 (_vala_path2);
#line 825 "Utils.c"
	}
#line 180 "../src/Utils.vala"
	return result;
#line 829 "Utils.c"
}

gboolean
scratch_utils_check_if_valid_text_file (const gchar* path,
                                        GFileInfo* info)
{
	gchar* content_type = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean result;
#line 183 "../src/Utils.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 183 "../src/Utils.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 184 "../src/Utils.vala"
	if (g_str_has_prefix (path, ".goutputstream")) {
#line 185 "../src/Utils.vala"
		result = FALSE;
#line 185 "../src/Utils.vala"
		return result;
#line 852 "Utils.c"
	}
#line 188 "../src/Utils.vala"
	if (g_file_info_get_is_backup (info)) {
#line 189 "../src/Utils.vala"
		result = FALSE;
#line 189 "../src/Utils.vala"
		return result;
#line 860 "Utils.c"
	}
#line 192 "../src/Utils.vala"
	_tmp0_ = g_file_info_get_content_type (info);
#line 192 "../src/Utils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 192 "../src/Utils.vala"
	content_type = _tmp1_;
#line 193 "../src/Utils.vala"
	if (g_file_info_get_file_type (info) == G_FILE_TYPE_REGULAR) {
#line 870 "Utils.c"
		const gchar* _tmp4_;
#line 194 "../src/Utils.vala"
		_tmp4_ = content_type;
#line 194 "../src/Utils.vala"
		_tmp3_ = g_content_type_is_a (_tmp4_, "text/*");
#line 876 "Utils.c"
	} else {
#line 193 "../src/Utils.vala"
		_tmp3_ = FALSE;
#line 880 "Utils.c"
	}
#line 193 "../src/Utils.vala"
	if (_tmp3_) {
#line 193 "../src/Utils.vala"
		_tmp2_ = TRUE;
#line 886 "Utils.c"
	} else {
		const gchar* _tmp5_;
#line 195 "../src/Utils.vala"
		_tmp5_ = content_type;
#line 195 "../src/Utils.vala"
		_tmp2_ = g_content_type_is_a (_tmp5_, "application/x-zerosize");
#line 893 "Utils.c"
	}
#line 193 "../src/Utils.vala"
	if (_tmp2_) {
#line 198 "../src/Utils.vala"
		result = TRUE;
#line 198 "../src/Utils.vala"
		_g_free0 (content_type);
#line 198 "../src/Utils.vala"
		return result;
#line 903 "Utils.c"
	}
#line 201 "../src/Utils.vala"
	result = FALSE;
#line 201 "../src/Utils.vala"
	_g_free0 (content_type);
#line 201 "../src/Utils.vala"
	return result;
#line 911 "Utils.c"
}

static GVariant*
_variant_new10 (gchar* value)
{
#line 218 "../src/Utils.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 919 "Utils.c"
}

static GVariant*
_variant_new11 (const gchar* value)
{
#line 218 "../src/Utils.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 927 "Utils.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 233 "../src/Utils.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 935 "Utils.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 233 "../src/Utils.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 943 "Utils.c"
}

GMenu*
scratch_utils_create_executable_app_items_for_file (GFile* file,
                                                    const gchar* file_type)
{
	GList* external_apps = NULL;
	GList* _tmp0_;
	GAppInfo* files_appinfo = NULL;
	GAppInfo* _tmp1_;
	GAppInfo* _tmp2_;
	GAppInfo* _tmp3_;
	gchar* this_id = NULL;
	GApplication* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GMenu* menu = NULL;
	GMenu* _tmp8_;
	GList* _tmp9_;
	GMenu* result;
#line 204 "../src/Utils.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 204 "../src/Utils.vala"
	g_return_val_if_fail (file_type != NULL, NULL);
#line 205 "../src/Utils.vala"
	_tmp0_ = g_app_info_get_all_for_type (file_type);
#line 205 "../src/Utils.vala"
	external_apps = _tmp0_;
#line 206 "../src/Utils.vala"
	_tmp1_ = g_app_info_get_default_for_type ("inode/directory", TRUE);
#line 206 "../src/Utils.vala"
	files_appinfo = _tmp1_;
#line 207 "../src/Utils.vala"
	_tmp2_ = files_appinfo;
#line 207 "../src/Utils.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 207 "../src/Utils.vala"
	external_apps = g_list_prepend (external_apps, _tmp3_);
#line 209 "../src/Utils.vala"
	_tmp4_ = g_application_get_default ();
#line 209 "../src/Utils.vala"
	_tmp5_ = g_application_get_application_id (_tmp4_);
#line 209 "../src/Utils.vala"
	_tmp6_ = _tmp5_;
#line 209 "../src/Utils.vala"
	_tmp7_ = g_strconcat (_tmp6_, ".desktop", NULL);
#line 209 "../src/Utils.vala"
	this_id = _tmp7_;
#line 210 "../src/Utils.vala"
	_tmp8_ = g_menu_new ();
#line 210 "../src/Utils.vala"
	menu = _tmp8_;
#line 212 "../src/Utils.vala"
	_tmp9_ = external_apps;
#line 999 "Utils.c"
	{
		GList* app_info_collection = NULL;
		GList* app_info_it = NULL;
#line 212 "../src/Utils.vala"
		app_info_collection = _tmp9_;
#line 212 "../src/Utils.vala"
		for (app_info_it = app_info_collection; app_info_it != NULL; app_info_it = app_info_it->next) {
#line 1007 "Utils.c"
			GAppInfo* _tmp10_;
			GAppInfo* app_info = NULL;
#line 212 "../src/Utils.vala"
			_tmp10_ = _g_object_ref0 ((GAppInfo*) app_info_it->data);
#line 212 "../src/Utils.vala"
			app_info = _tmp10_;
#line 1014 "Utils.c"
			{
				gchar* app_id = NULL;
				GAppInfo* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				GMenuItem* menu_item = NULL;
				GAppInfo* _tmp16_;
				const gchar* _tmp17_;
				const GVariantType* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				GVariant* _tmp21_;
				const gchar* _tmp22_;
				GVariant* _tmp23_;
				GVariant** _tmp24_;
				GVariant** _tmp25_;
				gint _tmp25__length1;
				GVariant* _tmp26_;
				GVariant* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
				GMenuItem* _tmp30_;
				GMenuItem* _tmp31_;
				GMenuItem* _tmp32_;
				GAppInfo* _tmp33_;
				GIcon* _tmp34_;
				GMenu* _tmp35_;
				GMenuItem* _tmp36_;
#line 213 "../src/Utils.vala"
				_tmp11_ = app_info;
#line 213 "../src/Utils.vala"
				_tmp12_ = g_app_info_get_id (_tmp11_);
#line 213 "../src/Utils.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 213 "../src/Utils.vala"
				app_id = _tmp13_;
#line 214 "../src/Utils.vala"
				_tmp14_ = app_id;
#line 214 "../src/Utils.vala"
				_tmp15_ = this_id;
#line 214 "../src/Utils.vala"
				if (g_strcmp0 (_tmp14_, _tmp15_) == 0) {
#line 215 "../src/Utils.vala"
					_g_free0 (app_id);
#line 215 "../src/Utils.vala"
					_g_object_unref0 (app_info);
#line 215 "../src/Utils.vala"
					continue;
#line 1065 "Utils.c"
				}
#line 218 "../src/Utils.vala"
				_tmp16_ = app_info;
#line 218 "../src/Utils.vala"
				_tmp17_ = g_app_info_get_name (_tmp16_);
#line 218 "../src/Utils.vala"
				_tmp18_ = G_VARIANT_TYPE_STRING;
#line 218 "../src/Utils.vala"
				_tmp19_ = g_file_get_path (file);
#line 218 "../src/Utils.vala"
				_tmp20_ = _tmp19_;
#line 218 "../src/Utils.vala"
				_tmp21_ = _variant_new10 (_tmp20_);
#line 218 "../src/Utils.vala"
				_tmp22_ = app_id;
#line 218 "../src/Utils.vala"
				_tmp23_ = _variant_new11 (_tmp22_);
#line 218 "../src/Utils.vala"
				_tmp24_ = g_new0 (GVariant*, 2 + 1);
#line 218 "../src/Utils.vala"
				_tmp24_[0] = _tmp21_;
#line 218 "../src/Utils.vala"
				_tmp24_[1] = _tmp23_;
#line 218 "../src/Utils.vala"
				_tmp25_ = _tmp24_;
#line 218 "../src/Utils.vala"
				_tmp25__length1 = 2;
#line 218 "../src/Utils.vala"
				_tmp26_ = g_variant_new_array (_tmp18_, _tmp25_, 2);
#line 218 "../src/Utils.vala"
				g_variant_ref_sink (_tmp26_);
#line 218 "../src/Utils.vala"
				_tmp27_ = _tmp26_;
#line 218 "../src/Utils.vala"
				_tmp28_ = g_action_print_detailed_name (SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_PREFIX SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_LAUNCH_APP_WITH_FILE_PATH, _tmp27_);
#line 218 "../src/Utils.vala"
				_tmp29_ = _tmp28_;
#line 218 "../src/Utils.vala"
				_tmp30_ = g_menu_item_new (_tmp17_, _tmp29_);
#line 218 "../src/Utils.vala"
				_tmp31_ = _tmp30_;
#line 218 "../src/Utils.vala"
				_g_free0 (_tmp29_);
#line 218 "../src/Utils.vala"
				_g_variant_unref0 (_tmp27_);
#line 218 "../src/Utils.vala"
				_tmp25_ = (_vala_array_free (_tmp25_, _tmp25__length1, (GDestroyNotify) g_variant_unref), NULL);
#line 218 "../src/Utils.vala"
				_g_free0 (_tmp20_);
#line 218 "../src/Utils.vala"
				menu_item = _tmp31_;
#line 229 "../src/Utils.vala"
				_tmp32_ = menu_item;
#line 229 "../src/Utils.vala"
				_tmp33_ = app_info;
#line 229 "../src/Utils.vala"
				_tmp34_ = g_app_info_get_icon (_tmp33_);
#line 229 "../src/Utils.vala"
				g_menu_item_set_icon (_tmp32_, _tmp34_);
#line 230 "../src/Utils.vala"
				_tmp35_ = menu;
#line 230 "../src/Utils.vala"
				_tmp36_ = menu_item;
#line 230 "../src/Utils.vala"
				g_menu_append_item (_tmp35_, _tmp36_);
#line 212 "../src/Utils.vala"
				_g_object_unref0 (menu_item);
#line 212 "../src/Utils.vala"
				_g_free0 (app_id);
#line 212 "../src/Utils.vala"
				_g_object_unref0 (app_info);
#line 1137 "Utils.c"
			}
		}
	}
#line 233 "../src/Utils.vala"
	result = menu;
#line 233 "../src/Utils.vala"
	_g_free0 (this_id);
#line 233 "../src/Utils.vala"
	_g_object_unref0 (files_appinfo);
#line 233 "../src/Utils.vala"
	(external_apps == NULL) ? NULL : (external_apps = (_g_list_free__g_object_unref0_ (external_apps), NULL));
#line 233 "../src/Utils.vala"
	return result;
#line 1151 "Utils.c"
}

void
scratch_utils_launch_app_with_file (GAppInfo* app_info,
                                    GFile* file)
{
	GList* file_list = NULL;
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 236 "../src/Utils.vala"
	g_return_if_fail (app_info != NULL);
#line 236 "../src/Utils.vala"
	g_return_if_fail (file != NULL);
#line 237 "../src/Utils.vala"
	file_list = NULL;
#line 238 "../src/Utils.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 238 "../src/Utils.vala"
	file_list = g_list_append (file_list, _tmp0_);
#line 1171 "Utils.c"
	{
#line 241 "../src/Utils.vala"
		g_app_info_launch (app_info, file_list, NULL, &_inner_error0_);
#line 241 "../src/Utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1177 "Utils.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 240 "../src/Utils.vala"
		e = _inner_error0_;
#line 240 "../src/Utils.vala"
		_inner_error0_ = NULL;
#line 243 "../src/Utils.vala"
		_tmp1_ = e;
#line 243 "../src/Utils.vala"
		_tmp2_ = _tmp1_->message;
#line 243 "../src/Utils.vala"
		g_warning ("Utils.vala:243: %s", _tmp2_);
#line 240 "../src/Utils.vala"
		_g_error_free0 (e);
#line 1199 "Utils.c"
	}
	__finally0:
#line 240 "../src/Utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 240 "../src/Utils.vala"
		(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
#line 240 "../src/Utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 240 "../src/Utils.vala"
		g_clear_error (&_inner_error0_);
#line 240 "../src/Utils.vala"
		return;
#line 1212 "Utils.c"
	}
#line 236 "../src/Utils.vala"
	(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
#line 1216 "Utils.c"
}

static GVariant*
_variant_new12 (gchar* value)
{
#line 254 "../src/Utils.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 1224 "Utils.c"
}

static GVariant*
_variant_new13 (const gchar* value)
{
#line 254 "../src/Utils.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 1232 "Utils.c"
}

GMenu*
scratch_utils_create_contract_items_for_file (GFile* file)
{
	GMenu* menu = NULL;
	GMenu* _tmp0_;
	GError* _inner_error0_ = NULL;
	GMenu* result;
#line 247 "../src/Utils.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 248 "../src/Utils.vala"
	_tmp0_ = g_menu_new ();
#line 248 "../src/Utils.vala"
	menu = _tmp0_;
#line 1248 "Utils.c"
	{
		GeeList* contracts = NULL;
		GeeList* _tmp1_;
#line 251 "../src/Utils.vala"
		_tmp1_ = granite_services_contractor_proxy_get_contracts_for_file (file, &_inner_error0_);
#line 251 "../src/Utils.vala"
		contracts = _tmp1_;
#line 251 "../src/Utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1258 "Utils.c"
			goto __catch0_g_error;
		}
		{
			GeeList* _contract_list = NULL;
			GeeList* _tmp2_;
			gint _contract_size = 0;
			GeeList* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			gint _contract_index = 0;
#line 252 "../src/Utils.vala"
			_tmp2_ = contracts;
#line 252 "../src/Utils.vala"
			_contract_list = _tmp2_;
#line 252 "../src/Utils.vala"
			_tmp3_ = _contract_list;
#line 252 "../src/Utils.vala"
			_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 252 "../src/Utils.vala"
			_tmp5_ = _tmp4_;
#line 252 "../src/Utils.vala"
			_contract_size = _tmp5_;
#line 252 "../src/Utils.vala"
			_contract_index = -1;
#line 252 "../src/Utils.vala"
			while (TRUE) {
#line 1285 "Utils.c"
				gint _tmp6_;
				gint _tmp7_;
				GraniteServicesContract* contract = NULL;
				GeeList* _tmp8_;
				gpointer _tmp9_;
				gchar* contract_name = NULL;
				GraniteServicesContract* _tmp10_;
				gchar* _tmp11_;
				GMenuItem* menu_item = NULL;
				const gchar* _tmp12_;
				const GVariantType* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				GVariant* _tmp16_;
				const gchar* _tmp17_;
				GVariant* _tmp18_;
				GVariant** _tmp19_;
				GVariant** _tmp20_;
				gint _tmp20__length1;
				GVariant* _tmp21_;
				GVariant* _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
				GMenuItem* _tmp25_;
				GMenuItem* _tmp26_;
				GMenu* _tmp27_;
				GMenuItem* _tmp28_;
#line 252 "../src/Utils.vala"
				_contract_index = _contract_index + 1;
#line 252 "../src/Utils.vala"
				_tmp6_ = _contract_index;
#line 252 "../src/Utils.vala"
				_tmp7_ = _contract_size;
#line 252 "../src/Utils.vala"
				if (!(_tmp6_ < _tmp7_)) {
#line 252 "../src/Utils.vala"
					break;
#line 1323 "Utils.c"
				}
#line 252 "../src/Utils.vala"
				_tmp8_ = _contract_list;
#line 252 "../src/Utils.vala"
				_tmp9_ = gee_list_get (_tmp8_, _contract_index);
#line 252 "../src/Utils.vala"
				contract = (GraniteServicesContract*) _tmp9_;
#line 253 "../src/Utils.vala"
				_tmp10_ = contract;
#line 253 "../src/Utils.vala"
				_tmp11_ = granite_services_contract_get_display_name (_tmp10_);
#line 253 "../src/Utils.vala"
				contract_name = _tmp11_;
#line 254 "../src/Utils.vala"
				_tmp12_ = contract_name;
#line 254 "../src/Utils.vala"
				_tmp13_ = G_VARIANT_TYPE_STRING;
#line 254 "../src/Utils.vala"
				_tmp14_ = g_file_get_path (file);
#line 254 "../src/Utils.vala"
				_tmp15_ = _tmp14_;
#line 254 "../src/Utils.vala"
				_tmp16_ = _variant_new12 (_tmp15_);
#line 254 "../src/Utils.vala"
				_tmp17_ = contract_name;
#line 254 "../src/Utils.vala"
				_tmp18_ = _variant_new13 (_tmp17_);
#line 254 "../src/Utils.vala"
				_tmp19_ = g_new0 (GVariant*, 2 + 1);
#line 254 "../src/Utils.vala"
				_tmp19_[0] = _tmp16_;
#line 254 "../src/Utils.vala"
				_tmp19_[1] = _tmp18_;
#line 254 "../src/Utils.vala"
				_tmp20_ = _tmp19_;
#line 254 "../src/Utils.vala"
				_tmp20__length1 = 2;
#line 254 "../src/Utils.vala"
				_tmp21_ = g_variant_new_array (_tmp13_, _tmp20_, 2);
#line 254 "../src/Utils.vala"
				g_variant_ref_sink (_tmp21_);
#line 254 "../src/Utils.vala"
				_tmp22_ = _tmp21_;
#line 254 "../src/Utils.vala"
				_tmp23_ = g_action_print_detailed_name (SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_PREFIX SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_EXECUTE_CONTRACT_WITH_FILE_PATH, _tmp22_);
#line 254 "../src/Utils.vala"
				_tmp24_ = _tmp23_;
#line 254 "../src/Utils.vala"
				_tmp25_ = g_menu_item_new (_tmp12_, _tmp24_);
#line 254 "../src/Utils.vala"
				_tmp26_ = _tmp25_;
#line 254 "../src/Utils.vala"
				_g_free0 (_tmp24_);
#line 254 "../src/Utils.vala"
				_g_variant_unref0 (_tmp22_);
#line 254 "../src/Utils.vala"
				_tmp20_ = (_vala_array_free (_tmp20_, _tmp20__length1, (GDestroyNotify) g_variant_unref), NULL);
#line 254 "../src/Utils.vala"
				_g_free0 (_tmp15_);
#line 254 "../src/Utils.vala"
				menu_item = _tmp26_;
#line 266 "../src/Utils.vala"
				_tmp27_ = menu;
#line 266 "../src/Utils.vala"
				_tmp28_ = menu_item;
#line 266 "../src/Utils.vala"
				g_menu_append_item (_tmp27_, _tmp28_);
#line 252 "../src/Utils.vala"
				_g_object_unref0 (menu_item);
#line 252 "../src/Utils.vala"
				_g_free0 (contract_name);
#line 252 "../src/Utils.vala"
				_g_object_unref0 (contract);
#line 1397 "Utils.c"
			}
		}
#line 250 "../src/Utils.vala"
		_g_object_unref0 (contracts);
#line 1402 "Utils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp29_;
		const gchar* _tmp30_;
#line 250 "../src/Utils.vala"
		e = _inner_error0_;
#line 250 "../src/Utils.vala"
		_inner_error0_ = NULL;
#line 269 "../src/Utils.vala"
		_tmp29_ = e;
#line 269 "../src/Utils.vala"
		_tmp30_ = _tmp29_->message;
#line 269 "../src/Utils.vala"
		g_warning ("Utils.vala:269: %s", _tmp30_);
#line 250 "../src/Utils.vala"
		_g_error_free0 (e);
#line 1422 "Utils.c"
	}
	__finally0:
#line 250 "../src/Utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 250 "../src/Utils.vala"
		_g_object_unref0 (menu);
#line 250 "../src/Utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 250 "../src/Utils.vala"
		g_clear_error (&_inner_error0_);
#line 250 "../src/Utils.vala"
		return NULL;
#line 1435 "Utils.c"
	}
#line 272 "../src/Utils.vala"
	result = menu;
#line 272 "../src/Utils.vala"
	return result;
#line 1441 "Utils.c"
}

void
scratch_utils_execute_contract_with_file_path (const gchar* path,
                                               const gchar* contract_name)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 275 "../src/Utils.vala"
	g_return_if_fail (path != NULL);
#line 275 "../src/Utils.vala"
	g_return_if_fail (contract_name != NULL);
#line 276 "../src/Utils.vala"
	_tmp0_ = g_file_new_for_path (path);
#line 276 "../src/Utils.vala"
	file = _tmp0_;
#line 1459 "Utils.c"
	{
		GeeList* contracts = NULL;
		GFile* _tmp1_;
		GeeList* _tmp2_;
		gint length = 0;
		GeeList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 279 "../src/Utils.vala"
		_tmp1_ = file;
#line 279 "../src/Utils.vala"
		_tmp2_ = granite_services_contractor_proxy_get_contracts_for_file (_tmp1_, &_inner_error0_);
#line 279 "../src/Utils.vala"
		contracts = _tmp2_;
#line 279 "../src/Utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1476 "Utils.c"
			goto __catch0_g_error;
		}
#line 280 "../src/Utils.vala"
		_tmp3_ = contracts;
#line 280 "../src/Utils.vala"
		_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 280 "../src/Utils.vala"
		_tmp5_ = _tmp4_;
#line 280 "../src/Utils.vala"
		length = _tmp5_;
#line 1487 "Utils.c"
		{
			gint i = 0;
#line 281 "../src/Utils.vala"
			i = 0;
#line 1492 "Utils.c"
			{
				gboolean _tmp6_ = FALSE;
#line 281 "../src/Utils.vala"
				_tmp6_ = TRUE;
#line 281 "../src/Utils.vala"
				while (TRUE) {
#line 1499 "Utils.c"
					GraniteServicesContract* contract = NULL;
					GeeList* _tmp8_;
					gpointer _tmp9_;
					GraniteServicesContract* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					gboolean _tmp13_;
#line 281 "../src/Utils.vala"
					if (!_tmp6_) {
#line 1509 "Utils.c"
						gint _tmp7_;
#line 281 "../src/Utils.vala"
						_tmp7_ = i;
#line 281 "../src/Utils.vala"
						i = _tmp7_ + 1;
#line 1515 "Utils.c"
					}
#line 281 "../src/Utils.vala"
					_tmp6_ = FALSE;
#line 281 "../src/Utils.vala"
					if (!(i < length)) {
#line 281 "../src/Utils.vala"
						break;
#line 1523 "Utils.c"
					}
#line 282 "../src/Utils.vala"
					_tmp8_ = contracts;
#line 282 "../src/Utils.vala"
					_tmp9_ = gee_list_get (_tmp8_, i);
#line 282 "../src/Utils.vala"
					contract = (GraniteServicesContract*) _tmp9_;
#line 283 "../src/Utils.vala"
					_tmp10_ = contract;
#line 283 "../src/Utils.vala"
					_tmp11_ = granite_services_contract_get_display_name (_tmp10_);
#line 283 "../src/Utils.vala"
					_tmp12_ = _tmp11_;
#line 283 "../src/Utils.vala"
					_tmp13_ = g_strcmp0 (_tmp12_, contract_name) == 0;
#line 283 "../src/Utils.vala"
					_g_free0 (_tmp12_);
#line 283 "../src/Utils.vala"
					if (_tmp13_) {
#line 1543 "Utils.c"
						GraniteServicesContract* _tmp14_;
						GFile* _tmp15_;
#line 284 "../src/Utils.vala"
						_tmp14_ = contract;
#line 284 "../src/Utils.vala"
						_tmp15_ = file;
#line 284 "../src/Utils.vala"
						granite_services_contract_execute_with_file (_tmp14_, _tmp15_, &_inner_error0_);
#line 284 "../src/Utils.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 284 "../src/Utils.vala"
							_g_object_unref0 (contract);
#line 284 "../src/Utils.vala"
							_g_object_unref0 (contracts);
#line 1558 "Utils.c"
							goto __catch0_g_error;
						}
#line 285 "../src/Utils.vala"
						_g_object_unref0 (contract);
#line 285 "../src/Utils.vala"
						break;
#line 1565 "Utils.c"
					}
#line 281 "../src/Utils.vala"
					_g_object_unref0 (contract);
#line 1569 "Utils.c"
				}
			}
		}
#line 278 "../src/Utils.vala"
		_g_object_unref0 (contracts);
#line 1575 "Utils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 278 "../src/Utils.vala"
		e = _inner_error0_;
#line 278 "../src/Utils.vala"
		_inner_error0_ = NULL;
#line 289 "../src/Utils.vala"
		_tmp16_ = e;
#line 289 "../src/Utils.vala"
		_tmp17_ = _tmp16_->message;
#line 289 "../src/Utils.vala"
		g_warning ("Utils.vala:289: %s", _tmp17_);
#line 278 "../src/Utils.vala"
		_g_error_free0 (e);
#line 1595 "Utils.c"
	}
	__finally0:
#line 278 "../src/Utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 278 "../src/Utils.vala"
		_g_object_unref0 (file);
#line 278 "../src/Utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 278 "../src/Utils.vala"
		g_clear_error (&_inner_error0_);
#line 278 "../src/Utils.vala"
		return;
#line 1608 "Utils.c"
	}
#line 275 "../src/Utils.vala"
	_g_object_unref0 (file);
#line 1612 "Utils.c"
}

gchar*
scratch_utils_get_accel_for_action (const gchar* detailed_action_name)
{
	GtkApplication* app_instance = NULL;
	GApplication* _tmp0_;
	GtkApplication* _tmp1_;
	gchar** accels = NULL;
	GtkApplication* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint accels_length1;
	gint _accels_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp9_;
	gchar* result;
#line 293 "../src/Utils.vala"
	g_return_val_if_fail (detailed_action_name != NULL, NULL);
#line 294 "../src/Utils.vala"
	_tmp0_ = g_application_get_default ();
#line 294 "../src/Utils.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication));
#line 294 "../src/Utils.vala"
	app_instance = _tmp1_;
#line 295 "../src/Utils.vala"
	_tmp2_ = app_instance;
#line 295 "../src/Utils.vala"
	_tmp4_ = _tmp3_ = gtk_application_get_accels_for_action (_tmp2_, detailed_action_name);
#line 295 "../src/Utils.vala"
	accels = _tmp4_;
#line 295 "../src/Utils.vala"
	accels_length1 = _vala_array_length (_tmp3_);
#line 295 "../src/Utils.vala"
	_accels_size_ = accels_length1;
#line 296 "../src/Utils.vala"
	_tmp5_ = accels;
#line 296 "../src/Utils.vala"
	_tmp5__length1 = accels_length1;
#line 296 "../src/Utils.vala"
	if (_tmp5__length1 > 0) {
#line 1655 "Utils.c"
		gchar** _tmp6_;
		gint _tmp6__length1;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 297 "../src/Utils.vala"
		_tmp6_ = accels;
#line 297 "../src/Utils.vala"
		_tmp6__length1 = accels_length1;
#line 297 "../src/Utils.vala"
		_tmp7_ = _tmp6_[0];
#line 297 "../src/Utils.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 297 "../src/Utils.vala"
		result = _tmp8_;
#line 297 "../src/Utils.vala"
		accels = (_vala_array_free (accels, accels_length1, (GDestroyNotify) g_free), NULL);
#line 297 "../src/Utils.vala"
		_g_object_unref0 (app_instance);
#line 297 "../src/Utils.vala"
		return result;
#line 1676 "Utils.c"
	}
#line 300 "../src/Utils.vala"
	g_warning ("Utils.vala:300: Accelerators were not found for the action: %s", detailed_action_name);
#line 301 "../src/Utils.vala"
	_tmp9_ = g_strdup ("");
#line 301 "../src/Utils.vala"
	result = _tmp9_;
#line 301 "../src/Utils.vala"
	accels = (_vala_array_free (accels, accels_length1, (GDestroyNotify) g_free), NULL);
#line 301 "../src/Utils.vala"
	_g_object_unref0 (app_instance);
#line 301 "../src/Utils.vala"
	return result;
#line 1690 "Utils.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

