/* Terminal.c generated by valac 0.56.18, the Vala compiler
 * generated from Terminal.vala, do not modify */

/*
 * SPDX-License-Identifier: LGPL-3.0-or-later
 * SPDX-FileCopyrightText: 2022 elementary, Inc. (https://elementary.io)
 *                         2011-2013 Mario Guerriero <mario@elementaryos.org>
 */

#include "codecore.h"
#include <vte/vte.h>
#include <gio/gio.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <glib/gstdio.h>
#include <pango/pango.h>
#include <gdk/gdk.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>

#define CODE_TERMINAL_MAX_SCALE 5.0
#define CODE_TERMINAL_MIN_SCALE 0.2
#define CODE_TERMINAL_LEGACY_SETTINGS_SCHEMA "org.pantheon.terminal.settings"
#define CODE_TERMINAL_SETTINGS_SCHEMA "io.elementary.terminal.settings"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CODE_TERMINAL_0_PROPERTY,
	CODE_TERMINAL_TERMINAL_PROPERTY,
	CODE_TERMINAL_ACTIONS_PROPERTY,
	CODE_TERMINAL_NUM_PROPERTIES
};
static GParamSpec* code_terminal_properties[CODE_TERMINAL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
typedef struct _Block41Data Block41Data;
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_settings_schema_source_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_source_unref (var), NULL)))

struct _CodeTerminalPrivate {
	VteTerminal* _terminal;
	GSimpleActionGroup* _actions;
	GPid child_pid;
	GtkClipboard* current_clipboard;
};

struct _Block41Data {
	int _ref_count_;
	CodeTerminal* self;
	GSimpleAction* copy_action;
	GSimpleAction* paste_action;
	GtkMenu* menu;
	GSettings* settings;
};

static gint CodeTerminal_private_offset;
static gpointer code_terminal_parent_class = NULL;

static void code_terminal_spawn_shell (CodeTerminal* self,
                                const gchar* dir);
static gchar* code_terminal_get_shell_location (CodeTerminal* self);
static void code_terminal_update_terminal_settings (CodeTerminal* self,
                                             const gchar* settings_schema);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static GObject * code_terminal_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static Block41Data* block41_data_ref (Block41Data* _data41_);
static void block41_data_unref (void * _userdata_);
static void _code_terminal___lambda114_ (CodeTerminal* self);
static void __code_terminal___lambda114__vte_terminal_child_exited (VteTerminal* _sender,
                                                             gint status,
                                                             gpointer self);
static void _code_terminal___lambda115_ (CodeTerminal* self);
static void __code_terminal___lambda115__g_simple_action_activate (GSimpleAction* _sender,
                                                            GVariant* parameter,
                                                            gpointer self);
static void _code_terminal___lambda116_ (CodeTerminal* self);
static void __code_terminal___lambda116__g_simple_action_activate (GSimpleAction* _sender,
                                                            GVariant* parameter,
                                                            gpointer self);
static gboolean _code_terminal___lambda117_ (Block41Data* _data41_,
                                      GdkEventButton* event);
static gboolean __code_terminal___lambda117__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                     GdkEventButton* event,
                                                                     gpointer self);
static void _code_terminal___lambda118_ (Block41Data* _data41_);
static void __code_terminal___lambda118__gtk_widget_realize (GtkWidget* _sender,
                                                      gpointer self);
static void _code_terminal___lambda119_ (Block41Data* _data41_);
static void __code_terminal___lambda119__vte_terminal_selection_changed (VteTerminal* _sender,
                                                                  gpointer self);
static void _code_terminal___lambda120_ (Block41Data* _data41_);
static void __code_terminal___lambda120__gtk_widget_destroy (GtkWidget* _sender,
                                                      gpointer self);
static void code_terminal_finalize (GObject * obj);
static GType code_terminal_get_type_once (void);
static void _vala_code_terminal_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_code_terminal_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
code_terminal_get_instance_private (CodeTerminal* self)
{
	return G_STRUCT_MEMBER_P (self, CodeTerminal_private_offset);
}

static void
code_terminal_spawn_shell (CodeTerminal* self,
                           const gchar* dir)
{
	GError* _inner_error0_ = NULL;
#line 99 "../src/Widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/Widgets/Terminal.vala"
	g_return_if_fail (dir != NULL);
#line 146 "Terminal.c"
	{
		VteTerminal* _tmp0_;
		gchar* _tmp1_;
		gchar** _tmp2_;
		gchar** _tmp3_;
		gint _tmp3__length1;
		GPid _tmp4_ = 0;
#line 101 "../src/Widgets/Terminal.vala"
		_tmp0_ = self->priv->_terminal;
#line 101 "../src/Widgets/Terminal.vala"
		_tmp1_ = vte_get_user_shell ();
#line 101 "../src/Widgets/Terminal.vala"
		_tmp2_ = g_new0 (gchar*, 1 + 1);
#line 101 "../src/Widgets/Terminal.vala"
		_tmp2_[0] = _tmp1_;
#line 101 "../src/Widgets/Terminal.vala"
		_tmp3_ = _tmp2_;
#line 101 "../src/Widgets/Terminal.vala"
		_tmp3__length1 = 1;
#line 101 "../src/Widgets/Terminal.vala"
		vte_terminal_spawn_sync (_tmp0_, VTE_PTY_DEFAULT, dir, _tmp3_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp4_, NULL, &_inner_error0_);
#line 101 "../src/Widgets/Terminal.vala"
		self->priv->child_pid = _tmp4_;
#line 101 "../src/Widgets/Terminal.vala"
		_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 101 "../src/Widgets/Terminal.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 174 "Terminal.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 100 "../src/Widgets/Terminal.vala"
		e = _inner_error0_;
#line 100 "../src/Widgets/Terminal.vala"
		_inner_error0_ = NULL;
#line 112 "../src/Widgets/Terminal.vala"
		_tmp5_ = e;
#line 112 "../src/Widgets/Terminal.vala"
		_tmp6_ = _tmp5_->message;
#line 112 "../src/Widgets/Terminal.vala"
		g_warning ("Terminal.vala:112: %s", _tmp6_);
#line 100 "../src/Widgets/Terminal.vala"
		_g_error_free0 (e);
#line 196 "Terminal.c"
	}
	__finally0:
#line 100 "../src/Widgets/Terminal.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "../src/Widgets/Terminal.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "../src/Widgets/Terminal.vala"
		g_clear_error (&_inner_error0_);
#line 100 "../src/Widgets/Terminal.vala"
		return;
#line 207 "Terminal.c"
	}
}

void
code_terminal_change_location (CodeTerminal* self,
                               const gchar* dir)
{
	VteTerminal* _tmp0_;
#line 116 "../src/Widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/Widgets/Terminal.vala"
	g_return_if_fail (dir != NULL);
#line 117 "../src/Widgets/Terminal.vala"
	kill ((pid_t) self->priv->child_pid, (gint) SIGTERM);
#line 118 "../src/Widgets/Terminal.vala"
	_tmp0_ = self->priv->_terminal;
#line 118 "../src/Widgets/Terminal.vala"
	vte_terminal_reset (_tmp0_, TRUE, TRUE);
#line 119 "../src/Widgets/Terminal.vala"
	code_terminal_spawn_shell (self, dir);
#line 228 "Terminal.c"
}

static gchar*
code_terminal_get_shell_location (CodeTerminal* self)
{
	gint pid = 0;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 122 "../src/Widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 123 "../src/Widgets/Terminal.vala"
	pid = (gint) ((GPid) self->priv->child_pid);
#line 241 "Terminal.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 125 "../src/Widgets/Terminal.vala"
		_tmp1_ = g_strdup_printf ("/proc/%d/cwd", pid);
#line 125 "../src/Widgets/Terminal.vala"
		_tmp2_ = _tmp1_;
#line 125 "../src/Widgets/Terminal.vala"
		_tmp3_ = g_file_read_link (_tmp2_, &_inner_error0_);
#line 125 "../src/Widgets/Terminal.vala"
		_tmp4_ = _tmp3_;
#line 125 "../src/Widgets/Terminal.vala"
		_g_free0 (_tmp2_);
#line 125 "../src/Widgets/Terminal.vala"
		_tmp0_ = _tmp4_;
#line 125 "../src/Widgets/Terminal.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 125 "../src/Widgets/Terminal.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 265 "Terminal.c"
				goto __catch0_g_file_error;
			}
#line 125 "../src/Widgets/Terminal.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 125 "../src/Widgets/Terminal.vala"
			g_clear_error (&_inner_error0_);
#line 125 "../src/Widgets/Terminal.vala"
			return NULL;
#line 274 "Terminal.c"
		}
#line 125 "../src/Widgets/Terminal.vala"
		_tmp5_ = _tmp0_;
#line 125 "../src/Widgets/Terminal.vala"
		_tmp0_ = NULL;
#line 125 "../src/Widgets/Terminal.vala"
		result = _tmp5_;
#line 125 "../src/Widgets/Terminal.vala"
		_g_free0 (_tmp0_);
#line 125 "../src/Widgets/Terminal.vala"
		return result;
#line 286 "Terminal.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* _error_ = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 124 "../src/Widgets/Terminal.vala"
		_error_ = _inner_error0_;
#line 124 "../src/Widgets/Terminal.vala"
		_inner_error0_ = NULL;
#line 127 "../src/Widgets/Terminal.vala"
		_tmp6_ = _error_;
#line 127 "../src/Widgets/Terminal.vala"
		_tmp7_ = _tmp6_->message;
#line 127 "../src/Widgets/Terminal.vala"
		g_warning ("Terminal.vala:127: An error occurred while fetching the current dir of" \
" shell: %s", _tmp7_);
#line 128 "../src/Widgets/Terminal.vala"
		_tmp8_ = g_strdup ("");
#line 128 "../src/Widgets/Terminal.vala"
		result = _tmp8_;
#line 128 "../src/Widgets/Terminal.vala"
		_g_error_free0 (_error_);
#line 128 "../src/Widgets/Terminal.vala"
		return result;
#line 313 "Terminal.c"
	}
	__finally0:
#line 124 "../src/Widgets/Terminal.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 124 "../src/Widgets/Terminal.vala"
	g_clear_error (&_inner_error0_);
#line 124 "../src/Widgets/Terminal.vala"
	return NULL;
#line 322 "Terminal.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 339 "Terminal.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 132 "../src/Widgets/Terminal.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 347 "Terminal.c"
}

static void
code_terminal_update_terminal_settings (CodeTerminal* self,
                                        const gchar* settings_schema)
{
	GSettings* pantheon_terminal_settings = NULL;
	GSettings* _tmp0_;
	gchar* font_name = NULL;
	GSettings* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	PangoFontDescription* fd = NULL;
	const gchar* _tmp7_;
	PangoFontDescription* _tmp8_;
	VteTerminal* _tmp9_;
	PangoFontDescription* _tmp10_;
	gboolean audible_bell_setting = FALSE;
	GSettings* _tmp11_;
	VteTerminal* _tmp12_;
	gchar* cursor_shape_setting = NULL;
	GSettings* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GQuark _tmp18_ = 0U;
#line 149 "../src/Widgets/Terminal.vala"
	static GQuark _tmp17_label0 = 0;
#line 149 "../src/Widgets/Terminal.vala"
	static GQuark _tmp17_label1 = 0;
#line 149 "../src/Widgets/Terminal.vala"
	static GQuark _tmp17_label2 = 0;
#line 380 "Terminal.c"
	gchar* background_setting = NULL;
	GSettings* _tmp22_;
	gchar* _tmp23_;
	GdkRGBA background_color = {0};
	const gchar* _tmp24_;
	gchar* foreground_setting = NULL;
	GSettings* _tmp25_;
	gchar* _tmp26_;
	GdkRGBA foreground_color = {0};
	const gchar* _tmp27_;
	gchar* palette_setting = NULL;
	GSettings* _tmp28_;
	gchar* _tmp29_;
	gchar** hex_palette = NULL;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar** _tmp46_;
	gint hex_palette_length1;
	gint _hex_palette_size_;
	gchar* current_string = NULL;
	gchar* _tmp47_;
	gint current_color = 0;
	GdkRGBA* palette = NULL;
	GdkRGBA* _tmp64_;
	gint palette_length1;
	gint _palette_size_;
	VteTerminal* _tmp72_;
	GdkRGBA _tmp73_;
	GdkRGBA _tmp74_;
	GdkRGBA* _tmp75_;
	gint _tmp75__length1;
#line 132 "../src/Widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 132 "../src/Widgets/Terminal.vala"
	g_return_if_fail (settings_schema != NULL);
#line 133 "../src/Widgets/Terminal.vala"
	_tmp0_ = g_settings_new (settings_schema);
#line 133 "../src/Widgets/Terminal.vala"
	pantheon_terminal_settings = _tmp0_;
#line 135 "../src/Widgets/Terminal.vala"
	_tmp1_ = pantheon_terminal_settings;
#line 135 "../src/Widgets/Terminal.vala"
	_tmp2_ = g_settings_get_string (_tmp1_, "font");
#line 135 "../src/Widgets/Terminal.vala"
	font_name = _tmp2_;
#line 136 "../src/Widgets/Terminal.vala"
	_tmp3_ = font_name;
#line 136 "../src/Widgets/Terminal.vala"
	if (g_strcmp0 (_tmp3_, "") == 0) {
#line 444 "Terminal.c"
		GSettings* system_settings = NULL;
		GSettings* _tmp4_;
		GSettings* _tmp5_;
		gchar* _tmp6_;
#line 137 "../src/Widgets/Terminal.vala"
		_tmp4_ = g_settings_new ("org.gnome.desktop.interface");
#line 137 "../src/Widgets/Terminal.vala"
		system_settings = _tmp4_;
#line 138 "../src/Widgets/Terminal.vala"
		_tmp5_ = system_settings;
#line 138 "../src/Widgets/Terminal.vala"
		_tmp6_ = g_settings_get_string (_tmp5_, "monospace-font-name");
#line 138 "../src/Widgets/Terminal.vala"
		_g_free0 (font_name);
#line 138 "../src/Widgets/Terminal.vala"
		font_name = _tmp6_;
#line 136 "../src/Widgets/Terminal.vala"
		_g_object_unref0 (system_settings);
#line 463 "Terminal.c"
	}
#line 141 "../src/Widgets/Terminal.vala"
	_tmp7_ = font_name;
#line 141 "../src/Widgets/Terminal.vala"
	_tmp8_ = pango_font_description_from_string (_tmp7_);
#line 141 "../src/Widgets/Terminal.vala"
	fd = _tmp8_;
#line 142 "../src/Widgets/Terminal.vala"
	_tmp9_ = self->priv->_terminal;
#line 142 "../src/Widgets/Terminal.vala"
	_tmp10_ = fd;
#line 142 "../src/Widgets/Terminal.vala"
	vte_terminal_set_font (_tmp9_, _tmp10_);
#line 144 "../src/Widgets/Terminal.vala"
	_tmp11_ = pantheon_terminal_settings;
#line 144 "../src/Widgets/Terminal.vala"
	audible_bell_setting = g_settings_get_boolean (_tmp11_, "audible-bell");
#line 145 "../src/Widgets/Terminal.vala"
	_tmp12_ = self->priv->_terminal;
#line 145 "../src/Widgets/Terminal.vala"
	vte_terminal_set_audible_bell (_tmp12_, audible_bell_setting);
#line 147 "../src/Widgets/Terminal.vala"
	_tmp13_ = pantheon_terminal_settings;
#line 147 "../src/Widgets/Terminal.vala"
	_tmp14_ = g_settings_get_string (_tmp13_, "cursor-shape");
#line 147 "../src/Widgets/Terminal.vala"
	cursor_shape_setting = _tmp14_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp15_ = cursor_shape_setting;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp16_ = _tmp15_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp18_ = (NULL == _tmp16_) ? 0 : g_quark_from_string (_tmp16_);
#line 149 "../src/Widgets/Terminal.vala"
	if (_tmp18_ == ((0 != _tmp17_label0) ? _tmp17_label0 : (_tmp17_label0 = g_quark_from_static_string ("Block")))) {
#line 149 "../src/Widgets/Terminal.vala"
		switch (0) {
#line 501 "Terminal.c"
			default:
			{
				VteTerminal* _tmp19_;
#line 151 "../src/Widgets/Terminal.vala"
				_tmp19_ = self->priv->_terminal;
#line 151 "../src/Widgets/Terminal.vala"
				vte_terminal_set_cursor_shape (_tmp19_, VTE_CURSOR_SHAPE_BLOCK);
#line 152 "../src/Widgets/Terminal.vala"
				break;
#line 511 "Terminal.c"
			}
		}
	} else if (_tmp18_ == ((0 != _tmp17_label1) ? _tmp17_label1 : (_tmp17_label1 = g_quark_from_static_string ("I-Beam")))) {
#line 149 "../src/Widgets/Terminal.vala"
		switch (0) {
#line 517 "Terminal.c"
			default:
			{
				VteTerminal* _tmp20_;
#line 154 "../src/Widgets/Terminal.vala"
				_tmp20_ = self->priv->_terminal;
#line 154 "../src/Widgets/Terminal.vala"
				vte_terminal_set_cursor_shape (_tmp20_, VTE_CURSOR_SHAPE_IBEAM);
#line 155 "../src/Widgets/Terminal.vala"
				break;
#line 527 "Terminal.c"
			}
		}
	} else if (_tmp18_ == ((0 != _tmp17_label2) ? _tmp17_label2 : (_tmp17_label2 = g_quark_from_static_string ("Underline")))) {
#line 149 "../src/Widgets/Terminal.vala"
		switch (0) {
#line 533 "Terminal.c"
			default:
			{
				VteTerminal* _tmp21_;
#line 157 "../src/Widgets/Terminal.vala"
				_tmp21_ = self->priv->_terminal;
#line 157 "../src/Widgets/Terminal.vala"
				vte_terminal_set_cursor_shape (_tmp21_, VTE_CURSOR_SHAPE_UNDERLINE);
#line 158 "../src/Widgets/Terminal.vala"
				break;
#line 543 "Terminal.c"
			}
		}
	}
#line 161 "../src/Widgets/Terminal.vala"
	_tmp22_ = pantheon_terminal_settings;
#line 161 "../src/Widgets/Terminal.vala"
	_tmp23_ = g_settings_get_string (_tmp22_, "background");
#line 161 "../src/Widgets/Terminal.vala"
	background_setting = _tmp23_;
#line 162 "../src/Widgets/Terminal.vala"
	memset (&background_color, 0, sizeof (GdkRGBA));
#line 163 "../src/Widgets/Terminal.vala"
	_tmp24_ = background_setting;
#line 163 "../src/Widgets/Terminal.vala"
	gdk_rgba_parse (&background_color, _tmp24_);
#line 165 "../src/Widgets/Terminal.vala"
	_tmp25_ = pantheon_terminal_settings;
#line 165 "../src/Widgets/Terminal.vala"
	_tmp26_ = g_settings_get_string (_tmp25_, "foreground");
#line 165 "../src/Widgets/Terminal.vala"
	foreground_setting = _tmp26_;
#line 166 "../src/Widgets/Terminal.vala"
	memset (&foreground_color, 0, sizeof (GdkRGBA));
#line 167 "../src/Widgets/Terminal.vala"
	_tmp27_ = foreground_setting;
#line 167 "../src/Widgets/Terminal.vala"
	gdk_rgba_parse (&foreground_color, _tmp27_);
#line 169 "../src/Widgets/Terminal.vala"
	_tmp28_ = pantheon_terminal_settings;
#line 169 "../src/Widgets/Terminal.vala"
	_tmp29_ = g_settings_get_string (_tmp28_, "palette");
#line 169 "../src/Widgets/Terminal.vala"
	palette_setting = _tmp29_;
#line 171 "../src/Widgets/Terminal.vala"
	_tmp30_ = g_strdup ("#000000");
#line 171 "../src/Widgets/Terminal.vala"
	_tmp31_ = g_strdup ("#FF6C60");
#line 171 "../src/Widgets/Terminal.vala"
	_tmp32_ = g_strdup ("#A8FF60");
#line 171 "../src/Widgets/Terminal.vala"
	_tmp33_ = g_strdup ("#FFFFCC");
#line 171 "../src/Widgets/Terminal.vala"
	_tmp34_ = g_strdup ("#96CBFE");
#line 171 "../src/Widgets/Terminal.vala"
	_tmp35_ = g_strdup ("#FF73FE");
#line 171 "../src/Widgets/Terminal.vala"
	_tmp36_ = g_strdup ("#C6C5FE");
#line 171 "../src/Widgets/Terminal.vala"
	_tmp37_ = g_strdup ("#EEEEEE");
#line 171 "../src/Widgets/Terminal.vala"
	_tmp38_ = g_strdup ("#000000");
#line 171 "../src/Widgets/Terminal.vala"
	_tmp39_ = g_strdup ("#FF6C60");
#line 171 "../src/Widgets/Terminal.vala"
	_tmp40_ = g_strdup ("#A8FF60");
#line 171 "../src/Widgets/Terminal.vala"
	_tmp41_ = g_strdup ("#FFFFB6");
#line 171 "../src/Widgets/Terminal.vala"
	_tmp42_ = g_strdup ("#96CBFE");
#line 171 "../src/Widgets/Terminal.vala"
	_tmp43_ = g_strdup ("#FF73FE");
#line 171 "../src/Widgets/Terminal.vala"
	_tmp44_ = g_strdup ("#C6C5FE");
#line 171 "../src/Widgets/Terminal.vala"
	_tmp45_ = g_strdup ("#EEEEEE");
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_ = g_new0 (gchar*, 16 + 1);
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_[0] = _tmp30_;
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_[1] = _tmp31_;
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_[2] = _tmp32_;
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_[3] = _tmp33_;
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_[4] = _tmp34_;
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_[5] = _tmp35_;
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_[6] = _tmp36_;
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_[7] = _tmp37_;
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_[8] = _tmp38_;
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_[9] = _tmp39_;
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_[10] = _tmp40_;
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_[11] = _tmp41_;
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_[12] = _tmp42_;
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_[13] = _tmp43_;
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_[14] = _tmp44_;
#line 171 "../src/Widgets/Terminal.vala"
	_tmp46_[15] = _tmp45_;
#line 171 "../src/Widgets/Terminal.vala"
	hex_palette = _tmp46_;
#line 171 "../src/Widgets/Terminal.vala"
	hex_palette_length1 = 16;
#line 171 "../src/Widgets/Terminal.vala"
	_hex_palette_size_ = hex_palette_length1;
#line 176 "../src/Widgets/Terminal.vala"
	_tmp47_ = g_strdup ("");
#line 176 "../src/Widgets/Terminal.vala"
	current_string = _tmp47_;
#line 177 "../src/Widgets/Terminal.vala"
	current_color = 0;
#line 655 "Terminal.c"
	{
		gint i = 0;
#line 178 "../src/Widgets/Terminal.vala"
		i = 0;
#line 660 "Terminal.c"
		{
			gboolean _tmp48_ = FALSE;
#line 178 "../src/Widgets/Terminal.vala"
			_tmp48_ = TRUE;
#line 178 "../src/Widgets/Terminal.vala"
			while (TRUE) {
#line 667 "Terminal.c"
				const gchar* _tmp50_;
				gint _tmp51_;
				gint _tmp52_;
				const gchar* _tmp53_;
#line 178 "../src/Widgets/Terminal.vala"
				if (!_tmp48_) {
#line 674 "Terminal.c"
					gint _tmp49_;
#line 178 "../src/Widgets/Terminal.vala"
					_tmp49_ = i;
#line 178 "../src/Widgets/Terminal.vala"
					i = _tmp49_ + 1;
#line 680 "Terminal.c"
				}
#line 178 "../src/Widgets/Terminal.vala"
				_tmp48_ = FALSE;
#line 178 "../src/Widgets/Terminal.vala"
				_tmp50_ = palette_setting;
#line 178 "../src/Widgets/Terminal.vala"
				_tmp51_ = strlen (_tmp50_);
#line 178 "../src/Widgets/Terminal.vala"
				_tmp52_ = _tmp51_;
#line 178 "../src/Widgets/Terminal.vala"
				if (!(i < _tmp52_)) {
#line 178 "../src/Widgets/Terminal.vala"
					break;
#line 694 "Terminal.c"
				}
#line 179 "../src/Widgets/Terminal.vala"
				_tmp53_ = palette_setting;
#line 179 "../src/Widgets/Terminal.vala"
				if (string_get (_tmp53_, (glong) i) == ':') {
#line 700 "Terminal.c"
					gchar** _tmp54_;
					gint _tmp54__length1;
					const gchar* _tmp55_;
					gchar* _tmp56_;
					gchar* _tmp57_;
					gint _tmp58_;
#line 180 "../src/Widgets/Terminal.vala"
					_tmp54_ = hex_palette;
#line 180 "../src/Widgets/Terminal.vala"
					_tmp54__length1 = hex_palette_length1;
#line 180 "../src/Widgets/Terminal.vala"
					_tmp55_ = current_string;
#line 180 "../src/Widgets/Terminal.vala"
					_tmp56_ = g_strdup (_tmp55_);
#line 180 "../src/Widgets/Terminal.vala"
					_g_free0 (_tmp54_[current_color]);
#line 180 "../src/Widgets/Terminal.vala"
					_tmp54_[current_color] = _tmp56_;
#line 181 "../src/Widgets/Terminal.vala"
					_tmp57_ = g_strdup ("");
#line 181 "../src/Widgets/Terminal.vala"
					_g_free0 (current_string);
#line 181 "../src/Widgets/Terminal.vala"
					current_string = _tmp57_;
#line 182 "../src/Widgets/Terminal.vala"
					_tmp58_ = current_color;
#line 182 "../src/Widgets/Terminal.vala"
					current_color = _tmp58_ + 1;
#line 729 "Terminal.c"
				} else {
					const gchar* _tmp59_;
					const gchar* _tmp60_;
					gchar* _tmp61_;
					gchar* _tmp62_;
					gchar* _tmp63_;
#line 184 "../src/Widgets/Terminal.vala"
					_tmp59_ = current_string;
#line 184 "../src/Widgets/Terminal.vala"
					_tmp60_ = palette_setting;
#line 184 "../src/Widgets/Terminal.vala"
					_tmp61_ = g_strdup_printf ("%c", string_get (_tmp60_, (glong) i));
#line 184 "../src/Widgets/Terminal.vala"
					_tmp62_ = _tmp61_;
#line 184 "../src/Widgets/Terminal.vala"
					_tmp63_ = g_strconcat (_tmp59_, _tmp62_, NULL);
#line 184 "../src/Widgets/Terminal.vala"
					_g_free0 (current_string);
#line 184 "../src/Widgets/Terminal.vala"
					current_string = _tmp63_;
#line 184 "../src/Widgets/Terminal.vala"
					_g_free0 (_tmp62_);
#line 752 "Terminal.c"
				}
			}
		}
	}
#line 188 "../src/Widgets/Terminal.vala"
	_tmp64_ = g_new0 (GdkRGBA, 16);
#line 188 "../src/Widgets/Terminal.vala"
	palette = _tmp64_;
#line 188 "../src/Widgets/Terminal.vala"
	palette_length1 = 16;
#line 188 "../src/Widgets/Terminal.vala"
	_palette_size_ = palette_length1;
#line 765 "Terminal.c"
	{
		gint i = 0;
#line 190 "../src/Widgets/Terminal.vala"
		i = 0;
#line 770 "Terminal.c"
		{
			gboolean _tmp65_ = FALSE;
#line 190 "../src/Widgets/Terminal.vala"
			_tmp65_ = TRUE;
#line 190 "../src/Widgets/Terminal.vala"
			while (TRUE) {
#line 777 "Terminal.c"
				gchar** _tmp67_;
				gint _tmp67__length1;
				GdkRGBA new_color = {0};
				gchar** _tmp68_;
				gint _tmp68__length1;
				const gchar* _tmp69_;
				GdkRGBA* _tmp70_;
				gint _tmp70__length1;
				GdkRGBA _tmp71_;
#line 190 "../src/Widgets/Terminal.vala"
				if (!_tmp65_) {
#line 789 "Terminal.c"
					gint _tmp66_;
#line 190 "../src/Widgets/Terminal.vala"
					_tmp66_ = i;
#line 190 "../src/Widgets/Terminal.vala"
					i = _tmp66_ + 1;
#line 795 "Terminal.c"
				}
#line 190 "../src/Widgets/Terminal.vala"
				_tmp65_ = FALSE;
#line 190 "../src/Widgets/Terminal.vala"
				_tmp67_ = hex_palette;
#line 190 "../src/Widgets/Terminal.vala"
				_tmp67__length1 = hex_palette_length1;
#line 190 "../src/Widgets/Terminal.vala"
				if (!(i < _tmp67__length1)) {
#line 190 "../src/Widgets/Terminal.vala"
					break;
#line 807 "Terminal.c"
				}
#line 191 "../src/Widgets/Terminal.vala"
				memset (&new_color, 0, sizeof (GdkRGBA));
#line 192 "../src/Widgets/Terminal.vala"
				_tmp68_ = hex_palette;
#line 192 "../src/Widgets/Terminal.vala"
				_tmp68__length1 = hex_palette_length1;
#line 192 "../src/Widgets/Terminal.vala"
				_tmp69_ = _tmp68_[i];
#line 192 "../src/Widgets/Terminal.vala"
				gdk_rgba_parse (&new_color, _tmp69_);
#line 193 "../src/Widgets/Terminal.vala"
				_tmp70_ = palette;
#line 193 "../src/Widgets/Terminal.vala"
				_tmp70__length1 = palette_length1;
#line 193 "../src/Widgets/Terminal.vala"
				_tmp71_ = new_color;
#line 193 "../src/Widgets/Terminal.vala"
				_tmp70_[i] = _tmp71_;
#line 827 "Terminal.c"
			}
		}
	}
#line 196 "../src/Widgets/Terminal.vala"
	_tmp72_ = self->priv->_terminal;
#line 196 "../src/Widgets/Terminal.vala"
	_tmp73_ = foreground_color;
#line 196 "../src/Widgets/Terminal.vala"
	_tmp74_ = background_color;
#line 196 "../src/Widgets/Terminal.vala"
	_tmp75_ = palette;
#line 196 "../src/Widgets/Terminal.vala"
	_tmp75__length1 = palette_length1;
#line 196 "../src/Widgets/Terminal.vala"
	vte_terminal_set_colors (_tmp72_, &_tmp73_, &_tmp74_, _tmp75_, (gsize) _tmp75__length1);
#line 132 "../src/Widgets/Terminal.vala"
	palette = (g_free (palette), NULL);
#line 132 "../src/Widgets/Terminal.vala"
	_g_free0 (current_string);
#line 132 "../src/Widgets/Terminal.vala"
	hex_palette = (_vala_array_free (hex_palette, hex_palette_length1, (GDestroyNotify) g_free), NULL);
#line 132 "../src/Widgets/Terminal.vala"
	_g_free0 (palette_setting);
#line 132 "../src/Widgets/Terminal.vala"
	_g_free0 (foreground_setting);
#line 132 "../src/Widgets/Terminal.vala"
	_g_free0 (background_setting);
#line 132 "../src/Widgets/Terminal.vala"
	_g_free0 (cursor_shape_setting);
#line 132 "../src/Widgets/Terminal.vala"
	__vala_PangoFontDescription_free0 (fd);
#line 132 "../src/Widgets/Terminal.vala"
	_g_free0 (font_name);
#line 132 "../src/Widgets/Terminal.vala"
	_g_object_unref0 (pantheon_terminal_settings);
#line 863 "Terminal.c"
}

void
code_terminal_increment_size (CodeTerminal* self)
{
	VteTerminal* _tmp0_;
	VteTerminal* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
#line 199 "../src/Widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 200 "../src/Widgets/Terminal.vala"
	_tmp0_ = self->priv->_terminal;
#line 200 "../src/Widgets/Terminal.vala"
	_tmp1_ = self->priv->_terminal;
#line 200 "../src/Widgets/Terminal.vala"
	_tmp2_ = vte_terminal_get_font_scale (_tmp1_);
#line 200 "../src/Widgets/Terminal.vala"
	_tmp3_ = _tmp2_;
#line 200 "../src/Widgets/Terminal.vala"
	vte_terminal_set_font_scale (_tmp0_, CLAMP (_tmp3_ + 0.1, CODE_TERMINAL_MIN_SCALE, CODE_TERMINAL_MAX_SCALE));
#line 885 "Terminal.c"
}

void
code_terminal_decrement_size (CodeTerminal* self)
{
	VteTerminal* _tmp0_;
	VteTerminal* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
#line 203 "../src/Widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 204 "../src/Widgets/Terminal.vala"
	_tmp0_ = self->priv->_terminal;
#line 204 "../src/Widgets/Terminal.vala"
	_tmp1_ = self->priv->_terminal;
#line 204 "../src/Widgets/Terminal.vala"
	_tmp2_ = vte_terminal_get_font_scale (_tmp1_);
#line 204 "../src/Widgets/Terminal.vala"
	_tmp3_ = _tmp2_;
#line 204 "../src/Widgets/Terminal.vala"
	vte_terminal_set_font_scale (_tmp0_, CLAMP (_tmp3_ - 0.1, CODE_TERMINAL_MIN_SCALE, CODE_TERMINAL_MAX_SCALE));
#line 907 "Terminal.c"
}

void
code_terminal_set_default_font_size (CodeTerminal* self)
{
	VteTerminal* _tmp0_;
#line 207 "../src/Widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/Widgets/Terminal.vala"
	_tmp0_ = self->priv->_terminal;
#line 208 "../src/Widgets/Terminal.vala"
	vte_terminal_set_font_scale (_tmp0_, 1.0);
#line 920 "Terminal.c"
}

CodeTerminal*
code_terminal_construct (GType object_type)
{
	CodeTerminal * self = NULL;
#line 7 "../src/Widgets/Terminal.vala"
	self = (CodeTerminal*) g_object_new (object_type, NULL);
#line 7 "../src/Widgets/Terminal.vala"
	return self;
#line 931 "Terminal.c"
}

CodeTerminal*
code_terminal_new (void)
{
#line 7 "../src/Widgets/Terminal.vala"
	return code_terminal_construct (CODE_TYPE_TERMINAL);
#line 939 "Terminal.c"
}

VteTerminal*
code_terminal_get_terminal (CodeTerminal* self)
{
	VteTerminal* result;
	VteTerminal* _tmp0_;
#line 18 "../src/Widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18 "../src/Widgets/Terminal.vala"
	_tmp0_ = self->priv->_terminal;
#line 18 "../src/Widgets/Terminal.vala"
	result = _tmp0_;
#line 18 "../src/Widgets/Terminal.vala"
	return result;
#line 955 "Terminal.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 18 "../src/Widgets/Terminal.vala"
	return self ? g_object_ref (self) : NULL;
#line 963 "Terminal.c"
}

static void
code_terminal_set_terminal (CodeTerminal* self,
                            VteTerminal* value)
{
	VteTerminal* old_value;
#line 18 "../src/Widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/Widgets/Terminal.vala"
	old_value = code_terminal_get_terminal (self);
#line 18 "../src/Widgets/Terminal.vala"
	if (old_value != value) {
#line 977 "Terminal.c"
		VteTerminal* _tmp0_;
#line 18 "../src/Widgets/Terminal.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 18 "../src/Widgets/Terminal.vala"
		_g_object_unref0 (self->priv->_terminal);
#line 18 "../src/Widgets/Terminal.vala"
		self->priv->_terminal = _tmp0_;
#line 18 "../src/Widgets/Terminal.vala"
		g_object_notify_by_pspec ((GObject *) self, code_terminal_properties[CODE_TERMINAL_TERMINAL_PROPERTY]);
#line 987 "Terminal.c"
	}
}

GSimpleActionGroup*
code_terminal_get_actions (CodeTerminal* self)
{
	GSimpleActionGroup* result;
	GSimpleActionGroup* _tmp0_;
#line 19 "../src/Widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19 "../src/Widgets/Terminal.vala"
	_tmp0_ = self->priv->_actions;
#line 19 "../src/Widgets/Terminal.vala"
	result = _tmp0_;
#line 19 "../src/Widgets/Terminal.vala"
	return result;
#line 1004 "Terminal.c"
}

static void
code_terminal_set_actions (CodeTerminal* self,
                           GSimpleActionGroup* value)
{
	GSimpleActionGroup* old_value;
#line 19 "../src/Widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/Widgets/Terminal.vala"
	old_value = code_terminal_get_actions (self);
#line 19 "../src/Widgets/Terminal.vala"
	if (old_value != value) {
#line 1018 "Terminal.c"
		GSimpleActionGroup* _tmp0_;
#line 19 "../src/Widgets/Terminal.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 19 "../src/Widgets/Terminal.vala"
		_g_object_unref0 (self->priv->_actions);
#line 19 "../src/Widgets/Terminal.vala"
		self->priv->_actions = _tmp0_;
#line 19 "../src/Widgets/Terminal.vala"
		g_object_notify_by_pspec ((GObject *) self, code_terminal_properties[CODE_TERMINAL_ACTIONS_PROPERTY]);
#line 1028 "Terminal.c"
	}
}

static Block41Data*
block41_data_ref (Block41Data* _data41_)
{
#line 24 "../src/Widgets/Terminal.vala"
	g_atomic_int_inc (&_data41_->_ref_count_);
#line 24 "../src/Widgets/Terminal.vala"
	return _data41_;
#line 1039 "Terminal.c"
}

static void
block41_data_unref (void * _userdata_)
{
	Block41Data* _data41_;
	_data41_ = (Block41Data*) _userdata_;
#line 24 "../src/Widgets/Terminal.vala"
	if (g_atomic_int_dec_and_test (&_data41_->_ref_count_)) {
#line 1049 "Terminal.c"
		CodeTerminal* self;
#line 24 "../src/Widgets/Terminal.vala"
		self = _data41_->self;
#line 24 "../src/Widgets/Terminal.vala"
		_g_object_unref0 (_data41_->settings);
#line 24 "../src/Widgets/Terminal.vala"
		_g_object_unref0 (_data41_->menu);
#line 24 "../src/Widgets/Terminal.vala"
		_g_object_unref0 (_data41_->paste_action);
#line 24 "../src/Widgets/Terminal.vala"
		_g_object_unref0 (_data41_->copy_action);
#line 24 "../src/Widgets/Terminal.vala"
		_g_object_unref0 (self);
#line 24 "../src/Widgets/Terminal.vala"
		g_slice_free (Block41Data, _data41_);
#line 1065 "Terminal.c"
	}
}

static gpointer
_g_settings_schema_source_ref0 (gpointer self)
{
#line 32 "../src/Widgets/Terminal.vala"
	return self ? g_settings_schema_source_ref (self) : NULL;
#line 1074 "Terminal.c"
}

static void
_code_terminal___lambda114_ (CodeTerminal* self)
{
	GApplication* _tmp0_;
#line 44 "../src/Widgets/Terminal.vala"
	_tmp0_ = g_application_get_default ();
#line 44 "../src/Widgets/Terminal.vala"
	g_action_group_activate_action ((GActionGroup*) _tmp0_, SCRATCH_MAIN_WINDOW_ACTION_PREFIX SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_TERMINAL, NULL);
#line 1085 "Terminal.c"
}

static void
__code_terminal___lambda114__vte_terminal_child_exited (VteTerminal* _sender,
                                                        gint status,
                                                        gpointer self)
{
#line 43 "../src/Widgets/Terminal.vala"
	_code_terminal___lambda114_ ((CodeTerminal*) self);
#line 1095 "Terminal.c"
}

static void
_code_terminal___lambda115_ (CodeTerminal* self)
{
	VteTerminal* _tmp0_;
#line 49 "../src/Widgets/Terminal.vala"
	_tmp0_ = self->priv->_terminal;
#line 49 "../src/Widgets/Terminal.vala"
	vte_terminal_copy_clipboard (_tmp0_);
#line 1106 "Terminal.c"
}

static void
__code_terminal___lambda115__g_simple_action_activate (GSimpleAction* _sender,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 49 "../src/Widgets/Terminal.vala"
	_code_terminal___lambda115_ ((CodeTerminal*) self);
#line 1116 "Terminal.c"
}

static void
_code_terminal___lambda116_ (CodeTerminal* self)
{
	VteTerminal* _tmp0_;
#line 52 "../src/Widgets/Terminal.vala"
	_tmp0_ = self->priv->_terminal;
#line 52 "../src/Widgets/Terminal.vala"
	vte_terminal_paste_clipboard (_tmp0_);
#line 1127 "Terminal.c"
}

static void
__code_terminal___lambda116__g_simple_action_activate (GSimpleAction* _sender,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 52 "../src/Widgets/Terminal.vala"
	_code_terminal___lambda116_ ((CodeTerminal*) self);
#line 1137 "Terminal.c"
}

static gboolean
_code_terminal___lambda117_ (Block41Data* _data41_,
                             GdkEventButton* event)
{
	CodeTerminal* self;
	gboolean result;
#line 66 "../src/Widgets/Terminal.vala"
	self = _data41_->self;
#line 66 "../src/Widgets/Terminal.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 67 "../src/Widgets/Terminal.vala"
	if (event->button == ((guint) 3)) {
#line 1152 "Terminal.c"
		GSimpleAction* _tmp0_;
		GtkClipboard* _tmp1_;
		GtkMenu* _tmp2_;
		GtkMenu* _tmp3_;
#line 68 "../src/Widgets/Terminal.vala"
		_tmp0_ = _data41_->paste_action;
#line 68 "../src/Widgets/Terminal.vala"
		_tmp1_ = self->priv->current_clipboard;
#line 68 "../src/Widgets/Terminal.vala"
		g_simple_action_set_enabled (_tmp0_, gtk_clipboard_wait_is_text_available (_tmp1_));
#line 69 "../src/Widgets/Terminal.vala"
		_tmp2_ = _data41_->menu;
#line 69 "../src/Widgets/Terminal.vala"
		gtk_menu_shell_select_first ((GtkMenuShell*) _tmp2_, FALSE);
#line 70 "../src/Widgets/Terminal.vala"
		_tmp3_ = _data41_->menu;
#line 70 "../src/Widgets/Terminal.vala"
		gtk_menu_popup_at_pointer (_tmp3_, (GdkEvent*) event);
#line 1171 "Terminal.c"
	}
#line 72 "../src/Widgets/Terminal.vala"
	result = FALSE;
#line 72 "../src/Widgets/Terminal.vala"
	return result;
#line 1177 "Terminal.c"
}

static gboolean
__code_terminal___lambda117__gtk_widget_button_press_event (GtkWidget* _sender,
                                                            GdkEventButton* event,
                                                            gpointer self)
{
	gboolean result;
	result = _code_terminal___lambda117_ (self, event);
#line 66 "../src/Widgets/Terminal.vala"
	return result;
#line 1189 "Terminal.c"
}

static void
_code_terminal___lambda118_ (Block41Data* _data41_)
{
	CodeTerminal* self;
	VteTerminal* _tmp0_;
	GtkClipboard* _tmp1_;
	GtkClipboard* _tmp2_;
	GSimpleAction* _tmp3_;
	VteTerminal* _tmp4_;
#line 75 "../src/Widgets/Terminal.vala"
	self = _data41_->self;
#line 76 "../src/Widgets/Terminal.vala"
	_tmp0_ = self->priv->_terminal;
#line 76 "../src/Widgets/Terminal.vala"
	_tmp1_ = gtk_widget_get_clipboard ((GtkWidget*) _tmp0_, GDK_SELECTION_CLIPBOARD);
#line 76 "../src/Widgets/Terminal.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 76 "../src/Widgets/Terminal.vala"
	_g_object_unref0 (self->priv->current_clipboard);
#line 76 "../src/Widgets/Terminal.vala"
	self->priv->current_clipboard = _tmp2_;
#line 77 "../src/Widgets/Terminal.vala"
	_tmp3_ = _data41_->copy_action;
#line 77 "../src/Widgets/Terminal.vala"
	_tmp4_ = self->priv->_terminal;
#line 77 "../src/Widgets/Terminal.vala"
	g_simple_action_set_enabled (_tmp3_, vte_terminal_get_has_selection (_tmp4_));
#line 1219 "Terminal.c"
}

static void
__code_terminal___lambda118__gtk_widget_realize (GtkWidget* _sender,
                                                 gpointer self)
{
#line 75 "../src/Widgets/Terminal.vala"
	_code_terminal___lambda118_ (self);
#line 1228 "Terminal.c"
}

static void
_code_terminal___lambda119_ (Block41Data* _data41_)
{
	CodeTerminal* self;
	GSimpleAction* _tmp0_;
	VteTerminal* _tmp1_;
#line 80 "../src/Widgets/Terminal.vala"
	self = _data41_->self;
#line 81 "../src/Widgets/Terminal.vala"
	_tmp0_ = _data41_->copy_action;
#line 81 "../src/Widgets/Terminal.vala"
	_tmp1_ = self->priv->_terminal;
#line 81 "../src/Widgets/Terminal.vala"
	g_simple_action_set_enabled (_tmp0_, vte_terminal_get_has_selection (_tmp1_));
#line 1245 "Terminal.c"
}

static void
__code_terminal___lambda119__vte_terminal_selection_changed (VteTerminal* _sender,
                                                             gpointer self)
{
#line 80 "../src/Widgets/Terminal.vala"
	_code_terminal___lambda119_ (self);
#line 1254 "Terminal.c"
}

static void
_code_terminal___lambda120_ (Block41Data* _data41_)
{
	CodeTerminal* self;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 92 "../src/Widgets/Terminal.vala"
	self = _data41_->self;
#line 93 "../src/Widgets/Terminal.vala"
	_tmp0_ = _data41_->settings;
#line 93 "../src/Widgets/Terminal.vala"
	_tmp1_ = code_terminal_get_shell_location (self);
#line 93 "../src/Widgets/Terminal.vala"
	_tmp2_ = _tmp1_;
#line 93 "../src/Widgets/Terminal.vala"
	g_settings_set_string (_tmp0_, "last-opened-path", _tmp2_);
#line 93 "../src/Widgets/Terminal.vala"
	_g_free0 (_tmp2_);
#line 1276 "Terminal.c"
}

static void
__code_terminal___lambda120__gtk_widget_destroy (GtkWidget* _sender,
                                                 gpointer self)
{
#line 92 "../src/Widgets/Terminal.vala"
	_code_terminal___lambda120_ (self);
#line 1285 "Terminal.c"
}

static GObject *
code_terminal_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CodeTerminal * self;
	Block41Data* _data41_;
	VteTerminal* _tmp0_ = NULL;
	VteTerminal* _tmp1_;
	GSettingsSchemaSource* schema_source = NULL;
	GSettingsSchemaSource* _tmp2_;
	GSettingsSchemaSource* _tmp3_;
	GSettingsSchema* terminal_schema = NULL;
	GSettingsSchemaSource* _tmp4_;
	GSettingsSchema* _tmp5_;
	GSettingsSchema* _tmp6_;
	VteTerminal* _tmp10_;
	GSimpleAction* _tmp11_;
	GSimpleAction* _tmp12_;
	GSimpleAction* _tmp13_;
	GSimpleAction* _tmp14_;
	GSimpleAction* _tmp15_;
	GSimpleActionGroup* _tmp16_;
	GSimpleActionGroup* _tmp17_;
	GSimpleActionGroup* _tmp18_;
	GSimpleAction* _tmp19_;
	GSimpleActionGroup* _tmp20_;
	GSimpleAction* _tmp21_;
	GMenu* menu_model = NULL;
	GMenu* _tmp22_;
	GMenu* _tmp23_;
	GMenu* _tmp24_;
	GMenu* _tmp25_;
	GtkMenu* _tmp26_;
	GtkMenu* _tmp27_;
	GSimpleActionGroup* _tmp28_;
	GtkMenu* _tmp29_;
	VteTerminal* _tmp30_;
	VteTerminal* _tmp31_;
	GSettings* _tmp32_;
	GSettings* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	GtkScrolledWindow* scrolled_window = NULL;
	VteTerminal* _tmp36_;
	GtkAdjustment* _tmp37_;
	GtkScrolledWindow* _tmp38_;
	GtkScrolledWindow* _tmp39_;
	VteTerminal* _tmp40_;
	GtkScrolledWindow* _tmp41_;
#line 24 "../src/Widgets/Terminal.vala"
	parent_class = G_OBJECT_CLASS (code_terminal_parent_class);
#line 24 "../src/Widgets/Terminal.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 24 "../src/Widgets/Terminal.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CODE_TYPE_TERMINAL, CodeTerminal);
#line 24 "../src/Widgets/Terminal.vala"
	_data41_ = g_slice_new0 (Block41Data);
#line 24 "../src/Widgets/Terminal.vala"
	_data41_->_ref_count_ = 1;
#line 24 "../src/Widgets/Terminal.vala"
	_data41_->self = g_object_ref (self);
#line 25 "../src/Widgets/Terminal.vala"
	_tmp0_ = (VteTerminal*) vte_terminal_new ();
#line 25 "../src/Widgets/Terminal.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp0_, TRUE);
#line 25 "../src/Widgets/Terminal.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp0_, TRUE);
#line 25 "../src/Widgets/Terminal.vala"
	vte_terminal_set_scrollback_lines (_tmp0_, (guint) -1);
#line 25 "../src/Widgets/Terminal.vala"
	g_object_ref_sink (_tmp0_);
#line 25 "../src/Widgets/Terminal.vala"
	_tmp1_ = _tmp0_;
#line 25 "../src/Widgets/Terminal.vala"
	code_terminal_set_terminal (self, _tmp1_);
#line 25 "../src/Widgets/Terminal.vala"
	_g_object_unref0 (_tmp1_);
#line 32 "../src/Widgets/Terminal.vala"
	_tmp2_ = g_settings_schema_source_get_default ();
#line 32 "../src/Widgets/Terminal.vala"
	_tmp3_ = _g_settings_schema_source_ref0 (_tmp2_);
#line 32 "../src/Widgets/Terminal.vala"
	schema_source = _tmp3_;
#line 33 "../src/Widgets/Terminal.vala"
	_tmp4_ = schema_source;
#line 33 "../src/Widgets/Terminal.vala"
	_tmp5_ = g_settings_schema_source_lookup (_tmp4_, CODE_TERMINAL_SETTINGS_SCHEMA, TRUE);
#line 33 "../src/Widgets/Terminal.vala"
	terminal_schema = _tmp5_;
#line 34 "../src/Widgets/Terminal.vala"
	_tmp6_ = terminal_schema;
#line 34 "../src/Widgets/Terminal.vala"
	if (_tmp6_ != NULL) {
#line 35 "../src/Widgets/Terminal.vala"
		code_terminal_update_terminal_settings (self, CODE_TERMINAL_SETTINGS_SCHEMA);
#line 1386 "Terminal.c"
	} else {
		GSettingsSchema* legacy_terminal_schema = NULL;
		GSettingsSchemaSource* _tmp7_;
		GSettingsSchema* _tmp8_;
		GSettingsSchema* _tmp9_;
#line 37 "../src/Widgets/Terminal.vala"
		_tmp7_ = schema_source;
#line 37 "../src/Widgets/Terminal.vala"
		_tmp8_ = g_settings_schema_source_lookup (_tmp7_, CODE_TERMINAL_LEGACY_SETTINGS_SCHEMA, TRUE);
#line 37 "../src/Widgets/Terminal.vala"
		legacy_terminal_schema = _tmp8_;
#line 38 "../src/Widgets/Terminal.vala"
		_tmp9_ = legacy_terminal_schema;
#line 38 "../src/Widgets/Terminal.vala"
		if (_tmp9_ != NULL) {
#line 39 "../src/Widgets/Terminal.vala"
			code_terminal_update_terminal_settings (self, CODE_TERMINAL_LEGACY_SETTINGS_SCHEMA);
#line 1404 "Terminal.c"
		}
#line 34 "../src/Widgets/Terminal.vala"
		_g_settings_schema_unref0 (legacy_terminal_schema);
#line 1408 "Terminal.c"
	}
#line 43 "../src/Widgets/Terminal.vala"
	_tmp10_ = self->priv->_terminal;
#line 43 "../src/Widgets/Terminal.vala"
	g_signal_connect_object (_tmp10_, "child-exited", (GCallback) __code_terminal___lambda114__vte_terminal_child_exited, self, 0);
#line 47 "../src/Widgets/Terminal.vala"
	_tmp11_ = g_simple_action_new (CODE_TERMINAL_ACTION_COPY, NULL);
#line 47 "../src/Widgets/Terminal.vala"
	_data41_->copy_action = _tmp11_;
#line 48 "../src/Widgets/Terminal.vala"
	_tmp12_ = _data41_->copy_action;
#line 48 "../src/Widgets/Terminal.vala"
	g_simple_action_set_enabled (_tmp12_, FALSE);
#line 49 "../src/Widgets/Terminal.vala"
	_tmp13_ = _data41_->copy_action;
#line 49 "../src/Widgets/Terminal.vala"
	g_signal_connect_object (_tmp13_, "activate", (GCallback) __code_terminal___lambda115__g_simple_action_activate, self, 0);
#line 51 "../src/Widgets/Terminal.vala"
	_tmp14_ = g_simple_action_new (CODE_TERMINAL_ACTION_PASTE, NULL);
#line 51 "../src/Widgets/Terminal.vala"
	_data41_->paste_action = _tmp14_;
#line 52 "../src/Widgets/Terminal.vala"
	_tmp15_ = _data41_->paste_action;
#line 52 "../src/Widgets/Terminal.vala"
	g_signal_connect_object (_tmp15_, "activate", (GCallback) __code_terminal___lambda116__g_simple_action_activate, self, 0);
#line 54 "../src/Widgets/Terminal.vala"
	_tmp16_ = g_simple_action_group_new ();
#line 54 "../src/Widgets/Terminal.vala"
	_tmp17_ = _tmp16_;
#line 54 "../src/Widgets/Terminal.vala"
	code_terminal_set_actions (self, _tmp17_);
#line 54 "../src/Widgets/Terminal.vala"
	_g_object_unref0 (_tmp17_);
#line 55 "../src/Widgets/Terminal.vala"
	_tmp18_ = self->priv->_actions;
#line 55 "../src/Widgets/Terminal.vala"
	_tmp19_ = _data41_->copy_action;
#line 55 "../src/Widgets/Terminal.vala"
	g_action_map_add_action ((GActionMap*) _tmp18_, (GAction*) _tmp19_);
#line 56 "../src/Widgets/Terminal.vala"
	_tmp20_ = self->priv->_actions;
#line 56 "../src/Widgets/Terminal.vala"
	_tmp21_ = _data41_->paste_action;
#line 56 "../src/Widgets/Terminal.vala"
	g_action_map_add_action ((GActionMap*) _tmp20_, (GAction*) _tmp21_);
#line 58 "../src/Widgets/Terminal.vala"
	_tmp22_ = g_menu_new ();
#line 58 "../src/Widgets/Terminal.vala"
	menu_model = _tmp22_;
#line 59 "../src/Widgets/Terminal.vala"
	_tmp23_ = menu_model;
#line 59 "../src/Widgets/Terminal.vala"
	g_menu_append (_tmp23_, _ ("Copy"), CODE_TERMINAL_ACTION_PREFIX CODE_TERMINAL_ACTION_COPY);
#line 60 "../src/Widgets/Terminal.vala"
	_tmp24_ = menu_model;
#line 60 "../src/Widgets/Terminal.vala"
	g_menu_append (_tmp24_, _ ("Paste"), CODE_TERMINAL_ACTION_PREFIX CODE_TERMINAL_ACTION_PASTE);
#line 62 "../src/Widgets/Terminal.vala"
	_tmp25_ = menu_model;
#line 62 "../src/Widgets/Terminal.vala"
	_tmp26_ = (GtkMenu*) gtk_menu_new_from_model ((GMenuModel*) _tmp25_);
#line 62 "../src/Widgets/Terminal.vala"
	g_object_ref_sink (_tmp26_);
#line 62 "../src/Widgets/Terminal.vala"
	_data41_->menu = _tmp26_;
#line 63 "../src/Widgets/Terminal.vala"
	_tmp27_ = _data41_->menu;
#line 63 "../src/Widgets/Terminal.vala"
	_tmp28_ = self->priv->_actions;
#line 63 "../src/Widgets/Terminal.vala"
	gtk_widget_insert_action_group ((GtkWidget*) _tmp27_, CODE_TERMINAL_ACTION_GROUP, (GActionGroup*) _tmp28_);
#line 64 "../src/Widgets/Terminal.vala"
	_tmp29_ = _data41_->menu;
#line 64 "../src/Widgets/Terminal.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp29_);
#line 66 "../src/Widgets/Terminal.vala"
	_tmp30_ = self->priv->_terminal;
#line 66 "../src/Widgets/Terminal.vala"
	g_signal_connect_data ((GtkWidget*) _tmp30_, "button-press-event", (GCallback) __code_terminal___lambda117__gtk_widget_button_press_event, block41_data_ref (_data41_), (GClosureNotify) block41_data_unref, 0);
#line 75 "../src/Widgets/Terminal.vala"
	g_signal_connect_data ((GtkWidget*) self, "realize", (GCallback) __code_terminal___lambda118__gtk_widget_realize, block41_data_ref (_data41_), (GClosureNotify) block41_data_unref, 0);
#line 80 "../src/Widgets/Terminal.vala"
	_tmp31_ = self->priv->_terminal;
#line 80 "../src/Widgets/Terminal.vala"
	g_signal_connect_data (_tmp31_, "selection-changed", (GCallback) __code_terminal___lambda119__vte_terminal_selection_changed, block41_data_ref (_data41_), (GClosureNotify) block41_data_unref, 0);
#line 84 "../src/Widgets/Terminal.vala"
	_tmp32_ = g_settings_new (CONSTANTS_PROJECT_NAME ".saved-state");
#line 84 "../src/Widgets/Terminal.vala"
	_data41_->settings = _tmp32_;
#line 85 "../src/Widgets/Terminal.vala"
	_tmp33_ = _data41_->settings;
#line 85 "../src/Widgets/Terminal.vala"
	_tmp34_ = g_settings_get_string (_tmp33_, "last-opened-path");
#line 85 "../src/Widgets/Terminal.vala"
	_tmp35_ = _tmp34_;
#line 85 "../src/Widgets/Terminal.vala"
	code_terminal_spawn_shell (self, _tmp35_);
#line 85 "../src/Widgets/Terminal.vala"
	_g_free0 (_tmp35_);
#line 87 "../src/Widgets/Terminal.vala"
	_tmp36_ = self->priv->_terminal;
#line 87 "../src/Widgets/Terminal.vala"
	_tmp37_ = gtk_scrollable_get_vadjustment ((GtkScrollable*) _tmp36_);
#line 87 "../src/Widgets/Terminal.vala"
	_tmp38_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, _tmp37_);
#line 87 "../src/Widgets/Terminal.vala"
	g_object_ref_sink (_tmp38_);
#line 87 "../src/Widgets/Terminal.vala"
	scrolled_window = _tmp38_;
#line 88 "../src/Widgets/Terminal.vala"
	_tmp39_ = scrolled_window;
#line 88 "../src/Widgets/Terminal.vala"
	_tmp40_ = self->priv->_terminal;
#line 88 "../src/Widgets/Terminal.vala"
	gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp40_);
#line 90 "../src/Widgets/Terminal.vala"
	_tmp41_ = scrolled_window;
#line 90 "../src/Widgets/Terminal.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp41_);
#line 92 "../src/Widgets/Terminal.vala"
	g_signal_connect_data ((GtkWidget*) self, "destroy", (GCallback) __code_terminal___lambda120__gtk_widget_destroy, block41_data_ref (_data41_), (GClosureNotify) block41_data_unref, 0);
#line 96 "../src/Widgets/Terminal.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 24 "../src/Widgets/Terminal.vala"
	_g_object_unref0 (scrolled_window);
#line 24 "../src/Widgets/Terminal.vala"
	_g_object_unref0 (menu_model);
#line 24 "../src/Widgets/Terminal.vala"
	_g_settings_schema_unref0 (terminal_schema);
#line 24 "../src/Widgets/Terminal.vala"
	_g_settings_schema_source_unref0 (schema_source);
#line 24 "../src/Widgets/Terminal.vala"
	block41_data_unref (_data41_);
#line 24 "../src/Widgets/Terminal.vala"
	_data41_ = NULL;
#line 24 "../src/Widgets/Terminal.vala"
	return obj;
#line 1546 "Terminal.c"
}

static void
code_terminal_class_init (CodeTerminalClass * klass,
                          gpointer klass_data)
{
#line 7 "../src/Widgets/Terminal.vala"
	code_terminal_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/Widgets/Terminal.vala"
	g_type_class_adjust_private_offset (klass, &CodeTerminal_private_offset);
#line 7 "../src/Widgets/Terminal.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_code_terminal_get_property;
#line 7 "../src/Widgets/Terminal.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_code_terminal_set_property;
#line 7 "../src/Widgets/Terminal.vala"
	G_OBJECT_CLASS (klass)->constructor = code_terminal_constructor;
#line 7 "../src/Widgets/Terminal.vala"
	G_OBJECT_CLASS (klass)->finalize = code_terminal_finalize;
#line 7 "../src/Widgets/Terminal.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CODE_TERMINAL_TERMINAL_PROPERTY, code_terminal_properties[CODE_TERMINAL_TERMINAL_PROPERTY] = g_param_spec_object ("terminal", "terminal", "terminal", vte_terminal_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 7 "../src/Widgets/Terminal.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CODE_TERMINAL_ACTIONS_PROPERTY, code_terminal_properties[CODE_TERMINAL_ACTIONS_PROPERTY] = g_param_spec_object ("actions", "actions", "actions", g_simple_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1569 "Terminal.c"
}

static void
code_terminal_instance_init (CodeTerminal * self,
                             gpointer klass)
{
#line 7 "../src/Widgets/Terminal.vala"
	self->priv = code_terminal_get_instance_private (self);
#line 1578 "Terminal.c"
}

static void
code_terminal_finalize (GObject * obj)
{
	CodeTerminal * self;
#line 7 "../src/Widgets/Terminal.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CODE_TYPE_TERMINAL, CodeTerminal);
#line 18 "../src/Widgets/Terminal.vala"
	_g_object_unref0 (self->priv->_terminal);
#line 19 "../src/Widgets/Terminal.vala"
	_g_object_unref0 (self->priv->_actions);
#line 22 "../src/Widgets/Terminal.vala"
	_g_object_unref0 (self->priv->current_clipboard);
#line 7 "../src/Widgets/Terminal.vala"
	G_OBJECT_CLASS (code_terminal_parent_class)->finalize (obj);
#line 1595 "Terminal.c"
}

static GType
code_terminal_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CodeTerminalClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) code_terminal_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CodeTerminal), 0, (GInstanceInitFunc) code_terminal_instance_init, NULL };
	GType code_terminal_type_id;
	code_terminal_type_id = g_type_register_static (gtk_box_get_type (), "CodeTerminal", &g_define_type_info, 0);
	CodeTerminal_private_offset = g_type_add_instance_private (code_terminal_type_id, sizeof (CodeTerminalPrivate));
	return code_terminal_type_id;
}

GType
code_terminal_get_type (void)
{
	static volatile gsize code_terminal_type_id__once = 0;
	if (g_once_init_enter (&code_terminal_type_id__once)) {
		GType code_terminal_type_id;
		code_terminal_type_id = code_terminal_get_type_once ();
		g_once_init_leave (&code_terminal_type_id__once, code_terminal_type_id);
	}
	return code_terminal_type_id__once;
}

static void
_vala_code_terminal_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	CodeTerminal * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CODE_TYPE_TERMINAL, CodeTerminal);
#line 7 "../src/Widgets/Terminal.vala"
	switch (property_id) {
#line 7 "../src/Widgets/Terminal.vala"
		case CODE_TERMINAL_TERMINAL_PROPERTY:
#line 7 "../src/Widgets/Terminal.vala"
		g_value_set_object (value, code_terminal_get_terminal (self));
#line 7 "../src/Widgets/Terminal.vala"
		break;
#line 7 "../src/Widgets/Terminal.vala"
		case CODE_TERMINAL_ACTIONS_PROPERTY:
#line 7 "../src/Widgets/Terminal.vala"
		g_value_set_object (value, code_terminal_get_actions (self));
#line 7 "../src/Widgets/Terminal.vala"
		break;
#line 1642 "Terminal.c"
		default:
#line 7 "../src/Widgets/Terminal.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/Widgets/Terminal.vala"
		break;
#line 1648 "Terminal.c"
	}
}

static void
_vala_code_terminal_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	CodeTerminal * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CODE_TYPE_TERMINAL, CodeTerminal);
#line 7 "../src/Widgets/Terminal.vala"
	switch (property_id) {
#line 7 "../src/Widgets/Terminal.vala"
		case CODE_TERMINAL_TERMINAL_PROPERTY:
#line 7 "../src/Widgets/Terminal.vala"
		code_terminal_set_terminal (self, g_value_get_object (value));
#line 7 "../src/Widgets/Terminal.vala"
		break;
#line 7 "../src/Widgets/Terminal.vala"
		case CODE_TERMINAL_ACTIONS_PROPERTY:
#line 7 "../src/Widgets/Terminal.vala"
		code_terminal_set_actions (self, g_value_get_object (value));
#line 7 "../src/Widgets/Terminal.vala"
		break;
#line 1674 "Terminal.c"
		default:
#line 7 "../src/Widgets/Terminal.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/Widgets/Terminal.vala"
		break;
#line 1680 "Terminal.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 181 "../src/Services/TemplateManager.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1691 "Terminal.c"
		gssize i;
#line 181 "../src/Services/TemplateManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 181 "../src/Services/TemplateManager.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 181 "../src/Services/TemplateManager.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1699 "Terminal.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 181 "../src/Services/TemplateManager.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 181 "../src/Services/TemplateManager.vala"
	g_free (array);
#line 1714 "Terminal.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 181 "../src/Services/TemplateManager.vala"
	if (mem && byte_size != 0) {
#line 181 "../src/Services/TemplateManager.vala"
		new_mem = g_malloc (byte_size);
#line 181 "../src/Services/TemplateManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 1728 "Terminal.c"
	} else {
#line 181 "../src/Services/TemplateManager.vala"
		new_mem = NULL;
#line 1732 "Terminal.c"
	}
#line 181 "../src/Services/TemplateManager.vala"
	return new_mem;
#line 1736 "Terminal.c"
}

