/* fuzzy-search-indexer.c generated by valac 0.56.18, the Vala compiler
 * generated from fuzzy-search-indexer.vala, do not modify */

/*
* SPDX-License-Identifier: GPL-3.0-or-later
* SPDX-FileCopyrightText: 2023 elementary, Inc. <https://elementary.io>
*
* Authored by: Colin Kiama <colinkiama@gmail.com>
*/

#include <glib.h>
#include "fuzzy-search.h"
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include "codecore.h"

#define SECONDS_IN_MICROSECONDS ((glong) 1000000)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	INITIAL_INDEX_REQUEST_0_PROPERTY,
	INITIAL_INDEX_REQUEST_MESSAGE_TYPE_PROPERTY,
	INITIAL_INDEX_REQUEST_PROJECT_PATH_PROPERTY,
	INITIAL_INDEX_REQUEST_NUM_PROPERTIES
};
static GParamSpec* initial_index_request_properties[INITIAL_INDEX_REQUEST_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	PROJECT_UPDATE_0_PROPERTY,
	PROJECT_UPDATE_MESSAGE_TYPE_PROPERTY,
	PROJECT_UPDATE_UPDATE_TYPE_PROPERTY,
	PROJECT_UPDATE_SOURCE_PATH_PROPERTY,
	PROJECT_UPDATE_DESTINATION_PATH_PROPERTY,
	PROJECT_UPDATE_PROJECT_PATH_PROPERTY,
	PROJECT_UPDATE_NUM_PROPERTIES
};
static GParamSpec* project_update_properties[PROJECT_UPDATE_NUM_PROPERTIES];
enum  {
	SCRATCH_SERVICES_FUZZY_SEARCH_INDEXER_0_PROPERTY,
	SCRATCH_SERVICES_FUZZY_SEARCH_INDEXER_PROJECT_PATHS_PROPERTY,
	SCRATCH_SERVICES_FUZZY_SEARCH_INDEXER_NUM_PROPERTIES
};
static GParamSpec* scratch_services_fuzzy_search_indexer_properties[SCRATCH_SERVICES_FUZZY_SEARCH_INDEXER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _ScratchServicesFuzzySearchIndexerStartAsyncData ScratchServicesFuzzySearchIndexerStartAsyncData;
typedef struct _ScratchServicesFuzzySearchIndexerProcessNextMessageAsyncData ScratchServicesFuzzySearchIndexerProcessNextMessageAsyncData;
typedef struct _Block5Data Block5Data;
typedef struct _ScratchServicesFuzzySearchIndexerProcessProjectUpdateAsyncData ScratchServicesFuzzySearchIndexerProcessProjectUpdateAsyncData;
#define _scratch_services_search_project_unref0(var) ((var == NULL) ? NULL : (var = (scratch_services_search_project_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
typedef struct _ScratchServicesFuzzySearchIndexerAddDirectoryAsyncData ScratchServicesFuzzySearchIndexerAddDirectoryAsyncData;
typedef struct _Block7Data Block7Data;
typedef struct _ScratchServicesFuzzySearchIndexerAddProjectAsyncData ScratchServicesFuzzySearchIndexerAddProjectAsyncData;
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
typedef struct _ScratchServicesFuzzySearchIndexerProcessInitialIndexingRequestsAsyncData ScratchServicesFuzzySearchIndexerProcessInitialIndexingRequestsAsyncData;

struct _InitialIndexRequestPrivate {
	IndexerMessageType _message_type;
	gchar* _project_path;
};

struct _ProjectUpdatePrivate {
	IndexerMessageType _message_type;
	ProjectUpdateType _update_type;
	gchar* _source_path;
	gchar* _destination_path;
	gchar* _project_path;
};

struct _ScratchServicesFuzzySearchIndexerPrivate {
	GeeHashMap* _project_paths;
	GeeArrayList* initial_indexing_queue;
	GSettings* folder_settings;
	GCancellable* cancellable;
	GeeConcurrentList* processing_queue;
	IndexerStatus status;
};

struct _Block3Data {
	int _ref_count_;
	ScratchServicesFuzzySearchIndexer* self;
	gpointer _async_data_;
};

struct _Block4Data {
	int _ref_count_;
	Block3Data * _data3_;
	IndexerMessage* first_item;
};

struct _ScratchServicesFuzzySearchIndexerStartAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ScratchServicesFuzzySearchIndexer* self;
	Block3Data* _data3_;
	gchar** initial_projects;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint initial_projects_length1;
	gint _initial_projects_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** path_collection;
	gint path_collection_length1;
	gint _path_collection_size_;
	gint path_it;
	const gchar* path;
	GeeArrayList* _tmp5_;
	const gchar* _tmp6_;
	InitialIndexRequest* _tmp7_;
	InitialIndexRequest* _tmp8_;
	GThread* _tmp9_;
	GThread* _tmp10_;
};

struct _ScratchServicesFuzzySearchIndexerProcessNextMessageAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ScratchServicesFuzzySearchIndexer* self;
	IndexerMessage* message;
	IndexerMessageType _tmp0_;
	IndexerMessageType _tmp1_;
};

struct _Block5Data {
	int _ref_count_;
	ScratchServicesFuzzySearchIndexer* self;
	ProjectUpdate* message;
	gpointer _async_data_;
};

struct _ScratchServicesFuzzySearchIndexerProcessProjectUpdateAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ScratchServicesFuzzySearchIndexer* self;
	ProjectUpdate* message;
	Block5Data* _data5_;
	ProjectUpdateType _tmp0_;
	ProjectUpdateType _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
};

struct _Block6Data {
	int _ref_count_;
	ScratchServicesFuzzySearchIndexer* self;
	ScratchServicesSearchProject* project_search;
	ProjectUpdate* message;
	gpointer _async_data_;
};

struct _ScratchServicesFuzzySearchIndexerAddDirectoryAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ScratchServicesFuzzySearchIndexer* self;
	ProjectUpdate* message;
	Block6Data* _data6_;
	gchar* path;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* project_key;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	GeeHashMap* _tmp6_;
	const gchar* _tmp7_;
	gpointer _tmp8_;
	ScratchServicesSearchProject* _tmp9_;
	const gchar* _tmp10_;
	GCancellable* _tmp11_;
};

struct _Block7Data {
	int _ref_count_;
	ScratchServicesFuzzySearchIndexer* self;
	ScratchServicesSearchProject* project_search;
	ProjectUpdate* message;
	gpointer _async_data_;
};

struct _ScratchServicesFuzzySearchIndexerAddProjectAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ScratchServicesFuzzySearchIndexer* self;
	ProjectUpdate* message;
	Block7Data* _data7_;
	gchar* path;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	ScratchServicesMonitoredRepository* monitor;
	ScratchServicesMonitoredRepository* _tmp3_;
	ScratchServicesSearchProject* _tmp4_;
	GeeHashMap* _tmp5_;
	GCancellable* _tmp6_;
};

struct _Block8Data {
	int _ref_count_;
	ScratchServicesFuzzySearchIndexer* self;
	GeeArrayList* request_queue;
	gpointer _async_data_;
};

struct _Block9Data {
	int _ref_count_;
	Block8Data * _data8_;
	InitialIndexRequest* request;
	ScratchServicesSearchProject* project_search;
};

struct _ScratchServicesFuzzySearchIndexerProcessInitialIndexingRequestsAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ScratchServicesFuzzySearchIndexer* self;
	GeeArrayList* request_queue;
	GeeHashMap* project_paths;
	Block8Data* _data8_;
	gint i;
	gboolean _tmp0_;
	Block9Data* _data9_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gpointer _tmp4_;
	ScratchServicesMonitoredRepository* monitor;
	InitialIndexRequest* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	ScratchServicesMonitoredRepository* _tmp8_;
	InitialIndexRequest* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	ScratchServicesMonitoredRepository* _tmp12_;
	ScratchServicesSearchProject* _tmp13_;
	InitialIndexRequest* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	ScratchServicesSearchProject* _tmp17_;
	ScratchServicesSearchProject* _tmp18_;
	InitialIndexRequest* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GCancellable* _tmp22_;
};

static GType indexer_message_type_id = 0;
static gint InitialIndexRequest_private_offset;
static gpointer initial_index_request_parent_class = NULL;
static IndexerMessageIface * initial_index_request_indexer_message_parent_iface = NULL;
static GType initial_index_request_type_id = 0;
static gint ProjectUpdate_private_offset;
static gpointer project_update_parent_class = NULL;
static IndexerMessageIface * project_update_indexer_message_parent_iface = NULL;
static GType project_update_type_id = 0;
static gint ScratchServicesFuzzySearchIndexer_private_offset;
static gpointer scratch_services_fuzzy_search_indexer_parent_class = NULL;
static GType scratch_services_fuzzy_search_indexer_type_id = 0;

static void initial_index_request_finalize (GObject * obj);
static void _vala_initial_index_request_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_initial_index_request_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void project_update_finalize (GObject * obj);
static void _vala_project_update_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_project_update_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void scratch_services_fuzzy_search_indexer_set_project_paths (ScratchServicesFuzzySearchIndexer* self,
                                                              GeeHashMap* value);
static void scratch_services_fuzzy_search_indexer_handle_opened_projects_change (ScratchServicesFuzzySearchIndexer* self);
static void _scratch_services_fuzzy_search_indexer_handle_opened_projects_change_g_settings_changed (GSettings* _sender,
                                                                                              const gchar* key,
                                                                                              gpointer self);
static void scratch_services_fuzzy_search_indexer_start_async_data_free (gpointer _data);
static gboolean scratch_services_fuzzy_search_indexer_start_async_co (ScratchServicesFuzzySearchIndexerStartAsyncData* _data_);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda8_ (Block3Data* _data3_);
static void scratch_services_fuzzy_search_indexer_process_initial_indexing_requests_async (ScratchServicesFuzzySearchIndexer* self,
                                                                                    GeeArrayList* request_queue,
                                                                                    GeeHashMap* project_paths,
                                                                                    GAsyncReadyCallback _callback_,
                                                                                    gpointer _user_data_);
static void scratch_services_fuzzy_search_indexer_process_initial_indexing_requests_finish (ScratchServicesFuzzySearchIndexer* self,
                                                                                     GAsyncResult* _res_);
static void _____lambda10_ (ScratchServicesFuzzySearchIndexer* self,
                     GObject* obj,
                     GAsyncResult* res);
static void ______lambda10__gasync_ready_callback (GObject* source_object,
                                            GAsyncResult* res,
                                            gpointer self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void scratch_services_fuzzy_search_indexer_process_next_message_async (ScratchServicesFuzzySearchIndexer* self,
                                                                       IndexerMessage* message,
                                                                       GAsyncReadyCallback _callback_,
                                                                       gpointer _user_data_);
static void scratch_services_fuzzy_search_indexer_process_next_message_finish (ScratchServicesFuzzySearchIndexer* self,
                                                                        GAsyncResult* _res_);
static void _____lambda16_ (Block4Data* _data4_,
                     GObject* obj,
                     GAsyncResult* res);
static void ______lambda16__gasync_ready_callback (GObject* source_object,
                                            GAsyncResult* res,
                                            gpointer self);
static gboolean _scratch_services_fuzzy_search_indexer_start_async_co_gsource_func (gpointer self);
static gpointer ___lambda8__gthread_func (gpointer self);
static void scratch_services_fuzzy_search_indexer_process_next_message_async_data_free (gpointer _data);
static gboolean scratch_services_fuzzy_search_indexer_process_next_message_async_co (ScratchServicesFuzzySearchIndexerProcessNextMessageAsyncData* _data_);
static void scratch_services_fuzzy_search_indexer_process_project_update_async (ScratchServicesFuzzySearchIndexer* self,
                                                                         ProjectUpdate* message,
                                                                         GAsyncReadyCallback _callback_,
                                                                         gpointer _user_data_);
static void scratch_services_fuzzy_search_indexer_process_project_update_finish (ScratchServicesFuzzySearchIndexer* self,
                                                                          GAsyncResult* _res_);
static void ___lambda15_ (ScratchServicesFuzzySearchIndexer* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda15__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void scratch_services_fuzzy_search_indexer_process_project_update_async_data_free (gpointer _data);
static gboolean scratch_services_fuzzy_search_indexer_process_project_update_async_co (ScratchServicesFuzzySearchIndexerProcessProjectUpdateAsyncData* _data_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void scratch_services_fuzzy_search_indexer_add_project_async (ScratchServicesFuzzySearchIndexer* self,
                                                              ProjectUpdate* message,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_);
static void scratch_services_fuzzy_search_indexer_add_project_finish (ScratchServicesFuzzySearchIndexer* self,
                                                               GAsyncResult* _res_);
static void ___lambda12_ (Block5Data* _data5_,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda12__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void scratch_services_fuzzy_search_indexer_remove_project (ScratchServicesFuzzySearchIndexer* self,
                                                           ProjectUpdate* message);
static void scratch_services_fuzzy_search_indexer_add_file (ScratchServicesFuzzySearchIndexer* self,
                                                     ProjectUpdate* message);
static void scratch_services_fuzzy_search_indexer_add_directory_async (ScratchServicesFuzzySearchIndexer* self,
                                                                ProjectUpdate* message,
                                                                GAsyncReadyCallback _callback_,
                                                                gpointer _user_data_);
static void scratch_services_fuzzy_search_indexer_add_directory_finish (ScratchServicesFuzzySearchIndexer* self,
                                                                 GAsyncResult* _res_);
static void ___lambda14_ (Block5Data* _data5_,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda14__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void scratch_services_fuzzy_search_indexer_remove_file (ScratchServicesFuzzySearchIndexer* self,
                                                        ProjectUpdate* message);
static gchar* scratch_services_fuzzy_search_indexer_get_project_path_of_file (ScratchServicesFuzzySearchIndexer* self,
                                                                       const gchar* file_path);
static void scratch_services_fuzzy_search_indexer_add_directory_async_data_free (gpointer _data);
static gboolean scratch_services_fuzzy_search_indexer_add_directory_async_co (ScratchServicesFuzzySearchIndexerAddDirectoryAsyncData* _data_);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda13_ (Block6Data* _data6_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda13__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void scratch_services_fuzzy_search_indexer_add_project_async_data_free (gpointer _data);
static gboolean scratch_services_fuzzy_search_indexer_add_project_async_co (ScratchServicesFuzzySearchIndexerAddProjectAsyncData* _data_);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda11_ (Block7Data* _data7_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda11__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static void scratch_services_fuzzy_search_indexer_process_initial_indexing_requests_async_data_free (gpointer _data);
static gboolean scratch_services_fuzzy_search_indexer_process_initial_indexing_requests_async_co (ScratchServicesFuzzySearchIndexerProcessInitialIndexingRequestsAsyncData* _data_);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void _____lambda9_ (Block9Data* _data9_,
                    GObject* obj,
                    GAsyncResult* res);
static void ______lambda9__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void scratch_services_fuzzy_search_indexer_finalize (GObject * obj);
static void _vala_scratch_services_fuzzy_search_indexer_get_property (GObject * object,
                                                               guint property_id,
                                                               GValue * value,
                                                               GParamSpec * pspec);
static void _vala_scratch_services_fuzzy_search_indexer_set_property (GObject * object,
                                                               guint property_id,
                                                               const GValue * value,
                                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static GType
indexer_message_type_get_type_once (void)
{
	static const GEnumValue values[] = {{INDEXER_MESSAGE_TYPE_INITIAL, "INDEXER_MESSAGE_TYPE_INITIAL", "initial"}, {INDEXER_MESSAGE_TYPE_PROJECT_UPDATE, "INDEXER_MESSAGE_TYPE_PROJECT_UPDATE", "project-update"}, {0, NULL, NULL}};
	GType indexer_message_type_type_id;
	indexer_message_type_type_id = g_enum_register_static ("IndexerMessageType", values);
	return indexer_message_type_type_id;
}

GType
indexer_message_type_get_type (void)
{
	static volatile gsize indexer_message_type_type_id__once = 0;
	if (g_once_init_enter (&indexer_message_type_type_id__once)) {
		GType indexer_message_type_type_id;
		indexer_message_type_type_id = indexer_message_type_get_type_once ();
		g_once_init_leave (&indexer_message_type_type_id__once, indexer_message_type_type_id);
	}
	return indexer_message_type_type_id__once;
}

static GType
indexer_status_get_type_once (void)
{
	static const GEnumValue values[] = {{INDEXER_STATUS_INITIALISING, "INDEXER_STATUS_INITIALISING", "initialising"}, {INDEXER_STATUS_INITIAL_PROCESSING, "INDEXER_STATUS_INITIAL_PROCESSING", "initial-processing"}, {INDEXER_STATUS_IDLE, "INDEXER_STATUS_IDLE", "idle"}, {INDEXER_STATUS_PROCESSING, "INDEXER_STATUS_PROCESSING", "processing"}, {0, NULL, NULL}};
	GType indexer_status_type_id;
	indexer_status_type_id = g_enum_register_static ("IndexerStatus", values);
	return indexer_status_type_id;
}

GType
indexer_status_get_type (void)
{
	static volatile gsize indexer_status_type_id__once = 0;
	if (g_once_init_enter (&indexer_status_type_id__once)) {
		GType indexer_status_type_id;
		indexer_status_type_id = indexer_status_get_type_once ();
		g_once_init_leave (&indexer_status_type_id__once, indexer_status_type_id);
	}
	return indexer_status_type_id__once;
}

static GType
project_update_type_get_type_once (void)
{
	static const GEnumValue values[] = {{PROJECT_UPDATE_TYPE_ADDED, "PROJECT_UPDATE_TYPE_ADDED", "added"}, {PROJECT_UPDATE_TYPE_REMOVED, "PROJECT_UPDATE_TYPE_REMOVED", "removed"}, {PROJECT_UPDATE_TYPE_FILE_CREATED, "PROJECT_UPDATE_TYPE_FILE_CREATED", "file-created"}, {PROJECT_UPDATE_TYPE_DIRECTORY_CREATED, "PROJECT_UPDATE_TYPE_DIRECTORY_CREATED", "directory-created"}, {PROJECT_UPDATE_TYPE_FILE_DELETED, "PROJECT_UPDATE_TYPE_FILE_DELETED", "file-deleted"}, {0, NULL, NULL}};
	GType project_update_type_type_id;
	project_update_type_type_id = g_enum_register_static ("ProjectUpdateType", values);
	return project_update_type_type_id;
}

GType
project_update_type_get_type (void)
{
	static volatile gsize project_update_type_type_id__once = 0;
	if (g_once_init_enter (&project_update_type_type_id__once)) {
		GType project_update_type_type_id;
		project_update_type_type_id = project_update_type_get_type_once ();
		g_once_init_leave (&project_update_type_type_id__once, project_update_type_type_id);
	}
	return project_update_type_type_id__once;
}

IndexerMessageType
indexer_message_get_message_type (IndexerMessage* self)
{
	IndexerMessageIface* _iface_;
#line 30 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 30 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_iface_ = INDEXER_MESSAGE_GET_INTERFACE (self);
#line 30 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (_iface_->get_message_type) {
#line 30 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		return _iface_->get_message_type (self);
#line 530 "fuzzy-search-indexer.c"
	}
#line 30 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return 0;
#line 534 "fuzzy-search-indexer.c"
}

void
indexer_message_set_message_type (IndexerMessage* self,
                                  IndexerMessageType value)
{
	IndexerMessageIface* _iface_;
#line 30 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 30 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_iface_ = INDEXER_MESSAGE_GET_INTERFACE (self);
#line 30 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (_iface_->set_message_type) {
#line 30 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_iface_->set_message_type (self, value);
#line 550 "fuzzy-search-indexer.c"
	}
}

static void
indexer_message_default_init (IndexerMessageIface * iface,
                              gpointer iface_data)
{
#line 29 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_interface_install_property (iface, g_param_spec_enum ("message-type", "message-type", "message-type", TYPE_INDEXER_MESSAGE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 560 "fuzzy-search-indexer.c"
}

GType
indexer_message_get_type (void)
{
	return indexer_message_type_id;
}

GType
indexer_message_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (IndexerMessageIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) indexer_message_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	indexer_message_type_id = g_type_module_register_type (module, G_TYPE_INTERFACE, "IndexerMessage", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (indexer_message_type_id, G_TYPE_OBJECT);
	return indexer_message_type_id;
}

static inline gpointer
initial_index_request_get_instance_private (InitialIndexRequest* self)
{
	return G_STRUCT_MEMBER_P (self, InitialIndexRequest_private_offset);
}

InitialIndexRequest*
initial_index_request_construct (GType object_type,
                                 const gchar* project_path)
{
	InitialIndexRequest * self = NULL;
#line 37 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_val_if_fail (project_path != NULL, NULL);
#line 38 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = (InitialIndexRequest*) g_object_new (object_type, "message-type", INDEXER_MESSAGE_TYPE_INITIAL, "project-path", project_path, NULL);
#line 37 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return self;
#line 595 "fuzzy-search-indexer.c"
}

InitialIndexRequest*
initial_index_request_new (const gchar* project_path)
{
#line 37 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return initial_index_request_construct (TYPE_INITIAL_INDEX_REQUEST, project_path);
#line 603 "fuzzy-search-indexer.c"
}

static IndexerMessageType
initial_index_request_real_get_message_type (IndexerMessage* base)
{
	IndexerMessageType result;
	InitialIndexRequest* self;
#line 34 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = (InitialIndexRequest*) base;
#line 34 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	result = self->priv->_message_type;
#line 34 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return result;
#line 617 "fuzzy-search-indexer.c"
}

static void
initial_index_request_real_set_message_type (IndexerMessage* base,
                                             IndexerMessageType value)
{
	InitialIndexRequest* self;
	IndexerMessageType old_value;
#line 34 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = (InitialIndexRequest*) base;
#line 34 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	old_value = initial_index_request_real_get_message_type (base);
#line 34 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (old_value != value) {
#line 34 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		self->priv->_message_type = value;
#line 34 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_object_notify_by_pspec ((GObject *) self, initial_index_request_properties[INITIAL_INDEX_REQUEST_MESSAGE_TYPE_PROPERTY]);
#line 636 "fuzzy-search-indexer.c"
	}
}

const gchar*
initial_index_request_get_project_path (InitialIndexRequest* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = self->priv->_project_path;
#line 35 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	result = _tmp0_;
#line 35 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return result;
#line 653 "fuzzy-search-indexer.c"
}

static void
initial_index_request_set_project_path (InitialIndexRequest* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 35 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 35 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	old_value = initial_index_request_get_project_path (self);
#line 35 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 667 "fuzzy-search-indexer.c"
		gchar* _tmp0_;
#line 35 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp0_ = g_strdup (value);
#line 35 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_free0 (self->priv->_project_path);
#line 35 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		self->priv->_project_path = _tmp0_;
#line 35 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_object_notify_by_pspec ((GObject *) self, initial_index_request_properties[INITIAL_INDEX_REQUEST_PROJECT_PATH_PROPERTY]);
#line 677 "fuzzy-search-indexer.c"
	}
}

static void
initial_index_request_class_init (InitialIndexRequestClass * klass,
                                  gpointer klass_data)
{
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	initial_index_request_parent_class = g_type_class_peek_parent (klass);
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_type_class_adjust_private_offset (klass, &InitialIndexRequest_private_offset);
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_initial_index_request_get_property;
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_initial_index_request_set_property;
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	G_OBJECT_CLASS (klass)->finalize = initial_index_request_finalize;
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INITIAL_INDEX_REQUEST_MESSAGE_TYPE_PROPERTY, initial_index_request_properties[INITIAL_INDEX_REQUEST_MESSAGE_TYPE_PROPERTY] = g_param_spec_enum ("message-type", "message-type", "message-type", TYPE_INDEXER_MESSAGE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), INITIAL_INDEX_REQUEST_PROJECT_PATH_PROPERTY, initial_index_request_properties[INITIAL_INDEX_REQUEST_PROJECT_PATH_PROPERTY] = g_param_spec_string ("project-path", "project-path", "project-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 699 "fuzzy-search-indexer.c"
}

static void
initial_index_request_indexer_message_interface_init (IndexerMessageIface * iface,
                                                      gpointer iface_data)
{
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	initial_index_request_indexer_message_parent_iface = g_type_interface_peek_parent (iface);
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	iface->get_message_type = initial_index_request_real_get_message_type;
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	iface->set_message_type = initial_index_request_real_set_message_type;
#line 712 "fuzzy-search-indexer.c"
}

static void
initial_index_request_instance_init (InitialIndexRequest * self,
                                     gpointer klass)
{
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self->priv = initial_index_request_get_instance_private (self);
#line 721 "fuzzy-search-indexer.c"
}

static void
initial_index_request_finalize (GObject * obj)
{
	InitialIndexRequest * self;
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_INITIAL_INDEX_REQUEST, InitialIndexRequest);
#line 35 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_free0 (self->priv->_project_path);
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	G_OBJECT_CLASS (initial_index_request_parent_class)->finalize (obj);
#line 734 "fuzzy-search-indexer.c"
}

GType
initial_index_request_get_type (void)
{
	return initial_index_request_type_id;
}

GType
initial_index_request_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (InitialIndexRequestClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) initial_index_request_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (InitialIndexRequest), 0, (GInstanceInitFunc) initial_index_request_instance_init, NULL };
	static const GInterfaceInfo indexer_message_info = { (GInterfaceInitFunc) initial_index_request_indexer_message_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	initial_index_request_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "InitialIndexRequest", &g_define_type_info, 0);
	g_type_module_add_interface (module, initial_index_request_type_id, TYPE_INDEXER_MESSAGE, &indexer_message_info);
	InitialIndexRequest_private_offset = sizeof (InitialIndexRequestPrivate);
	return initial_index_request_type_id;
}

static void
_vala_initial_index_request_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	InitialIndexRequest * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_INITIAL_INDEX_REQUEST, InitialIndexRequest);
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	switch (property_id) {
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case INITIAL_INDEX_REQUEST_MESSAGE_TYPE_PROPERTY:
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_value_set_enum (value, indexer_message_get_message_type ((IndexerMessage*) self));
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case INITIAL_INDEX_REQUEST_PROJECT_PATH_PROPERTY:
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_value_set_string (value, initial_index_request_get_project_path (self));
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 776 "fuzzy-search-indexer.c"
		default:
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 782 "fuzzy-search-indexer.c"
	}
}

static void
_vala_initial_index_request_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	InitialIndexRequest * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_INITIAL_INDEX_REQUEST, InitialIndexRequest);
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	switch (property_id) {
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case INITIAL_INDEX_REQUEST_MESSAGE_TYPE_PROPERTY:
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		indexer_message_set_message_type ((IndexerMessage*) self, g_value_get_enum (value));
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case INITIAL_INDEX_REQUEST_PROJECT_PATH_PROPERTY:
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		initial_index_request_set_project_path (self, g_value_get_string (value));
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 808 "fuzzy-search-indexer.c"
		default:
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 814 "fuzzy-search-indexer.c"
	}
}

static inline gpointer
project_update_get_instance_private (ProjectUpdate* self)
{
	return G_STRUCT_MEMBER_P (self, ProjectUpdate_private_offset);
}

ProjectUpdate*
project_update_construct (GType object_type,
                          ProjectUpdateType update_type,
                          const gchar* source_path,
                          const gchar* destination_path)
{
	ProjectUpdate * self = NULL;
#line 52 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_val_if_fail (source_path != NULL, NULL);
#line 53 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = (ProjectUpdate*) g_object_new (object_type, "message-type", INDEXER_MESSAGE_TYPE_PROJECT_UPDATE, "update-type", update_type, "source-path", source_path, "destination-path", destination_path, NULL);
#line 52 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return self;
#line 837 "fuzzy-search-indexer.c"
}

ProjectUpdate*
project_update_new (ProjectUpdateType update_type,
                    const gchar* source_path,
                    const gchar* destination_path)
{
#line 52 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return project_update_construct (TYPE_PROJECT_UPDATE, update_type, source_path, destination_path);
#line 847 "fuzzy-search-indexer.c"
}

static IndexerMessageType
project_update_real_get_message_type (IndexerMessage* base)
{
	IndexerMessageType result;
	ProjectUpdate* self;
#line 46 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = (ProjectUpdate*) base;
#line 46 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	result = self->priv->_message_type;
#line 46 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return result;
#line 861 "fuzzy-search-indexer.c"
}

static void
project_update_real_set_message_type (IndexerMessage* base,
                                      IndexerMessageType value)
{
	ProjectUpdate* self;
	IndexerMessageType old_value;
#line 46 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = (ProjectUpdate*) base;
#line 46 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	old_value = project_update_real_get_message_type (base);
#line 46 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (old_value != value) {
#line 46 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		self->priv->_message_type = value;
#line 46 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_object_notify_by_pspec ((GObject *) self, project_update_properties[PROJECT_UPDATE_MESSAGE_TYPE_PROPERTY]);
#line 880 "fuzzy-search-indexer.c"
	}
}

ProjectUpdateType
project_update_get_update_type (ProjectUpdate* self)
{
	ProjectUpdateType result;
#line 47 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 47 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	result = self->priv->_update_type;
#line 47 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return result;
#line 894 "fuzzy-search-indexer.c"
}

static void
project_update_set_update_type (ProjectUpdate* self,
                                ProjectUpdateType value)
{
	ProjectUpdateType old_value;
#line 47 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 47 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	old_value = project_update_get_update_type (self);
#line 47 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (old_value != value) {
#line 47 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		self->priv->_update_type = value;
#line 47 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_object_notify_by_pspec ((GObject *) self, project_update_properties[PROJECT_UPDATE_UPDATE_TYPE_PROPERTY]);
#line 912 "fuzzy-search-indexer.c"
	}
}

const gchar*
project_update_get_source_path (ProjectUpdate* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 48 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = self->priv->_source_path;
#line 48 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	result = _tmp0_;
#line 48 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return result;
#line 929 "fuzzy-search-indexer.c"
}

static void
project_update_set_source_path (ProjectUpdate* self,
                                const gchar* value)
{
	gchar* old_value;
#line 48 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 48 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	old_value = project_update_get_source_path (self);
#line 48 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 943 "fuzzy-search-indexer.c"
		gchar* _tmp0_;
#line 48 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp0_ = g_strdup (value);
#line 48 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_free0 (self->priv->_source_path);
#line 48 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		self->priv->_source_path = _tmp0_;
#line 48 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_object_notify_by_pspec ((GObject *) self, project_update_properties[PROJECT_UPDATE_SOURCE_PATH_PROPERTY]);
#line 953 "fuzzy-search-indexer.c"
	}
}

const gchar*
project_update_get_destination_path (ProjectUpdate* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = self->priv->_destination_path;
#line 49 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	result = _tmp0_;
#line 49 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return result;
#line 970 "fuzzy-search-indexer.c"
}

static void
project_update_set_destination_path (ProjectUpdate* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 49 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 49 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	old_value = project_update_get_destination_path (self);
#line 49 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 984 "fuzzy-search-indexer.c"
		gchar* _tmp0_;
#line 49 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp0_ = g_strdup (value);
#line 49 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_free0 (self->priv->_destination_path);
#line 49 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		self->priv->_destination_path = _tmp0_;
#line 49 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_object_notify_by_pspec ((GObject *) self, project_update_properties[PROJECT_UPDATE_DESTINATION_PATH_PROPERTY]);
#line 994 "fuzzy-search-indexer.c"
	}
}

const gchar*
project_update_get_project_path (ProjectUpdate* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 50 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = self->priv->_project_path;
#line 50 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	result = _tmp0_;
#line 50 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return result;
#line 1011 "fuzzy-search-indexer.c"
}

static void
project_update_set_project_path (ProjectUpdate* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 50 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 50 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	old_value = project_update_get_project_path (self);
#line 50 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1025 "fuzzy-search-indexer.c"
		gchar* _tmp0_;
#line 50 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp0_ = g_strdup (value);
#line 50 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_free0 (self->priv->_project_path);
#line 50 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		self->priv->_project_path = _tmp0_;
#line 50 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_object_notify_by_pspec ((GObject *) self, project_update_properties[PROJECT_UPDATE_PROJECT_PATH_PROPERTY]);
#line 1035 "fuzzy-search-indexer.c"
	}
}

static void
project_update_class_init (ProjectUpdateClass * klass,
                           gpointer klass_data)
{
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	project_update_parent_class = g_type_class_peek_parent (klass);
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_type_class_adjust_private_offset (klass, &ProjectUpdate_private_offset);
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_project_update_get_property;
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_project_update_set_property;
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	G_OBJECT_CLASS (klass)->finalize = project_update_finalize;
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PROJECT_UPDATE_MESSAGE_TYPE_PROPERTY, project_update_properties[PROJECT_UPDATE_MESSAGE_TYPE_PROPERTY] = g_param_spec_enum ("message-type", "message-type", "message-type", TYPE_INDEXER_MESSAGE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PROJECT_UPDATE_UPDATE_TYPE_PROPERTY, project_update_properties[PROJECT_UPDATE_UPDATE_TYPE_PROPERTY] = g_param_spec_enum ("update-type", "update-type", "update-type", TYPE_PROJECT_UPDATE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PROJECT_UPDATE_SOURCE_PATH_PROPERTY, project_update_properties[PROJECT_UPDATE_SOURCE_PATH_PROPERTY] = g_param_spec_string ("source-path", "source-path", "source-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PROJECT_UPDATE_DESTINATION_PATH_PROPERTY, project_update_properties[PROJECT_UPDATE_DESTINATION_PATH_PROPERTY] = g_param_spec_string ("destination-path", "destination-path", "destination-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PROJECT_UPDATE_PROJECT_PATH_PROPERTY, project_update_properties[PROJECT_UPDATE_PROJECT_PATH_PROPERTY] = g_param_spec_string ("project-path", "project-path", "project-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1063 "fuzzy-search-indexer.c"
}

static void
project_update_indexer_message_interface_init (IndexerMessageIface * iface,
                                               gpointer iface_data)
{
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	project_update_indexer_message_parent_iface = g_type_interface_peek_parent (iface);
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	iface->get_message_type = project_update_real_get_message_type;
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	iface->set_message_type = project_update_real_set_message_type;
#line 1076 "fuzzy-search-indexer.c"
}

static void
project_update_instance_init (ProjectUpdate * self,
                              gpointer klass)
{
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self->priv = project_update_get_instance_private (self);
#line 1085 "fuzzy-search-indexer.c"
}

static void
project_update_finalize (GObject * obj)
{
	ProjectUpdate * self;
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PROJECT_UPDATE, ProjectUpdate);
#line 48 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_free0 (self->priv->_source_path);
#line 49 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_free0 (self->priv->_destination_path);
#line 50 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_free0 (self->priv->_project_path);
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	G_OBJECT_CLASS (project_update_parent_class)->finalize (obj);
#line 1102 "fuzzy-search-indexer.c"
}

GType
project_update_get_type (void)
{
	return project_update_type_id;
}

GType
project_update_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ProjectUpdateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) project_update_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ProjectUpdate), 0, (GInstanceInitFunc) project_update_instance_init, NULL };
	static const GInterfaceInfo indexer_message_info = { (GInterfaceInitFunc) project_update_indexer_message_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	project_update_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "ProjectUpdate", &g_define_type_info, 0);
	g_type_module_add_interface (module, project_update_type_id, TYPE_INDEXER_MESSAGE, &indexer_message_info);
	ProjectUpdate_private_offset = sizeof (ProjectUpdatePrivate);
	return project_update_type_id;
}

static void
_vala_project_update_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	ProjectUpdate * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PROJECT_UPDATE, ProjectUpdate);
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	switch (property_id) {
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case PROJECT_UPDATE_MESSAGE_TYPE_PROPERTY:
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_value_set_enum (value, indexer_message_get_message_type ((IndexerMessage*) self));
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case PROJECT_UPDATE_UPDATE_TYPE_PROPERTY:
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_value_set_enum (value, project_update_get_update_type (self));
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case PROJECT_UPDATE_SOURCE_PATH_PROPERTY:
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_value_set_string (value, project_update_get_source_path (self));
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case PROJECT_UPDATE_DESTINATION_PATH_PROPERTY:
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_value_set_string (value, project_update_get_destination_path (self));
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case PROJECT_UPDATE_PROJECT_PATH_PROPERTY:
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_value_set_string (value, project_update_get_project_path (self));
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 1162 "fuzzy-search-indexer.c"
		default:
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 1168 "fuzzy-search-indexer.c"
	}
}

static void
_vala_project_update_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	ProjectUpdate * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PROJECT_UPDATE, ProjectUpdate);
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	switch (property_id) {
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case PROJECT_UPDATE_MESSAGE_TYPE_PROPERTY:
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		indexer_message_set_message_type ((IndexerMessage*) self, g_value_get_enum (value));
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case PROJECT_UPDATE_UPDATE_TYPE_PROPERTY:
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		project_update_set_update_type (self, g_value_get_enum (value));
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case PROJECT_UPDATE_SOURCE_PATH_PROPERTY:
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		project_update_set_source_path (self, g_value_get_string (value));
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case PROJECT_UPDATE_DESTINATION_PATH_PROPERTY:
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		project_update_set_destination_path (self, g_value_get_string (value));
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case PROJECT_UPDATE_PROJECT_PATH_PROPERTY:
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		project_update_set_project_path (self, g_value_get_string (value));
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 1212 "fuzzy-search-indexer.c"
		default:
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 45 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 1218 "fuzzy-search-indexer.c"
	}
}

static inline gpointer
scratch_services_fuzzy_search_indexer_get_instance_private (ScratchServicesFuzzySearchIndexer* self)
{
	return G_STRUCT_MEMBER_P (self, ScratchServicesFuzzySearchIndexer_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 72 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return self ? g_object_ref (self) : NULL;
#line 1233 "fuzzy-search-indexer.c"
}

static void
_scratch_services_fuzzy_search_indexer_handle_opened_projects_change_g_settings_changed (GSettings* _sender,
                                                                                         const gchar* key,
                                                                                         gpointer self)
{
#line 79 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_fuzzy_search_indexer_handle_opened_projects_change ((ScratchServicesFuzzySearchIndexer*) self);
#line 1243 "fuzzy-search-indexer.c"
}

ScratchServicesFuzzySearchIndexer*
scratch_services_fuzzy_search_indexer_construct (GType object_type,
                                                 GCancellable* cancellable)
{
	ScratchServicesFuzzySearchIndexer * self = NULL;
	GCancellable* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeConcurrentList* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
#line 71 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_val_if_fail (cancellable != NULL, NULL);
#line 71 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = (ScratchServicesFuzzySearchIndexer*) g_object_new (object_type, NULL);
#line 72 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = _g_object_ref0 (cancellable);
#line 72 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 72 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self->priv->cancellable = _tmp0_;
#line 73 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self->priv->status = INDEXER_STATUS_INITIALISING;
#line 74 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp1_ = gee_array_list_new (TYPE_INITIAL_INDEX_REQUEST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 74 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (self->priv->initial_indexing_queue);
#line 74 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self->priv->initial_indexing_queue = _tmp1_;
#line 75 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp2_ = gee_concurrent_list_new (TYPE_INDEXER_MESSAGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 75 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (self->priv->processing_queue);
#line 75 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self->priv->processing_queue = _tmp2_;
#line 76 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp3_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SCRATCH_SERVICES_TYPE_SEARCH_PROJECT, (GBoxedCopyFunc) scratch_services_search_project_ref, (GDestroyNotify) scratch_services_search_project_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 76 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp4_ = _tmp3_;
#line 76 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_fuzzy_search_indexer_set_project_paths (self, _tmp4_);
#line 76 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_tmp4_);
#line 78 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp5_ = g_settings_new ("io.elementary.code.folder-manager");
#line 78 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (self->priv->folder_settings);
#line 78 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self->priv->folder_settings = _tmp5_;
#line 79 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp6_ = self->priv->folder_settings;
#line 79 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_signal_connect_object (_tmp6_, "changed::opened-folders", (GCallback) _scratch_services_fuzzy_search_indexer_handle_opened_projects_change_g_settings_changed, self, 0);
#line 71 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return self;
#line 1302 "fuzzy-search-indexer.c"
}

ScratchServicesFuzzySearchIndexer*
scratch_services_fuzzy_search_indexer_new (GCancellable* cancellable)
{
#line 71 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return scratch_services_fuzzy_search_indexer_construct (SCRATCH_SERVICES_TYPE_FUZZY_SEARCH_INDEXER, cancellable);
#line 1310 "fuzzy-search-indexer.c"
}

void
scratch_services_fuzzy_search_indexer_handle_folder_item_change (ScratchServicesFuzzySearchIndexer* self,
                                                                 GFile* source,
                                                                 GFile* dest,
                                                                 GFileMonitorEvent event)
{
#line 82 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 82 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (source != NULL);
#line 83 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	switch (event) {
#line 83 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 1327 "fuzzy-search-indexer.c"
		{
			gchar* path = NULL;
			gchar* _tmp0_;
			gboolean is_directory = FALSE;
			const gchar* _tmp1_;
			ProjectUpdateType _tmp2_ = 0;
			ProjectUpdate* project_update = NULL;
			const gchar* _tmp3_;
			ProjectUpdate* _tmp4_;
			GeeConcurrentList* _tmp5_;
			ProjectUpdate* _tmp6_;
#line 85 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp0_ = g_file_get_path (source);
#line 85 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			path = _tmp0_;
#line 86 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp1_ = path;
#line 86 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			is_directory = g_file_test (_tmp1_, G_FILE_TEST_IS_DIR);
#line 89 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			if (is_directory) {
#line 89 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp2_ = PROJECT_UPDATE_TYPE_DIRECTORY_CREATED;
#line 1351 "fuzzy-search-indexer.c"
			} else {
#line 89 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp2_ = PROJECT_UPDATE_TYPE_FILE_CREATED;
#line 1355 "fuzzy-search-indexer.c"
			}
#line 88 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp3_ = path;
#line 88 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp4_ = project_update_new (_tmp2_, _tmp3_, NULL);
#line 88 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			project_update = _tmp4_;
#line 93 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp5_ = self->priv->processing_queue;
#line 93 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp6_ = project_update;
#line 93 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, (IndexerMessage*) _tmp6_);
#line 94 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_g_object_unref0 (project_update);
#line 94 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_g_free0 (path);
#line 94 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			break;
#line 1375 "fuzzy-search-indexer.c"
		}
#line 83 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 1379 "fuzzy-search-indexer.c"
		{
			gchar* path = NULL;
			gchar* _tmp7_;
			ProjectUpdate* project_update = NULL;
			const gchar* _tmp8_;
			ProjectUpdate* _tmp9_;
			GeeConcurrentList* _tmp10_;
			ProjectUpdate* _tmp11_;
#line 96 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp7_ = g_file_get_path (source);
#line 96 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			path = _tmp7_;
#line 98 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp8_ = path;
#line 98 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp9_ = project_update_new (PROJECT_UPDATE_TYPE_FILE_DELETED, _tmp8_, NULL);
#line 98 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			project_update = _tmp9_;
#line 99 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp10_ = self->priv->processing_queue;
#line 99 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp11_ = project_update;
#line 99 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, (IndexerMessage*) _tmp11_);
#line 100 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_g_object_unref0 (project_update);
#line 100 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_g_free0 (path);
#line 100 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			break;
#line 1410 "fuzzy-search-indexer.c"
		}
		default:
		{
#line 102 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			break;
#line 1416 "fuzzy-search-indexer.c"
		}
	}
}

static void
scratch_services_fuzzy_search_indexer_start_async_data_free (gpointer _data)
{
	ScratchServicesFuzzySearchIndexerStartAsyncData* _data_;
	_data_ = _data;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->self);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_slice_free (ScratchServicesFuzzySearchIndexerStartAsyncData, _data_);
#line 1430 "fuzzy-search-indexer.c"
}

void
scratch_services_fuzzy_search_indexer_start_async (ScratchServicesFuzzySearchIndexer* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	ScratchServicesFuzzySearchIndexerStartAsyncData* _data_;
	ScratchServicesFuzzySearchIndexer* _tmp0_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_ = g_slice_new0 (ScratchServicesFuzzySearchIndexerStartAsyncData);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, scratch_services_fuzzy_search_indexer_start_async_data_free);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->self = _tmp0_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_fuzzy_search_indexer_start_async_co (_data_);
#line 1454 "fuzzy-search-indexer.c"
}

void
scratch_services_fuzzy_search_indexer_start_finish (ScratchServicesFuzzySearchIndexer* self,
                                                    GAsyncResult* _res_)
{
	ScratchServicesFuzzySearchIndexerStartAsyncData* _data_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1464 "fuzzy-search-indexer.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return _data3_;
#line 1474 "fuzzy-search-indexer.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1484 "fuzzy-search-indexer.c"
		ScratchServicesFuzzySearchIndexer* self;
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		self = _data3_->self;
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_object_unref0 (self);
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_slice_free (Block3Data, _data3_);
#line 1492 "fuzzy-search-indexer.c"
	}
}

static void
_____lambda10_ (ScratchServicesFuzzySearchIndexer* self,
                GObject* obj,
                GAsyncResult* res)
{
#line 128 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (res != NULL);
#line 129 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_fuzzy_search_indexer_process_initial_indexing_requests_finish (self, res);
#line 130 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self->priv->status = INDEXER_STATUS_IDLE;
#line 1507 "fuzzy-search-indexer.c"
}

static void
______lambda10__gasync_ready_callback (GObject* source_object,
                                       GAsyncResult* res,
                                       gpointer self)
{
#line 125 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_____lambda10_ ((ScratchServicesFuzzySearchIndexer*) self, source_object, res);
#line 125 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_unref (self);
#line 1519 "fuzzy-search-indexer.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return _data4_;
#line 1529 "fuzzy-search-indexer.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1539 "fuzzy-search-indexer.c"
		ScratchServicesFuzzySearchIndexer* self;
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		self = _data4_->_data3_->self;
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_object_unref0 (_data4_->first_item);
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		block3_data_unref (_data4_->_data3_);
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_data4_->_data3_ = NULL;
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_slice_free (Block4Data, _data4_);
#line 1551 "fuzzy-search-indexer.c"
	}
}

static void
_____lambda16_ (Block4Data* _data4_,
                GObject* obj,
                GAsyncResult* res)
{
	Block3Data* _data3_;
	ScratchServicesFuzzySearchIndexer* self;
	GeeConcurrentList* _tmp0_;
	IndexerMessage* _tmp1_;
#line 142 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data3_ = _data4_->_data3_;
#line 142 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = _data3_->self;
#line 142 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (res != NULL);
#line 143 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_fuzzy_search_indexer_process_next_message_finish (self, res);
#line 144 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = self->priv->processing_queue;
#line 144 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp1_ = _data4_->first_item;
#line 144 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _tmp1_);
#line 145 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self->priv->status = INDEXER_STATUS_IDLE;
#line 146 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_debug ("fuzzy-search-indexer.vala:146: Find Project Files: Indexer is now idle" \
"!");
#line 1582 "fuzzy-search-indexer.c"
}

static void
______lambda16__gasync_ready_callback (GObject* source_object,
                                       GAsyncResult* res,
                                       gpointer self)
{
#line 142 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_____lambda16_ (self, source_object, res);
#line 142 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	block4_data_unref (self);
#line 1594 "fuzzy-search-indexer.c"
}

static gboolean
_scratch_services_fuzzy_search_indexer_start_async_co_gsource_func (gpointer self)
{
	gboolean result;
	result = scratch_services_fuzzy_search_indexer_start_async_co (self);
#line 164 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return result;
#line 1604 "fuzzy-search-indexer.c"
}

static void
__lambda8_ (Block3Data* _data3_)
{
	ScratchServicesFuzzySearchIndexer* self;
	GSettings* _tmp15_;
	guint _tmp16_;
	GQuark _tmp17_;
#line 114 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = _data3_->self;
#line 115 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	while (TRUE) {
#line 1618 "fuzzy-search-indexer.c"
		GCancellable* _tmp0_;
#line 115 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp0_ = self->priv->cancellable;
#line 115 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		if (!(g_cancellable_is_cancelled (_tmp0_) == FALSE)) {
#line 115 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			break;
#line 1626 "fuzzy-search-indexer.c"
		}
#line 116 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		switch (self->priv->status) {
#line 116 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			case INDEXER_STATUS_INITIALISING:
#line 1632 "fuzzy-search-indexer.c"
			{
				GeeArrayList* _tmp1_;
				gint _tmp2_;
				gint _tmp3_;
				GeeArrayList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 118 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp1_ = self->priv->initial_indexing_queue;
#line 118 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 118 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp3_ = _tmp2_;
#line 118 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				if (_tmp3_ < 1) {
#line 119 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					self->priv->status = INDEXER_STATUS_IDLE;
#line 120 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					g_debug ("fuzzy-search-indexer.vala:120: Find Project Files: Indexer is now idle" \
"!\n");
#line 121 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					break;
#line 1654 "fuzzy-search-indexer.c"
				}
#line 124 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp4_ = self->priv->initial_indexing_queue;
#line 124 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 124 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp6_ = _tmp5_;
#line 124 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				if (_tmp6_ > 0) {
#line 1664 "fuzzy-search-indexer.c"
					GeeArrayList* _tmp7_;
					GeeHashMap* _tmp8_;
#line 125 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_tmp7_ = self->priv->initial_indexing_queue;
#line 125 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_tmp8_ = self->priv->_project_paths;
#line 125 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					scratch_services_fuzzy_search_indexer_process_initial_indexing_requests_async (self, _tmp7_, _tmp8_, ______lambda10__gasync_ready_callback, g_object_ref (self));
#line 133 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					self->priv->status = INDEXER_STATUS_INITIAL_PROCESSING;
#line 134 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					g_debug ("fuzzy-search-indexer.vala:134: Find Project Files: Indexer is now doin" \
"g initial processing!");
#line 1677 "fuzzy-search-indexer.c"
				}
#line 137 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				break;
#line 1681 "fuzzy-search-indexer.c"
			}
#line 116 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			case INDEXER_STATUS_IDLE:
#line 1685 "fuzzy-search-indexer.c"
			{
				GeeConcurrentList* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp9_ = self->priv->processing_queue;
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp11_ = _tmp10_;
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				if (_tmp11_ > 0) {
#line 1698 "fuzzy-search-indexer.c"
					Block4Data* _data4_;
					GeeConcurrentList* _tmp12_;
					gpointer _tmp13_;
					IndexerMessage* _tmp14_;
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_data4_ = g_slice_new0 (Block4Data);
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_data4_->_ref_count_ = 1;
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_data4_->_data3_ = block3_data_ref (_data3_);
#line 141 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_tmp12_ = self->priv->processing_queue;
#line 141 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, 0);
#line 141 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_data4_->first_item = (IndexerMessage*) _tmp13_;
#line 142 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_tmp14_ = _data4_->first_item;
#line 142 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					scratch_services_fuzzy_search_indexer_process_next_message_async (self, _tmp14_, ______lambda16__gasync_ready_callback, block4_data_ref (_data4_));
#line 149 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					self->priv->status = INDEXER_STATUS_PROCESSING;
#line 150 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					g_debug ("fuzzy-search-indexer.vala:150: Find Project Files: Indexer now process" \
"ing!");
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					block4_data_unref (_data4_);
#line 140 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_data4_ = NULL;
#line 1727 "fuzzy-search-indexer.c"
				}
#line 152 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				break;
#line 1731 "fuzzy-search-indexer.c"
			}
#line 116 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			case INDEXER_STATUS_INITIAL_PROCESSING:
#line 116 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			case INDEXER_STATUS_PROCESSING:
#line 1737 "fuzzy-search-indexer.c"
			{
#line 155 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				break;
#line 1741 "fuzzy-search-indexer.c"
			}
			default:
			{
#line 157 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				break;
#line 1747 "fuzzy-search-indexer.c"
			}
		}
#line 160 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_usleep ((gulong) (1 * SECONDS_IN_MICROSECONDS));
#line 1752 "fuzzy-search-indexer.c"
	}
#line 163 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp15_ = self->priv->folder_settings;
#line 163 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_signal_parse_name ("changed::opened-folders", g_settings_get_type (), &_tmp16_, &_tmp17_, TRUE);
#line 163 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_signal_handlers_disconnect_matched (_tmp15_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp16_, _tmp17_, NULL, (GCallback) _scratch_services_fuzzy_search_indexer_handle_opened_projects_change_g_settings_changed, self);
#line 164 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _scratch_services_fuzzy_search_indexer_start_async_co_gsource_func, _data3_->_async_data_, NULL);
#line 1762 "fuzzy-search-indexer.c"
}

static gpointer
___lambda8__gthread_func (gpointer self)
{
	gpointer result;
#line 114 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	__lambda8_ (self);
#line 1771 "fuzzy-search-indexer.c"
	result = NULL;
#line 114 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	block3_data_unref (self);
#line 114 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return result;
#line 1777 "fuzzy-search-indexer.c"
}

static gboolean
scratch_services_fuzzy_search_indexer_start_async_co (ScratchServicesFuzzySearchIndexerStartAsyncData* _data_)
{
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	switch (_data_->_state_) {
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case 0:
#line 1787 "fuzzy-search-indexer.c"
		goto _state_0;
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case 1:
#line 1791 "fuzzy-search-indexer.c"
		goto _state_1;
		default:
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_assert_not_reached ();
#line 1796 "fuzzy-search-indexer.c"
	}
	_state_0:
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data3_ = g_slice_new0 (Block3Data);
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data3_->_ref_count_ = 1;
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data3_->self = g_object_ref (_data_->self);
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data3_->_async_data_ = _data_;
#line 107 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp0_ = _data_->self->priv->folder_settings;
#line 107 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp2_ = _data_->_tmp1_ = g_settings_get_strv (_data_->_tmp0_, "opened-folders");
#line 107 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->initial_projects = _data_->_tmp2_;
#line 107 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->initial_projects_length1 = _vala_array_length (_data_->_tmp1_);
#line 107 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_initial_projects_size_ = _data_->initial_projects_length1;
#line 108 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp3_ = _data_->initial_projects;
#line 108 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp3__length1 = _data_->initial_projects_length1;
#line 108 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (_data_->_tmp3_ != NULL) {
#line 109 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_data_->_tmp4_ = _data_->initial_projects;
#line 109 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_data_->_tmp4__length1 = _data_->initial_projects_length1;
#line 1827 "fuzzy-search-indexer.c"
		{
#line 109 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_data_->path_collection_length1 = 0;
#line 109 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_data_->_path_collection_size_ = 0;
#line 109 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_data_->path_collection = _data_->_tmp4_;
#line 109 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_data_->path_collection_length1 = _data_->_tmp4__length1;
#line 109 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			for (_data_->path_it = 0; _data_->path_it < _data_->path_collection_length1; _data_->path_it = _data_->path_it + 1) {
#line 109 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->path = _data_->path_collection[_data_->path_it];
#line 1841 "fuzzy-search-indexer.c"
				{
#line 110 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_data_->_tmp5_ = _data_->self->priv->initial_indexing_queue;
#line 110 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_data_->_tmp6_ = _data_->path;
#line 110 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_data_->_tmp7_ = initial_index_request_new (_data_->_tmp6_);
#line 110 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_data_->_tmp8_ = _data_->_tmp7_;
#line 110 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp5_, _data_->_tmp8_);
#line 110 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_g_object_unref0 (_data_->_tmp8_);
#line 1855 "fuzzy-search-indexer.c"
				}
			}
		}
	}
#line 114 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp9_ = g_thread_new (NULL, ___lambda8__gthread_func, block3_data_ref (_data_->_data3_));
#line 114 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 114 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_thread_unref0 (_data_->_tmp10_);
#line 167 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_state_ = 1;
#line 167 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return FALSE;
#line 1870 "fuzzy-search-indexer.c"
	_state_1:
	;
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->initial_projects = (_vala_array_free (_data_->initial_projects, _data_->initial_projects_length1, (GDestroyNotify) g_free), NULL);
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	block3_data_unref (_data_->_data3_);
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data3_ = NULL;
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (_data_->_state_ != 0) {
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1887 "fuzzy-search-indexer.c"
		}
	}
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_unref (_data_->_async_result);
#line 106 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return FALSE;
#line 1894 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_process_next_message_async_data_free (gpointer _data)
{
	ScratchServicesFuzzySearchIndexerProcessNextMessageAsyncData* _data_;
	_data_ = _data;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->message);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->self);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_slice_free (ScratchServicesFuzzySearchIndexerProcessNextMessageAsyncData, _data_);
#line 1908 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_process_next_message_async (ScratchServicesFuzzySearchIndexer* self,
                                                                  IndexerMessage* message,
                                                                  GAsyncReadyCallback _callback_,
                                                                  gpointer _user_data_)
{
	ScratchServicesFuzzySearchIndexerProcessNextMessageAsyncData* _data_;
	ScratchServicesFuzzySearchIndexer* _tmp0_;
	IndexerMessage* _tmp1_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (message != NULL);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_ = g_slice_new0 (ScratchServicesFuzzySearchIndexerProcessNextMessageAsyncData);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, scratch_services_fuzzy_search_indexer_process_next_message_async_data_free);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->self = _tmp0_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp1_ = _g_object_ref0 (message);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->message);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->message = _tmp1_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_fuzzy_search_indexer_process_next_message_async_co (_data_);
#line 1942 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_process_next_message_finish (ScratchServicesFuzzySearchIndexer* self,
                                                                   GAsyncResult* _res_)
{
	ScratchServicesFuzzySearchIndexerProcessNextMessageAsyncData* _data_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1952 "fuzzy-search-indexer.c"
}

static void
___lambda15_ (ScratchServicesFuzzySearchIndexer* self,
              GObject* obj,
              GAsyncResult* res)
{
#line 173 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (res != NULL);
#line 174 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_fuzzy_search_indexer_process_project_update_finish (self, res);
#line 1964 "fuzzy-search-indexer.c"
}

static void
____lambda15__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 173 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	___lambda15_ ((ScratchServicesFuzzySearchIndexer*) self, source_object, res);
#line 173 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_unref (self);
#line 1976 "fuzzy-search-indexer.c"
}

static gboolean
scratch_services_fuzzy_search_indexer_process_next_message_async_co (ScratchServicesFuzzySearchIndexerProcessNextMessageAsyncData* _data_)
{
#line 170 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	switch (_data_->_state_) {
#line 170 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case 0:
#line 1986 "fuzzy-search-indexer.c"
		goto _state_0;
		default:
#line 170 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_assert_not_reached ();
#line 1991 "fuzzy-search-indexer.c"
	}
	_state_0:
#line 171 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp0_ = indexer_message_get_message_type (_data_->message);
#line 171 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 171 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	switch (_data_->_tmp1_) {
#line 171 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case INDEXER_MESSAGE_TYPE_PROJECT_UPDATE:
#line 2002 "fuzzy-search-indexer.c"
		{
#line 173 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			scratch_services_fuzzy_search_indexer_process_project_update_async (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->message, TYPE_PROJECT_UPDATE, ProjectUpdate), ____lambda15__gasync_ready_callback, g_object_ref (_data_->self));
#line 177 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			break;
#line 2008 "fuzzy-search-indexer.c"
		}
		default:
		{
#line 179 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			break;
#line 2014 "fuzzy-search-indexer.c"
		}
	}
#line 170 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 170 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (_data_->_state_ != 0) {
#line 170 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 170 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2025 "fuzzy-search-indexer.c"
		}
	}
#line 170 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_unref (_data_->_async_result);
#line 170 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return FALSE;
#line 2032 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_process_project_update_async_data_free (gpointer _data)
{
	ScratchServicesFuzzySearchIndexerProcessProjectUpdateAsyncData* _data_;
	_data_ = _data;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->self);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_slice_free (ScratchServicesFuzzySearchIndexerProcessProjectUpdateAsyncData, _data_);
#line 2044 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_process_project_update_async (ScratchServicesFuzzySearchIndexer* self,
                                                                    ProjectUpdate* message,
                                                                    GAsyncReadyCallback _callback_,
                                                                    gpointer _user_data_)
{
	ScratchServicesFuzzySearchIndexerProcessProjectUpdateAsyncData* _data_;
	ScratchServicesFuzzySearchIndexer* _tmp0_;
	ProjectUpdate* _tmp1_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (message != NULL);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_ = g_slice_new0 (ScratchServicesFuzzySearchIndexerProcessProjectUpdateAsyncData);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, scratch_services_fuzzy_search_indexer_process_project_update_async_data_free);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->self = _tmp0_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp1_ = _g_object_ref0 (message);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->message);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->message = _tmp1_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_fuzzy_search_indexer_process_project_update_async_co (_data_);
#line 2078 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_process_project_update_finish (ScratchServicesFuzzySearchIndexer* self,
                                                                     GAsyncResult* _res_)
{
	ScratchServicesFuzzySearchIndexerProcessProjectUpdateAsyncData* _data_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2088 "fuzzy-search-indexer.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return _data5_;
#line 2098 "fuzzy-search-indexer.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 2108 "fuzzy-search-indexer.c"
		ScratchServicesFuzzySearchIndexer* self;
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		self = _data5_->self;
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_object_unref0 (_data5_->message);
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_object_unref0 (self);
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_slice_free (Block5Data, _data5_);
#line 2118 "fuzzy-search-indexer.c"
	}
}

static void
___lambda12_ (Block5Data* _data5_,
              GObject* obj,
              GAsyncResult* res)
{
	ScratchServicesFuzzySearchIndexer* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 186 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = _data5_->self;
#line 186 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (res != NULL);
#line 187 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_fuzzy_search_indexer_add_project_finish (self, res);
#line 188 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = project_update_get_source_path (_data5_->message);
#line 188 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp1_ = _tmp0_;
#line 188 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_debug ("fuzzy-search-indexer.vala:188: Find Project Files: Added project: %s", _tmp1_);
#line 2142 "fuzzy-search-indexer.c"
}

static void
____lambda12__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 186 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	___lambda12_ (self, source_object, res);
#line 186 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	block5_data_unref (self);
#line 2154 "fuzzy-search-indexer.c"
}

static void
___lambda14_ (Block5Data* _data5_,
              GObject* obj,
              GAsyncResult* res)
{
	ScratchServicesFuzzySearchIndexer* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 202 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = _data5_->self;
#line 202 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (res != NULL);
#line 203 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_fuzzy_search_indexer_add_directory_finish (self, res);
#line 204 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = project_update_get_source_path (_data5_->message);
#line 204 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp1_ = _tmp0_;
#line 204 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_debug ("fuzzy-search-indexer.vala:204: Find Project Files: Added directory: %s", _tmp1_);
#line 2177 "fuzzy-search-indexer.c"
}

static void
____lambda14__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 202 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	___lambda14_ (self, source_object, res);
#line 202 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	block5_data_unref (self);
#line 2189 "fuzzy-search-indexer.c"
}

static gboolean
scratch_services_fuzzy_search_indexer_process_project_update_async_co (ScratchServicesFuzzySearchIndexerProcessProjectUpdateAsyncData* _data_)
{
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	switch (_data_->_state_) {
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case 0:
#line 2199 "fuzzy-search-indexer.c"
		goto _state_0;
		default:
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_assert_not_reached ();
#line 2204 "fuzzy-search-indexer.c"
	}
	_state_0:
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data5_ = g_slice_new0 (Block5Data);
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data5_->_ref_count_ = 1;
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data5_->self = g_object_ref (_data_->self);
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->_data5_->message);
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data5_->message = _data_->message;
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data5_->_async_data_ = _data_;
#line 184 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp0_ = project_update_get_update_type (_data_->_data5_->message);
#line 184 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 184 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	switch (_data_->_tmp1_) {
#line 184 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case PROJECT_UPDATE_TYPE_ADDED:
#line 2227 "fuzzy-search-indexer.c"
		{
#line 186 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			scratch_services_fuzzy_search_indexer_add_project_async (_data_->self, _data_->_data5_->message, ____lambda12__gasync_ready_callback, block5_data_ref (_data_->_data5_));
#line 191 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			break;
#line 2233 "fuzzy-search-indexer.c"
		}
#line 184 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case PROJECT_UPDATE_TYPE_REMOVED:
#line 2237 "fuzzy-search-indexer.c"
		{
#line 193 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			scratch_services_fuzzy_search_indexer_remove_project (_data_->self, _data_->_data5_->message);
#line 194 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_data_->_tmp2_ = project_update_get_source_path (_data_->_data5_->message);
#line 194 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_data_->_tmp3_ = _data_->_tmp2_;
#line 194 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			g_debug ("fuzzy-search-indexer.vala:194: Find Project Files: Removed project: %s", _data_->_tmp3_);
#line 195 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			break;
#line 2249 "fuzzy-search-indexer.c"
		}
#line 184 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case PROJECT_UPDATE_TYPE_FILE_CREATED:
#line 2253 "fuzzy-search-indexer.c"
		{
#line 197 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			scratch_services_fuzzy_search_indexer_add_file (_data_->self, _data_->_data5_->message);
#line 198 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_data_->_tmp4_ = project_update_get_source_path (_data_->_data5_->message);
#line 198 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_data_->_tmp5_ = _data_->_tmp4_;
#line 198 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			g_debug ("fuzzy-search-indexer.vala:198: Find Project Files: Added file: %s", _data_->_tmp5_);
#line 200 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			break;
#line 2265 "fuzzy-search-indexer.c"
		}
#line 184 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case PROJECT_UPDATE_TYPE_DIRECTORY_CREATED:
#line 2269 "fuzzy-search-indexer.c"
		{
#line 202 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			scratch_services_fuzzy_search_indexer_add_directory_async (_data_->self, _data_->_data5_->message, ____lambda14__gasync_ready_callback, block5_data_ref (_data_->_data5_));
#line 207 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			break;
#line 2275 "fuzzy-search-indexer.c"
		}
#line 184 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case PROJECT_UPDATE_TYPE_FILE_DELETED:
#line 2279 "fuzzy-search-indexer.c"
		{
#line 209 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			scratch_services_fuzzy_search_indexer_remove_file (_data_->self, _data_->_data5_->message);
#line 210 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_data_->_tmp6_ = project_update_get_source_path (_data_->_data5_->message);
#line 210 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_data_->_tmp7_ = _data_->_tmp6_;
#line 210 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			g_debug ("fuzzy-search-indexer.vala:210: Find Project Files: Deleted directory: " \
"%s", _data_->_tmp7_);
#line 211 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			break;
#line 2291 "fuzzy-search-indexer.c"
		}
		default:
#line 184 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 2296 "fuzzy-search-indexer.c"
	}
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	block5_data_unref (_data_->_data5_);
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data5_ = NULL;
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (_data_->_state_ != 0) {
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2310 "fuzzy-search-indexer.c"
		}
	}
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_unref (_data_->_async_result);
#line 183 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return FALSE;
#line 2317 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_remove_file (ScratchServicesFuzzySearchIndexer* self,
                                                   ProjectUpdate* message)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* project_key = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	ScratchServicesSearchProject* project_search = NULL;
	GeeHashMap* _tmp6_;
	const gchar* _tmp7_;
	gpointer _tmp8_;
	ScratchServicesSearchProject* _tmp9_;
	const gchar* _tmp10_;
	GCancellable* _tmp11_;
	GeeConcurrentList* _tmp12_;
#line 215 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 215 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (message != NULL);
#line 216 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = project_update_get_source_path (message);
#line 216 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp1_ = _tmp0_;
#line 216 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 216 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	path = _tmp2_;
#line 217 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp3_ = path;
#line 217 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp4_ = scratch_services_fuzzy_search_indexer_get_project_path_of_file (self, _tmp3_);
#line 217 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	project_key = _tmp4_;
#line 218 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp5_ = project_key;
#line 218 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (_tmp5_ == NULL) {
#line 219 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_free0 (project_key);
#line 219 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_free0 (path);
#line 219 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		return;
#line 2368 "fuzzy-search-indexer.c"
	}
#line 222 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp6_ = self->priv->_project_paths;
#line 222 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp7_ = project_key;
#line 222 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, _tmp7_);
#line 222 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	project_search = (ScratchServicesSearchProject*) _tmp8_;
#line 223 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp9_ = project_search;
#line 223 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp10_ = path;
#line 223 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp11_ = self->priv->cancellable;
#line 223 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_search_project_remove_file (_tmp9_, _tmp10_, _tmp11_);
#line 224 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp12_ = self->priv->processing_queue;
#line 224 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp12_, (IndexerMessage*) message);
#line 215 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_scratch_services_search_project_unref0 (project_search);
#line 215 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_free0 (project_key);
#line 215 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_free0 (path);
#line 2396 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_add_file (ScratchServicesFuzzySearchIndexer* self,
                                                ProjectUpdate* message)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* project_key = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	ScratchServicesSearchProject* project_search = NULL;
	GeeHashMap* _tmp6_;
	const gchar* _tmp7_;
	gpointer _tmp8_;
	ScratchServicesSearchProject* _tmp9_;
	const gchar* _tmp10_;
	GCancellable* _tmp11_;
	GeeConcurrentList* _tmp12_;
#line 227 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 227 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (message != NULL);
#line 228 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = project_update_get_source_path (message);
#line 228 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp1_ = _tmp0_;
#line 228 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 228 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	path = _tmp2_;
#line 229 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp3_ = path;
#line 229 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp4_ = scratch_services_fuzzy_search_indexer_get_project_path_of_file (self, _tmp3_);
#line 229 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	project_key = _tmp4_;
#line 230 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp5_ = project_key;
#line 230 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (_tmp5_ == NULL) {
#line 231 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_free0 (project_key);
#line 231 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_free0 (path);
#line 231 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		return;
#line 2447 "fuzzy-search-indexer.c"
	}
#line 234 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp6_ = self->priv->_project_paths;
#line 234 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp7_ = project_key;
#line 234 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, _tmp7_);
#line 234 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	project_search = (ScratchServicesSearchProject*) _tmp8_;
#line 235 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp9_ = project_search;
#line 235 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp10_ = path;
#line 235 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp11_ = self->priv->cancellable;
#line 235 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_search_project_add_file (_tmp9_, _tmp10_, _tmp11_);
#line 236 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp12_ = self->priv->processing_queue;
#line 236 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp12_, (IndexerMessage*) message);
#line 227 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_scratch_services_search_project_unref0 (project_search);
#line 227 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_free0 (project_key);
#line 227 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_free0 (path);
#line 2475 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_add_directory_async_data_free (gpointer _data)
{
	ScratchServicesFuzzySearchIndexerAddDirectoryAsyncData* _data_;
	_data_ = _data;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->self);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_slice_free (ScratchServicesFuzzySearchIndexerAddDirectoryAsyncData, _data_);
#line 2487 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_add_directory_async (ScratchServicesFuzzySearchIndexer* self,
                                                           ProjectUpdate* message,
                                                           GAsyncReadyCallback _callback_,
                                                           gpointer _user_data_)
{
	ScratchServicesFuzzySearchIndexerAddDirectoryAsyncData* _data_;
	ScratchServicesFuzzySearchIndexer* _tmp0_;
	ProjectUpdate* _tmp1_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (message != NULL);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_ = g_slice_new0 (ScratchServicesFuzzySearchIndexerAddDirectoryAsyncData);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, scratch_services_fuzzy_search_indexer_add_directory_async_data_free);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->self = _tmp0_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp1_ = _g_object_ref0 (message);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->message);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->message = _tmp1_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_fuzzy_search_indexer_add_directory_async_co (_data_);
#line 2521 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_add_directory_finish (ScratchServicesFuzzySearchIndexer* self,
                                                            GAsyncResult* _res_)
{
	ScratchServicesFuzzySearchIndexerAddDirectoryAsyncData* _data_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2531 "fuzzy-search-indexer.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return _data6_;
#line 2541 "fuzzy-search-indexer.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 2551 "fuzzy-search-indexer.c"
		ScratchServicesFuzzySearchIndexer* self;
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		self = _data6_->self;
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_scratch_services_search_project_unref0 (_data6_->project_search);
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_object_unref0 (_data6_->message);
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_object_unref0 (self);
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_slice_free (Block6Data, _data6_);
#line 2563 "fuzzy-search-indexer.c"
	}
}

static void
__lambda13_ (Block6Data* _data6_,
             GObject* obj,
             GAsyncResult* res)
{
	ScratchServicesFuzzySearchIndexer* self;
	ScratchServicesSearchProject* _tmp0_;
	GeeConcurrentList* _tmp1_;
#line 247 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = _data6_->self;
#line 247 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (res != NULL);
#line 248 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = _data6_->project_search;
#line 248 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_search_project_add_directory_finish (_tmp0_, res);
#line 249 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp1_ = self->priv->processing_queue;
#line 249 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, (IndexerMessage*) _data6_->message);
#line 2587 "fuzzy-search-indexer.c"
}

static void
___lambda13__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 247 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	__lambda13_ (self, source_object, res);
#line 247 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	block6_data_unref (self);
#line 2599 "fuzzy-search-indexer.c"
}

static gboolean
scratch_services_fuzzy_search_indexer_add_directory_async_co (ScratchServicesFuzzySearchIndexerAddDirectoryAsyncData* _data_)
{
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	switch (_data_->_state_) {
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case 0:
#line 2609 "fuzzy-search-indexer.c"
		goto _state_0;
		default:
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_assert_not_reached ();
#line 2614 "fuzzy-search-indexer.c"
	}
	_state_0:
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data6_ = g_slice_new0 (Block6Data);
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data6_->_ref_count_ = 1;
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data6_->self = g_object_ref (_data_->self);
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->_data6_->message);
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data6_->message = _data_->message;
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data6_->_async_data_ = _data_;
#line 240 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp0_ = project_update_get_source_path (_data_->_data6_->message);
#line 240 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 240 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp2_ = g_strdup (_data_->_tmp1_);
#line 240 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->path = _data_->_tmp2_;
#line 241 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp3_ = _data_->path;
#line 241 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp4_ = scratch_services_fuzzy_search_indexer_get_project_path_of_file (_data_->self, _data_->_tmp3_);
#line 241 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->project_key = _data_->_tmp4_;
#line 242 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp5_ = _data_->project_key;
#line 242 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (_data_->_tmp5_ == NULL) {
#line 243 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_free0 (_data_->project_key);
#line 243 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_free0 (_data_->path);
#line 243 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		block6_data_unref (_data_->_data6_);
#line 243 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_data_->_data6_ = NULL;
#line 243 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 243 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		if (_data_->_state_ != 0) {
#line 243 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 243 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2663 "fuzzy-search-indexer.c"
			}
		}
#line 243 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_object_unref (_data_->_async_result);
#line 243 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		return FALSE;
#line 2670 "fuzzy-search-indexer.c"
	}
#line 246 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp6_ = _data_->self->priv->_project_paths;
#line 246 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp7_ = _data_->project_key;
#line 246 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _data_->_tmp6_, _data_->_tmp7_);
#line 246 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data6_->project_search = (ScratchServicesSearchProject*) _data_->_tmp8_;
#line 247 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp9_ = _data_->_data6_->project_search;
#line 247 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp10_ = _data_->path;
#line 247 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp11_ = _data_->self->priv->cancellable;
#line 247 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_search_project_add_directory_async (_data_->_tmp9_, _data_->_tmp10_, _data_->_tmp11_, ___lambda13__gasync_ready_callback, block6_data_ref (_data_->_data6_));
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_free0 (_data_->project_key);
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_free0 (_data_->path);
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	block6_data_unref (_data_->_data6_);
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data6_ = NULL;
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (_data_->_state_ != 0) {
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2704 "fuzzy-search-indexer.c"
		}
	}
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_unref (_data_->_async_result);
#line 239 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return FALSE;
#line 2711 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_add_project_async_data_free (gpointer _data)
{
	ScratchServicesFuzzySearchIndexerAddProjectAsyncData* _data_;
	_data_ = _data;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->self);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_slice_free (ScratchServicesFuzzySearchIndexerAddProjectAsyncData, _data_);
#line 2723 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_add_project_async (ScratchServicesFuzzySearchIndexer* self,
                                                         ProjectUpdate* message,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_)
{
	ScratchServicesFuzzySearchIndexerAddProjectAsyncData* _data_;
	ScratchServicesFuzzySearchIndexer* _tmp0_;
	ProjectUpdate* _tmp1_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (message != NULL);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_ = g_slice_new0 (ScratchServicesFuzzySearchIndexerAddProjectAsyncData);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, scratch_services_fuzzy_search_indexer_add_project_async_data_free);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->self = _tmp0_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp1_ = _g_object_ref0 (message);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->message);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->message = _tmp1_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_fuzzy_search_indexer_add_project_async_co (_data_);
#line 2757 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_add_project_finish (ScratchServicesFuzzySearchIndexer* self,
                                                          GAsyncResult* _res_)
{
	ScratchServicesFuzzySearchIndexerAddProjectAsyncData* _data_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2767 "fuzzy-search-indexer.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return _data7_;
#line 2777 "fuzzy-search-indexer.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 2787 "fuzzy-search-indexer.c"
		ScratchServicesFuzzySearchIndexer* self;
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		self = _data7_->self;
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_scratch_services_search_project_unref0 (_data7_->project_search);
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_object_unref0 (_data7_->message);
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_object_unref0 (self);
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_slice_free (Block7Data, _data7_);
#line 2799 "fuzzy-search-indexer.c"
	}
}

static void
__lambda11_ (Block7Data* _data7_,
             GObject* obj,
             GAsyncResult* res)
{
	ScratchServicesFuzzySearchIndexer* self;
	GeeConcurrentList* _tmp0_;
#line 259 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = _data7_->self;
#line 259 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (res != NULL);
#line 260 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_search_project_parse_finish (_data7_->project_search, res);
#line 261 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = self->priv->processing_queue;
#line 261 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, (IndexerMessage*) _data7_->message);
#line 2820 "fuzzy-search-indexer.c"
}

static void
___lambda11__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 259 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	__lambda11_ (self, source_object, res);
#line 259 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	block7_data_unref (self);
#line 2832 "fuzzy-search-indexer.c"
}

static gboolean
scratch_services_fuzzy_search_indexer_add_project_async_co (ScratchServicesFuzzySearchIndexerAddProjectAsyncData* _data_)
{
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	switch (_data_->_state_) {
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case 0:
#line 2842 "fuzzy-search-indexer.c"
		goto _state_0;
		default:
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_assert_not_reached ();
#line 2847 "fuzzy-search-indexer.c"
	}
	_state_0:
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data7_ = g_slice_new0 (Block7Data);
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data7_->_ref_count_ = 1;
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data7_->self = g_object_ref (_data_->self);
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->_data7_->message);
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data7_->message = _data_->message;
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data7_->_async_data_ = _data_;
#line 254 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp0_ = project_update_get_source_path (_data_->_data7_->message);
#line 254 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 254 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp2_ = g_strdup (_data_->_tmp1_);
#line 254 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->path = _data_->_tmp2_;
#line 255 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp3_ = scratch_services_git_manager_get_monitored_repository (_data_->path);
#line 255 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->monitor = _data_->_tmp3_;
#line 256 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp4_ = scratch_services_search_project_new (_data_->path, _data_->monitor);
#line 256 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data7_->project_search = _data_->_tmp4_;
#line 257 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp5_ = _data_->self->priv->_project_paths;
#line 257 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp5_, _data_->path, _data_->_data7_->project_search);
#line 259 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_tmp6_ = _data_->self->priv->cancellable;
#line 259 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_search_project_parse_async (_data_->_data7_->project_search, _data_->path, _data_->_tmp6_, ___lambda11__gasync_ready_callback, block7_data_ref (_data_->_data7_));
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->monitor);
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_free0 (_data_->path);
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	block7_data_unref (_data_->_data7_);
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data7_ = NULL;
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (_data_->_state_ != 0) {
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2902 "fuzzy-search-indexer.c"
		}
	}
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_unref (_data_->_async_result);
#line 253 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return FALSE;
#line 2909 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_remove_project (ScratchServicesFuzzySearchIndexer* self,
                                                      ProjectUpdate* message)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GeeHashMap* _tmp3_;
#line 265 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 265 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (message != NULL);
#line 266 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = project_update_get_source_path (message);
#line 266 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp1_ = _tmp0_;
#line 266 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 266 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	path = _tmp2_;
#line 267 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp3_ = self->priv->_project_paths;
#line 267 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp3_, path, NULL);
#line 265 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_free0 (path);
#line 2939 "fuzzy-search-indexer.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 272 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (length >= 0) {
#line 2948 "fuzzy-search-indexer.c"
		gchar** result;
		gssize i;
#line 272 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		result = g_new0 (gchar*, length + 1);
#line 272 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		for (i = 0; i < length; i++) {
#line 2955 "fuzzy-search-indexer.c"
			gchar* _tmp0_;
#line 272 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp0_ = g_strdup (self[i]);
#line 272 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			result[i] = _tmp0_;
#line 2961 "fuzzy-search-indexer.c"
		}
#line 272 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		return result;
#line 2965 "fuzzy-search-indexer.c"
	}
#line 272 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return NULL;
#line 2969 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_handle_opened_projects_change (ScratchServicesFuzzySearchIndexer* self)
{
	gchar** opened_projects_array = NULL;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint opened_projects_array_length1;
	gint _opened_projects_array_size_;
	GeeArrayList* opened_projects = NULL;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GeeArrayList* _tmp5_;
#line 270 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 271 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = self->priv->folder_settings;
#line 271 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "opened-folders");
#line 271 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	opened_projects_array = _tmp2_;
#line 271 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	opened_projects_array_length1 = _vala_array_length (_tmp1_);
#line 271 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_opened_projects_array_size_ = opened_projects_array_length1;
#line 272 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp3_ = opened_projects_array;
#line 272 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp3__length1 = opened_projects_array_length1;
#line 272 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup1 (_tmp3_, _tmp3__length1) : _tmp3_;
#line 272 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp4__length1 = _tmp3__length1;
#line 272 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp5_ = gee_array_list_new_wrap (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp4_, _tmp4__length1, NULL, NULL, NULL);
#line 272 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	opened_projects = _tmp5_;
#line 3011 "fuzzy-search-indexer.c"
	{
		GeeArrayList* _project_list = NULL;
		GeeArrayList* _tmp6_;
		gint _project_size = 0;
		GeeArrayList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _project_index = 0;
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp6_ = opened_projects;
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_project_list = _tmp6_;
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp7_ = _project_list;
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp9_ = _tmp8_;
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_project_size = _tmp9_;
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_project_index = -1;
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		while (TRUE) {
#line 3036 "fuzzy-search-indexer.c"
			gint _tmp10_;
			gint _tmp11_;
			gchar* project = NULL;
			GeeArrayList* _tmp12_;
			gpointer _tmp13_;
			GeeHashMap* _tmp14_;
			GeeSet* _tmp15_;
			GeeSet* _tmp16_;
			GeeSet* _tmp17_;
			const gchar* _tmp18_;
			gboolean _tmp19_;
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_project_index = _project_index + 1;
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp10_ = _project_index;
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp11_ = _project_size;
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			if (!(_tmp10_ < _tmp11_)) {
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				break;
#line 3058 "fuzzy-search-indexer.c"
			}
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp12_ = _project_list;
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _project_index);
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			project = (gchar*) _tmp13_;
#line 275 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp14_ = self->priv->_project_paths;
#line 275 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp15_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp14_);
#line 275 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp16_ = _tmp15_;
#line 275 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp17_ = _tmp16_;
#line 275 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp18_ = project;
#line 275 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp19_ = gee_collection_contains ((GeeCollection*) _tmp17_, _tmp18_) == FALSE;
#line 275 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_g_object_unref0 (_tmp17_);
#line 275 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			if (_tmp19_) {
#line 3082 "fuzzy-search-indexer.c"
				GeeConcurrentList* _tmp20_;
				const gchar* _tmp21_;
				ProjectUpdate* _tmp22_;
				ProjectUpdate* _tmp23_;
#line 276 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp20_ = self->priv->processing_queue;
#line 276 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp21_ = project;
#line 276 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp22_ = project_update_new (PROJECT_UPDATE_TYPE_ADDED, _tmp21_, NULL);
#line 276 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp23_ = _tmp22_;
#line 276 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, (IndexerMessage*) _tmp23_);
#line 276 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_g_object_unref0 (_tmp23_);
#line 3099 "fuzzy-search-indexer.c"
			}
#line 274 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_g_free0 (project);
#line 3103 "fuzzy-search-indexer.c"
		}
	}
	{
		GeeIterator* _project_it = NULL;
		GeeHashMap* _tmp24_;
		GeeSet* _tmp25_;
		GeeSet* _tmp26_;
		GeeSet* _tmp27_;
		GeeIterator* _tmp28_;
		GeeIterator* _tmp29_;
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp24_ = self->priv->_project_paths;
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp25_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp24_);
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp26_ = _tmp25_;
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp27_ = _tmp26_;
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp28_ = gee_iterable_iterator ((GeeIterable*) _tmp27_);
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp29_ = _tmp28_;
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_object_unref0 (_tmp27_);
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_project_it = _tmp29_;
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		while (TRUE) {
#line 3132 "fuzzy-search-indexer.c"
			GeeIterator* _tmp30_;
			gchar* project = NULL;
			GeeIterator* _tmp31_;
			gpointer _tmp32_;
			GeeArrayList* _tmp33_;
			const gchar* _tmp34_;
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp30_ = _project_it;
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			if (!gee_iterator_next (_tmp30_)) {
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				break;
#line 3145 "fuzzy-search-indexer.c"
			}
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp31_ = _project_it;
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp32_ = gee_iterator_get (_tmp31_);
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			project = (gchar*) _tmp32_;
#line 282 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp33_ = opened_projects;
#line 282 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_tmp34_ = project;
#line 282 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp33_, _tmp34_) == FALSE) {
#line 3159 "fuzzy-search-indexer.c"
				GeeConcurrentList* _tmp35_;
				const gchar* _tmp36_;
				ProjectUpdate* _tmp37_;
				ProjectUpdate* _tmp38_;
#line 283 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp35_ = self->priv->processing_queue;
#line 283 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp36_ = project;
#line 283 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp37_ = project_update_new (PROJECT_UPDATE_TYPE_REMOVED, _tmp36_, NULL);
#line 283 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_tmp38_ = _tmp37_;
#line 283 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp35_, (IndexerMessage*) _tmp38_);
#line 283 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_g_object_unref0 (_tmp38_);
#line 3176 "fuzzy-search-indexer.c"
			}
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_g_free0 (project);
#line 3180 "fuzzy-search-indexer.c"
		}
#line 281 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_object_unref0 (_project_it);
#line 3184 "fuzzy-search-indexer.c"
	}
#line 270 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (opened_projects);
#line 270 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	opened_projects_array = (_vala_array_free (opened_projects_array, opened_projects_array_length1, (GDestroyNotify) g_free), NULL);
#line 3190 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_process_initial_indexing_requests_async_data_free (gpointer _data)
{
	ScratchServicesFuzzySearchIndexerProcessInitialIndexingRequestsAsyncData* _data_;
	_data_ = _data;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->project_paths);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->self);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_slice_free (ScratchServicesFuzzySearchIndexerProcessInitialIndexingRequestsAsyncData, _data_);
#line 3204 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_process_initial_indexing_requests_async (ScratchServicesFuzzySearchIndexer* self,
                                                                               GeeArrayList* request_queue,
                                                                               GeeHashMap* project_paths,
                                                                               GAsyncReadyCallback _callback_,
                                                                               gpointer _user_data_)
{
	ScratchServicesFuzzySearchIndexerProcessInitialIndexingRequestsAsyncData* _data_;
	ScratchServicesFuzzySearchIndexer* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeHashMap* _tmp2_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (request_queue != NULL);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (project_paths != NULL);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_ = g_slice_new0 (ScratchServicesFuzzySearchIndexerProcessInitialIndexingRequestsAsyncData);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, scratch_services_fuzzy_search_indexer_process_initial_indexing_requests_async_data_free);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->self = _tmp0_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp1_ = _g_object_ref0 (request_queue);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->request_queue);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->request_queue = _tmp1_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp2_ = _g_object_ref0 (project_paths);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->project_paths);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->project_paths = _tmp2_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_fuzzy_search_indexer_process_initial_indexing_requests_async_co (_data_);
#line 3248 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_process_initial_indexing_requests_finish (ScratchServicesFuzzySearchIndexer* self,
                                                                                GAsyncResult* _res_)
{
	ScratchServicesFuzzySearchIndexerProcessInitialIndexingRequestsAsyncData* _data_;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3258 "fuzzy-search-indexer.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return _data8_;
#line 3268 "fuzzy-search-indexer.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 3278 "fuzzy-search-indexer.c"
		ScratchServicesFuzzySearchIndexer* self;
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		self = _data8_->self;
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_object_unref0 (_data8_->request_queue);
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_object_unref0 (self);
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_slice_free (Block8Data, _data8_);
#line 3288 "fuzzy-search-indexer.c"
	}
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return _data9_;
#line 3299 "fuzzy-search-indexer.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 3309 "fuzzy-search-indexer.c"
		ScratchServicesFuzzySearchIndexer* self;
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		self = _data9_->_data8_->self;
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_scratch_services_search_project_unref0 (_data9_->project_search);
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_object_unref0 (_data9_->request);
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		block8_data_unref (_data9_->_data8_);
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_data9_->_data8_ = NULL;
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_slice_free (Block9Data, _data9_);
#line 3323 "fuzzy-search-indexer.c"
	}
}

static void
_____lambda9_ (Block9Data* _data9_,
               GObject* obj,
               GAsyncResult* res)
{
	Block8Data* _data8_;
	ScratchServicesFuzzySearchIndexer* self;
	ScratchServicesSearchProject* _tmp0_;
	InitialIndexRequest* _tmp1_;
#line 297 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data8_ = _data9_->_data8_;
#line 297 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = _data8_->self;
#line 297 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (res != NULL);
#line 298 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = _data9_->project_search;
#line 298 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_search_project_parse_finish (_tmp0_, res);
#line 299 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp1_ = _data9_->request;
#line 299 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _data8_->request_queue, _tmp1_);
#line 3350 "fuzzy-search-indexer.c"
}

static void
______lambda9__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 297 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_____lambda9_ (self, source_object, res);
#line 297 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	block9_data_unref (self);
#line 3362 "fuzzy-search-indexer.c"
}

static gboolean
scratch_services_fuzzy_search_indexer_process_initial_indexing_requests_async_co (ScratchServicesFuzzySearchIndexerProcessInitialIndexingRequestsAsyncData* _data_)
{
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	switch (_data_->_state_) {
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case 0:
#line 3372 "fuzzy-search-indexer.c"
		goto _state_0;
		default:
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_assert_not_reached ();
#line 3377 "fuzzy-search-indexer.c"
	}
	_state_0:
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data8_ = g_slice_new0 (Block8Data);
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data8_->_ref_count_ = 1;
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data8_->self = g_object_ref (_data_->self);
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_data_->_data8_->request_queue);
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data8_->request_queue = _data_->request_queue;
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data8_->_async_data_ = _data_;
#line 3392 "fuzzy-search-indexer.c"
	{
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_data_->i = 0;
#line 3396 "fuzzy-search-indexer.c"
		{
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_data_->_tmp0_ = TRUE;
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			while (TRUE) {
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_data9_ = g_slice_new0 (Block9Data);
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_data9_->_ref_count_ = 1;
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_data9_->_data8_ = block8_data_ref (_data_->_data8_);
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				if (!_data_->_tmp0_) {
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_data_->_tmp1_ = _data_->i;
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_data_->i = _data_->_tmp1_ + 1;
#line 3414 "fuzzy-search-indexer.c"
				}
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp0_ = FALSE;
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_data8_->request_queue);
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp3_ = _data_->_tmp2_;
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				if (!(_data_->i < _data_->_tmp3_)) {
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					block9_data_unref (_data_->_data9_);
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					_data_->_data9_ = NULL;
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
					break;
#line 3430 "fuzzy-search-indexer.c"
				}
#line 292 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_data8_->request_queue, _data_->i);
#line 292 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_data9_->request = (InitialIndexRequest*) _data_->_tmp4_;
#line 293 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp5_ = _data_->_data9_->request;
#line 293 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp6_ = initial_index_request_get_project_path (_data_->_tmp5_);
#line 293 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp7_ = _data_->_tmp6_;
#line 293 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp8_ = scratch_services_git_manager_get_monitored_repository (_data_->_tmp7_);
#line 293 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->monitor = _data_->_tmp8_;
#line 294 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp9_ = _data_->_data9_->request;
#line 294 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp10_ = initial_index_request_get_project_path (_data_->_tmp9_);
#line 294 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp11_ = _data_->_tmp10_;
#line 294 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp12_ = _data_->monitor;
#line 294 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp13_ = scratch_services_search_project_new (_data_->_tmp11_, _data_->_tmp12_);
#line 294 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_data9_->project_search = _data_->_tmp13_;
#line 296 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp14_ = _data_->_data9_->request;
#line 296 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp15_ = initial_index_request_get_project_path (_data_->_tmp14_);
#line 296 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp16_ = _data_->_tmp15_;
#line 296 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp17_ = _data_->_data9_->project_search;
#line 296 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _data_->project_paths, _data_->_tmp16_, _data_->_tmp17_);
#line 297 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp18_ = _data_->_data9_->project_search;
#line 297 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp19_ = _data_->_data9_->request;
#line 297 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp20_ = initial_index_request_get_project_path (_data_->_tmp19_);
#line 297 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp21_ = _data_->_tmp20_;
#line 297 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_tmp22_ = _data_->self->priv->cancellable;
#line 297 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				scratch_services_search_project_parse_async (_data_->_tmp18_, _data_->_tmp21_, _data_->_tmp22_, ______lambda9__gasync_ready_callback, block9_data_ref (_data_->_data9_));
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_g_object_unref0 (_data_->monitor);
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				block9_data_unref (_data_->_data9_);
#line 291 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
				_data_->_data9_ = NULL;
#line 3486 "fuzzy-search-indexer.c"
			}
		}
	}
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	block8_data_unref (_data_->_data8_);
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_data_->_data8_ = NULL;
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (_data_->_state_ != 0) {
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3502 "fuzzy-search-indexer.c"
		}
	}
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_unref (_data_->_async_result);
#line 288 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return FALSE;
#line 3509 "fuzzy-search-indexer.c"
}

static gchar*
scratch_services_fuzzy_search_indexer_get_project_path_of_file (ScratchServicesFuzzySearchIndexer* self,
                                                                const gchar* file_path)
{
	GeeIterator* iter = NULL;
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	GeeIterator* _tmp4_;
	GeeIterator* _tmp5_;
	gchar* result;
#line 304 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 304 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 305 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = self->priv->_project_paths;
#line 305 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 305 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp2_ = _tmp1_;
#line 305 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp3_ = _tmp2_;
#line 305 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 305 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp5_ = _tmp4_;
#line 305 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (_tmp3_);
#line 305 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	iter = _tmp5_;
#line 306 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	while (TRUE) {
#line 3546 "fuzzy-search-indexer.c"
		GeeIterator* _tmp6_;
		gchar* project_path = NULL;
		GeeIterator* _tmp7_;
		gpointer _tmp8_;
		const gchar* _tmp9_;
#line 306 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp6_ = iter;
#line 306 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		if (!gee_iterator_next (_tmp6_)) {
#line 306 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			break;
#line 3558 "fuzzy-search-indexer.c"
		}
#line 307 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp7_ = iter;
#line 307 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp8_ = gee_iterator_get (_tmp7_);
#line 307 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		project_path = (gchar*) _tmp8_;
#line 308 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp9_ = project_path;
#line 308 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		if (g_str_has_prefix (file_path, _tmp9_)) {
#line 309 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			result = project_path;
#line 309 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			_g_object_unref0 (iter);
#line 309 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
			return result;
#line 3576 "fuzzy-search-indexer.c"
		}
#line 306 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_free0 (project_path);
#line 3580 "fuzzy-search-indexer.c"
	}
#line 313 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	result = NULL;
#line 313 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (iter);
#line 313 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return result;
#line 3588 "fuzzy-search-indexer.c"
}

GeeHashMap*
scratch_services_fuzzy_search_indexer_get_project_paths (ScratchServicesFuzzySearchIndexer* self)
{
	GeeHashMap* result;
	GeeHashMap* _tmp0_;
#line 63 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 63 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_tmp0_ = self->priv->_project_paths;
#line 63 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	result = _tmp0_;
#line 63 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	return result;
#line 3604 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_set_project_paths (ScratchServicesFuzzySearchIndexer* self,
                                                         GeeHashMap* value)
{
	GeeHashMap* old_value;
#line 63 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_return_if_fail (self != NULL);
#line 63 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	old_value = scratch_services_fuzzy_search_indexer_get_project_paths (self);
#line 63 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	if (old_value != value) {
#line 3618 "fuzzy-search-indexer.c"
		GeeHashMap* _tmp0_;
#line 63 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 63 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		_g_object_unref0 (self->priv->_project_paths);
#line 63 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		self->priv->_project_paths = _tmp0_;
#line 63 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_services_fuzzy_search_indexer_properties[SCRATCH_SERVICES_FUZZY_SEARCH_INDEXER_PROJECT_PATHS_PROPERTY]);
#line 3628 "fuzzy-search-indexer.c"
	}
}

static void
scratch_services_fuzzy_search_indexer_class_init (ScratchServicesFuzzySearchIndexerClass * klass,
                                                  gpointer klass_data)
{
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	scratch_services_fuzzy_search_indexer_parent_class = g_type_class_peek_parent (klass);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_type_class_adjust_private_offset (klass, &ScratchServicesFuzzySearchIndexer_private_offset);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_scratch_services_fuzzy_search_indexer_get_property;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_scratch_services_fuzzy_search_indexer_set_property;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	G_OBJECT_CLASS (klass)->finalize = scratch_services_fuzzy_search_indexer_finalize;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_SERVICES_FUZZY_SEARCH_INDEXER_PROJECT_PATHS_PROPERTY, scratch_services_fuzzy_search_indexer_properties[SCRATCH_SERVICES_FUZZY_SEARCH_INDEXER_PROJECT_PATHS_PROPERTY] = g_param_spec_object ("project-paths", "project-paths", "project-paths", GEE_TYPE_HASH_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3648 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_instance_init (ScratchServicesFuzzySearchIndexer * self,
                                                     gpointer klass)
{
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self->priv = scratch_services_fuzzy_search_indexer_get_instance_private (self);
#line 3657 "fuzzy-search-indexer.c"
}

static void
scratch_services_fuzzy_search_indexer_finalize (GObject * obj)
{
	ScratchServicesFuzzySearchIndexer * self;
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_SERVICES_TYPE_FUZZY_SEARCH_INDEXER, ScratchServicesFuzzySearchIndexer);
#line 63 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (self->priv->_project_paths);
#line 65 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (self->priv->initial_indexing_queue);
#line 66 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (self->priv->folder_settings);
#line 67 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 68 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	_g_object_unref0 (self->priv->processing_queue);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	G_OBJECT_CLASS (scratch_services_fuzzy_search_indexer_parent_class)->finalize (obj);
#line 3678 "fuzzy-search-indexer.c"
}

GType
scratch_services_fuzzy_search_indexer_get_type (void)
{
	return scratch_services_fuzzy_search_indexer_type_id;
}

GType
scratch_services_fuzzy_search_indexer_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScratchServicesFuzzySearchIndexerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scratch_services_fuzzy_search_indexer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScratchServicesFuzzySearchIndexer), 0, (GInstanceInitFunc) scratch_services_fuzzy_search_indexer_instance_init, NULL };
	scratch_services_fuzzy_search_indexer_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "ScratchServicesFuzzySearchIndexer", &g_define_type_info, 0);
	ScratchServicesFuzzySearchIndexer_private_offset = sizeof (ScratchServicesFuzzySearchIndexerPrivate);
	return scratch_services_fuzzy_search_indexer_type_id;
}

static void
_vala_scratch_services_fuzzy_search_indexer_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec)
{
	ScratchServicesFuzzySearchIndexer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_SERVICES_TYPE_FUZZY_SEARCH_INDEXER, ScratchServicesFuzzySearchIndexer);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	switch (property_id) {
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case SCRATCH_SERVICES_FUZZY_SEARCH_INDEXER_PROJECT_PATHS_PROPERTY:
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		g_value_set_object (value, scratch_services_fuzzy_search_indexer_get_project_paths (self));
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 3712 "fuzzy-search-indexer.c"
		default:
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 3718 "fuzzy-search-indexer.c"
	}
}

static void
_vala_scratch_services_fuzzy_search_indexer_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec)
{
	ScratchServicesFuzzySearchIndexer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_SERVICES_TYPE_FUZZY_SEARCH_INDEXER, ScratchServicesFuzzySearchIndexer);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
	switch (property_id) {
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		case SCRATCH_SERVICES_FUZZY_SEARCH_INDEXER_PROJECT_PATHS_PROPERTY:
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		scratch_services_fuzzy_search_indexer_set_project_paths (self, g_value_get_object (value));
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 3738 "fuzzy-search-indexer.c"
		default:
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 62 "../plugins/fuzzy-search/fuzzy-search-indexer.vala"
		break;
#line 3744 "fuzzy-search-indexer.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

