/* FileView.c generated by valac 0.56.18, the Vala compiler
 * generated from FileView.vala, do not modify */

/*-
 * Copyright (c) 2017 - 2022 elementary LLC. (https://elementary.io),
 *               2013 Julien Spautz <spautz.julien@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Julien Spautz <spautz.julien@gmail.com>, Andrei-Costin Zisu <matzipan@gmail.com>
 */

#include "codecore.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gee.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gio/gdesktopappinfo.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_0_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTIONS_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_TOPLEVEL_ACTION_GROUP_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_IGNORE_NEXT_SELECT_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_ICON_NAME_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_TITLE_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTIVE_PROJECT_PATH_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_NUM_PROPERTIES
};
static GParamSpec* scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
typedef struct _Block10Data Block10Data;
typedef struct _Block11Data Block11Data;
typedef struct _Block12Data Block12Data;
enum  {
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_SELECT_SIGNAL,
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_RENAME_REQUEST_SIGNAL,
	SCRATCH_FOLDER_MANAGER_FILE_VIEW_NUM_SIGNALS
};
static guint scratch_folder_manager_file_view_signals[SCRATCH_FOLDER_MANAGER_FILE_VIEW_NUM_SIGNALS] = {0};

struct _ScratchFolderManagerFileViewPrivate {
	GSettings* settings;
	ScratchServicesGitManager* git_manager;
	ScratchServicesPluginsManager* plugins;
	GSimpleActionGroup* _actions;
	GActionGroup* _toplevel_action_group;
	gboolean _ignore_next_select;
	gchar* _icon_name;
	gchar* _title;
};

struct _Block8Data {
	int _ref_count_;
	ScratchFolderManagerFileView* self;
	gchar* path;
};

struct _Block9Data {
	int _ref_count_;
	Block8Data * _data8_;
	gulong once;
};

struct _Block10Data {
	int _ref_count_;
	ScratchFolderManagerFileView* self;
	ScratchFolderManagerFolderItem* folder_to_rename;
};

struct _Block11Data {
	int _ref_count_;
	ScratchFolderManagerFileView* self;
	ScratchFolderManagerItem* item_to_delete;
};

struct _Block12Data {
	int _ref_count_;
	ScratchFolderManagerFileView* self;
	ScratchFolderManagerProjectFolderItem* folder_root;
};

static gint ScratchFolderManagerFileView_private_offset;
static gpointer scratch_folder_manager_file_view_parent_class = NULL;
static CodePaneSwitcherIface * scratch_folder_manager_file_view_code_pane_switcher_parent_iface = NULL;

static void scratch_folder_manager_file_view_action_launch_app_with_file_path (ScratchFolderManagerFileView* self,
                                                                        GSimpleAction* action,
                                                                        GVariant* param);
static void _scratch_folder_manager_file_view_action_launch_app_with_file_path_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                          GVariant* parameter,
                                                                                                          gpointer self);
static void scratch_folder_manager_file_view_action_show_app_chooser (ScratchFolderManagerFileView* self,
                                                               GSimpleAction* action,
                                                               GVariant* param);
static void _scratch_folder_manager_file_view_action_show_app_chooser_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                 GVariant* parameter,
                                                                                                 gpointer self);
static void scratch_folder_manager_file_view_action_execute_contract_with_file_path (ScratchFolderManagerFileView* self,
                                                                              GSimpleAction* action,
                                                                              GVariant* param);
static void _scratch_folder_manager_file_view_action_execute_contract_with_file_path_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                                GVariant* parameter,
                                                                                                                gpointer self);
static void scratch_folder_manager_file_view_action_rename_file (ScratchFolderManagerFileView* self,
                                                          GSimpleAction* action,
                                                          GVariant* param);
static void _scratch_folder_manager_file_view_action_rename_file_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                            GVariant* parameter,
                                                                                            gpointer self);
static void scratch_folder_manager_file_view_action_rename_folder (ScratchFolderManagerFileView* self,
                                                            GSimpleAction* action,
                                                            GVariant* param);
static void _scratch_folder_manager_file_view_action_rename_folder_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                              GVariant* parameter,
                                                                                              gpointer self);
static void scratch_folder_manager_file_view_action_delete (ScratchFolderManagerFileView* self,
                                                     GSimpleAction* action,
                                                     GVariant* param);
static void _scratch_folder_manager_file_view_action_delete_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                       GVariant* parameter,
                                                                                       gpointer self);
static void scratch_folder_manager_file_view_add_new_file (ScratchFolderManagerFileView* self,
                                                    GSimpleAction* action,
                                                    GVariant* param);
static void _scratch_folder_manager_file_view_add_new_file_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                      GVariant* parameter,
                                                                                      gpointer self);
static void scratch_folder_manager_file_view_add_new_folder (ScratchFolderManagerFileView* self,
                                                      GSimpleAction* action,
                                                      GVariant* param);
static void _scratch_folder_manager_file_view_add_new_folder_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self);
static void scratch_folder_manager_file_view_action_close_folder (ScratchFolderManagerFileView* self,
                                                           GSimpleAction* action,
                                                           GVariant* parameter);
static void _scratch_folder_manager_file_view_action_close_folder_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                             GVariant* parameter,
                                                                                             gpointer self);
static void scratch_folder_manager_file_view_action_close_other_folders (ScratchFolderManagerFileView* self,
                                                                  GSimpleAction* action,
                                                                  GVariant* parameter);
static void _scratch_folder_manager_file_view_action_close_other_folders_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                    GVariant* parameter,
                                                                                                    gpointer self);
static CodeWidgetsSourceListItem* scratch_folder_manager_file_view_find_path (ScratchFolderManagerFileView* self,
                                                                       CodeWidgetsSourceListExpandableItem* list,
                                                                       const gchar* path,
                                                                       gboolean expand);
static void scratch_folder_manager_file_view_write_settings (ScratchFolderManagerFileView* self);
static void scratch_folder_manager_file_view_on_item_selected (ScratchFolderManagerFileView* self,
                                                        CodeWidgetsSourceListItem* item);
static void scratch_folder_manager_file_view_add_folder (ScratchFolderManagerFileView* self,
                                                  ScratchFolderManagerFile* folder,
                                                  gboolean expand);
static gboolean scratch_folder_manager_file_view_is_open (ScratchFolderManagerFileView* self,
                                                   ScratchFolderManagerFile* folder);
static gint __lambda78_ (ScratchFolderManagerFileView* self,
                  ScratchFolderManagerProjectFolderItem* a,
                  ScratchFolderManagerProjectFolderItem* b);
static gint ___lambda78__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
static void _scratch_folder_manager_file_view_on_item_selected_code_widgets_source_list_item_selected (CodeWidgetsSourceList* _sender,
                                                                                                CodeWidgetsSourceListItem* item,
                                                                                                gpointer self);
static void scratch_folder_manager_file_view_rename_file (ScratchFolderManagerFileView* self,
                                                   const gchar* path);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void ___lambda70_ (Block9Data* _data9_,
                   const gchar* new_name);
static void ____lambda70__code_widgets_source_list_item_edited (CodeWidgetsSourceListItem* _sender,
                                                         const gchar* new_name,
                                                         gpointer self);
static gboolean __lambda71_ (ScratchFolderManagerFileView* self);
static gboolean ___lambda71__gsource_func (gpointer self);
static void scratch_folder_manager_file_view_rename_folder (ScratchFolderManagerFileView* self,
                                                     const gchar* path);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static gboolean ___lambda72_ (Block10Data* _data10_);
static gboolean ____lambda72__gsource_func (gpointer self);
static void scratch_folder_manager_file_view_rename_items_with_same_name (ScratchFolderManagerFileView* self,
                                                                   ScratchFolderManagerItem* item);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void ____lambda73_ (Block11Data* _data11_);
static void _____lambda73__scratch_folder_manager_project_folder_item_closed (ScratchFolderManagerProjectFolderItem* _sender,
                                                                       gpointer self);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static void __lambda77_ (Block12Data* _data12_);
static void ___lambda77__scratch_folder_manager_project_folder_item_closed (ScratchFolderManagerProjectFolderItem* _sender,
                                                                     gpointer self);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void scratch_folder_manager_file_view_set_actions (ScratchFolderManagerFileView* self,
                                                   GSimpleActionGroup* value);
static void scratch_folder_manager_file_view_set_toplevel_action_group (ScratchFolderManagerFileView* self,
                                                                 GActionGroup* value);
static void g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static GObject * scratch_folder_manager_file_view_constructor (GType type,
                                                        guint n_construct_properties,
                                                        GObjectConstructParam * construct_properties);
static void _scratch_folder_manager_file_view___lambda84_ (ScratchFolderManagerFileView* self);
static void __scratch_folder_manager_file_view___lambda84__gtk_widget_realize (GtkWidget* _sender,
                                                                        gpointer self);
static void scratch_folder_manager_file_view_finalize (GObject * obj);
static GType scratch_folder_manager_file_view_get_type_once (void);
static void _vala_scratch_folder_manager_file_view_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec);
static void _vala_scratch_folder_manager_file_view_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GActionEntry SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_ENTRIES[10] = {{SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_LAUNCH_APP_WITH_FILE_PATH, _scratch_folder_manager_file_view_action_launch_app_with_file_path_gsimple_action_activate_callback, "as"}, {SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_SHOW_APP_CHOOSER, _scratch_folder_manager_file_view_action_show_app_chooser_gsimple_action_activate_callback, "s"}, {SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_EXECUTE_CONTRACT_WITH_FILE_PATH, _scratch_folder_manager_file_view_action_execute_contract_with_file_path_gsimple_action_activate_callback, "as"}, {SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_RENAME_FILE, _scratch_folder_manager_file_view_action_rename_file_gsimple_action_activate_callback, "s"}, {SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_RENAME_FOLDER, _scratch_folder_manager_file_view_action_rename_folder_gsimple_action_activate_callback, "s"}, {SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_DELETE, _scratch_folder_manager_file_view_action_delete_gsimple_action_activate_callback, "s"}, {SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_NEW_FILE, _scratch_folder_manager_file_view_add_new_file_gsimple_action_activate_callback, "s"}, {SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_NEW_FOLDER, _scratch_folder_manager_file_view_add_new_folder_gsimple_action_activate_callback, "s"}, {SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_CLOSE_FOLDER, _scratch_folder_manager_file_view_action_close_folder_gsimple_action_activate_callback, "s"}, {SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_CLOSE_OTHER_FOLDERS, _scratch_folder_manager_file_view_action_close_other_folders_gsimple_action_activate_callback, "s"}};

static inline gpointer
scratch_folder_manager_file_view_get_instance_private (ScratchFolderManagerFileView* self)
{
	return G_STRUCT_MEMBER_P (self, ScratchFolderManagerFileView_private_offset);
}

static void
_scratch_folder_manager_file_view_action_launch_app_with_file_path_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                     GVariant* parameter,
                                                                                                     gpointer self)
{
#line 39 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_action_launch_app_with_file_path ((ScratchFolderManagerFileView*) self, action, parameter);
#line 282 "FileView.c"
}

static void
_scratch_folder_manager_file_view_action_show_app_chooser_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                            GVariant* parameter,
                                                                                            gpointer self)
{
#line 39 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_action_show_app_chooser ((ScratchFolderManagerFileView*) self, action, parameter);
#line 292 "FileView.c"
}

static void
_scratch_folder_manager_file_view_action_execute_contract_with_file_path_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                           GVariant* parameter,
                                                                                                           gpointer self)
{
#line 39 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_action_execute_contract_with_file_path ((ScratchFolderManagerFileView*) self, action, parameter);
#line 302 "FileView.c"
}

static void
_scratch_folder_manager_file_view_action_rename_file_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                       GVariant* parameter,
                                                                                       gpointer self)
{
#line 39 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_action_rename_file ((ScratchFolderManagerFileView*) self, action, parameter);
#line 312 "FileView.c"
}

static void
_scratch_folder_manager_file_view_action_rename_folder_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                         GVariant* parameter,
                                                                                         gpointer self)
{
#line 39 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_action_rename_folder ((ScratchFolderManagerFileView*) self, action, parameter);
#line 322 "FileView.c"
}

static void
_scratch_folder_manager_file_view_action_delete_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self)
{
#line 39 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_action_delete ((ScratchFolderManagerFileView*) self, action, parameter);
#line 332 "FileView.c"
}

static void
_scratch_folder_manager_file_view_add_new_file_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self)
{
#line 39 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_add_new_file ((ScratchFolderManagerFileView*) self, action, parameter);
#line 342 "FileView.c"
}

static void
_scratch_folder_manager_file_view_add_new_folder_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self)
{
#line 39 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_add_new_folder ((ScratchFolderManagerFileView*) self, action, parameter);
#line 352 "FileView.c"
}

static void
_scratch_folder_manager_file_view_action_close_folder_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self)
{
#line 39 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_action_close_folder ((ScratchFolderManagerFileView*) self, action, parameter);
#line 362 "FileView.c"
}

static void
_scratch_folder_manager_file_view_action_close_other_folders_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                               GVariant* parameter,
                                                                                               gpointer self)
{
#line 39 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_action_close_other_folders ((ScratchFolderManagerFileView*) self, action, parameter);
#line 372 "FileView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 71 "../src/FolderManager/FileView.vala"
	return self ? g_object_ref (self) : NULL;
#line 380 "FileView.c"
}

ScratchFolderManagerFileView*
scratch_folder_manager_file_view_construct (GType object_type,
                                            ScratchServicesPluginsManager* plugins_manager)
{
	ScratchFolderManagerFileView * self = NULL;
	CodeWidgetsSourceListExpandableItem* _tmp0_;
	CodeWidgetsSourceListExpandableItem* _tmp1_;
	ScratchServicesPluginsManager* _tmp2_;
#line 70 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (plugins_manager != NULL, NULL);
#line 70 "../src/FolderManager/FileView.vala"
	_tmp0_ = code_widgets_source_list_expandable_item_new ("");
#line 70 "../src/FolderManager/FileView.vala"
	_tmp1_ = _tmp0_;
#line 70 "../src/FolderManager/FileView.vala"
	self = (ScratchFolderManagerFileView*) code_widgets_source_list_construct (object_type, _tmp1_);
#line 70 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (_tmp1_);
#line 71 "../src/FolderManager/FileView.vala"
	_tmp2_ = _g_object_ref0 (plugins_manager);
#line 71 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (self->priv->plugins);
#line 71 "../src/FolderManager/FileView.vala"
	self->priv->plugins = _tmp2_;
#line 70 "../src/FolderManager/FileView.vala"
	return self;
#line 409 "FileView.c"
}

ScratchFolderManagerFileView*
scratch_folder_manager_file_view_new (ScratchServicesPluginsManager* plugins_manager)
{
#line 70 "../src/FolderManager/FileView.vala"
	return scratch_folder_manager_file_view_construct (SCRATCH_FOLDER_MANAGER_TYPE_FILE_VIEW, plugins_manager);
#line 417 "FileView.c"
}

static void
scratch_folder_manager_file_view_action_close_folder (ScratchFolderManagerFileView* self,
                                                      GSimpleAction* action,
                                                      GVariant* parameter)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	ScratchFolderManagerProjectFolderItem* project_item = NULL;
	CodeWidgetsSourceListExpandableItem* _tmp5_;
	CodeWidgetsSourceListExpandableItem* _tmp6_;
	const gchar* _tmp7_;
	CodeWidgetsSourceListItem* _tmp8_;
	ScratchFolderManagerProjectFolderItem* _tmp9_;
	ScratchFolderManagerProjectFolderItem* _tmp10_;
	ScratchFolderManagerProjectFolderItem* _tmp11_;
#line 94 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/FolderManager/FileView.vala"
	g_return_if_fail (action != NULL);
#line 95 "../src/FolderManager/FileView.vala"
	_tmp0_ = g_variant_get_string (parameter, NULL);
#line 95 "../src/FolderManager/FileView.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 95 "../src/FolderManager/FileView.vala"
	path = _tmp1_;
#line 96 "../src/FolderManager/FileView.vala"
	_tmp3_ = path;
#line 96 "../src/FolderManager/FileView.vala"
	if (_tmp3_ == NULL) {
#line 96 "../src/FolderManager/FileView.vala"
		_tmp2_ = TRUE;
#line 454 "FileView.c"
	} else {
		const gchar* _tmp4_;
#line 96 "../src/FolderManager/FileView.vala"
		_tmp4_ = path;
#line 96 "../src/FolderManager/FileView.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") == 0;
#line 461 "FileView.c"
	}
#line 96 "../src/FolderManager/FileView.vala"
	if (_tmp2_) {
#line 97 "../src/FolderManager/FileView.vala"
		_g_free0 (path);
#line 97 "../src/FolderManager/FileView.vala"
		return;
#line 469 "FileView.c"
	}
#line 100 "../src/FolderManager/FileView.vala"
	_tmp5_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 100 "../src/FolderManager/FileView.vala"
	_tmp6_ = _tmp5_;
#line 100 "../src/FolderManager/FileView.vala"
	_tmp7_ = path;
#line 100 "../src/FolderManager/FileView.vala"
	_tmp8_ = scratch_folder_manager_file_view_find_path (self, _tmp6_, _tmp7_, FALSE);
#line 100 "../src/FolderManager/FileView.vala"
	_tmp9_ = _g_object_ref0 (SCRATCH_FOLDER_MANAGER_IS_PROJECT_FOLDER_ITEM (_tmp8_) ? ((ScratchFolderManagerProjectFolderItem*) _tmp8_) : NULL);
#line 100 "../src/FolderManager/FileView.vala"
	project_item = _tmp9_;
#line 101 "../src/FolderManager/FileView.vala"
	_tmp10_ = project_item;
#line 101 "../src/FolderManager/FileView.vala"
	if (_tmp10_ == NULL) {
#line 102 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (project_item);
#line 102 "../src/FolderManager/FileView.vala"
		_g_free0 (path);
#line 102 "../src/FolderManager/FileView.vala"
		return;
#line 493 "FileView.c"
	}
#line 105 "../src/FolderManager/FileView.vala"
	_tmp11_ = project_item;
#line 105 "../src/FolderManager/FileView.vala"
	g_signal_emit_by_name (_tmp11_, "closed");
#line 94 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (project_item);
#line 94 "../src/FolderManager/FileView.vala"
	_g_free0 (path);
#line 503 "FileView.c"
}

static void
scratch_folder_manager_file_view_action_close_other_folders (ScratchFolderManagerFileView* self,
                                                             GSimpleAction* action,
                                                             GVariant* parameter)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	ScratchFolderManagerProjectFolderItem* folder_root = NULL;
	CodeWidgetsSourceListExpandableItem* _tmp5_;
	CodeWidgetsSourceListExpandableItem* _tmp6_;
	const gchar* _tmp7_;
	CodeWidgetsSourceListItem* _tmp8_;
	ScratchFolderManagerProjectFolderItem* _tmp9_;
	ScratchFolderManagerProjectFolderItem* _tmp10_;
#line 108 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/FolderManager/FileView.vala"
	g_return_if_fail (action != NULL);
#line 109 "../src/FolderManager/FileView.vala"
	_tmp0_ = g_variant_get_string (parameter, NULL);
#line 109 "../src/FolderManager/FileView.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 109 "../src/FolderManager/FileView.vala"
	path = _tmp1_;
#line 110 "../src/FolderManager/FileView.vala"
	_tmp3_ = path;
#line 110 "../src/FolderManager/FileView.vala"
	if (_tmp3_ == NULL) {
#line 110 "../src/FolderManager/FileView.vala"
		_tmp2_ = TRUE;
#line 539 "FileView.c"
	} else {
		const gchar* _tmp4_;
#line 110 "../src/FolderManager/FileView.vala"
		_tmp4_ = path;
#line 110 "../src/FolderManager/FileView.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") == 0;
#line 546 "FileView.c"
	}
#line 110 "../src/FolderManager/FileView.vala"
	if (_tmp2_) {
#line 111 "../src/FolderManager/FileView.vala"
		_g_free0 (path);
#line 111 "../src/FolderManager/FileView.vala"
		return;
#line 554 "FileView.c"
	}
#line 114 "../src/FolderManager/FileView.vala"
	_tmp5_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 114 "../src/FolderManager/FileView.vala"
	_tmp6_ = _tmp5_;
#line 114 "../src/FolderManager/FileView.vala"
	_tmp7_ = path;
#line 114 "../src/FolderManager/FileView.vala"
	_tmp8_ = scratch_folder_manager_file_view_find_path (self, _tmp6_, _tmp7_, FALSE);
#line 114 "../src/FolderManager/FileView.vala"
	_tmp9_ = _g_object_ref0 (SCRATCH_FOLDER_MANAGER_IS_PROJECT_FOLDER_ITEM (_tmp8_) ? ((ScratchFolderManagerProjectFolderItem*) _tmp8_) : NULL);
#line 114 "../src/FolderManager/FileView.vala"
	folder_root = _tmp9_;
#line 115 "../src/FolderManager/FileView.vala"
	_tmp10_ = folder_root;
#line 115 "../src/FolderManager/FileView.vala"
	if (_tmp10_ == NULL) {
#line 116 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (folder_root);
#line 116 "../src/FolderManager/FileView.vala"
		_g_free0 (path);
#line 116 "../src/FolderManager/FileView.vala"
		return;
#line 578 "FileView.c"
	}
	{
		GeeIterator* _child_it = NULL;
		CodeWidgetsSourceListExpandableItem* _tmp11_;
		CodeWidgetsSourceListExpandableItem* _tmp12_;
		GeeCollection* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeIterator* _tmp16_;
		GeeIterator* _tmp17_;
#line 119 "../src/FolderManager/FileView.vala"
		_tmp11_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 119 "../src/FolderManager/FileView.vala"
		_tmp12_ = _tmp11_;
#line 119 "../src/FolderManager/FileView.vala"
		_tmp13_ = code_widgets_source_list_expandable_item_get_children (_tmp12_);
#line 119 "../src/FolderManager/FileView.vala"
		_tmp14_ = _tmp13_;
#line 119 "../src/FolderManager/FileView.vala"
		_tmp15_ = _tmp14_;
#line 119 "../src/FolderManager/FileView.vala"
		_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
#line 119 "../src/FolderManager/FileView.vala"
		_tmp17_ = _tmp16_;
#line 119 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp15_);
#line 119 "../src/FolderManager/FileView.vala"
		_child_it = _tmp17_;
#line 119 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 609 "FileView.c"
			GeeIterator* _tmp18_;
			CodeWidgetsSourceListItem* child = NULL;
			GeeIterator* _tmp19_;
			gpointer _tmp20_;
			ScratchFolderManagerProjectFolderItem* project_folder_item = NULL;
			CodeWidgetsSourceListItem* _tmp21_;
			ScratchFolderManagerProjectFolderItem* _tmp22_;
			ScratchFolderManagerProjectFolderItem* _tmp23_;
			ScratchFolderManagerProjectFolderItem* _tmp24_;
#line 119 "../src/FolderManager/FileView.vala"
			_tmp18_ = _child_it;
#line 119 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp18_)) {
#line 119 "../src/FolderManager/FileView.vala"
				break;
#line 625 "FileView.c"
			}
#line 119 "../src/FolderManager/FileView.vala"
			_tmp19_ = _child_it;
#line 119 "../src/FolderManager/FileView.vala"
			_tmp20_ = gee_iterator_get (_tmp19_);
#line 119 "../src/FolderManager/FileView.vala"
			child = (CodeWidgetsSourceListItem*) _tmp20_;
#line 120 "../src/FolderManager/FileView.vala"
			_tmp21_ = child;
#line 120 "../src/FolderManager/FileView.vala"
			_tmp22_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, SCRATCH_FOLDER_MANAGER_TYPE_PROJECT_FOLDER_ITEM, ScratchFolderManagerProjectFolderItem));
#line 120 "../src/FolderManager/FileView.vala"
			project_folder_item = _tmp22_;
#line 121 "../src/FolderManager/FileView.vala"
			_tmp23_ = project_folder_item;
#line 121 "../src/FolderManager/FileView.vala"
			_tmp24_ = folder_root;
#line 121 "../src/FolderManager/FileView.vala"
			if (_tmp23_ != _tmp24_) {
#line 645 "FileView.c"
				GActionGroup* _tmp25_;
				ScratchFolderManagerProjectFolderItem* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
				GVariant* _tmp30_;
				GVariant* _tmp31_;
				CodeWidgetsSourceListExpandableItem* _tmp32_;
				CodeWidgetsSourceListExpandableItem* _tmp33_;
				ScratchFolderManagerProjectFolderItem* _tmp34_;
				ScratchServicesGitManager* _tmp35_;
				ScratchServicesGitManager* _tmp36_;
				ScratchFolderManagerProjectFolderItem* _tmp37_;
#line 122 "../src/FolderManager/FileView.vala"
				_tmp25_ = self->priv->_toplevel_action_group;
#line 122 "../src/FolderManager/FileView.vala"
				_tmp26_ = project_folder_item;
#line 122 "../src/FolderManager/FileView.vala"
				_tmp27_ = scratch_folder_manager_item_get_path ((ScratchFolderManagerItem*) _tmp26_);
#line 122 "../src/FolderManager/FileView.vala"
				_tmp28_ = _tmp27_;
#line 122 "../src/FolderManager/FileView.vala"
				_tmp29_ = _tmp28_;
#line 122 "../src/FolderManager/FileView.vala"
				_tmp30_ = g_variant_new_string (_tmp29_);
#line 122 "../src/FolderManager/FileView.vala"
				g_variant_ref_sink (_tmp30_);
#line 122 "../src/FolderManager/FileView.vala"
				_tmp31_ = _tmp30_;
#line 122 "../src/FolderManager/FileView.vala"
				g_action_group_activate_action (_tmp25_, SCRATCH_MAIN_WINDOW_ACTION_CLOSE_PROJECT_DOCS, _tmp31_);
#line 122 "../src/FolderManager/FileView.vala"
				_g_variant_unref0 (_tmp31_);
#line 122 "../src/FolderManager/FileView.vala"
				_g_free0 (_tmp29_);
#line 123 "../src/FolderManager/FileView.vala"
				_tmp32_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 123 "../src/FolderManager/FileView.vala"
				_tmp33_ = _tmp32_;
#line 123 "../src/FolderManager/FileView.vala"
				_tmp34_ = project_folder_item;
#line 123 "../src/FolderManager/FileView.vala"
				code_widgets_source_list_expandable_item_remove (_tmp33_, (CodeWidgetsSourceListItem*) _tmp34_);
#line 124 "../src/FolderManager/FileView.vala"
				_tmp35_ = scratch_services_git_manager_get_instance ();
#line 124 "../src/FolderManager/FileView.vala"
				_tmp36_ = _tmp35_;
#line 124 "../src/FolderManager/FileView.vala"
				_tmp37_ = project_folder_item;
#line 124 "../src/FolderManager/FileView.vala"
				scratch_services_git_manager_remove_project (_tmp36_, _tmp37_);
#line 124 "../src/FolderManager/FileView.vala"
				_g_object_unref0 (_tmp36_);
#line 699 "FileView.c"
			}
#line 119 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (project_folder_item);
#line 119 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child);
#line 705 "FileView.c"
		}
#line 119 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_child_it);
#line 709 "FileView.c"
	}
#line 128 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_write_settings (self);
#line 108 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (folder_root);
#line 108 "../src/FolderManager/FileView.vala"
	_g_free0 (path);
#line 717 "FileView.c"
}

static void
scratch_folder_manager_file_view_on_item_selected (ScratchFolderManagerFileView* self,
                                                   CodeWidgetsSourceListItem* item)
{
	gboolean _tmp0_;
#line 131 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/FolderManager/FileView.vala"
	_tmp0_ = self->priv->_ignore_next_select;
#line 134 "../src/FolderManager/FileView.vala"
	if (_tmp0_) {
#line 135 "../src/FolderManager/FileView.vala"
		scratch_folder_manager_file_view_set_ignore_next_select (self, FALSE);
#line 136 "../src/FolderManager/FileView.vala"
		return;
#line 735 "FileView.c"
	}
#line 139 "../src/FolderManager/FileView.vala"
	if (SCRATCH_FOLDER_MANAGER_IS_FILE_ITEM (item)) {
#line 739 "FileView.c"
		ScratchFolderManagerFile* _tmp1_;
		ScratchFolderManagerFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 140 "../src/FolderManager/FileView.vala"
		_tmp1_ = scratch_folder_manager_item_get_file ((ScratchFolderManagerItem*) G_TYPE_CHECK_INSTANCE_CAST (item, SCRATCH_FOLDER_MANAGER_TYPE_FILE_ITEM, ScratchFolderManagerFileItem));
#line 140 "../src/FolderManager/FileView.vala"
		_tmp2_ = _tmp1_;
#line 140 "../src/FolderManager/FileView.vala"
		_tmp3_ = scratch_folder_manager_file_get_path (_tmp2_);
#line 140 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 140 "../src/FolderManager/FileView.vala"
		_tmp5_ = _tmp4_;
#line 140 "../src/FolderManager/FileView.vala"
		g_signal_emit (self, scratch_folder_manager_file_view_signals[SCRATCH_FOLDER_MANAGER_FILE_VIEW_SELECT_SIGNAL], 0, _tmp5_);
#line 140 "../src/FolderManager/FileView.vala"
		_g_free0 (_tmp5_);
#line 759 "FileView.c"
	}
}

void
scratch_folder_manager_file_view_restore_saved_state (ScratchFolderManagerFileView* self)
{
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
#line 144 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/FolderManager/FileView.vala"
	_tmp0_ = self->priv->settings;
#line 145 "../src/FolderManager/FileView.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "opened-folders");
#line 775 "FileView.c"
	{
		gchar** path_collection = NULL;
		gint path_collection_length1 = 0;
		gint _path_collection_size_ = 0;
		gint path_it = 0;
#line 145 "../src/FolderManager/FileView.vala"
		path_collection = _tmp2_;
#line 145 "../src/FolderManager/FileView.vala"
		path_collection_length1 = _vala_array_length (_tmp1_);
#line 145 "../src/FolderManager/FileView.vala"
		for (path_it = 0; path_it < path_collection_length1; path_it = path_it + 1) {
#line 787 "FileView.c"
			const gchar* path = NULL;
#line 145 "../src/FolderManager/FileView.vala"
			path = path_collection[path_it];
#line 791 "FileView.c"
			{
				const gchar* _tmp3_;
				ScratchFolderManagerFile* _tmp4_;
				ScratchFolderManagerFile* _tmp5_;
#line 146 "../src/FolderManager/FileView.vala"
				_tmp3_ = path;
#line 146 "../src/FolderManager/FileView.vala"
				_tmp4_ = scratch_folder_manager_file_new (_tmp3_);
#line 146 "../src/FolderManager/FileView.vala"
				_tmp5_ = _tmp4_;
#line 146 "../src/FolderManager/FileView.vala"
				scratch_folder_manager_file_view_add_folder (self, _tmp5_, FALSE);
#line 146 "../src/FolderManager/FileView.vala"
				_g_object_unref0 (_tmp5_);
#line 806 "FileView.c"
			}
		}
#line 145 "../src/FolderManager/FileView.vala"
		path_collection = (_vala_array_free (path_collection, path_collection_length1, (GDestroyNotify) g_free), NULL);
#line 811 "FileView.c"
	}
}

void
scratch_folder_manager_file_view_open_folder (ScratchFolderManagerFileView* self,
                                              ScratchFolderManagerFile* folder)
{
#line 150 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/FolderManager/FileView.vala"
	g_return_if_fail (folder != NULL);
#line 151 "../src/FolderManager/FileView.vala"
	if (scratch_folder_manager_file_view_is_open (self, folder)) {
#line 825 "FileView.c"
		CodeWidgetsSourceListItem* existing = NULL;
		CodeWidgetsSourceListExpandableItem* _tmp0_;
		CodeWidgetsSourceListExpandableItem* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		CodeWidgetsSourceListItem* _tmp5_;
		CodeWidgetsSourceListItem* _tmp6_;
		CodeWidgetsSourceListItem* _tmp7_;
		CodeWidgetsSourceListItem* _tmp8_;
#line 152 "../src/FolderManager/FileView.vala"
		_tmp0_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 152 "../src/FolderManager/FileView.vala"
		_tmp1_ = _tmp0_;
#line 152 "../src/FolderManager/FileView.vala"
		_tmp2_ = scratch_folder_manager_file_get_path (folder);
#line 152 "../src/FolderManager/FileView.vala"
		_tmp3_ = _tmp2_;
#line 152 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 152 "../src/FolderManager/FileView.vala"
		_tmp5_ = scratch_folder_manager_file_view_find_path (self, _tmp1_, _tmp4_, FALSE);
#line 152 "../src/FolderManager/FileView.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 152 "../src/FolderManager/FileView.vala"
		_tmp7_ = _tmp6_;
#line 152 "../src/FolderManager/FileView.vala"
		_g_free0 (_tmp4_);
#line 152 "../src/FolderManager/FileView.vala"
		existing = _tmp7_;
#line 153 "../src/FolderManager/FileView.vala"
		_tmp8_ = existing;
#line 153 "../src/FolderManager/FileView.vala"
		if (CODE_WIDGETS_SOURCE_LIST_IS_EXPANDABLE_ITEM (_tmp8_)) {
#line 860 "FileView.c"
			CodeWidgetsSourceListItem* _tmp9_;
#line 154 "../src/FolderManager/FileView.vala"
			_tmp9_ = existing;
#line 154 "../src/FolderManager/FileView.vala"
			code_widgets_source_list_expandable_item_set_expanded (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, CODE_WIDGETS_SOURCE_LIST_TYPE_EXPANDABLE_ITEM, CodeWidgetsSourceListExpandableItem), TRUE);
#line 866 "FileView.c"
		}
#line 157 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (existing);
#line 157 "../src/FolderManager/FileView.vala"
		return;
#line 872 "FileView.c"
	}
#line 160 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_add_folder (self, folder, TRUE);
#line 876 "FileView.c"
}

void
scratch_folder_manager_file_view_collapse_all (ScratchFolderManagerFileView* self)
{
#line 163 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 884 "FileView.c"
	{
		GeeIterator* _child_it = NULL;
		CodeWidgetsSourceListExpandableItem* _tmp0_;
		CodeWidgetsSourceListExpandableItem* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 164 "../src/FolderManager/FileView.vala"
		_tmp0_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 164 "../src/FolderManager/FileView.vala"
		_tmp1_ = _tmp0_;
#line 164 "../src/FolderManager/FileView.vala"
		_tmp2_ = code_widgets_source_list_expandable_item_get_children (_tmp1_);
#line 164 "../src/FolderManager/FileView.vala"
		_tmp3_ = _tmp2_;
#line 164 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 164 "../src/FolderManager/FileView.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 164 "../src/FolderManager/FileView.vala"
		_tmp6_ = _tmp5_;
#line 164 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp4_);
#line 164 "../src/FolderManager/FileView.vala"
		_child_it = _tmp6_;
#line 164 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 914 "FileView.c"
			GeeIterator* _tmp7_;
			CodeWidgetsSourceListItem* child = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			CodeWidgetsSourceListItem* _tmp10_;
#line 164 "../src/FolderManager/FileView.vala"
			_tmp7_ = _child_it;
#line 164 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 164 "../src/FolderManager/FileView.vala"
				break;
#line 926 "FileView.c"
			}
#line 164 "../src/FolderManager/FileView.vala"
			_tmp8_ = _child_it;
#line 164 "../src/FolderManager/FileView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 164 "../src/FolderManager/FileView.vala"
			child = (CodeWidgetsSourceListItem*) _tmp9_;
#line 165 "../src/FolderManager/FileView.vala"
			_tmp10_ = child;
#line 165 "../src/FolderManager/FileView.vala"
			code_widgets_source_list_expandable_item_collapse_all ((CodeWidgetsSourceListExpandableItem*) G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, SCRATCH_FOLDER_MANAGER_TYPE_PROJECT_FOLDER_ITEM, ScratchFolderManagerProjectFolderItem), TRUE, TRUE);
#line 164 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child);
#line 940 "FileView.c"
		}
#line 164 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_child_it);
#line 944 "FileView.c"
	}
}

static gint
__lambda78_ (ScratchFolderManagerFileView* self,
             ScratchFolderManagerProjectFolderItem* a,
             ScratchFolderManagerProjectFolderItem* b)
{
	gint _tmp0_ = 0;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean _tmp9_;
	gint result;
#line 177 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 177 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 178 "../src/FolderManager/FileView.vala"
	_tmp1_ = code_widgets_source_list_item_get_name ((CodeWidgetsSourceListItem*) a);
#line 178 "../src/FolderManager/FileView.vala"
	_tmp2_ = _tmp1_;
#line 178 "../src/FolderManager/FileView.vala"
	_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 178 "../src/FolderManager/FileView.vala"
	_tmp4_ = _tmp3_;
#line 178 "../src/FolderManager/FileView.vala"
	_tmp5_ = code_widgets_source_list_item_get_name ((CodeWidgetsSourceListItem*) b);
#line 178 "../src/FolderManager/FileView.vala"
	_tmp6_ = _tmp5_;
#line 178 "../src/FolderManager/FileView.vala"
	_tmp7_ = g_utf8_strdown (_tmp6_, (gssize) -1);
#line 178 "../src/FolderManager/FileView.vala"
	_tmp8_ = _tmp7_;
#line 178 "../src/FolderManager/FileView.vala"
	_tmp9_ = g_strcmp0 (_tmp4_, _tmp8_) > 0;
#line 178 "../src/FolderManager/FileView.vala"
	_g_free0 (_tmp8_);
#line 178 "../src/FolderManager/FileView.vala"
	_g_free0 (_tmp4_);
#line 178 "../src/FolderManager/FileView.vala"
	if (_tmp9_) {
#line 178 "../src/FolderManager/FileView.vala"
		_tmp0_ = 0;
#line 994 "FileView.c"
	} else {
#line 178 "../src/FolderManager/FileView.vala"
		_tmp0_ = -1;
#line 998 "FileView.c"
	}
#line 178 "../src/FolderManager/FileView.vala"
	result = _tmp0_;
#line 178 "../src/FolderManager/FileView.vala"
	return result;
#line 1004 "FileView.c"
}

static gint
___lambda78__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda78_ ((ScratchFolderManagerFileView*) self, (ScratchFolderManagerProjectFolderItem*) a, (ScratchFolderManagerProjectFolderItem*) b);
#line 177 "../src/FolderManager/FileView.vala"
	return result;
#line 1016 "FileView.c"
}

void
scratch_folder_manager_file_view_order_folders (ScratchFolderManagerFileView* self)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp16_;
#line 169 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/FolderManager/FileView.vala"
	_tmp0_ = gee_array_list_new (SCRATCH_FOLDER_MANAGER_TYPE_PROJECT_FOLDER_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 170 "../src/FolderManager/FileView.vala"
	list = _tmp0_;
#line 1031 "FileView.c"
	{
		GeeIterator* _child_it = NULL;
		CodeWidgetsSourceListExpandableItem* _tmp1_;
		CodeWidgetsSourceListExpandableItem* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		GeeIterator* _tmp6_;
		GeeIterator* _tmp7_;
#line 172 "../src/FolderManager/FileView.vala"
		_tmp1_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 172 "../src/FolderManager/FileView.vala"
		_tmp2_ = _tmp1_;
#line 172 "../src/FolderManager/FileView.vala"
		_tmp3_ = code_widgets_source_list_expandable_item_get_children (_tmp2_);
#line 172 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 172 "../src/FolderManager/FileView.vala"
		_tmp5_ = _tmp4_;
#line 172 "../src/FolderManager/FileView.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 172 "../src/FolderManager/FileView.vala"
		_tmp7_ = _tmp6_;
#line 172 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp5_);
#line 172 "../src/FolderManager/FileView.vala"
		_child_it = _tmp7_;
#line 172 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 1061 "FileView.c"
			GeeIterator* _tmp8_;
			CodeWidgetsSourceListItem* child = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			CodeWidgetsSourceListExpandableItem* _tmp11_;
			CodeWidgetsSourceListExpandableItem* _tmp12_;
			CodeWidgetsSourceListItem* _tmp13_;
			GeeArrayList* _tmp14_;
			CodeWidgetsSourceListItem* _tmp15_;
#line 172 "../src/FolderManager/FileView.vala"
			_tmp8_ = _child_it;
#line 172 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp8_)) {
#line 172 "../src/FolderManager/FileView.vala"
				break;
#line 1077 "FileView.c"
			}
#line 172 "../src/FolderManager/FileView.vala"
			_tmp9_ = _child_it;
#line 172 "../src/FolderManager/FileView.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 172 "../src/FolderManager/FileView.vala"
			child = (CodeWidgetsSourceListItem*) _tmp10_;
#line 173 "../src/FolderManager/FileView.vala"
			_tmp11_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 173 "../src/FolderManager/FileView.vala"
			_tmp12_ = _tmp11_;
#line 173 "../src/FolderManager/FileView.vala"
			_tmp13_ = child;
#line 173 "../src/FolderManager/FileView.vala"
			code_widgets_source_list_expandable_item_remove (_tmp12_, (CodeWidgetsSourceListItem*) (SCRATCH_FOLDER_MANAGER_IS_PROJECT_FOLDER_ITEM (_tmp13_) ? ((ScratchFolderManagerProjectFolderItem*) _tmp13_) : NULL));
#line 174 "../src/FolderManager/FileView.vala"
			_tmp14_ = list;
#line 174 "../src/FolderManager/FileView.vala"
			_tmp15_ = child;
#line 174 "../src/FolderManager/FileView.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, SCRATCH_FOLDER_MANAGER_IS_PROJECT_FOLDER_ITEM (_tmp15_) ? ((ScratchFolderManagerProjectFolderItem*) _tmp15_) : NULL);
#line 172 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child);
#line 1101 "FileView.c"
		}
#line 172 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_child_it);
#line 1105 "FileView.c"
	}
#line 177 "../src/FolderManager/FileView.vala"
	_tmp16_ = list;
#line 177 "../src/FolderManager/FileView.vala"
	gee_list_sort ((GeeList*) _tmp16_, ___lambda78__gcompare_data_func, g_object_ref (self), g_object_unref);
#line 1111 "FileView.c"
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp17_;
		gint _item_size = 0;
		GeeArrayList* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		gint _item_index = 0;
#line 181 "../src/FolderManager/FileView.vala"
		_tmp17_ = list;
#line 181 "../src/FolderManager/FileView.vala"
		_item_list = _tmp17_;
#line 181 "../src/FolderManager/FileView.vala"
		_tmp18_ = _item_list;
#line 181 "../src/FolderManager/FileView.vala"
		_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 181 "../src/FolderManager/FileView.vala"
		_tmp20_ = _tmp19_;
#line 181 "../src/FolderManager/FileView.vala"
		_item_size = _tmp20_;
#line 181 "../src/FolderManager/FileView.vala"
		_item_index = -1;
#line 181 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 1136 "FileView.c"
			gint _tmp21_;
			gint _tmp22_;
			ScratchFolderManagerProjectFolderItem* item = NULL;
			GeeArrayList* _tmp23_;
			gpointer _tmp24_;
			CodeWidgetsSourceListExpandableItem* _tmp25_;
			CodeWidgetsSourceListExpandableItem* _tmp26_;
			ScratchFolderManagerProjectFolderItem* _tmp27_;
#line 181 "../src/FolderManager/FileView.vala"
			_item_index = _item_index + 1;
#line 181 "../src/FolderManager/FileView.vala"
			_tmp21_ = _item_index;
#line 181 "../src/FolderManager/FileView.vala"
			_tmp22_ = _item_size;
#line 181 "../src/FolderManager/FileView.vala"
			if (!(_tmp21_ < _tmp22_)) {
#line 181 "../src/FolderManager/FileView.vala"
				break;
#line 1155 "FileView.c"
			}
#line 181 "../src/FolderManager/FileView.vala"
			_tmp23_ = _item_list;
#line 181 "../src/FolderManager/FileView.vala"
			_tmp24_ = gee_abstract_list_get ((GeeAbstractList*) _tmp23_, _item_index);
#line 181 "../src/FolderManager/FileView.vala"
			item = (ScratchFolderManagerProjectFolderItem*) _tmp24_;
#line 182 "../src/FolderManager/FileView.vala"
			_tmp25_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 182 "../src/FolderManager/FileView.vala"
			_tmp26_ = _tmp25_;
#line 182 "../src/FolderManager/FileView.vala"
			_tmp27_ = item;
#line 182 "../src/FolderManager/FileView.vala"
			code_widgets_source_list_expandable_item_add (_tmp26_, (CodeWidgetsSourceListItem*) _tmp27_);
#line 181 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (item);
#line 1173 "FileView.c"
		}
	}
#line 169 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (list);
#line 1178 "FileView.c"
}

static void
_scratch_folder_manager_file_view_on_item_selected_code_widgets_source_list_item_selected (CodeWidgetsSourceList* _sender,
                                                                                           CodeWidgetsSourceListItem* item,
                                                                                           gpointer self)
{
#line 187 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_on_item_selected ((ScratchFolderManagerFileView*) self, item);
#line 1188 "FileView.c"
}

void
scratch_folder_manager_file_view_select_path (ScratchFolderManagerFileView* self,
                                              const gchar* path)
{
	guint _tmp0_;
	CodeWidgetsSourceListExpandableItem* _tmp1_;
	CodeWidgetsSourceListExpandableItem* _tmp2_;
	CodeWidgetsSourceListItem* _tmp3_;
#line 186 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 186 "../src/FolderManager/FileView.vala"
	g_return_if_fail (path != NULL);
#line 187 "../src/FolderManager/FileView.vala"
	g_signal_parse_name ("item-selected", CODE_WIDGETS_TYPE_SOURCE_LIST, &_tmp0_, NULL, FALSE);
#line 187 "../src/FolderManager/FileView.vala"
	g_signal_handlers_disconnect_matched ((CodeWidgetsSourceList*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _scratch_folder_manager_file_view_on_item_selected_code_widgets_source_list_item_selected, self);
#line 188 "../src/FolderManager/FileView.vala"
	_tmp1_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 188 "../src/FolderManager/FileView.vala"
	_tmp2_ = _tmp1_;
#line 188 "../src/FolderManager/FileView.vala"
	_tmp3_ = scratch_folder_manager_file_view_find_path (self, _tmp2_, path, FALSE);
#line 188 "../src/FolderManager/FileView.vala"
	code_widgets_source_list_set_selected ((CodeWidgetsSourceList*) self, _tmp3_);
#line 189 "../src/FolderManager/FileView.vala"
	g_signal_connect_object ((CodeWidgetsSourceList*) self, "item-selected", (GCallback) _scratch_folder_manager_file_view_on_item_selected_code_widgets_source_list_item_selected, self, 0);
#line 1217 "FileView.c"
}

void
scratch_folder_manager_file_view_unselect_all (ScratchFolderManagerFileView* self)
{
#line 192 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 193 "../src/FolderManager/FileView.vala"
	code_widgets_source_list_set_selected ((CodeWidgetsSourceList*) self, NULL);
#line 1227 "FileView.c"
}

void
scratch_folder_manager_file_view_collapse_other_projects (ScratchFolderManagerFileView* self,
                                                          const gchar* keep_open_path)
{
	const gchar* path = NULL;
#line 196 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 198 "../src/FolderManager/FileView.vala"
	if (keep_open_path == NULL) {
#line 1239 "FileView.c"
		ScratchServicesGitManager* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 199 "../src/FolderManager/FileView.vala"
		_tmp0_ = self->priv->git_manager;
#line 199 "../src/FolderManager/FileView.vala"
		_tmp1_ = scratch_services_git_manager_get_active_project_path (_tmp0_);
#line 199 "../src/FolderManager/FileView.vala"
		_tmp2_ = _tmp1_;
#line 199 "../src/FolderManager/FileView.vala"
		path = _tmp2_;
#line 1251 "FileView.c"
	} else {
		ScratchServicesGitManager* _tmp3_;
		const gchar* _tmp4_;
#line 201 "../src/FolderManager/FileView.vala"
		path = keep_open_path;
#line 202 "../src/FolderManager/FileView.vala"
		_tmp3_ = self->priv->git_manager;
#line 202 "../src/FolderManager/FileView.vala"
		_tmp4_ = path;
#line 202 "../src/FolderManager/FileView.vala"
		scratch_services_git_manager_set_active_project_path (_tmp3_, _tmp4_);
#line 1263 "FileView.c"
	}
	{
		GeeIterator* _child_it = NULL;
		CodeWidgetsSourceListExpandableItem* _tmp5_;
		CodeWidgetsSourceListExpandableItem* _tmp6_;
		GeeCollection* _tmp7_;
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
		GeeIterator* _tmp10_;
		GeeIterator* _tmp11_;
#line 205 "../src/FolderManager/FileView.vala"
		_tmp5_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 205 "../src/FolderManager/FileView.vala"
		_tmp6_ = _tmp5_;
#line 205 "../src/FolderManager/FileView.vala"
		_tmp7_ = code_widgets_source_list_expandable_item_get_children (_tmp6_);
#line 205 "../src/FolderManager/FileView.vala"
		_tmp8_ = _tmp7_;
#line 205 "../src/FolderManager/FileView.vala"
		_tmp9_ = _tmp8_;
#line 205 "../src/FolderManager/FileView.vala"
		_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 205 "../src/FolderManager/FileView.vala"
		_tmp11_ = _tmp10_;
#line 205 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp9_);
#line 205 "../src/FolderManager/FileView.vala"
		_child_it = _tmp11_;
#line 205 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 1294 "FileView.c"
			GeeIterator* _tmp12_;
			CodeWidgetsSourceListItem* child = NULL;
			GeeIterator* _tmp13_;
			gpointer _tmp14_;
			ScratchFolderManagerProjectFolderItem* project_folder = NULL;
			CodeWidgetsSourceListItem* _tmp15_;
			ScratchFolderManagerProjectFolderItem* _tmp16_;
			ScratchFolderManagerProjectFolderItem* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			const gchar* _tmp21_;
			gboolean _tmp22_;
#line 205 "../src/FolderManager/FileView.vala"
			_tmp12_ = _child_it;
#line 205 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp12_)) {
#line 205 "../src/FolderManager/FileView.vala"
				break;
#line 1314 "FileView.c"
			}
#line 205 "../src/FolderManager/FileView.vala"
			_tmp13_ = _child_it;
#line 205 "../src/FolderManager/FileView.vala"
			_tmp14_ = gee_iterator_get (_tmp13_);
#line 205 "../src/FolderManager/FileView.vala"
			child = (CodeWidgetsSourceListItem*) _tmp14_;
#line 206 "../src/FolderManager/FileView.vala"
			_tmp15_ = child;
#line 206 "../src/FolderManager/FileView.vala"
			_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, SCRATCH_FOLDER_MANAGER_TYPE_PROJECT_FOLDER_ITEM, ScratchFolderManagerProjectFolderItem));
#line 206 "../src/FolderManager/FileView.vala"
			project_folder = _tmp16_;
#line 207 "../src/FolderManager/FileView.vala"
			_tmp17_ = project_folder;
#line 207 "../src/FolderManager/FileView.vala"
			_tmp18_ = scratch_folder_manager_item_get_path ((ScratchFolderManagerItem*) _tmp17_);
#line 207 "../src/FolderManager/FileView.vala"
			_tmp19_ = _tmp18_;
#line 207 "../src/FolderManager/FileView.vala"
			_tmp20_ = _tmp19_;
#line 207 "../src/FolderManager/FileView.vala"
			_tmp21_ = path;
#line 207 "../src/FolderManager/FileView.vala"
			_tmp22_ = g_strcmp0 (_tmp20_, _tmp21_) != 0;
#line 207 "../src/FolderManager/FileView.vala"
			_g_free0 (_tmp20_);
#line 207 "../src/FolderManager/FileView.vala"
			if (_tmp22_) {
#line 1344 "FileView.c"
				ScratchFolderManagerProjectFolderItem* _tmp23_;
				GActionGroup* _tmp24_;
				ScratchFolderManagerProjectFolderItem* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				GVariant* _tmp29_;
				GVariant* _tmp30_;
#line 208 "../src/FolderManager/FileView.vala"
				_tmp23_ = project_folder;
#line 208 "../src/FolderManager/FileView.vala"
				code_widgets_source_list_expandable_item_set_expanded ((CodeWidgetsSourceListExpandableItem*) _tmp23_, FALSE);
#line 209 "../src/FolderManager/FileView.vala"
				_tmp24_ = self->priv->_toplevel_action_group;
#line 209 "../src/FolderManager/FileView.vala"
				_tmp25_ = project_folder;
#line 209 "../src/FolderManager/FileView.vala"
				_tmp26_ = scratch_folder_manager_item_get_path ((ScratchFolderManagerItem*) _tmp25_);
#line 209 "../src/FolderManager/FileView.vala"
				_tmp27_ = _tmp26_;
#line 209 "../src/FolderManager/FileView.vala"
				_tmp28_ = _tmp27_;
#line 209 "../src/FolderManager/FileView.vala"
				_tmp29_ = g_variant_new_string (_tmp28_);
#line 209 "../src/FolderManager/FileView.vala"
				g_variant_ref_sink (_tmp29_);
#line 209 "../src/FolderManager/FileView.vala"
				_tmp30_ = _tmp29_;
#line 209 "../src/FolderManager/FileView.vala"
				g_action_group_activate_action (_tmp24_, SCRATCH_MAIN_WINDOW_ACTION_HIDE_PROJECT_DOCS, _tmp30_);
#line 209 "../src/FolderManager/FileView.vala"
				_g_variant_unref0 (_tmp30_);
#line 209 "../src/FolderManager/FileView.vala"
				_g_free0 (_tmp28_);
#line 1379 "FileView.c"
			} else {
				ScratchFolderManagerProjectFolderItem* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				const gchar* _tmp35_;
				gboolean _tmp36_;
#line 210 "../src/FolderManager/FileView.vala"
				_tmp31_ = project_folder;
#line 210 "../src/FolderManager/FileView.vala"
				_tmp32_ = scratch_folder_manager_item_get_path ((ScratchFolderManagerItem*) _tmp31_);
#line 210 "../src/FolderManager/FileView.vala"
				_tmp33_ = _tmp32_;
#line 210 "../src/FolderManager/FileView.vala"
				_tmp34_ = _tmp33_;
#line 210 "../src/FolderManager/FileView.vala"
				_tmp35_ = path;
#line 210 "../src/FolderManager/FileView.vala"
				_tmp36_ = g_strcmp0 (_tmp34_, _tmp35_) == 0;
#line 210 "../src/FolderManager/FileView.vala"
				_g_free0 (_tmp34_);
#line 210 "../src/FolderManager/FileView.vala"
				if (_tmp36_) {
#line 1403 "FileView.c"
					ScratchFolderManagerProjectFolderItem* _tmp37_;
					GActionGroup* _tmp38_;
					ScratchFolderManagerProjectFolderItem* _tmp39_;
					gchar* _tmp40_;
					gchar* _tmp41_;
					gchar* _tmp42_;
					GVariant* _tmp43_;
					GVariant* _tmp44_;
#line 211 "../src/FolderManager/FileView.vala"
					_tmp37_ = project_folder;
#line 211 "../src/FolderManager/FileView.vala"
					code_widgets_source_list_expandable_item_set_expanded ((CodeWidgetsSourceListExpandableItem*) _tmp37_, TRUE);
#line 212 "../src/FolderManager/FileView.vala"
					_tmp38_ = self->priv->_toplevel_action_group;
#line 212 "../src/FolderManager/FileView.vala"
					_tmp39_ = project_folder;
#line 212 "../src/FolderManager/FileView.vala"
					_tmp40_ = scratch_folder_manager_item_get_path ((ScratchFolderManagerItem*) _tmp39_);
#line 212 "../src/FolderManager/FileView.vala"
					_tmp41_ = _tmp40_;
#line 212 "../src/FolderManager/FileView.vala"
					_tmp42_ = _tmp41_;
#line 212 "../src/FolderManager/FileView.vala"
					_tmp43_ = g_variant_new_string (_tmp42_);
#line 212 "../src/FolderManager/FileView.vala"
					g_variant_ref_sink (_tmp43_);
#line 212 "../src/FolderManager/FileView.vala"
					_tmp44_ = _tmp43_;
#line 212 "../src/FolderManager/FileView.vala"
					g_action_group_activate_action (_tmp38_, SCRATCH_MAIN_WINDOW_ACTION_RESTORE_PROJECT_DOCS, _tmp44_);
#line 212 "../src/FolderManager/FileView.vala"
					_g_variant_unref0 (_tmp44_);
#line 212 "../src/FolderManager/FileView.vala"
					_g_free0 (_tmp42_);
#line 1438 "FileView.c"
				}
			}
#line 205 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (project_folder);
#line 205 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child);
#line 1445 "FileView.c"
		}
#line 205 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_child_it);
#line 1449 "FileView.c"
	}
}

static CodeWidgetsSourceListItem*
scratch_folder_manager_file_view_find_path (ScratchFolderManagerFileView* self,
                                            CodeWidgetsSourceListExpandableItem* list,
                                            const gchar* path,
                                            gboolean expand)
{
	CodeWidgetsSourceListItem* result;
#line 217 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 217 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 217 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 1466 "FileView.c"
	{
		GeeIterator* _item_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 220 "../src/FolderManager/FileView.vala"
		_tmp0_ = code_widgets_source_list_expandable_item_get_children (list);
#line 220 "../src/FolderManager/FileView.vala"
		_tmp1_ = _tmp0_;
#line 220 "../src/FolderManager/FileView.vala"
		_tmp2_ = _tmp1_;
#line 220 "../src/FolderManager/FileView.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 220 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 220 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp2_);
#line 220 "../src/FolderManager/FileView.vala"
		_item_it = _tmp4_;
#line 220 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 1490 "FileView.c"
			GeeIterator* _tmp5_;
			CodeWidgetsSourceListItem* item = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			CodeWidgetsSourceListItem* _tmp8_;
#line 220 "../src/FolderManager/FileView.vala"
			_tmp5_ = _item_it;
#line 220 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 220 "../src/FolderManager/FileView.vala"
				break;
#line 1502 "FileView.c"
			}
#line 220 "../src/FolderManager/FileView.vala"
			_tmp6_ = _item_it;
#line 220 "../src/FolderManager/FileView.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 220 "../src/FolderManager/FileView.vala"
			item = (CodeWidgetsSourceListItem*) _tmp7_;
#line 221 "../src/FolderManager/FileView.vala"
			_tmp8_ = item;
#line 221 "../src/FolderManager/FileView.vala"
			if (SCRATCH_FOLDER_MANAGER_IS_ITEM (_tmp8_)) {
#line 1514 "FileView.c"
				ScratchFolderManagerItem* code_item = NULL;
				CodeWidgetsSourceListItem* _tmp9_;
				ScratchFolderManagerItem* _tmp10_;
				ScratchFolderManagerItem* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				gboolean _tmp15_;
				CodeWidgetsSourceListItem* _tmp17_;
#line 222 "../src/FolderManager/FileView.vala"
				_tmp9_ = item;
#line 222 "../src/FolderManager/FileView.vala"
				_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, SCRATCH_FOLDER_MANAGER_TYPE_ITEM, ScratchFolderManagerItem));
#line 222 "../src/FolderManager/FileView.vala"
				code_item = _tmp10_;
#line 223 "../src/FolderManager/FileView.vala"
				_tmp11_ = code_item;
#line 223 "../src/FolderManager/FileView.vala"
				_tmp12_ = scratch_folder_manager_item_get_path (_tmp11_);
#line 223 "../src/FolderManager/FileView.vala"
				_tmp13_ = _tmp12_;
#line 223 "../src/FolderManager/FileView.vala"
				_tmp14_ = _tmp13_;
#line 223 "../src/FolderManager/FileView.vala"
				_tmp15_ = g_strcmp0 (_tmp14_, path) == 0;
#line 223 "../src/FolderManager/FileView.vala"
				_g_free0 (_tmp14_);
#line 223 "../src/FolderManager/FileView.vala"
				if (_tmp15_) {
#line 1544 "FileView.c"
					CodeWidgetsSourceListItem* _tmp16_;
#line 224 "../src/FolderManager/FileView.vala"
					_tmp16_ = item;
#line 224 "../src/FolderManager/FileView.vala"
					result = G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, CODE_WIDGETS_SOURCE_LIST_TYPE_ITEM, CodeWidgetsSourceListItem);
#line 224 "../src/FolderManager/FileView.vala"
					_g_object_unref0 (code_item);
#line 224 "../src/FolderManager/FileView.vala"
					_g_object_unref0 (item);
#line 224 "../src/FolderManager/FileView.vala"
					_g_object_unref0 (_item_it);
#line 224 "../src/FolderManager/FileView.vala"
					return result;
#line 1558 "FileView.c"
				}
#line 227 "../src/FolderManager/FileView.vala"
				_tmp17_ = item;
#line 227 "../src/FolderManager/FileView.vala"
				if (CODE_WIDGETS_SOURCE_LIST_IS_EXPANDABLE_ITEM (_tmp17_)) {
#line 1564 "FileView.c"
					CodeWidgetsSourceListExpandableItem* expander = NULL;
					CodeWidgetsSourceListItem* _tmp18_;
					CodeWidgetsSourceListExpandableItem* _tmp19_;
					ScratchFolderManagerItem* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					gboolean _tmp24_;
					CodeWidgetsSourceListExpandableItem* _tmp25_;
					gboolean _tmp26_;
					gboolean _tmp27_;
					CodeWidgetsSourceListItem* recurse_item = NULL;
					CodeWidgetsSourceListExpandableItem* _tmp29_;
					CodeWidgetsSourceListItem* _tmp30_;
					CodeWidgetsSourceListItem* _tmp31_;
#line 228 "../src/FolderManager/FileView.vala"
					_tmp18_ = item;
#line 228 "../src/FolderManager/FileView.vala"
					_tmp19_ = _g_object_ref0 (CODE_WIDGETS_SOURCE_LIST_IS_EXPANDABLE_ITEM (_tmp18_) ? ((CodeWidgetsSourceListExpandableItem*) _tmp18_) : NULL);
#line 228 "../src/FolderManager/FileView.vala"
					expander = _tmp19_;
#line 229 "../src/FolderManager/FileView.vala"
					_tmp20_ = code_item;
#line 229 "../src/FolderManager/FileView.vala"
					_tmp21_ = scratch_folder_manager_item_get_path (_tmp20_);
#line 229 "../src/FolderManager/FileView.vala"
					_tmp22_ = _tmp21_;
#line 229 "../src/FolderManager/FileView.vala"
					_tmp23_ = _tmp22_;
#line 229 "../src/FolderManager/FileView.vala"
					_tmp24_ = !g_str_has_prefix (path, _tmp23_);
#line 229 "../src/FolderManager/FileView.vala"
					_g_free0 (_tmp23_);
#line 229 "../src/FolderManager/FileView.vala"
					if (_tmp24_) {
#line 230 "../src/FolderManager/FileView.vala"
						_g_object_unref0 (expander);
#line 230 "../src/FolderManager/FileView.vala"
						_g_object_unref0 (code_item);
#line 230 "../src/FolderManager/FileView.vala"
						_g_object_unref0 (item);
#line 230 "../src/FolderManager/FileView.vala"
						continue;
#line 1608 "FileView.c"
					}
#line 233 "../src/FolderManager/FileView.vala"
					_tmp25_ = expander;
#line 233 "../src/FolderManager/FileView.vala"
					_tmp26_ = code_widgets_source_list_expandable_item_get_expanded (_tmp25_);
#line 233 "../src/FolderManager/FileView.vala"
					_tmp27_ = _tmp26_;
#line 233 "../src/FolderManager/FileView.vala"
					if (!_tmp27_) {
#line 234 "../src/FolderManager/FileView.vala"
						if (expand) {
#line 1620 "FileView.c"
							CodeWidgetsSourceListExpandableItem* _tmp28_;
#line 235 "../src/FolderManager/FileView.vala"
							_tmp28_ = expander;
#line 235 "../src/FolderManager/FileView.vala"
							code_widgets_source_list_expandable_item_set_expanded (_tmp28_, TRUE);
#line 1626 "FileView.c"
						} else {
#line 237 "../src/FolderManager/FileView.vala"
							_g_object_unref0 (expander);
#line 237 "../src/FolderManager/FileView.vala"
							_g_object_unref0 (code_item);
#line 237 "../src/FolderManager/FileView.vala"
							_g_object_unref0 (item);
#line 237 "../src/FolderManager/FileView.vala"
							continue;
#line 1636 "FileView.c"
						}
					}
#line 241 "../src/FolderManager/FileView.vala"
					_tmp29_ = expander;
#line 241 "../src/FolderManager/FileView.vala"
					_tmp30_ = scratch_folder_manager_file_view_find_path (self, _tmp29_, path, expand);
#line 241 "../src/FolderManager/FileView.vala"
					recurse_item = _tmp30_;
#line 242 "../src/FolderManager/FileView.vala"
					_tmp31_ = recurse_item;
#line 242 "../src/FolderManager/FileView.vala"
					if (_tmp31_ != NULL) {
#line 1649 "FileView.c"
						CodeWidgetsSourceListItem* _tmp32_;
#line 243 "../src/FolderManager/FileView.vala"
						_tmp32_ = recurse_item;
#line 243 "../src/FolderManager/FileView.vala"
						result = _tmp32_;
#line 243 "../src/FolderManager/FileView.vala"
						_g_object_unref0 (expander);
#line 243 "../src/FolderManager/FileView.vala"
						_g_object_unref0 (code_item);
#line 243 "../src/FolderManager/FileView.vala"
						_g_object_unref0 (item);
#line 243 "../src/FolderManager/FileView.vala"
						_g_object_unref0 (_item_it);
#line 243 "../src/FolderManager/FileView.vala"
						return result;
#line 1665 "FileView.c"
					}
#line 227 "../src/FolderManager/FileView.vala"
					_g_object_unref0 (expander);
#line 1669 "FileView.c"
				}
#line 221 "../src/FolderManager/FileView.vala"
				_g_object_unref0 (code_item);
#line 1673 "FileView.c"
			}
#line 220 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (item);
#line 1677 "FileView.c"
		}
#line 220 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_item_it);
#line 1681 "FileView.c"
	}
#line 249 "../src/FolderManager/FileView.vala"
	result = NULL;
#line 249 "../src/FolderManager/FileView.vala"
	return result;
#line 1687 "FileView.c"
}

ScratchFolderManagerProjectFolderItem*
scratch_folder_manager_file_view_get_project_for_file (ScratchFolderManagerFileView* self,
                                                       GFile* file)
{
	ScratchFolderManagerProjectFolderItem* result;
#line 252 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 252 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 1699 "FileView.c"
	{
		GeeIterator* _item_it = NULL;
		CodeWidgetsSourceListExpandableItem* _tmp0_;
		CodeWidgetsSourceListExpandableItem* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 253 "../src/FolderManager/FileView.vala"
		_tmp0_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 253 "../src/FolderManager/FileView.vala"
		_tmp1_ = _tmp0_;
#line 253 "../src/FolderManager/FileView.vala"
		_tmp2_ = code_widgets_source_list_expandable_item_get_children (_tmp1_);
#line 253 "../src/FolderManager/FileView.vala"
		_tmp3_ = _tmp2_;
#line 253 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 253 "../src/FolderManager/FileView.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 253 "../src/FolderManager/FileView.vala"
		_tmp6_ = _tmp5_;
#line 253 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp4_);
#line 253 "../src/FolderManager/FileView.vala"
		_item_it = _tmp6_;
#line 253 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 1729 "FileView.c"
			GeeIterator* _tmp7_;
			CodeWidgetsSourceListItem* item = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			CodeWidgetsSourceListItem* _tmp10_;
#line 253 "../src/FolderManager/FileView.vala"
			_tmp7_ = _item_it;
#line 253 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 253 "../src/FolderManager/FileView.vala"
				break;
#line 1741 "FileView.c"
			}
#line 253 "../src/FolderManager/FileView.vala"
			_tmp8_ = _item_it;
#line 253 "../src/FolderManager/FileView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 253 "../src/FolderManager/FileView.vala"
			item = (CodeWidgetsSourceListItem*) _tmp9_;
#line 254 "../src/FolderManager/FileView.vala"
			_tmp10_ = item;
#line 254 "../src/FolderManager/FileView.vala"
			if (SCRATCH_FOLDER_MANAGER_IS_PROJECT_FOLDER_ITEM (_tmp10_)) {
#line 1753 "FileView.c"
				ScratchFolderManagerProjectFolderItem* folder = NULL;
				CodeWidgetsSourceListItem* _tmp11_;
				ScratchFolderManagerProjectFolderItem* _tmp12_;
				ScratchFolderManagerProjectFolderItem* _tmp13_;
#line 255 "../src/FolderManager/FileView.vala"
				_tmp11_ = item;
#line 255 "../src/FolderManager/FileView.vala"
				_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, SCRATCH_FOLDER_MANAGER_TYPE_PROJECT_FOLDER_ITEM, ScratchFolderManagerProjectFolderItem));
#line 255 "../src/FolderManager/FileView.vala"
				folder = _tmp12_;
#line 256 "../src/FolderManager/FileView.vala"
				_tmp13_ = folder;
#line 256 "../src/FolderManager/FileView.vala"
				if (scratch_folder_manager_project_folder_item_contains_file (_tmp13_, file)) {
#line 257 "../src/FolderManager/FileView.vala"
					result = folder;
#line 257 "../src/FolderManager/FileView.vala"
					_g_object_unref0 (item);
#line 257 "../src/FolderManager/FileView.vala"
					_g_object_unref0 (_item_it);
#line 257 "../src/FolderManager/FileView.vala"
					return result;
#line 1776 "FileView.c"
				}
#line 254 "../src/FolderManager/FileView.vala"
				_g_object_unref0 (folder);
#line 1780 "FileView.c"
			}
#line 253 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (item);
#line 1784 "FileView.c"
		}
#line 253 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_item_it);
#line 1788 "FileView.c"
	}
#line 262 "../src/FolderManager/FileView.vala"
	result = NULL;
#line 262 "../src/FolderManager/FileView.vala"
	return result;
#line 1794 "FileView.c"
}

CodeWidgetsSourceListItem*
scratch_folder_manager_file_view_expand_to_path (ScratchFolderManagerFileView* self,
                                                 const gchar* path)
{
	CodeWidgetsSourceListExpandableItem* _tmp0_;
	CodeWidgetsSourceListExpandableItem* _tmp1_;
	CodeWidgetsSourceListItem* _tmp2_;
	CodeWidgetsSourceListItem* result;
#line 265 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 265 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 266 "../src/FolderManager/FileView.vala"
	_tmp0_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 266 "../src/FolderManager/FileView.vala"
	_tmp1_ = _tmp0_;
#line 266 "../src/FolderManager/FileView.vala"
	_tmp2_ = scratch_folder_manager_file_view_find_path (self, _tmp1_, path, TRUE);
#line 266 "../src/FolderManager/FileView.vala"
	result = _tmp2_;
#line 266 "../src/FolderManager/FileView.vala"
	return result;
#line 1819 "FileView.c"
}

void
scratch_folder_manager_file_view_search_global (ScratchFolderManagerFileView* self,
                                                const gchar* path,
                                                const gchar* term)
{
	ScratchFolderManagerItem* item_for_path = NULL;
	CodeWidgetsSourceListItem* _tmp0_;
	ScratchFolderManagerItem* _tmp1_;
	ScratchFolderManagerItem* _tmp2_;
#line 270 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 270 "../src/FolderManager/FileView.vala"
	g_return_if_fail (path != NULL);
#line 271 "../src/FolderManager/FileView.vala"
	_tmp0_ = scratch_folder_manager_file_view_expand_to_path (self, path);
#line 271 "../src/FolderManager/FileView.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, SCRATCH_FOLDER_MANAGER_TYPE_ITEM, ScratchFolderManagerItem));
#line 271 "../src/FolderManager/FileView.vala"
	item_for_path = _tmp1_;
#line 272 "../src/FolderManager/FileView.vala"
	_tmp2_ = item_for_path;
#line 272 "../src/FolderManager/FileView.vala"
	if (_tmp2_ != NULL) {
#line 1845 "FileView.c"
		ScratchFolderManagerProjectFolderItem* search_root = NULL;
		ScratchFolderManagerItem* _tmp3_;
		ScratchFolderManagerProjectFolderItem* _tmp4_;
		ScratchFolderManagerProjectFolderItem* _tmp5_;
#line 273 "../src/FolderManager/FileView.vala"
		_tmp3_ = item_for_path;
#line 273 "../src/FolderManager/FileView.vala"
		_tmp4_ = scratch_folder_manager_item_get_root_folder (_tmp3_, NULL);
#line 273 "../src/FolderManager/FileView.vala"
		search_root = _tmp4_;
#line 274 "../src/FolderManager/FileView.vala"
		_tmp5_ = search_root;
#line 274 "../src/FolderManager/FileView.vala"
		if (SCRATCH_FOLDER_MANAGER_IS_PROJECT_FOLDER_ITEM (_tmp5_)) {
#line 1860 "FileView.c"
			GFile* _tmp6_ = NULL;
			ScratchFolderManagerItem* _tmp7_;
			GFile* start_folder = NULL;
			GFile* _tmp18_;
			gboolean is_explicit = FALSE;
			ScratchFolderManagerItem* _tmp19_;
			ScratchFolderManagerProjectFolderItem* _tmp20_;
			GFile* _tmp21_;
#line 275 "../src/FolderManager/FileView.vala"
			_tmp7_ = item_for_path;
#line 275 "../src/FolderManager/FileView.vala"
			if (SCRATCH_FOLDER_MANAGER_IS_FOLDER_ITEM (_tmp7_)) {
#line 1873 "FileView.c"
				ScratchFolderManagerItem* _tmp8_;
				ScratchFolderManagerFile* _tmp9_;
				ScratchFolderManagerFile* _tmp10_;
				GFile* _tmp11_;
				GFile* _tmp12_;
#line 276 "../src/FolderManager/FileView.vala"
				_tmp8_ = item_for_path;
#line 276 "../src/FolderManager/FileView.vala"
				_tmp9_ = scratch_folder_manager_item_get_file (_tmp8_);
#line 276 "../src/FolderManager/FileView.vala"
				_tmp10_ = _tmp9_;
#line 276 "../src/FolderManager/FileView.vala"
				_tmp11_ = scratch_folder_manager_file_get_file (_tmp10_);
#line 276 "../src/FolderManager/FileView.vala"
				_tmp12_ = _tmp11_;
#line 276 "../src/FolderManager/FileView.vala"
				_tmp6_ = _tmp12_;
#line 1891 "FileView.c"
			} else {
				ScratchFolderManagerProjectFolderItem* _tmp13_;
				ScratchFolderManagerFile* _tmp14_;
				ScratchFolderManagerFile* _tmp15_;
				GFile* _tmp16_;
				GFile* _tmp17_;
#line 277 "../src/FolderManager/FileView.vala"
				_tmp13_ = search_root;
#line 277 "../src/FolderManager/FileView.vala"
				_tmp14_ = scratch_folder_manager_item_get_file ((ScratchFolderManagerItem*) _tmp13_);
#line 277 "../src/FolderManager/FileView.vala"
				_tmp15_ = _tmp14_;
#line 277 "../src/FolderManager/FileView.vala"
				_tmp16_ = scratch_folder_manager_file_get_file (_tmp15_);
#line 277 "../src/FolderManager/FileView.vala"
				_tmp17_ = _tmp16_;
#line 277 "../src/FolderManager/FileView.vala"
				_tmp6_ = _tmp17_;
#line 1910 "FileView.c"
			}
#line 275 "../src/FolderManager/FileView.vala"
			_tmp18_ = _g_object_ref0 (_tmp6_);
#line 275 "../src/FolderManager/FileView.vala"
			start_folder = _tmp18_;
#line 279 "../src/FolderManager/FileView.vala"
			_tmp19_ = item_for_path;
#line 279 "../src/FolderManager/FileView.vala"
			is_explicit = !SCRATCH_FOLDER_MANAGER_IS_PROJECT_FOLDER_ITEM (_tmp19_);
#line 280 "../src/FolderManager/FileView.vala"
			_tmp20_ = search_root;
#line 280 "../src/FolderManager/FileView.vala"
			_tmp21_ = start_folder;
#line 280 "../src/FolderManager/FileView.vala"
			scratch_folder_manager_project_folder_item_global_search (_tmp20_, _tmp21_, term, is_explicit);
#line 274 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (start_folder);
#line 1928 "FileView.c"
		}
#line 272 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (search_root);
#line 1932 "FileView.c"
	}
#line 270 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (item_for_path);
#line 1936 "FileView.c"
}

void
scratch_folder_manager_file_view_clear_badges (ScratchFolderManagerFileView* self)
{
#line 285 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 1944 "FileView.c"
	{
		GeeIterator* _child_it = NULL;
		CodeWidgetsSourceListExpandableItem* _tmp0_;
		CodeWidgetsSourceListExpandableItem* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 286 "../src/FolderManager/FileView.vala"
		_tmp0_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 286 "../src/FolderManager/FileView.vala"
		_tmp1_ = _tmp0_;
#line 286 "../src/FolderManager/FileView.vala"
		_tmp2_ = code_widgets_source_list_expandable_item_get_children (_tmp1_);
#line 286 "../src/FolderManager/FileView.vala"
		_tmp3_ = _tmp2_;
#line 286 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 286 "../src/FolderManager/FileView.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 286 "../src/FolderManager/FileView.vala"
		_tmp6_ = _tmp5_;
#line 286 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp4_);
#line 286 "../src/FolderManager/FileView.vala"
		_child_it = _tmp6_;
#line 286 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 1974 "FileView.c"
			GeeIterator* _tmp7_;
			CodeWidgetsSourceListItem* child = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			CodeWidgetsSourceListItem* _tmp10_;
#line 286 "../src/FolderManager/FileView.vala"
			_tmp7_ = _child_it;
#line 286 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 286 "../src/FolderManager/FileView.vala"
				break;
#line 1986 "FileView.c"
			}
#line 286 "../src/FolderManager/FileView.vala"
			_tmp8_ = _child_it;
#line 286 "../src/FolderManager/FileView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 286 "../src/FolderManager/FileView.vala"
			child = (CodeWidgetsSourceListItem*) _tmp9_;
#line 287 "../src/FolderManager/FileView.vala"
			_tmp10_ = child;
#line 287 "../src/FolderManager/FileView.vala"
			if (SCRATCH_FOLDER_MANAGER_IS_PROJECT_FOLDER_ITEM (_tmp10_)) {
#line 1998 "FileView.c"
				CodeWidgetsSourceListItem* _tmp11_;
#line 288 "../src/FolderManager/FileView.vala"
				_tmp11_ = child;
#line 288 "../src/FolderManager/FileView.vala"
				scratch_folder_manager_folder_item_remove_all_badges (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, SCRATCH_FOLDER_MANAGER_TYPE_FOLDER_ITEM, ScratchFolderManagerFolderItem));
#line 2004 "FileView.c"
			}
#line 286 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child);
#line 2008 "FileView.c"
		}
#line 286 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_child_it);
#line 2012 "FileView.c"
	}
}

void
scratch_folder_manager_file_view_new_branch (ScratchFolderManagerFileView* self,
                                             const gchar* active_project_path)
{
	ScratchFolderManagerProjectFolderItem* active_project = NULL;
	CodeWidgetsSourceListExpandableItem* _tmp0_;
	CodeWidgetsSourceListExpandableItem* _tmp1_;
	CodeWidgetsSourceListItem* _tmp2_;
	gboolean _tmp3_ = FALSE;
	ScratchFolderManagerProjectFolderItem* _tmp4_;
	gchar* branch_name = NULL;
	ScratchDialogsNewBranchDialog* dialog = NULL;
	ScratchFolderManagerProjectFolderItem* _tmp8_;
	ScratchDialogsNewBranchDialog* _tmp9_;
	ScratchDialogsNewBranchDialog* _tmp10_;
	ScratchDialogsNewBranchDialog* _tmp11_;
	ScratchDialogsNewBranchDialog* _tmp16_;
	const gchar* _tmp17_;
#line 293 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 293 "../src/FolderManager/FileView.vala"
	g_return_if_fail (active_project_path != NULL);
#line 294 "../src/FolderManager/FileView.vala"
	_tmp0_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 294 "../src/FolderManager/FileView.vala"
	_tmp1_ = _tmp0_;
#line 294 "../src/FolderManager/FileView.vala"
	_tmp2_ = scratch_folder_manager_file_view_find_path (self, _tmp1_, active_project_path, FALSE);
#line 294 "../src/FolderManager/FileView.vala"
	active_project = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, SCRATCH_FOLDER_MANAGER_TYPE_PROJECT_FOLDER_ITEM, ScratchFolderManagerProjectFolderItem);
#line 295 "../src/FolderManager/FileView.vala"
	_tmp4_ = active_project;
#line 295 "../src/FolderManager/FileView.vala"
	if (_tmp4_ == NULL) {
#line 295 "../src/FolderManager/FileView.vala"
		_tmp3_ = TRUE;
#line 2052 "FileView.c"
	} else {
		ScratchFolderManagerProjectFolderItem* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 295 "../src/FolderManager/FileView.vala"
		_tmp5_ = active_project;
#line 295 "../src/FolderManager/FileView.vala"
		_tmp6_ = scratch_folder_manager_project_folder_item_get_is_git_repo (_tmp5_);
#line 295 "../src/FolderManager/FileView.vala"
		_tmp7_ = _tmp6_;
#line 295 "../src/FolderManager/FileView.vala"
		_tmp3_ = !_tmp7_;
#line 2065 "FileView.c"
	}
#line 295 "../src/FolderManager/FileView.vala"
	if (_tmp3_) {
#line 296 "../src/FolderManager/FileView.vala"
		gdk_beep ();
#line 297 "../src/FolderManager/FileView.vala"
		return;
#line 2073 "FileView.c"
	}
#line 300 "../src/FolderManager/FileView.vala"
	branch_name = NULL;
#line 301 "../src/FolderManager/FileView.vala"
	_tmp8_ = active_project;
#line 301 "../src/FolderManager/FileView.vala"
	_tmp9_ = scratch_dialogs_new_branch_dialog_new (_tmp8_);
#line 301 "../src/FolderManager/FileView.vala"
	g_object_ref_sink (_tmp9_);
#line 301 "../src/FolderManager/FileView.vala"
	dialog = _tmp9_;
#line 302 "../src/FolderManager/FileView.vala"
	_tmp10_ = dialog;
#line 302 "../src/FolderManager/FileView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp10_);
#line 303 "../src/FolderManager/FileView.vala"
	_tmp11_ = dialog;
#line 303 "../src/FolderManager/FileView.vala"
	if (gtk_dialog_run ((GtkDialog*) _tmp11_) == ((gint) GTK_RESPONSE_APPLY)) {
#line 2093 "FileView.c"
		ScratchDialogsNewBranchDialog* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 304 "../src/FolderManager/FileView.vala"
		_tmp12_ = dialog;
#line 304 "../src/FolderManager/FileView.vala"
		_tmp13_ = scratch_dialogs_new_branch_dialog_get_new_branch_name (_tmp12_);
#line 304 "../src/FolderManager/FileView.vala"
		_tmp14_ = _tmp13_;
#line 304 "../src/FolderManager/FileView.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 304 "../src/FolderManager/FileView.vala"
		_g_free0 (branch_name);
#line 304 "../src/FolderManager/FileView.vala"
		branch_name = _tmp15_;
#line 2110 "FileView.c"
	}
#line 307 "../src/FolderManager/FileView.vala"
	_tmp16_ = dialog;
#line 307 "../src/FolderManager/FileView.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp16_);
#line 308 "../src/FolderManager/FileView.vala"
	_tmp17_ = branch_name;
#line 308 "../src/FolderManager/FileView.vala"
	if (_tmp17_ != NULL) {
#line 2120 "FileView.c"
		ScratchFolderManagerProjectFolderItem* _tmp18_;
		const gchar* _tmp19_;
#line 309 "../src/FolderManager/FileView.vala"
		_tmp18_ = active_project;
#line 309 "../src/FolderManager/FileView.vala"
		_tmp19_ = branch_name;
#line 309 "../src/FolderManager/FileView.vala"
		scratch_folder_manager_project_folder_item_new_branch (_tmp18_, _tmp19_);
#line 2129 "FileView.c"
	}
#line 293 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (dialog);
#line 293 "../src/FolderManager/FileView.vala"
	_g_free0 (branch_name);
#line 2135 "FileView.c"
}

void
scratch_folder_manager_file_view_folder_item_update_hook (ScratchFolderManagerFileView* self,
                                                          GFile* source,
                                                          GFile* dest,
                                                          GFileMonitorEvent event)
{
	ScratchServicesPluginsManager* _tmp0_;
#line 313 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 313 "../src/FolderManager/FileView.vala"
	g_return_if_fail (source != NULL);
#line 314 "../src/FolderManager/FileView.vala"
	_tmp0_ = self->priv->plugins;
#line 314 "../src/FolderManager/FileView.vala"
	g_signal_emit_by_name (_tmp0_, "hook-folder-item-change", source, dest, event);
#line 2153 "FileView.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 317 "../src/FolderManager/FileView.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 317 "../src/FolderManager/FileView.vala"
	return _data8_;
#line 2163 "FileView.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 317 "../src/FolderManager/FileView.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 2173 "FileView.c"
		ScratchFolderManagerFileView* self;
#line 317 "../src/FolderManager/FileView.vala"
		self = _data8_->self;
#line 317 "../src/FolderManager/FileView.vala"
		_g_free0 (_data8_->path);
#line 317 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (self);
#line 317 "../src/FolderManager/FileView.vala"
		g_slice_free (Block8Data, _data8_);
#line 2183 "FileView.c"
	}
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 319 "../src/FolderManager/FileView.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 319 "../src/FolderManager/FileView.vala"
	return _data9_;
#line 2194 "FileView.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 319 "../src/FolderManager/FileView.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 2204 "FileView.c"
		ScratchFolderManagerFileView* self;
#line 319 "../src/FolderManager/FileView.vala"
		self = _data9_->_data8_->self;
#line 319 "../src/FolderManager/FileView.vala"
		block8_data_unref (_data9_->_data8_);
#line 319 "../src/FolderManager/FileView.vala"
		_data9_->_data8_ = NULL;
#line 319 "../src/FolderManager/FileView.vala"
		g_slice_free (Block9Data, _data9_);
#line 2214 "FileView.c"
	}
}

static void
___lambda70_ (Block9Data* _data9_,
              const gchar* new_name)
{
	Block8Data* _data8_;
	ScratchFolderManagerFileView* self;
	CodeWidgetsSourceListItem* _tmp0_;
	CodeWidgetsSourceListItem* _tmp1_;
	gchar* new_path = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GActionGroup* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	gchar* new_uri = NULL;
	gchar* _tmp11_;
	GtkRecentManager* _tmp12_;
#line 321 "../src/FolderManager/FileView.vala"
	_data8_ = _data9_->_data8_;
#line 321 "../src/FolderManager/FileView.vala"
	self = _data8_->self;
#line 321 "../src/FolderManager/FileView.vala"
	g_return_if_fail (new_name != NULL);
#line 322 "../src/FolderManager/FileView.vala"
	_tmp0_ = code_widgets_source_list_get_selected ((CodeWidgetsSourceList*) self);
#line 322 "../src/FolderManager/FileView.vala"
	_tmp1_ = _tmp0_;
#line 322 "../src/FolderManager/FileView.vala"
	g_signal_handler_disconnect ((GObject*) _tmp1_, _data9_->once);
#line 323 "../src/FolderManager/FileView.vala"
	_tmp2_ = g_path_get_dirname (_data8_->path);
#line 323 "../src/FolderManager/FileView.vala"
	_tmp3_ = _tmp2_;
#line 323 "../src/FolderManager/FileView.vala"
	_tmp4_ = g_strconcat (_tmp3_, G_DIR_SEPARATOR_S, NULL);
#line 323 "../src/FolderManager/FileView.vala"
	_tmp5_ = _tmp4_;
#line 323 "../src/FolderManager/FileView.vala"
	_tmp6_ = g_strconcat (_tmp5_, new_name, NULL);
#line 323 "../src/FolderManager/FileView.vala"
	_tmp7_ = _tmp6_;
#line 323 "../src/FolderManager/FileView.vala"
	_g_free0 (_tmp5_);
#line 323 "../src/FolderManager/FileView.vala"
	_g_free0 (_tmp3_);
#line 323 "../src/FolderManager/FileView.vala"
	new_path = _tmp7_;
#line 324 "../src/FolderManager/FileView.vala"
	_tmp8_ = self->priv->_toplevel_action_group;
#line 324 "../src/FolderManager/FileView.vala"
	_tmp9_ = g_variant_new_string (_data8_->path);
#line 324 "../src/FolderManager/FileView.vala"
	g_variant_ref_sink (_tmp9_);
#line 324 "../src/FolderManager/FileView.vala"
	_tmp10_ = _tmp9_;
#line 324 "../src/FolderManager/FileView.vala"
	g_action_group_activate_action (_tmp8_, SCRATCH_MAIN_WINDOW_ACTION_CLOSE_TAB, _tmp10_);
#line 324 "../src/FolderManager/FileView.vala"
	_g_variant_unref0 (_tmp10_);
#line 326 "../src/FolderManager/FileView.vala"
	_tmp11_ = g_strconcat ("file://", new_path, NULL);
#line 326 "../src/FolderManager/FileView.vala"
	new_uri = _tmp11_;
#line 327 "../src/FolderManager/FileView.vala"
	_tmp12_ = gtk_recent_manager_get_default ();
#line 327 "../src/FolderManager/FileView.vala"
	gtk_recent_manager_add_item (_tmp12_, new_uri);
#line 328 "../src/FolderManager/FileView.vala"
	g_signal_emit (self, scratch_folder_manager_file_view_signals[SCRATCH_FOLDER_MANAGER_FILE_VIEW_SELECT_SIGNAL], 0, new_path);
#line 321 "../src/FolderManager/FileView.vala"
	_g_free0 (new_uri);
#line 321 "../src/FolderManager/FileView.vala"
	_g_free0 (new_path);
#line 2295 "FileView.c"
}

static void
____lambda70__code_widgets_source_list_item_edited (CodeWidgetsSourceListItem* _sender,
                                                    const gchar* new_name,
                                                    gpointer self)
{
#line 321 "../src/FolderManager/FileView.vala"
	___lambda70_ (self, new_name);
#line 2305 "FileView.c"
}

static gboolean
__lambda71_ (ScratchFolderManagerFileView* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 334 "../src/FolderManager/FileView.vala"
	_tmp0_ = code_widgets_source_list_get_editing ((CodeWidgetsSourceList*) self);
#line 334 "../src/FolderManager/FileView.vala"
	_tmp1_ = _tmp0_;
#line 334 "../src/FolderManager/FileView.vala"
	if (_tmp1_) {
#line 335 "../src/FolderManager/FileView.vala"
		result = G_SOURCE_CONTINUE;
#line 335 "../src/FolderManager/FileView.vala"
		return result;
#line 2324 "FileView.c"
	} else {
#line 338 "../src/FolderManager/FileView.vala"
		scratch_folder_manager_file_view_unselect_all (self);
#line 339 "../src/FolderManager/FileView.vala"
		result = G_SOURCE_REMOVE;
#line 339 "../src/FolderManager/FileView.vala"
		return result;
#line 2332 "FileView.c"
	}
}

static gboolean
___lambda71__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda71_ ((ScratchFolderManagerFileView*) self);
#line 333 "../src/FolderManager/FileView.vala"
	return result;
#line 2343 "FileView.c"
}

static void
scratch_folder_manager_file_view_rename_file (ScratchFolderManagerFileView* self,
                                              const gchar* path)
{
	Block8Data* _data8_;
	gchar* _tmp0_;
	CodeWidgetsSourceListItem* _tmp1_;
	CodeWidgetsSourceListItem* _tmp2_;
#line 317 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 317 "../src/FolderManager/FileView.vala"
	g_return_if_fail (path != NULL);
#line 317 "../src/FolderManager/FileView.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 317 "../src/FolderManager/FileView.vala"
	_data8_->_ref_count_ = 1;
#line 317 "../src/FolderManager/FileView.vala"
	_data8_->self = g_object_ref (self);
#line 317 "../src/FolderManager/FileView.vala"
	_tmp0_ = g_strdup (path);
#line 317 "../src/FolderManager/FileView.vala"
	_g_free0 (_data8_->path);
#line 317 "../src/FolderManager/FileView.vala"
	_data8_->path = _tmp0_;
#line 318 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_select_path (self, _data8_->path);
#line 319 "../src/FolderManager/FileView.vala"
	_tmp1_ = code_widgets_source_list_get_selected ((CodeWidgetsSourceList*) self);
#line 319 "../src/FolderManager/FileView.vala"
	_tmp2_ = _tmp1_;
#line 319 "../src/FolderManager/FileView.vala"
	if (code_widgets_source_list_start_editing_item ((CodeWidgetsSourceList*) self, _tmp2_)) {
#line 2378 "FileView.c"
		Block9Data* _data9_;
		CodeWidgetsSourceListItem* _tmp3_;
		CodeWidgetsSourceListItem* _tmp4_;
		gulong _tmp5_;
#line 319 "../src/FolderManager/FileView.vala"
		_data9_ = g_slice_new0 (Block9Data);
#line 319 "../src/FolderManager/FileView.vala"
		_data9_->_ref_count_ = 1;
#line 319 "../src/FolderManager/FileView.vala"
		_data9_->_data8_ = block8_data_ref (_data8_);
#line 320 "../src/FolderManager/FileView.vala"
		_data9_->once = (gulong) 0;
#line 321 "../src/FolderManager/FileView.vala"
		_tmp3_ = code_widgets_source_list_get_selected ((CodeWidgetsSourceList*) self);
#line 321 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 321 "../src/FolderManager/FileView.vala"
		_tmp5_ = g_signal_connect_data (_tmp4_, "edited", (GCallback) ____lambda70__code_widgets_source_list_item_edited, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 321 "../src/FolderManager/FileView.vala"
		_data9_->once = _tmp5_;
#line 319 "../src/FolderManager/FileView.vala"
		block9_data_unref (_data9_);
#line 319 "../src/FolderManager/FileView.vala"
		_data9_ = NULL;
#line 2403 "FileView.c"
	}
#line 333 "../src/FolderManager/FileView.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, ___lambda71__gsource_func, g_object_ref (self), g_object_unref);
#line 317 "../src/FolderManager/FileView.vala"
	block8_data_unref (_data8_);
#line 317 "../src/FolderManager/FileView.vala"
	_data8_ = NULL;
#line 2411 "FileView.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 344 "../src/FolderManager/FileView.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 344 "../src/FolderManager/FileView.vala"
	return _data10_;
#line 2421 "FileView.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 344 "../src/FolderManager/FileView.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 2431 "FileView.c"
		ScratchFolderManagerFileView* self;
#line 344 "../src/FolderManager/FileView.vala"
		self = _data10_->self;
#line 344 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_data10_->folder_to_rename);
#line 344 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (self);
#line 344 "../src/FolderManager/FileView.vala"
		g_slice_free (Block10Data, _data10_);
#line 2441 "FileView.c"
	}
}

static gboolean
___lambda72_ (Block10Data* _data10_)
{
	ScratchFolderManagerFileView* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 355 "../src/FolderManager/FileView.vala"
	self = _data10_->self;
#line 356 "../src/FolderManager/FileView.vala"
	_tmp0_ = code_widgets_source_list_get_editing ((CodeWidgetsSourceList*) self);
#line 356 "../src/FolderManager/FileView.vala"
	_tmp1_ = _tmp0_;
#line 356 "../src/FolderManager/FileView.vala"
	if (_tmp1_) {
#line 357 "../src/FolderManager/FileView.vala"
		result = G_SOURCE_CONTINUE;
#line 357 "../src/FolderManager/FileView.vala"
		return result;
#line 2464 "FileView.c"
	} else {
		ScratchFolderManagerFolderItem* _tmp2_;
#line 359 "../src/FolderManager/FileView.vala"
		scratch_folder_manager_file_view_unselect_all (self);
#line 361 "../src/FolderManager/FileView.vala"
		_tmp2_ = _data10_->folder_to_rename;
#line 361 "../src/FolderManager/FileView.vala"
		code_widgets_source_list_item_set_selectable ((CodeWidgetsSourceListItem*) _tmp2_, FALSE);
#line 2473 "FileView.c"
	}
#line 364 "../src/FolderManager/FileView.vala"
	result = G_SOURCE_REMOVE;
#line 364 "../src/FolderManager/FileView.vala"
	return result;
#line 2479 "FileView.c"
}

static gboolean
____lambda72__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda72_ (self);
#line 355 "../src/FolderManager/FileView.vala"
	return result;
#line 2489 "FileView.c"
}

static void
scratch_folder_manager_file_view_rename_folder (ScratchFolderManagerFileView* self,
                                                const gchar* path)
{
	Block10Data* _data10_;
	CodeWidgetsSourceListExpandableItem* _tmp0_;
	CodeWidgetsSourceListExpandableItem* _tmp1_;
	CodeWidgetsSourceListItem* _tmp2_;
	ScratchFolderManagerFolderItem* _tmp3_;
	ScratchFolderManagerFolderItem* _tmp4_;
	ScratchFolderManagerFolderItem* _tmp5_;
	ScratchFolderManagerFolderItem* _tmp6_;
#line 344 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 344 "../src/FolderManager/FileView.vala"
	g_return_if_fail (path != NULL);
#line 344 "../src/FolderManager/FileView.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 344 "../src/FolderManager/FileView.vala"
	_data10_->_ref_count_ = 1;
#line 344 "../src/FolderManager/FileView.vala"
	_data10_->self = g_object_ref (self);
#line 345 "../src/FolderManager/FileView.vala"
	_tmp0_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 345 "../src/FolderManager/FileView.vala"
	_tmp1_ = _tmp0_;
#line 345 "../src/FolderManager/FileView.vala"
	_tmp2_ = scratch_folder_manager_file_view_find_path (self, _tmp1_, path, FALSE);
#line 345 "../src/FolderManager/FileView.vala"
	_tmp3_ = _g_object_ref0 (SCRATCH_FOLDER_MANAGER_IS_FOLDER_ITEM (_tmp2_) ? ((ScratchFolderManagerFolderItem*) _tmp2_) : NULL);
#line 345 "../src/FolderManager/FileView.vala"
	_data10_->folder_to_rename = _tmp3_;
#line 346 "../src/FolderManager/FileView.vala"
	_tmp4_ = _data10_->folder_to_rename;
#line 346 "../src/FolderManager/FileView.vala"
	if (_tmp4_ == NULL) {
#line 347 "../src/FolderManager/FileView.vala"
		g_critical ("FileView.vala:347: Could not find folder from given path to rename: %s", path);
#line 348 "../src/FolderManager/FileView.vala"
		block10_data_unref (_data10_);
#line 348 "../src/FolderManager/FileView.vala"
		_data10_ = NULL;
#line 348 "../src/FolderManager/FileView.vala"
		return;
#line 2536 "FileView.c"
	}
#line 351 "../src/FolderManager/FileView.vala"
	_tmp5_ = _data10_->folder_to_rename;
#line 351 "../src/FolderManager/FileView.vala"
	code_widgets_source_list_item_set_selectable ((CodeWidgetsSourceListItem*) _tmp5_, TRUE);
#line 352 "../src/FolderManager/FileView.vala"
	_tmp6_ = _data10_->folder_to_rename;
#line 352 "../src/FolderManager/FileView.vala"
	if (code_widgets_source_list_start_editing_item ((CodeWidgetsSourceList*) self, (CodeWidgetsSourceListItem*) _tmp6_)) {
#line 355 "../src/FolderManager/FileView.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 200, ____lambda72__gsource_func, block10_data_ref (_data10_), block10_data_unref);
#line 2548 "FileView.c"
	} else {
		ScratchFolderManagerFolderItem* _tmp7_;
#line 367 "../src/FolderManager/FileView.vala"
		g_critical ("FileView.vala:367: Could not rename %s", path);
#line 368 "../src/FolderManager/FileView.vala"
		_tmp7_ = _data10_->folder_to_rename;
#line 368 "../src/FolderManager/FileView.vala"
		code_widgets_source_list_item_set_selectable ((CodeWidgetsSourceListItem*) _tmp7_, FALSE);
#line 2557 "FileView.c"
	}
#line 344 "../src/FolderManager/FileView.vala"
	block10_data_unref (_data10_);
#line 344 "../src/FolderManager/FileView.vala"
	_data10_ = NULL;
#line 2563 "FileView.c"
}

static void
scratch_folder_manager_file_view_rename_items_with_same_name (ScratchFolderManagerFileView* self,
                                                              ScratchFolderManagerItem* item)
{
	gchar* item_name = NULL;
	ScratchFolderManagerFile* _tmp0_;
	ScratchFolderManagerFile* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp47_;
#line 372 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 372 "../src/FolderManager/FileView.vala"
	g_return_if_fail (item != NULL);
#line 373 "../src/FolderManager/FileView.vala"
	_tmp0_ = scratch_folder_manager_item_get_file (item);
#line 373 "../src/FolderManager/FileView.vala"
	_tmp1_ = _tmp0_;
#line 373 "../src/FolderManager/FileView.vala"
	_tmp2_ = scratch_folder_manager_file_get_name (_tmp1_);
#line 373 "../src/FolderManager/FileView.vala"
	_tmp3_ = _tmp2_;
#line 373 "../src/FolderManager/FileView.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 373 "../src/FolderManager/FileView.vala"
	item_name = _tmp4_;
#line 2593 "FileView.c"
	{
		GeeIterator* _child_it = NULL;
		CodeWidgetsSourceListExpandableItem* _tmp5_;
		CodeWidgetsSourceListExpandableItem* _tmp6_;
		GeeCollection* _tmp7_;
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
		GeeIterator* _tmp10_;
		GeeIterator* _tmp11_;
#line 374 "../src/FolderManager/FileView.vala"
		_tmp5_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 374 "../src/FolderManager/FileView.vala"
		_tmp6_ = _tmp5_;
#line 374 "../src/FolderManager/FileView.vala"
		_tmp7_ = code_widgets_source_list_expandable_item_get_children (_tmp6_);
#line 374 "../src/FolderManager/FileView.vala"
		_tmp8_ = _tmp7_;
#line 374 "../src/FolderManager/FileView.vala"
		_tmp9_ = _tmp8_;
#line 374 "../src/FolderManager/FileView.vala"
		_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 374 "../src/FolderManager/FileView.vala"
		_tmp11_ = _tmp10_;
#line 374 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp9_);
#line 374 "../src/FolderManager/FileView.vala"
		_child_it = _tmp11_;
#line 374 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 2623 "FileView.c"
			GeeIterator* _tmp12_;
			CodeWidgetsSourceListItem* child = NULL;
			GeeIterator* _tmp13_;
			gpointer _tmp14_;
			gchar* new_other_item_name = NULL;
			gchar* new_item_name = NULL;
			ScratchFolderManagerProjectFolderItem* other_item = NULL;
			CodeWidgetsSourceListItem* _tmp15_;
			ScratchFolderManagerProjectFolderItem* _tmp16_;
			ScratchFolderManagerFile* _tmp17_;
			ScratchFolderManagerFile* _tmp18_;
			GFile* _tmp19_;
			GFile* _tmp20_;
			ScratchFolderManagerProjectFolderItem* _tmp21_;
			ScratchFolderManagerFile* _tmp22_;
			ScratchFolderManagerFile* _tmp23_;
			GFile* _tmp24_;
			GFile* _tmp25_;
			gchar* _tmp26_ = NULL;
			gchar* _tmp27_ = NULL;
			gboolean _tmp28_;
#line 374 "../src/FolderManager/FileView.vala"
			_tmp12_ = _child_it;
#line 374 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp12_)) {
#line 374 "../src/FolderManager/FileView.vala"
				break;
#line 2651 "FileView.c"
			}
#line 374 "../src/FolderManager/FileView.vala"
			_tmp13_ = _child_it;
#line 374 "../src/FolderManager/FileView.vala"
			_tmp14_ = gee_iterator_get (_tmp13_);
#line 374 "../src/FolderManager/FileView.vala"
			child = (CodeWidgetsSourceListItem*) _tmp14_;
#line 376 "../src/FolderManager/FileView.vala"
			_tmp15_ = child;
#line 376 "../src/FolderManager/FileView.vala"
			_tmp16_ = _g_object_ref0 (SCRATCH_FOLDER_MANAGER_IS_PROJECT_FOLDER_ITEM (_tmp15_) ? ((ScratchFolderManagerProjectFolderItem*) _tmp15_) : NULL);
#line 376 "../src/FolderManager/FileView.vala"
			other_item = _tmp16_;
#line 378 "../src/FolderManager/FileView.vala"
			_tmp17_ = scratch_folder_manager_item_get_file (item);
#line 378 "../src/FolderManager/FileView.vala"
			_tmp18_ = _tmp17_;
#line 378 "../src/FolderManager/FileView.vala"
			_tmp19_ = scratch_folder_manager_file_get_file (_tmp18_);
#line 378 "../src/FolderManager/FileView.vala"
			_tmp20_ = _tmp19_;
#line 378 "../src/FolderManager/FileView.vala"
			_tmp21_ = other_item;
#line 378 "../src/FolderManager/FileView.vala"
			_tmp22_ = scratch_folder_manager_item_get_file ((ScratchFolderManagerItem*) _tmp21_);
#line 378 "../src/FolderManager/FileView.vala"
			_tmp23_ = _tmp22_;
#line 378 "../src/FolderManager/FileView.vala"
			_tmp24_ = scratch_folder_manager_file_get_file (_tmp23_);
#line 378 "../src/FolderManager/FileView.vala"
			_tmp25_ = _tmp24_;
#line 378 "../src/FolderManager/FileView.vala"
			_tmp28_ = scratch_utils_find_unique_path (_tmp20_, _tmp25_, &_tmp26_, &_tmp27_);
#line 378 "../src/FolderManager/FileView.vala"
			_g_free0 (new_item_name);
#line 378 "../src/FolderManager/FileView.vala"
			new_item_name = _tmp26_;
#line 378 "../src/FolderManager/FileView.vala"
			_g_free0 (new_other_item_name);
#line 378 "../src/FolderManager/FileView.vala"
			new_other_item_name = _tmp27_;
#line 378 "../src/FolderManager/FileView.vala"
			if (_tmp28_) {
#line 2695 "FileView.c"
				const gchar* _tmp29_;
				gint _tmp30_;
				gint _tmp31_;
				const gchar* _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				ScratchFolderManagerProjectFolderItem* _tmp37_;
				const gchar* _tmp38_;
				const gchar* _tmp39_;
				gint _tmp40_;
				gint _tmp41_;
				const gchar* _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
#line 379 "../src/FolderManager/FileView.vala"
				_tmp29_ = item_name;
#line 379 "../src/FolderManager/FileView.vala"
				_tmp30_ = strlen (_tmp29_);
#line 379 "../src/FolderManager/FileView.vala"
				_tmp31_ = _tmp30_;
#line 379 "../src/FolderManager/FileView.vala"
				_tmp32_ = new_item_name;
#line 379 "../src/FolderManager/FileView.vala"
				_tmp33_ = strlen (_tmp32_);
#line 379 "../src/FolderManager/FileView.vala"
				_tmp34_ = _tmp33_;
#line 379 "../src/FolderManager/FileView.vala"
				if (_tmp31_ < _tmp34_) {
#line 2724 "FileView.c"
					const gchar* _tmp35_;
					gchar* _tmp36_;
#line 380 "../src/FolderManager/FileView.vala"
					_tmp35_ = new_item_name;
#line 380 "../src/FolderManager/FileView.vala"
					_tmp36_ = g_strdup (_tmp35_);
#line 380 "../src/FolderManager/FileView.vala"
					_g_free0 (item_name);
#line 380 "../src/FolderManager/FileView.vala"
					item_name = _tmp36_;
#line 2735 "FileView.c"
				}
#line 383 "../src/FolderManager/FileView.vala"
				_tmp37_ = other_item;
#line 383 "../src/FolderManager/FileView.vala"
				_tmp38_ = code_widgets_source_list_item_get_name ((CodeWidgetsSourceListItem*) _tmp37_);
#line 383 "../src/FolderManager/FileView.vala"
				_tmp39_ = _tmp38_;
#line 383 "../src/FolderManager/FileView.vala"
				_tmp40_ = strlen (_tmp39_);
#line 383 "../src/FolderManager/FileView.vala"
				_tmp41_ = _tmp40_;
#line 383 "../src/FolderManager/FileView.vala"
				_tmp42_ = new_other_item_name;
#line 383 "../src/FolderManager/FileView.vala"
				_tmp43_ = strlen (_tmp42_);
#line 383 "../src/FolderManager/FileView.vala"
				_tmp44_ = _tmp43_;
#line 383 "../src/FolderManager/FileView.vala"
				if (_tmp41_ < _tmp44_) {
#line 2755 "FileView.c"
					ScratchFolderManagerProjectFolderItem* _tmp45_;
					const gchar* _tmp46_;
#line 384 "../src/FolderManager/FileView.vala"
					_tmp45_ = other_item;
#line 384 "../src/FolderManager/FileView.vala"
					_tmp46_ = new_other_item_name;
#line 384 "../src/FolderManager/FileView.vala"
					code_widgets_source_list_item_set_name ((CodeWidgetsSourceListItem*) _tmp45_, _tmp46_);
#line 2764 "FileView.c"
				}
			}
#line 374 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (other_item);
#line 374 "../src/FolderManager/FileView.vala"
			_g_free0 (new_item_name);
#line 374 "../src/FolderManager/FileView.vala"
			_g_free0 (new_other_item_name);
#line 374 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child);
#line 2775 "FileView.c"
		}
#line 374 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_child_it);
#line 2779 "FileView.c"
	}
#line 389 "../src/FolderManager/FileView.vala"
	_tmp47_ = item_name;
#line 389 "../src/FolderManager/FileView.vala"
	code_widgets_source_list_item_set_name ((CodeWidgetsSourceListItem*) item, _tmp47_);
#line 372 "../src/FolderManager/FileView.vala"
	_g_free0 (item_name);
#line 2787 "FileView.c"
}

static void
scratch_folder_manager_file_view_add_new_folder (ScratchFolderManagerFileView* self,
                                                 GSimpleAction* action,
                                                 GVariant* param)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	ScratchFolderManagerFolderItem* folder = NULL;
	CodeWidgetsSourceListExpandableItem* _tmp5_;
	CodeWidgetsSourceListExpandableItem* _tmp6_;
	const gchar* _tmp7_;
	CodeWidgetsSourceListItem* _tmp8_;
	ScratchFolderManagerFolderItem* _tmp9_;
	ScratchFolderManagerFolderItem* _tmp10_;
	ScratchFolderManagerFolderItem* _tmp11_;
#line 392 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 392 "../src/FolderManager/FileView.vala"
	g_return_if_fail (action != NULL);
#line 394 "../src/FolderManager/FileView.vala"
	_tmp0_ = g_variant_get_string (param, NULL);
#line 394 "../src/FolderManager/FileView.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 394 "../src/FolderManager/FileView.vala"
	path = _tmp1_;
#line 396 "../src/FolderManager/FileView.vala"
	_tmp3_ = path;
#line 396 "../src/FolderManager/FileView.vala"
	if (_tmp3_ == NULL) {
#line 396 "../src/FolderManager/FileView.vala"
		_tmp2_ = TRUE;
#line 2824 "FileView.c"
	} else {
		const gchar* _tmp4_;
#line 396 "../src/FolderManager/FileView.vala"
		_tmp4_ = path;
#line 396 "../src/FolderManager/FileView.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") == 0;
#line 2831 "FileView.c"
	}
#line 396 "../src/FolderManager/FileView.vala"
	if (_tmp2_) {
#line 397 "../src/FolderManager/FileView.vala"
		_g_free0 (path);
#line 397 "../src/FolderManager/FileView.vala"
		return;
#line 2839 "FileView.c"
	}
#line 400 "../src/FolderManager/FileView.vala"
	_tmp5_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 400 "../src/FolderManager/FileView.vala"
	_tmp6_ = _tmp5_;
#line 400 "../src/FolderManager/FileView.vala"
	_tmp7_ = path;
#line 400 "../src/FolderManager/FileView.vala"
	_tmp8_ = scratch_folder_manager_file_view_find_path (self, _tmp6_, _tmp7_, FALSE);
#line 400 "../src/FolderManager/FileView.vala"
	_tmp9_ = _g_object_ref0 (SCRATCH_FOLDER_MANAGER_IS_FOLDER_ITEM (_tmp8_) ? ((ScratchFolderManagerFolderItem*) _tmp8_) : NULL);
#line 400 "../src/FolderManager/FileView.vala"
	folder = _tmp9_;
#line 401 "../src/FolderManager/FileView.vala"
	_tmp10_ = folder;
#line 401 "../src/FolderManager/FileView.vala"
	if (_tmp10_ == NULL) {
#line 402 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (folder);
#line 402 "../src/FolderManager/FileView.vala"
		_g_free0 (path);
#line 402 "../src/FolderManager/FileView.vala"
		return;
#line 2863 "FileView.c"
	}
#line 405 "../src/FolderManager/FileView.vala"
	_tmp11_ = folder;
#line 405 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_folder_item_on_add_new (_tmp11_, TRUE);
#line 392 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (folder);
#line 392 "../src/FolderManager/FileView.vala"
	_g_free0 (path);
#line 2873 "FileView.c"
}

static void
scratch_folder_manager_file_view_add_new_file (ScratchFolderManagerFileView* self,
                                               GSimpleAction* action,
                                               GVariant* param)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	ScratchFolderManagerFolderItem* folder = NULL;
	CodeWidgetsSourceListExpandableItem* _tmp5_;
	CodeWidgetsSourceListExpandableItem* _tmp6_;
	const gchar* _tmp7_;
	CodeWidgetsSourceListItem* _tmp8_;
	ScratchFolderManagerFolderItem* _tmp9_;
	ScratchFolderManagerFolderItem* _tmp10_;
	ScratchFolderManagerFolderItem* _tmp11_;
#line 408 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 408 "../src/FolderManager/FileView.vala"
	g_return_if_fail (action != NULL);
#line 410 "../src/FolderManager/FileView.vala"
	_tmp0_ = g_variant_get_string (param, NULL);
#line 410 "../src/FolderManager/FileView.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 410 "../src/FolderManager/FileView.vala"
	path = _tmp1_;
#line 412 "../src/FolderManager/FileView.vala"
	_tmp3_ = path;
#line 412 "../src/FolderManager/FileView.vala"
	if (_tmp3_ == NULL) {
#line 412 "../src/FolderManager/FileView.vala"
		_tmp2_ = TRUE;
#line 2910 "FileView.c"
	} else {
		const gchar* _tmp4_;
#line 412 "../src/FolderManager/FileView.vala"
		_tmp4_ = path;
#line 412 "../src/FolderManager/FileView.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") == 0;
#line 2917 "FileView.c"
	}
#line 412 "../src/FolderManager/FileView.vala"
	if (_tmp2_) {
#line 413 "../src/FolderManager/FileView.vala"
		_g_free0 (path);
#line 413 "../src/FolderManager/FileView.vala"
		return;
#line 2925 "FileView.c"
	}
#line 416 "../src/FolderManager/FileView.vala"
	_tmp5_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 416 "../src/FolderManager/FileView.vala"
	_tmp6_ = _tmp5_;
#line 416 "../src/FolderManager/FileView.vala"
	_tmp7_ = path;
#line 416 "../src/FolderManager/FileView.vala"
	_tmp8_ = scratch_folder_manager_file_view_find_path (self, _tmp6_, _tmp7_, FALSE);
#line 416 "../src/FolderManager/FileView.vala"
	_tmp9_ = _g_object_ref0 (SCRATCH_FOLDER_MANAGER_IS_FOLDER_ITEM (_tmp8_) ? ((ScratchFolderManagerFolderItem*) _tmp8_) : NULL);
#line 416 "../src/FolderManager/FileView.vala"
	folder = _tmp9_;
#line 417 "../src/FolderManager/FileView.vala"
	_tmp10_ = folder;
#line 417 "../src/FolderManager/FileView.vala"
	if (_tmp10_ == NULL) {
#line 418 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (folder);
#line 418 "../src/FolderManager/FileView.vala"
		_g_free0 (path);
#line 418 "../src/FolderManager/FileView.vala"
		return;
#line 2949 "FileView.c"
	}
#line 421 "../src/FolderManager/FileView.vala"
	_tmp11_ = folder;
#line 421 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_folder_item_on_add_new (_tmp11_, FALSE);
#line 408 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (folder);
#line 408 "../src/FolderManager/FileView.vala"
	_g_free0 (path);
#line 2959 "FileView.c"
}

static void
scratch_folder_manager_file_view_action_launch_app_with_file_path (ScratchFolderManagerFileView* self,
                                                                   GSimpleAction* action,
                                                                   GVariant* param)
{
	const gchar** params = NULL;
	gsize _tmp0_ = 0;
	const gchar** _tmp1_;
	gint params_length1;
	gint _params_size_;
	gchar* path = NULL;
	const gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	gchar* app_id = NULL;
	const gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp12_;
	GDesktopAppInfo* app_info = NULL;
	const gchar* _tmp14_;
	GDesktopAppInfo* _tmp15_;
	GFile* file = NULL;
	const gchar* _tmp16_;
	GFile* _tmp17_;
	GDesktopAppInfo* _tmp18_;
	GFile* _tmp19_;
#line 424 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 424 "../src/FolderManager/FileView.vala"
	g_return_if_fail (action != NULL);
#line 425 "../src/FolderManager/FileView.vala"
	_tmp1_ = g_variant_get_strv (param, &_tmp0_);
#line 425 "../src/FolderManager/FileView.vala"
	params = _tmp1_;
#line 425 "../src/FolderManager/FileView.vala"
	params_length1 = _tmp0_;
#line 425 "../src/FolderManager/FileView.vala"
	_params_size_ = params_length1;
#line 426 "../src/FolderManager/FileView.vala"
	_tmp2_ = params;
#line 426 "../src/FolderManager/FileView.vala"
	_tmp2__length1 = params_length1;
#line 426 "../src/FolderManager/FileView.vala"
	_tmp3_ = _tmp2_[0];
#line 426 "../src/FolderManager/FileView.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 426 "../src/FolderManager/FileView.vala"
	path = _tmp4_;
#line 427 "../src/FolderManager/FileView.vala"
	_tmp6_ = path;
#line 427 "../src/FolderManager/FileView.vala"
	if (_tmp6_ == NULL) {
#line 427 "../src/FolderManager/FileView.vala"
		_tmp5_ = TRUE;
#line 3022 "FileView.c"
	} else {
		const gchar* _tmp7_;
#line 427 "../src/FolderManager/FileView.vala"
		_tmp7_ = path;
#line 427 "../src/FolderManager/FileView.vala"
		_tmp5_ = g_strcmp0 (_tmp7_, "") == 0;
#line 3029 "FileView.c"
	}
#line 427 "../src/FolderManager/FileView.vala"
	if (_tmp5_) {
#line 428 "../src/FolderManager/FileView.vala"
		_g_free0 (path);
#line 428 "../src/FolderManager/FileView.vala"
		params = (g_free (params), NULL);
#line 428 "../src/FolderManager/FileView.vala"
		return;
#line 3039 "FileView.c"
	}
#line 431 "../src/FolderManager/FileView.vala"
	_tmp8_ = params;
#line 431 "../src/FolderManager/FileView.vala"
	_tmp8__length1 = params_length1;
#line 431 "../src/FolderManager/FileView.vala"
	_tmp9_ = _tmp8_[1];
#line 431 "../src/FolderManager/FileView.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 431 "../src/FolderManager/FileView.vala"
	app_id = _tmp10_;
#line 432 "../src/FolderManager/FileView.vala"
	_tmp12_ = app_id;
#line 432 "../src/FolderManager/FileView.vala"
	if (_tmp12_ == NULL) {
#line 432 "../src/FolderManager/FileView.vala"
		_tmp11_ = TRUE;
#line 3057 "FileView.c"
	} else {
		const gchar* _tmp13_;
#line 432 "../src/FolderManager/FileView.vala"
		_tmp13_ = app_id;
#line 432 "../src/FolderManager/FileView.vala"
		_tmp11_ = g_strcmp0 (_tmp13_, "") == 0;
#line 3064 "FileView.c"
	}
#line 432 "../src/FolderManager/FileView.vala"
	if (_tmp11_) {
#line 433 "../src/FolderManager/FileView.vala"
		_g_free0 (app_id);
#line 433 "../src/FolderManager/FileView.vala"
		_g_free0 (path);
#line 433 "../src/FolderManager/FileView.vala"
		params = (g_free (params), NULL);
#line 433 "../src/FolderManager/FileView.vala"
		return;
#line 3076 "FileView.c"
	}
#line 436 "../src/FolderManager/FileView.vala"
	_tmp14_ = app_id;
#line 436 "../src/FolderManager/FileView.vala"
	_tmp15_ = g_desktop_app_info_new (_tmp14_);
#line 436 "../src/FolderManager/FileView.vala"
	app_info = _tmp15_;
#line 437 "../src/FolderManager/FileView.vala"
	_tmp16_ = path;
#line 437 "../src/FolderManager/FileView.vala"
	_tmp17_ = g_file_new_for_path (_tmp16_);
#line 437 "../src/FolderManager/FileView.vala"
	file = _tmp17_;
#line 439 "../src/FolderManager/FileView.vala"
	_tmp18_ = app_info;
#line 439 "../src/FolderManager/FileView.vala"
	_tmp19_ = file;
#line 439 "../src/FolderManager/FileView.vala"
	scratch_utils_launch_app_with_file ((GAppInfo*) _tmp18_, _tmp19_);
#line 424 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (file);
#line 424 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (app_info);
#line 424 "../src/FolderManager/FileView.vala"
	_g_free0 (app_id);
#line 424 "../src/FolderManager/FileView.vala"
	_g_free0 (path);
#line 424 "../src/FolderManager/FileView.vala"
	params = (g_free (params), NULL);
#line 3106 "FileView.c"
}

static void
scratch_folder_manager_file_view_action_show_app_chooser (ScratchFolderManagerFileView* self,
                                                          GSimpleAction* action,
                                                          GVariant* param)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	GFile* file = NULL;
	const gchar* _tmp5_;
	GFile* _tmp6_;
	GtkAppChooserDialog* dialog = NULL;
	GtkWindow* _tmp7_;
	GtkWindow* _tmp8_;
	GFile* _tmp9_;
	GtkAppChooserDialog* _tmp10_;
	GtkAppChooserDialog* _tmp11_;
	GtkAppChooserDialog* _tmp12_;
	GtkAppChooserDialog* _tmp13_;
	GtkAppChooserDialog* _tmp19_;
#line 442 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 442 "../src/FolderManager/FileView.vala"
	g_return_if_fail (action != NULL);
#line 443 "../src/FolderManager/FileView.vala"
	_tmp0_ = g_variant_get_string (param, NULL);
#line 443 "../src/FolderManager/FileView.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 443 "../src/FolderManager/FileView.vala"
	path = _tmp1_;
#line 445 "../src/FolderManager/FileView.vala"
	_tmp3_ = path;
#line 445 "../src/FolderManager/FileView.vala"
	if (_tmp3_ == NULL) {
#line 445 "../src/FolderManager/FileView.vala"
		_tmp2_ = TRUE;
#line 3147 "FileView.c"
	} else {
		const gchar* _tmp4_;
#line 445 "../src/FolderManager/FileView.vala"
		_tmp4_ = path;
#line 445 "../src/FolderManager/FileView.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") == 0;
#line 3154 "FileView.c"
	}
#line 445 "../src/FolderManager/FileView.vala"
	if (_tmp2_) {
#line 446 "../src/FolderManager/FileView.vala"
		_g_free0 (path);
#line 446 "../src/FolderManager/FileView.vala"
		return;
#line 3162 "FileView.c"
	}
#line 449 "../src/FolderManager/FileView.vala"
	_tmp5_ = path;
#line 449 "../src/FolderManager/FileView.vala"
	_tmp6_ = g_file_new_for_path (_tmp5_);
#line 449 "../src/FolderManager/FileView.vala"
	file = _tmp6_;
#line 450 "../src/FolderManager/FileView.vala"
	_tmp7_ = (GtkWindow*) gtk_window_new (GTK_WINDOW_TOPLEVEL);
#line 450 "../src/FolderManager/FileView.vala"
	g_object_ref_sink (_tmp7_);
#line 450 "../src/FolderManager/FileView.vala"
	_tmp8_ = _tmp7_;
#line 450 "../src/FolderManager/FileView.vala"
	_tmp9_ = file;
#line 450 "../src/FolderManager/FileView.vala"
	_tmp10_ = (GtkAppChooserDialog*) gtk_app_chooser_dialog_new (_tmp8_, GTK_DIALOG_MODAL, _tmp9_);
#line 450 "../src/FolderManager/FileView.vala"
	g_object_ref_sink (_tmp10_);
#line 450 "../src/FolderManager/FileView.vala"
	_tmp11_ = _tmp10_;
#line 450 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (_tmp8_);
#line 450 "../src/FolderManager/FileView.vala"
	dialog = _tmp11_;
#line 451 "../src/FolderManager/FileView.vala"
	_tmp12_ = dialog;
#line 451 "../src/FolderManager/FileView.vala"
	gtk_window_set_deletable ((GtkWindow*) _tmp12_, FALSE);
#line 453 "../src/FolderManager/FileView.vala"
	_tmp13_ = dialog;
#line 453 "../src/FolderManager/FileView.vala"
	if (gtk_dialog_run ((GtkDialog*) _tmp13_) == ((gint) GTK_RESPONSE_OK)) {
#line 3196 "FileView.c"
		GAppInfo* app_info = NULL;
		GtkAppChooserDialog* _tmp14_;
		GAppInfo* _tmp15_;
		GAppInfo* _tmp16_;
#line 454 "../src/FolderManager/FileView.vala"
		_tmp14_ = dialog;
#line 454 "../src/FolderManager/FileView.vala"
		_tmp15_ = gtk_app_chooser_get_app_info ((GtkAppChooser*) _tmp14_);
#line 454 "../src/FolderManager/FileView.vala"
		app_info = _tmp15_;
#line 455 "../src/FolderManager/FileView.vala"
		_tmp16_ = app_info;
#line 455 "../src/FolderManager/FileView.vala"
		if (_tmp16_ != NULL) {
#line 3211 "FileView.c"
			GAppInfo* _tmp17_;
			GFile* _tmp18_;
#line 456 "../src/FolderManager/FileView.vala"
			_tmp17_ = app_info;
#line 456 "../src/FolderManager/FileView.vala"
			_tmp18_ = file;
#line 456 "../src/FolderManager/FileView.vala"
			scratch_utils_launch_app_with_file (_tmp17_, _tmp18_);
#line 3220 "FileView.c"
		}
#line 453 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (app_info);
#line 3224 "FileView.c"
	}
#line 460 "../src/FolderManager/FileView.vala"
	_tmp19_ = dialog;
#line 460 "../src/FolderManager/FileView.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp19_);
#line 442 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (dialog);
#line 442 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (file);
#line 442 "../src/FolderManager/FileView.vala"
	_g_free0 (path);
#line 3236 "FileView.c"
}

static void
scratch_folder_manager_file_view_action_execute_contract_with_file_path (ScratchFolderManagerFileView* self,
                                                                         GSimpleAction* action,
                                                                         GVariant* param)
{
	const gchar** params = NULL;
	gsize _tmp0_ = 0;
	const gchar** _tmp1_;
	gint params_length1;
	gint _params_size_;
	gchar* path = NULL;
	const gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	gchar* contract_name = NULL;
	const gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp12_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
#line 463 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 463 "../src/FolderManager/FileView.vala"
	g_return_if_fail (action != NULL);
#line 464 "../src/FolderManager/FileView.vala"
	_tmp1_ = g_variant_get_strv (param, &_tmp0_);
#line 464 "../src/FolderManager/FileView.vala"
	params = _tmp1_;
#line 464 "../src/FolderManager/FileView.vala"
	params_length1 = _tmp0_;
#line 464 "../src/FolderManager/FileView.vala"
	_params_size_ = params_length1;
#line 465 "../src/FolderManager/FileView.vala"
	_tmp2_ = params;
#line 465 "../src/FolderManager/FileView.vala"
	_tmp2__length1 = params_length1;
#line 465 "../src/FolderManager/FileView.vala"
	_tmp3_ = _tmp2_[0];
#line 465 "../src/FolderManager/FileView.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 465 "../src/FolderManager/FileView.vala"
	path = _tmp4_;
#line 466 "../src/FolderManager/FileView.vala"
	_tmp6_ = path;
#line 466 "../src/FolderManager/FileView.vala"
	if (_tmp6_ == NULL) {
#line 466 "../src/FolderManager/FileView.vala"
		_tmp5_ = TRUE;
#line 3293 "FileView.c"
	} else {
		const gchar* _tmp7_;
#line 466 "../src/FolderManager/FileView.vala"
		_tmp7_ = path;
#line 466 "../src/FolderManager/FileView.vala"
		_tmp5_ = g_strcmp0 (_tmp7_, "") == 0;
#line 3300 "FileView.c"
	}
#line 466 "../src/FolderManager/FileView.vala"
	if (_tmp5_) {
#line 467 "../src/FolderManager/FileView.vala"
		_g_free0 (path);
#line 467 "../src/FolderManager/FileView.vala"
		params = (g_free (params), NULL);
#line 467 "../src/FolderManager/FileView.vala"
		return;
#line 3310 "FileView.c"
	}
#line 470 "../src/FolderManager/FileView.vala"
	_tmp8_ = params;
#line 470 "../src/FolderManager/FileView.vala"
	_tmp8__length1 = params_length1;
#line 470 "../src/FolderManager/FileView.vala"
	_tmp9_ = _tmp8_[1];
#line 470 "../src/FolderManager/FileView.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 470 "../src/FolderManager/FileView.vala"
	contract_name = _tmp10_;
#line 471 "../src/FolderManager/FileView.vala"
	_tmp12_ = contract_name;
#line 471 "../src/FolderManager/FileView.vala"
	if (_tmp12_ == NULL) {
#line 471 "../src/FolderManager/FileView.vala"
		_tmp11_ = TRUE;
#line 3328 "FileView.c"
	} else {
		const gchar* _tmp13_;
#line 471 "../src/FolderManager/FileView.vala"
		_tmp13_ = contract_name;
#line 471 "../src/FolderManager/FileView.vala"
		_tmp11_ = g_strcmp0 (_tmp13_, "") == 0;
#line 3335 "FileView.c"
	}
#line 471 "../src/FolderManager/FileView.vala"
	if (_tmp11_) {
#line 472 "../src/FolderManager/FileView.vala"
		_g_free0 (contract_name);
#line 472 "../src/FolderManager/FileView.vala"
		_g_free0 (path);
#line 472 "../src/FolderManager/FileView.vala"
		params = (g_free (params), NULL);
#line 472 "../src/FolderManager/FileView.vala"
		return;
#line 3347 "FileView.c"
	}
#line 475 "../src/FolderManager/FileView.vala"
	_tmp14_ = path;
#line 475 "../src/FolderManager/FileView.vala"
	_tmp15_ = contract_name;
#line 475 "../src/FolderManager/FileView.vala"
	scratch_utils_execute_contract_with_file_path (_tmp14_, _tmp15_);
#line 463 "../src/FolderManager/FileView.vala"
	_g_free0 (contract_name);
#line 463 "../src/FolderManager/FileView.vala"
	_g_free0 (path);
#line 463 "../src/FolderManager/FileView.vala"
	params = (g_free (params), NULL);
#line 3361 "FileView.c"
}

static void
scratch_folder_manager_file_view_action_rename_file (ScratchFolderManagerFileView* self,
                                                     GSimpleAction* action,
                                                     GVariant* param)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	const gchar* _tmp5_;
#line 478 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 478 "../src/FolderManager/FileView.vala"
	g_return_if_fail (action != NULL);
#line 479 "../src/FolderManager/FileView.vala"
	_tmp0_ = g_variant_get_string (param, NULL);
#line 479 "../src/FolderManager/FileView.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 479 "../src/FolderManager/FileView.vala"
	path = _tmp1_;
#line 481 "../src/FolderManager/FileView.vala"
	_tmp3_ = path;
#line 481 "../src/FolderManager/FileView.vala"
	if (_tmp3_ == NULL) {
#line 481 "../src/FolderManager/FileView.vala"
		_tmp2_ = TRUE;
#line 3391 "FileView.c"
	} else {
		const gchar* _tmp4_;
#line 481 "../src/FolderManager/FileView.vala"
		_tmp4_ = path;
#line 481 "../src/FolderManager/FileView.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") == 0;
#line 3398 "FileView.c"
	}
#line 481 "../src/FolderManager/FileView.vala"
	if (_tmp2_) {
#line 482 "../src/FolderManager/FileView.vala"
		_g_free0 (path);
#line 482 "../src/FolderManager/FileView.vala"
		return;
#line 3406 "FileView.c"
	}
#line 485 "../src/FolderManager/FileView.vala"
	_tmp5_ = path;
#line 485 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_rename_file (self, _tmp5_);
#line 478 "../src/FolderManager/FileView.vala"
	_g_free0 (path);
#line 3414 "FileView.c"
}

static void
scratch_folder_manager_file_view_action_rename_folder (ScratchFolderManagerFileView* self,
                                                       GSimpleAction* action,
                                                       GVariant* param)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	const gchar* _tmp5_;
#line 488 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 488 "../src/FolderManager/FileView.vala"
	g_return_if_fail (action != NULL);
#line 489 "../src/FolderManager/FileView.vala"
	_tmp0_ = g_variant_get_string (param, NULL);
#line 489 "../src/FolderManager/FileView.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 489 "../src/FolderManager/FileView.vala"
	path = _tmp1_;
#line 491 "../src/FolderManager/FileView.vala"
	_tmp3_ = path;
#line 491 "../src/FolderManager/FileView.vala"
	if (_tmp3_ == NULL) {
#line 491 "../src/FolderManager/FileView.vala"
		_tmp2_ = TRUE;
#line 3444 "FileView.c"
	} else {
		const gchar* _tmp4_;
#line 491 "../src/FolderManager/FileView.vala"
		_tmp4_ = path;
#line 491 "../src/FolderManager/FileView.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") == 0;
#line 3451 "FileView.c"
	}
#line 491 "../src/FolderManager/FileView.vala"
	if (_tmp2_) {
#line 492 "../src/FolderManager/FileView.vala"
		_g_free0 (path);
#line 492 "../src/FolderManager/FileView.vala"
		return;
#line 3459 "FileView.c"
	}
#line 495 "../src/FolderManager/FileView.vala"
	_tmp5_ = path;
#line 495 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_rename_folder (self, _tmp5_);
#line 488 "../src/FolderManager/FileView.vala"
	_g_free0 (path);
#line 3467 "FileView.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 507 "../src/FolderManager/FileView.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 507 "../src/FolderManager/FileView.vala"
	return _data11_;
#line 3477 "FileView.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 507 "../src/FolderManager/FileView.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 3487 "FileView.c"
		ScratchFolderManagerFileView* self;
#line 507 "../src/FolderManager/FileView.vala"
		self = _data11_->self;
#line 507 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_data11_->item_to_delete);
#line 507 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (self);
#line 507 "../src/FolderManager/FileView.vala"
		g_slice_free (Block11Data, _data11_);
#line 3497 "FileView.c"
	}
}

static void
____lambda73_ (Block11Data* _data11_)
{
	ScratchFolderManagerFileView* self;
	ScratchFolderManagerItem* _tmp0_;
#line 512 "../src/FolderManager/FileView.vala"
	self = _data11_->self;
#line 513 "../src/FolderManager/FileView.vala"
	_tmp0_ = _data11_->item_to_delete;
#line 513 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_item_trash (_tmp0_);
#line 3512 "FileView.c"
}

static void
_____lambda73__scratch_folder_manager_project_folder_item_closed (ScratchFolderManagerProjectFolderItem* _sender,
                                                                  gpointer self)
{
#line 512 "../src/FolderManager/FileView.vala"
	____lambda73_ (self);
#line 3521 "FileView.c"
}

static void
scratch_folder_manager_file_view_action_delete (ScratchFolderManagerFileView* self,
                                                GSimpleAction* action,
                                                GVariant* param)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	CodeWidgetsSourceListItem* item = NULL;
	CodeWidgetsSourceListExpandableItem* _tmp5_;
	CodeWidgetsSourceListExpandableItem* _tmp6_;
	const gchar* _tmp7_;
	CodeWidgetsSourceListItem* _tmp8_;
	CodeWidgetsSourceListItem* _tmp9_;
	CodeWidgetsSourceListItem* _tmp10_;
#line 499 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 499 "../src/FolderManager/FileView.vala"
	g_return_if_fail (action != NULL);
#line 500 "../src/FolderManager/FileView.vala"
	_tmp0_ = g_variant_get_string (param, NULL);
#line 500 "../src/FolderManager/FileView.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 500 "../src/FolderManager/FileView.vala"
	path = _tmp1_;
#line 502 "../src/FolderManager/FileView.vala"
	_tmp3_ = path;
#line 502 "../src/FolderManager/FileView.vala"
	if (_tmp3_ == NULL) {
#line 502 "../src/FolderManager/FileView.vala"
		_tmp2_ = TRUE;
#line 3557 "FileView.c"
	} else {
		const gchar* _tmp4_;
#line 502 "../src/FolderManager/FileView.vala"
		_tmp4_ = path;
#line 502 "../src/FolderManager/FileView.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "") == 0;
#line 3564 "FileView.c"
	}
#line 502 "../src/FolderManager/FileView.vala"
	if (_tmp2_) {
#line 503 "../src/FolderManager/FileView.vala"
		_g_free0 (path);
#line 503 "../src/FolderManager/FileView.vala"
		return;
#line 3572 "FileView.c"
	}
#line 506 "../src/FolderManager/FileView.vala"
	_tmp5_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 506 "../src/FolderManager/FileView.vala"
	_tmp6_ = _tmp5_;
#line 506 "../src/FolderManager/FileView.vala"
	_tmp7_ = path;
#line 506 "../src/FolderManager/FileView.vala"
	_tmp8_ = scratch_folder_manager_file_view_find_path (self, _tmp6_, _tmp7_, FALSE);
#line 506 "../src/FolderManager/FileView.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 506 "../src/FolderManager/FileView.vala"
	item = _tmp9_;
#line 507 "../src/FolderManager/FileView.vala"
	_tmp10_ = item;
#line 507 "../src/FolderManager/FileView.vala"
	if (_tmp10_ != NULL) {
#line 3590 "FileView.c"
		Block11Data* _data11_;
		CodeWidgetsSourceListItem* _tmp11_;
		ScratchFolderManagerItem* _tmp12_;
		ScratchFolderManagerItem* _tmp13_;
		ScratchFolderManagerItem* _tmp16_;
#line 507 "../src/FolderManager/FileView.vala"
		_data11_ = g_slice_new0 (Block11Data);
#line 507 "../src/FolderManager/FileView.vala"
		_data11_->_ref_count_ = 1;
#line 507 "../src/FolderManager/FileView.vala"
		_data11_->self = g_object_ref (self);
#line 508 "../src/FolderManager/FileView.vala"
		_tmp11_ = item;
#line 508 "../src/FolderManager/FileView.vala"
		_tmp12_ = _g_object_ref0 (SCRATCH_FOLDER_MANAGER_IS_ITEM (_tmp11_) ? ((ScratchFolderManagerItem*) _tmp11_) : NULL);
#line 508 "../src/FolderManager/FileView.vala"
		_data11_->item_to_delete = _tmp12_;
#line 511 "../src/FolderManager/FileView.vala"
		_tmp13_ = _data11_->item_to_delete;
#line 511 "../src/FolderManager/FileView.vala"
		if (SCRATCH_FOLDER_MANAGER_IS_PROJECT_FOLDER_ITEM (_tmp13_)) {
#line 3612 "FileView.c"
			ScratchFolderManagerItem* _tmp14_;
			ScratchFolderManagerItem* _tmp15_;
#line 512 "../src/FolderManager/FileView.vala"
			_tmp14_ = _data11_->item_to_delete;
#line 512 "../src/FolderManager/FileView.vala"
			g_signal_connect_data ((ScratchFolderManagerProjectFolderItem*) _tmp14_, "closed", (GCallback) _____lambda73__scratch_folder_manager_project_folder_item_closed, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, G_CONNECT_AFTER);
#line 515 "../src/FolderManager/FileView.vala"
			_tmp15_ = _data11_->item_to_delete;
#line 515 "../src/FolderManager/FileView.vala"
			g_signal_emit_by_name ((ScratchFolderManagerProjectFolderItem*) _tmp15_, "closed");
#line 516 "../src/FolderManager/FileView.vala"
			block11_data_unref (_data11_);
#line 516 "../src/FolderManager/FileView.vala"
			_data11_ = NULL;
#line 516 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (item);
#line 516 "../src/FolderManager/FileView.vala"
			_g_free0 (path);
#line 516 "../src/FolderManager/FileView.vala"
			return;
#line 3633 "FileView.c"
		}
#line 519 "../src/FolderManager/FileView.vala"
		_tmp16_ = _data11_->item_to_delete;
#line 519 "../src/FolderManager/FileView.vala"
		scratch_folder_manager_item_trash (_tmp16_);
#line 507 "../src/FolderManager/FileView.vala"
		block11_data_unref (_data11_);
#line 507 "../src/FolderManager/FileView.vala"
		_data11_ = NULL;
#line 3643 "FileView.c"
	}
#line 499 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (item);
#line 499 "../src/FolderManager/FileView.vala"
	_g_free0 (path);
#line 3649 "FileView.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 523 "../src/FolderManager/FileView.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 523 "../src/FolderManager/FileView.vala"
	return _data12_;
#line 3659 "FileView.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 523 "../src/FolderManager/FileView.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 3669 "FileView.c"
		ScratchFolderManagerFileView* self;
#line 523 "../src/FolderManager/FileView.vala"
		self = _data12_->self;
#line 523 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_data12_->folder_root);
#line 523 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (self);
#line 523 "../src/FolderManager/FileView.vala"
		g_slice_free (Block12Data, _data12_);
#line 3679 "FileView.c"
	}
}

static void
__lambda77_ (Block12Data* _data12_)
{
	ScratchFolderManagerFileView* self;
	GActionGroup* _tmp0_;
	ScratchFolderManagerProjectFolderItem* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	CodeWidgetsSourceListExpandableItem* _tmp7_;
	CodeWidgetsSourceListExpandableItem* _tmp8_;
	ScratchFolderManagerProjectFolderItem* _tmp9_;
	ScratchServicesGitManager* _tmp31_;
	ScratchServicesGitManager* _tmp32_;
	ScratchFolderManagerProjectFolderItem* _tmp33_;
#line 537 "../src/FolderManager/FileView.vala"
	self = _data12_->self;
#line 538 "../src/FolderManager/FileView.vala"
	_tmp0_ = self->priv->_toplevel_action_group;
#line 538 "../src/FolderManager/FileView.vala"
	_tmp1_ = _data12_->folder_root;
#line 538 "../src/FolderManager/FileView.vala"
	_tmp2_ = scratch_folder_manager_item_get_path ((ScratchFolderManagerItem*) _tmp1_);
#line 538 "../src/FolderManager/FileView.vala"
	_tmp3_ = _tmp2_;
#line 538 "../src/FolderManager/FileView.vala"
	_tmp4_ = _tmp3_;
#line 538 "../src/FolderManager/FileView.vala"
	_tmp5_ = g_variant_new_string (_tmp4_);
#line 538 "../src/FolderManager/FileView.vala"
	g_variant_ref_sink (_tmp5_);
#line 538 "../src/FolderManager/FileView.vala"
	_tmp6_ = _tmp5_;
#line 538 "../src/FolderManager/FileView.vala"
	g_action_group_activate_action (_tmp0_, SCRATCH_MAIN_WINDOW_ACTION_CLOSE_PROJECT_DOCS, _tmp6_);
#line 538 "../src/FolderManager/FileView.vala"
	_g_variant_unref0 (_tmp6_);
#line 538 "../src/FolderManager/FileView.vala"
	_g_free0 (_tmp4_);
#line 539 "../src/FolderManager/FileView.vala"
	_tmp7_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 539 "../src/FolderManager/FileView.vala"
	_tmp8_ = _tmp7_;
#line 539 "../src/FolderManager/FileView.vala"
	_tmp9_ = _data12_->folder_root;
#line 539 "../src/FolderManager/FileView.vala"
	code_widgets_source_list_expandable_item_remove (_tmp8_, (CodeWidgetsSourceListItem*) _tmp9_);
#line 3732 "FileView.c"
	{
		GeeIterator* _child_it = NULL;
		CodeWidgetsSourceListExpandableItem* _tmp10_;
		CodeWidgetsSourceListExpandableItem* _tmp11_;
		GeeCollection* _tmp12_;
		GeeCollection* _tmp13_;
		GeeCollection* _tmp14_;
		GeeIterator* _tmp15_;
		GeeIterator* _tmp16_;
#line 540 "../src/FolderManager/FileView.vala"
		_tmp10_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 540 "../src/FolderManager/FileView.vala"
		_tmp11_ = _tmp10_;
#line 540 "../src/FolderManager/FileView.vala"
		_tmp12_ = code_widgets_source_list_expandable_item_get_children (_tmp11_);
#line 540 "../src/FolderManager/FileView.vala"
		_tmp13_ = _tmp12_;
#line 540 "../src/FolderManager/FileView.vala"
		_tmp14_ = _tmp13_;
#line 540 "../src/FolderManager/FileView.vala"
		_tmp15_ = gee_iterable_iterator ((GeeIterable*) _tmp14_);
#line 540 "../src/FolderManager/FileView.vala"
		_tmp16_ = _tmp15_;
#line 540 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp14_);
#line 540 "../src/FolderManager/FileView.vala"
		_child_it = _tmp16_;
#line 540 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 3762 "FileView.c"
			GeeIterator* _tmp17_;
			CodeWidgetsSourceListItem* child = NULL;
			GeeIterator* _tmp18_;
			gpointer _tmp19_;
			ScratchFolderManagerProjectFolderItem* child_folder = NULL;
			CodeWidgetsSourceListItem* _tmp20_;
			ScratchFolderManagerProjectFolderItem* _tmp21_;
			ScratchFolderManagerProjectFolderItem* _tmp22_;
			const gchar* _tmp23_;
			const gchar* _tmp24_;
			ScratchFolderManagerProjectFolderItem* _tmp25_;
			ScratchFolderManagerFile* _tmp26_;
			ScratchFolderManagerFile* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
#line 540 "../src/FolderManager/FileView.vala"
			_tmp17_ = _child_it;
#line 540 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp17_)) {
#line 540 "../src/FolderManager/FileView.vala"
				break;
#line 3784 "FileView.c"
			}
#line 540 "../src/FolderManager/FileView.vala"
			_tmp18_ = _child_it;
#line 540 "../src/FolderManager/FileView.vala"
			_tmp19_ = gee_iterator_get (_tmp18_);
#line 540 "../src/FolderManager/FileView.vala"
			child = (CodeWidgetsSourceListItem*) _tmp19_;
#line 541 "../src/FolderManager/FileView.vala"
			_tmp20_ = child;
#line 541 "../src/FolderManager/FileView.vala"
			_tmp21_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, SCRATCH_FOLDER_MANAGER_TYPE_PROJECT_FOLDER_ITEM, ScratchFolderManagerProjectFolderItem));
#line 541 "../src/FolderManager/FileView.vala"
			child_folder = _tmp21_;
#line 542 "../src/FolderManager/FileView.vala"
			_tmp22_ = child_folder;
#line 542 "../src/FolderManager/FileView.vala"
			_tmp23_ = code_widgets_source_list_item_get_name ((CodeWidgetsSourceListItem*) _tmp22_);
#line 542 "../src/FolderManager/FileView.vala"
			_tmp24_ = _tmp23_;
#line 542 "../src/FolderManager/FileView.vala"
			_tmp25_ = child_folder;
#line 542 "../src/FolderManager/FileView.vala"
			_tmp26_ = scratch_folder_manager_item_get_file ((ScratchFolderManagerItem*) _tmp25_);
#line 542 "../src/FolderManager/FileView.vala"
			_tmp27_ = _tmp26_;
#line 542 "../src/FolderManager/FileView.vala"
			_tmp28_ = scratch_folder_manager_file_get_name (_tmp27_);
#line 542 "../src/FolderManager/FileView.vala"
			_tmp29_ = _tmp28_;
#line 542 "../src/FolderManager/FileView.vala"
			if (g_strcmp0 (_tmp24_, _tmp29_) != 0) {
#line 3816 "FileView.c"
				ScratchFolderManagerProjectFolderItem* _tmp30_;
#line 543 "../src/FolderManager/FileView.vala"
				_tmp30_ = child_folder;
#line 543 "../src/FolderManager/FileView.vala"
				scratch_folder_manager_file_view_rename_items_with_same_name (self, (ScratchFolderManagerItem*) _tmp30_);
#line 3822 "FileView.c"
			}
#line 540 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child_folder);
#line 540 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child);
#line 3828 "FileView.c"
		}
#line 540 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_child_it);
#line 3832 "FileView.c"
	}
#line 546 "../src/FolderManager/FileView.vala"
	_tmp31_ = scratch_services_git_manager_get_instance ();
#line 546 "../src/FolderManager/FileView.vala"
	_tmp32_ = _tmp31_;
#line 546 "../src/FolderManager/FileView.vala"
	_tmp33_ = _data12_->folder_root;
#line 546 "../src/FolderManager/FileView.vala"
	scratch_services_git_manager_remove_project (_tmp32_, _tmp33_);
#line 546 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (_tmp32_);
#line 547 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_write_settings (self);
#line 3846 "FileView.c"
}

static void
___lambda77__scratch_folder_manager_project_folder_item_closed (ScratchFolderManagerProjectFolderItem* _sender,
                                                                gpointer self)
{
#line 537 "../src/FolderManager/FileView.vala"
	__lambda77_ (self);
#line 3855 "FileView.c"
}

static void
scratch_folder_manager_file_view_add_folder (ScratchFolderManagerFileView* self,
                                             ScratchFolderManagerFile* folder,
                                             gboolean expand)
{
	Block12Data* _data12_;
	ScratchFolderManagerProjectFolderItem* _tmp3_;
	CodeWidgetsSourceListExpandableItem* _tmp4_;
	CodeWidgetsSourceListExpandableItem* _tmp5_;
	ScratchFolderManagerProjectFolderItem* _tmp6_;
	ScratchFolderManagerProjectFolderItem* _tmp7_;
	ScratchFolderManagerProjectFolderItem* _tmp8_;
	ScratchFolderManagerProjectFolderItem* _tmp9_;
#line 523 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 523 "../src/FolderManager/FileView.vala"
	g_return_if_fail (folder != NULL);
#line 523 "../src/FolderManager/FileView.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 523 "../src/FolderManager/FileView.vala"
	_data12_->_ref_count_ = 1;
#line 523 "../src/FolderManager/FileView.vala"
	_data12_->self = g_object_ref (self);
#line 524 "../src/FolderManager/FileView.vala"
	if (scratch_folder_manager_file_view_is_open (self, folder)) {
#line 3883 "FileView.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 525 "../src/FolderManager/FileView.vala"
		_tmp0_ = scratch_folder_manager_file_get_path (folder);
#line 525 "../src/FolderManager/FileView.vala"
		_tmp1_ = _tmp0_;
#line 525 "../src/FolderManager/FileView.vala"
		_tmp2_ = _tmp1_;
#line 525 "../src/FolderManager/FileView.vala"
		g_warning ("FileView.vala:525: Folder '%s' is already open.", _tmp2_);
#line 525 "../src/FolderManager/FileView.vala"
		_g_free0 (_tmp2_);
#line 526 "../src/FolderManager/FileView.vala"
		block12_data_unref (_data12_);
#line 526 "../src/FolderManager/FileView.vala"
		_data12_ = NULL;
#line 526 "../src/FolderManager/FileView.vala"
		return;
#line 3903 "FileView.c"
	} else {
#line 527 "../src/FolderManager/FileView.vala"
		if (!scratch_folder_manager_file_is_valid_directory (folder, TRUE)) {
#line 528 "../src/FolderManager/FileView.vala"
			g_warning ("FileView.vala:528: Cannot open invalid directory.");
#line 529 "../src/FolderManager/FileView.vala"
			block12_data_unref (_data12_);
#line 529 "../src/FolderManager/FileView.vala"
			_data12_ = NULL;
#line 529 "../src/FolderManager/FileView.vala"
			return;
#line 3915 "FileView.c"
		}
	}
#line 532 "../src/FolderManager/FileView.vala"
	_tmp3_ = scratch_folder_manager_project_folder_item_new (folder, self);
#line 532 "../src/FolderManager/FileView.vala"
	_data12_->folder_root = _tmp3_;
#line 533 "../src/FolderManager/FileView.vala"
	_tmp4_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 533 "../src/FolderManager/FileView.vala"
	_tmp5_ = _tmp4_;
#line 533 "../src/FolderManager/FileView.vala"
	_tmp6_ = _data12_->folder_root;
#line 533 "../src/FolderManager/FileView.vala"
	code_widgets_source_list_expandable_item_add (_tmp5_, (CodeWidgetsSourceListItem*) _tmp6_);
#line 534 "../src/FolderManager/FileView.vala"
	_tmp7_ = _data12_->folder_root;
#line 534 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_rename_items_with_same_name (self, (ScratchFolderManagerItem*) _tmp7_);
#line 536 "../src/FolderManager/FileView.vala"
	_tmp8_ = _data12_->folder_root;
#line 536 "../src/FolderManager/FileView.vala"
	code_widgets_source_list_expandable_item_set_expanded ((CodeWidgetsSourceListExpandableItem*) _tmp8_, expand);
#line 537 "../src/FolderManager/FileView.vala"
	_tmp9_ = _data12_->folder_root;
#line 537 "../src/FolderManager/FileView.vala"
	g_signal_connect_data (_tmp9_, "closed", (GCallback) ___lambda77__scratch_folder_manager_project_folder_item_closed, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 550 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_write_settings (self);
#line 523 "../src/FolderManager/FileView.vala"
	block12_data_unref (_data12_);
#line 523 "../src/FolderManager/FileView.vala"
	_data12_ = NULL;
#line 3948 "FileView.c"
}

static gboolean
scratch_folder_manager_file_view_is_open (ScratchFolderManagerFileView* self,
                                          ScratchFolderManagerFile* folder)
{
	gboolean result;
#line 553 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 553 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (folder != NULL, FALSE);
#line 3960 "FileView.c"
	{
		GeeIterator* _child_it = NULL;
		CodeWidgetsSourceListExpandableItem* _tmp0_;
		CodeWidgetsSourceListExpandableItem* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 554 "../src/FolderManager/FileView.vala"
		_tmp0_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 554 "../src/FolderManager/FileView.vala"
		_tmp1_ = _tmp0_;
#line 554 "../src/FolderManager/FileView.vala"
		_tmp2_ = code_widgets_source_list_expandable_item_get_children (_tmp1_);
#line 554 "../src/FolderManager/FileView.vala"
		_tmp3_ = _tmp2_;
#line 554 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 554 "../src/FolderManager/FileView.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 554 "../src/FolderManager/FileView.vala"
		_tmp6_ = _tmp5_;
#line 554 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp4_);
#line 554 "../src/FolderManager/FileView.vala"
		_child_it = _tmp6_;
#line 554 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 3990 "FileView.c"
			GeeIterator* _tmp7_;
			CodeWidgetsSourceListItem* child = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			CodeWidgetsSourceListItem* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gboolean _tmp17_;
#line 554 "../src/FolderManager/FileView.vala"
			_tmp7_ = _child_it;
#line 554 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 554 "../src/FolderManager/FileView.vala"
				break;
#line 4009 "FileView.c"
			}
#line 554 "../src/FolderManager/FileView.vala"
			_tmp8_ = _child_it;
#line 554 "../src/FolderManager/FileView.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 554 "../src/FolderManager/FileView.vala"
			child = (CodeWidgetsSourceListItem*) _tmp9_;
#line 555 "../src/FolderManager/FileView.vala"
			_tmp10_ = scratch_folder_manager_file_get_path (folder);
#line 555 "../src/FolderManager/FileView.vala"
			_tmp11_ = _tmp10_;
#line 555 "../src/FolderManager/FileView.vala"
			_tmp12_ = _tmp11_;
#line 555 "../src/FolderManager/FileView.vala"
			_tmp13_ = child;
#line 555 "../src/FolderManager/FileView.vala"
			_tmp14_ = scratch_folder_manager_item_get_path (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, SCRATCH_FOLDER_MANAGER_TYPE_ITEM, ScratchFolderManagerItem));
#line 555 "../src/FolderManager/FileView.vala"
			_tmp15_ = _tmp14_;
#line 555 "../src/FolderManager/FileView.vala"
			_tmp16_ = _tmp15_;
#line 555 "../src/FolderManager/FileView.vala"
			_tmp17_ = g_strcmp0 (_tmp12_, _tmp16_) == 0;
#line 555 "../src/FolderManager/FileView.vala"
			_g_free0 (_tmp16_);
#line 555 "../src/FolderManager/FileView.vala"
			_g_free0 (_tmp12_);
#line 555 "../src/FolderManager/FileView.vala"
			if (_tmp17_) {
#line 556 "../src/FolderManager/FileView.vala"
				result = TRUE;
#line 556 "../src/FolderManager/FileView.vala"
				_g_object_unref0 (child);
#line 556 "../src/FolderManager/FileView.vala"
				_g_object_unref0 (_child_it);
#line 556 "../src/FolderManager/FileView.vala"
				return result;
#line 4047 "FileView.c"
			}
#line 554 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (child);
#line 4051 "FileView.c"
		}
#line 554 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_child_it);
#line 4055 "FileView.c"
	}
#line 557 "../src/FolderManager/FileView.vala"
	result = FALSE;
#line 557 "../src/FolderManager/FileView.vala"
	return result;
#line 4061 "FileView.c"
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 575 "../src/FolderManager/FileView.vala"
	if ((*length) == (*size)) {
#line 575 "../src/FolderManager/FileView.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 575 "../src/FolderManager/FileView.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 4076 "FileView.c"
	}
#line 575 "../src/FolderManager/FileView.vala"
	(*array)[(*length)++] = value;
#line 575 "../src/FolderManager/FileView.vala"
	(*array)[*length] = NULL;
#line 4082 "FileView.c"
}

static void
scratch_folder_manager_file_view_write_settings (ScratchFolderManagerFileView* self)
{
	gchar** to_save = NULL;
	gchar** _tmp0_;
	gint to_save_length1;
	gint _to_save_size_;
	GSettings* _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
#line 560 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 561 "../src/FolderManager/FileView.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 561 "../src/FolderManager/FileView.vala"
	to_save = _tmp0_;
#line 561 "../src/FolderManager/FileView.vala"
	to_save_length1 = 0;
#line 561 "../src/FolderManager/FileView.vala"
	_to_save_size_ = to_save_length1;
#line 4105 "FileView.c"
	{
		GeeIterator* _main_folder_it = NULL;
		CodeWidgetsSourceListExpandableItem* _tmp1_;
		CodeWidgetsSourceListExpandableItem* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		GeeIterator* _tmp6_;
		GeeIterator* _tmp7_;
#line 563 "../src/FolderManager/FileView.vala"
		_tmp1_ = code_widgets_source_list_get_root ((CodeWidgetsSourceList*) self);
#line 563 "../src/FolderManager/FileView.vala"
		_tmp2_ = _tmp1_;
#line 563 "../src/FolderManager/FileView.vala"
		_tmp3_ = code_widgets_source_list_expandable_item_get_children (_tmp2_);
#line 563 "../src/FolderManager/FileView.vala"
		_tmp4_ = _tmp3_;
#line 563 "../src/FolderManager/FileView.vala"
		_tmp5_ = _tmp4_;
#line 563 "../src/FolderManager/FileView.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 563 "../src/FolderManager/FileView.vala"
		_tmp7_ = _tmp6_;
#line 563 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_tmp5_);
#line 563 "../src/FolderManager/FileView.vala"
		_main_folder_it = _tmp7_;
#line 563 "../src/FolderManager/FileView.vala"
		while (TRUE) {
#line 4135 "FileView.c"
			GeeIterator* _tmp8_;
			CodeWidgetsSourceListItem* main_folder = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			gboolean saved = FALSE;
			gchar* folder_path = NULL;
			CodeWidgetsSourceListItem* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar** _tmp14_;
			gint _tmp14__length1;
#line 563 "../src/FolderManager/FileView.vala"
			_tmp8_ = _main_folder_it;
#line 563 "../src/FolderManager/FileView.vala"
			if (!gee_iterator_next (_tmp8_)) {
#line 563 "../src/FolderManager/FileView.vala"
				break;
#line 4153 "FileView.c"
			}
#line 563 "../src/FolderManager/FileView.vala"
			_tmp9_ = _main_folder_it;
#line 563 "../src/FolderManager/FileView.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 563 "../src/FolderManager/FileView.vala"
			main_folder = (CodeWidgetsSourceListItem*) _tmp10_;
#line 564 "../src/FolderManager/FileView.vala"
			saved = FALSE;
#line 565 "../src/FolderManager/FileView.vala"
			_tmp11_ = main_folder;
#line 565 "../src/FolderManager/FileView.vala"
			_tmp12_ = scratch_folder_manager_item_get_path (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, SCRATCH_FOLDER_MANAGER_TYPE_ITEM, ScratchFolderManagerItem));
#line 565 "../src/FolderManager/FileView.vala"
			_tmp13_ = _tmp12_;
#line 565 "../src/FolderManager/FileView.vala"
			folder_path = _tmp13_;
#line 567 "../src/FolderManager/FileView.vala"
			_tmp14_ = to_save;
#line 567 "../src/FolderManager/FileView.vala"
			_tmp14__length1 = to_save_length1;
#line 4175 "FileView.c"
			{
				gchar** saved_folder_collection = NULL;
				gint saved_folder_collection_length1 = 0;
				gint _saved_folder_collection_size_ = 0;
				gint saved_folder_it = 0;
#line 567 "../src/FolderManager/FileView.vala"
				saved_folder_collection = _tmp14_;
#line 567 "../src/FolderManager/FileView.vala"
				saved_folder_collection_length1 = _tmp14__length1;
#line 567 "../src/FolderManager/FileView.vala"
				for (saved_folder_it = 0; saved_folder_it < saved_folder_collection_length1; saved_folder_it = saved_folder_it + 1) {
#line 4187 "FileView.c"
					gchar* _tmp15_;
					gchar* saved_folder = NULL;
#line 567 "../src/FolderManager/FileView.vala"
					_tmp15_ = g_strdup (saved_folder_collection[saved_folder_it]);
#line 567 "../src/FolderManager/FileView.vala"
					saved_folder = _tmp15_;
#line 4194 "FileView.c"
					{
						const gchar* _tmp16_;
						const gchar* _tmp17_;
#line 568 "../src/FolderManager/FileView.vala"
						_tmp16_ = folder_path;
#line 568 "../src/FolderManager/FileView.vala"
						_tmp17_ = saved_folder;
#line 568 "../src/FolderManager/FileView.vala"
						if (g_strcmp0 (_tmp16_, _tmp17_) == 0) {
#line 569 "../src/FolderManager/FileView.vala"
							saved = TRUE;
#line 570 "../src/FolderManager/FileView.vala"
							_g_free0 (saved_folder);
#line 570 "../src/FolderManager/FileView.vala"
							break;
#line 4210 "FileView.c"
						}
#line 567 "../src/FolderManager/FileView.vala"
						_g_free0 (saved_folder);
#line 4214 "FileView.c"
					}
				}
			}
#line 574 "../src/FolderManager/FileView.vala"
			if (!saved) {
#line 4220 "FileView.c"
				const gchar* _tmp18_;
				gchar* _tmp19_;
#line 575 "../src/FolderManager/FileView.vala"
				_tmp18_ = folder_path;
#line 575 "../src/FolderManager/FileView.vala"
				_tmp19_ = g_strdup (_tmp18_);
#line 575 "../src/FolderManager/FileView.vala"
				_vala_array_add3 (&to_save, &to_save_length1, &_to_save_size_, _tmp19_);
#line 4229 "FileView.c"
			}
#line 563 "../src/FolderManager/FileView.vala"
			_g_free0 (folder_path);
#line 563 "../src/FolderManager/FileView.vala"
			_g_object_unref0 (main_folder);
#line 4235 "FileView.c"
		}
#line 563 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (_main_folder_it);
#line 4239 "FileView.c"
	}
#line 579 "../src/FolderManager/FileView.vala"
	_tmp20_ = self->priv->settings;
#line 579 "../src/FolderManager/FileView.vala"
	_tmp21_ = to_save;
#line 579 "../src/FolderManager/FileView.vala"
	_tmp21__length1 = to_save_length1;
#line 579 "../src/FolderManager/FileView.vala"
	g_settings_set_strv (_tmp20_, "opened-folders", _tmp21_);
#line 560 "../src/FolderManager/FileView.vala"
	to_save = (_vala_array_free (to_save, to_save_length1, (GDestroyNotify) g_free), NULL);
#line 4251 "FileView.c"
}

GSimpleActionGroup*
scratch_folder_manager_file_view_get_actions (ScratchFolderManagerFileView* self)
{
	GSimpleActionGroup* result;
	GSimpleActionGroup* _tmp0_;
#line 59 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../src/FolderManager/FileView.vala"
	_tmp0_ = self->priv->_actions;
#line 59 "../src/FolderManager/FileView.vala"
	result = _tmp0_;
#line 59 "../src/FolderManager/FileView.vala"
	return result;
#line 4267 "FileView.c"
}

static void
scratch_folder_manager_file_view_set_actions (ScratchFolderManagerFileView* self,
                                              GSimpleActionGroup* value)
{
	GSimpleActionGroup* old_value;
#line 59 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/FolderManager/FileView.vala"
	old_value = scratch_folder_manager_file_view_get_actions (self);
#line 59 "../src/FolderManager/FileView.vala"
	if (old_value != value) {
#line 4281 "FileView.c"
		GSimpleActionGroup* _tmp0_;
#line 59 "../src/FolderManager/FileView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 59 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (self->priv->_actions);
#line 59 "../src/FolderManager/FileView.vala"
		self->priv->_actions = _tmp0_;
#line 59 "../src/FolderManager/FileView.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTIONS_PROPERTY]);
#line 4291 "FileView.c"
	}
}

GActionGroup*
scratch_folder_manager_file_view_get_toplevel_action_group (ScratchFolderManagerFileView* self)
{
	GActionGroup* result;
	GActionGroup* _tmp0_;
#line 60 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../src/FolderManager/FileView.vala"
	_tmp0_ = self->priv->_toplevel_action_group;
#line 60 "../src/FolderManager/FileView.vala"
	result = _tmp0_;
#line 60 "../src/FolderManager/FileView.vala"
	return result;
#line 4308 "FileView.c"
}

static void
scratch_folder_manager_file_view_set_toplevel_action_group (ScratchFolderManagerFileView* self,
                                                            GActionGroup* value)
{
	GActionGroup* old_value;
#line 60 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/FolderManager/FileView.vala"
	old_value = scratch_folder_manager_file_view_get_toplevel_action_group (self);
#line 60 "../src/FolderManager/FileView.vala"
	if (old_value != value) {
#line 4322 "FileView.c"
		GActionGroup* _tmp0_;
#line 60 "../src/FolderManager/FileView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 60 "../src/FolderManager/FileView.vala"
		_g_object_unref0 (self->priv->_toplevel_action_group);
#line 60 "../src/FolderManager/FileView.vala"
		self->priv->_toplevel_action_group = _tmp0_;
#line 60 "../src/FolderManager/FileView.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_TOPLEVEL_ACTION_GROUP_PROPERTY]);
#line 4332 "FileView.c"
	}
}

gboolean
scratch_folder_manager_file_view_get_ignore_next_select (ScratchFolderManagerFileView* self)
{
	gboolean result;
#line 61 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "../src/FolderManager/FileView.vala"
	result = self->priv->_ignore_next_select;
#line 61 "../src/FolderManager/FileView.vala"
	return result;
#line 4346 "FileView.c"
}

void
scratch_folder_manager_file_view_set_ignore_next_select (ScratchFolderManagerFileView* self,
                                                         gboolean value)
{
	gboolean old_value;
#line 61 "../src/FolderManager/FileView.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/FolderManager/FileView.vala"
	old_value = scratch_folder_manager_file_view_get_ignore_next_select (self);
#line 61 "../src/FolderManager/FileView.vala"
	if (old_value != value) {
#line 61 "../src/FolderManager/FileView.vala"
		self->priv->_ignore_next_select = value;
#line 61 "../src/FolderManager/FileView.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_IGNORE_NEXT_SELECT_PROPERTY]);
#line 4364 "FileView.c"
	}
}

static const gchar*
scratch_folder_manager_file_view_real_get_icon_name (CodePaneSwitcher* base)
{
	const gchar* result;
	ScratchFolderManagerFileView* self;
	const gchar* _tmp0_;
#line 62 "../src/FolderManager/FileView.vala"
	self = (ScratchFolderManagerFileView*) base;
#line 62 "../src/FolderManager/FileView.vala"
	_tmp0_ = self->priv->_icon_name;
#line 62 "../src/FolderManager/FileView.vala"
	result = _tmp0_;
#line 62 "../src/FolderManager/FileView.vala"
	return result;
#line 4382 "FileView.c"
}

static void
scratch_folder_manager_file_view_real_set_icon_name (CodePaneSwitcher* base,
                                                     const gchar* value)
{
	ScratchFolderManagerFileView* self;
	gchar* old_value;
#line 62 "../src/FolderManager/FileView.vala"
	self = (ScratchFolderManagerFileView*) base;
#line 62 "../src/FolderManager/FileView.vala"
	old_value = scratch_folder_manager_file_view_real_get_icon_name (base);
#line 62 "../src/FolderManager/FileView.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 4397 "FileView.c"
		gchar* _tmp0_;
#line 62 "../src/FolderManager/FileView.vala"
		_tmp0_ = g_strdup (value);
#line 62 "../src/FolderManager/FileView.vala"
		_g_free0 (self->priv->_icon_name);
#line 62 "../src/FolderManager/FileView.vala"
		self->priv->_icon_name = _tmp0_;
#line 62 "../src/FolderManager/FileView.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_ICON_NAME_PROPERTY]);
#line 4407 "FileView.c"
	}
}

static const gchar*
scratch_folder_manager_file_view_real_get_title (CodePaneSwitcher* base)
{
	const gchar* result;
	ScratchFolderManagerFileView* self;
	const gchar* _tmp0_;
#line 63 "../src/FolderManager/FileView.vala"
	self = (ScratchFolderManagerFileView*) base;
#line 63 "../src/FolderManager/FileView.vala"
	_tmp0_ = self->priv->_title;
#line 63 "../src/FolderManager/FileView.vala"
	result = _tmp0_;
#line 63 "../src/FolderManager/FileView.vala"
	return result;
#line 4425 "FileView.c"
}

static void
scratch_folder_manager_file_view_real_set_title (CodePaneSwitcher* base,
                                                 const gchar* value)
{
	ScratchFolderManagerFileView* self;
	gchar* old_value;
#line 63 "../src/FolderManager/FileView.vala"
	self = (ScratchFolderManagerFileView*) base;
#line 63 "../src/FolderManager/FileView.vala"
	old_value = scratch_folder_manager_file_view_real_get_title (base);
#line 63 "../src/FolderManager/FileView.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 4440 "FileView.c"
		gchar* _tmp0_;
#line 63 "../src/FolderManager/FileView.vala"
		_tmp0_ = g_strdup (value);
#line 63 "../src/FolderManager/FileView.vala"
		_g_free0 (self->priv->_title);
#line 63 "../src/FolderManager/FileView.vala"
		self->priv->_title = _tmp0_;
#line 63 "../src/FolderManager/FileView.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_TITLE_PROPERTY]);
#line 4450 "FileView.c"
	}
}

const gchar*
scratch_folder_manager_file_view_get_active_project_path (ScratchFolderManagerFileView* self)
{
	const gchar* result;
	ScratchServicesGitManager* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 65 "../src/FolderManager/FileView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../src/FolderManager/FileView.vala"
	_tmp0_ = self->priv->git_manager;
#line 66 "../src/FolderManager/FileView.vala"
	_tmp1_ = scratch_services_git_manager_get_active_project_path (_tmp0_);
#line 66 "../src/FolderManager/FileView.vala"
	_tmp2_ = _tmp1_;
#line 66 "../src/FolderManager/FileView.vala"
	result = _tmp2_;
#line 66 "../src/FolderManager/FileView.vala"
	return result;
#line 4473 "FileView.c"
}

static void
g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__OBJECT) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 24 "../src/FolderManager/FileView.vala"
	g_return_if_fail (return_value != NULL);
#line 24 "../src/FolderManager/FileView.vala"
	g_return_if_fail (n_param_values == 2);
#line 24 "../src/FolderManager/FileView.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "../src/FolderManager/FileView.vala"
		data1 = closure->data;
#line 24 "../src/FolderManager/FileView.vala"
		data2 = param_values->data[0].v_pointer;
#line 4501 "FileView.c"
	} else {
#line 24 "../src/FolderManager/FileView.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "../src/FolderManager/FileView.vala"
		data2 = closure->data;
#line 4507 "FileView.c"
	}
#line 24 "../src/FolderManager/FileView.vala"
	callback = (GMarshalFunc_BOOLEAN__OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 24 "../src/FolderManager/FileView.vala"
	v_return = callback (data1, g_value_get_object (param_values + 1), data2);
#line 24 "../src/FolderManager/FileView.vala"
	g_value_set_boolean (return_value, v_return);
#line 4515 "FileView.c"
}

static void
_scratch_folder_manager_file_view___lambda84_ (ScratchFolderManagerFileView* self)
{
	GActionGroup* _tmp0_;
	GActionGroup* _tmp1_;
#line 89 "../src/FolderManager/FileView.vala"
	_tmp0_ = gtk_widget_get_action_group ((GtkWidget*) self, SCRATCH_MAIN_WINDOW_ACTION_GROUP);
#line 89 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_set_toplevel_action_group (self, _tmp0_);
#line 90 "../src/FolderManager/FileView.vala"
	_tmp1_ = self->priv->_toplevel_action_group;
#line 90 "../src/FolderManager/FileView.vala"
	g_assert_nonnull (_tmp1_);
#line 4531 "FileView.c"
}

static void
__scratch_folder_manager_file_view___lambda84__gtk_widget_realize (GtkWidget* _sender,
                                                                   gpointer self)
{
#line 88 "../src/FolderManager/FileView.vala"
	_scratch_folder_manager_file_view___lambda84_ ((ScratchFolderManagerFileView*) self);
#line 4540 "FileView.c"
}

static GObject *
scratch_folder_manager_file_view_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ScratchFolderManagerFileView * self;
	GSettings* _tmp0_;
	ScratchServicesGitManager* _tmp1_;
	GSimpleActionGroup* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	GSimpleActionGroup* _tmp5_;
#line 74 "../src/FolderManager/FileView.vala"
	parent_class = G_OBJECT_CLASS (scratch_folder_manager_file_view_parent_class);
#line 74 "../src/FolderManager/FileView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 74 "../src/FolderManager/FileView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_FOLDER_MANAGER_TYPE_FILE_VIEW, ScratchFolderManagerFileView);
#line 75 "../src/FolderManager/FileView.vala"
	code_pane_switcher_set_icon_name ((CodePaneSwitcher*) self, "folder-symbolic");
#line 76 "../src/FolderManager/FileView.vala"
	code_pane_switcher_set_title ((CodePaneSwitcher*) self, _ ("Folders"));
#line 78 "../src/FolderManager/FileView.vala"
	g_signal_connect_object ((CodeWidgetsSourceList*) self, "item-selected", (GCallback) _scratch_folder_manager_file_view_on_item_selected_code_widgets_source_list_item_selected, self, 0);
#line 80 "../src/FolderManager/FileView.vala"
	_tmp0_ = g_settings_new ("io.elementary.code.folder-manager");
#line 80 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (self->priv->settings);
#line 80 "../src/FolderManager/FileView.vala"
	self->priv->settings = _tmp0_;
#line 82 "../src/FolderManager/FileView.vala"
	_tmp1_ = scratch_services_git_manager_get_instance ();
#line 82 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (self->priv->git_manager);
#line 82 "../src/FolderManager/FileView.vala"
	self->priv->git_manager = _tmp1_;
#line 84 "../src/FolderManager/FileView.vala"
	_tmp2_ = g_simple_action_group_new ();
#line 84 "../src/FolderManager/FileView.vala"
	_tmp3_ = _tmp2_;
#line 84 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_set_actions (self, _tmp3_);
#line 84 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (_tmp3_);
#line 85 "../src/FolderManager/FileView.vala"
	_tmp4_ = self->priv->_actions;
#line 85 "../src/FolderManager/FileView.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp4_, SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_ENTRIES, (gint) G_N_ELEMENTS (SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_ENTRIES), self);
#line 86 "../src/FolderManager/FileView.vala"
	_tmp5_ = self->priv->_actions;
#line 86 "../src/FolderManager/FileView.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTION_GROUP, (GActionGroup*) _tmp5_);
#line 88 "../src/FolderManager/FileView.vala"
	g_signal_connect_object ((GtkWidget*) self, "realize", (GCallback) __scratch_folder_manager_file_view___lambda84__gtk_widget_realize, self, 0);
#line 74 "../src/FolderManager/FileView.vala"
	return obj;
#line 4601 "FileView.c"
}

static void
scratch_folder_manager_file_view_class_init (ScratchFolderManagerFileViewClass * klass,
                                             gpointer klass_data)
{
#line 24 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/FolderManager/FileView.vala"
	g_type_class_adjust_private_offset (klass, &ScratchFolderManagerFileView_private_offset);
#line 24 "../src/FolderManager/FileView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_scratch_folder_manager_file_view_get_property;
#line 24 "../src/FolderManager/FileView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_scratch_folder_manager_file_view_set_property;
#line 24 "../src/FolderManager/FileView.vala"
	G_OBJECT_CLASS (klass)->constructor = scratch_folder_manager_file_view_constructor;
#line 24 "../src/FolderManager/FileView.vala"
	G_OBJECT_CLASS (klass)->finalize = scratch_folder_manager_file_view_finalize;
#line 24 "../src/FolderManager/FileView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTIONS_PROPERTY, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTIONS_PROPERTY] = g_param_spec_object ("actions", "actions", "actions", g_simple_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/FolderManager/FileView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_VIEW_TOPLEVEL_ACTION_GROUP_PROPERTY, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_TOPLEVEL_ACTION_GROUP_PROPERTY] = g_param_spec_object ("toplevel-action-group", "toplevel-action-group", "toplevel-action-group", g_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/FolderManager/FileView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_VIEW_IGNORE_NEXT_SELECT_PROPERTY, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_IGNORE_NEXT_SELECT_PROPERTY] = g_param_spec_boolean ("ignore-next-select", "ignore-next-select", "ignore-next-select", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/FolderManager/FileView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_VIEW_ICON_NAME_PROPERTY, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/FolderManager/FileView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_VIEW_TITLE_PROPERTY, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/FolderManager/FileView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTIVE_PROJECT_PATH_PROPERTY, scratch_folder_manager_file_view_properties[SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTIVE_PROJECT_PATH_PROPERTY] = g_param_spec_string ("active-project-path", "active-project-path", "active-project-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_signals[SCRATCH_FOLDER_MANAGER_FILE_VIEW_SELECT_SIGNAL] = g_signal_new ("select", SCRATCH_FOLDER_MANAGER_TYPE_FILE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 24 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_signals[SCRATCH_FOLDER_MANAGER_FILE_VIEW_RENAME_REQUEST_SIGNAL] = g_signal_new ("rename-request", SCRATCH_FOLDER_MANAGER_TYPE_FILE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__OBJECT, G_TYPE_BOOLEAN, 1, SCRATCH_FOLDER_MANAGER_TYPE_FILE);
#line 4636 "FileView.c"
}

static void
scratch_folder_manager_file_view_code_pane_switcher_interface_init (CodePaneSwitcherIface * iface,
                                                                    gpointer iface_data)
{
#line 24 "../src/FolderManager/FileView.vala"
	scratch_folder_manager_file_view_code_pane_switcher_parent_iface = g_type_interface_peek_parent (iface);
#line 24 "../src/FolderManager/FileView.vala"
	iface->get_icon_name = scratch_folder_manager_file_view_real_get_icon_name;
#line 24 "../src/FolderManager/FileView.vala"
	iface->set_icon_name = scratch_folder_manager_file_view_real_set_icon_name;
#line 24 "../src/FolderManager/FileView.vala"
	iface->get_title = scratch_folder_manager_file_view_real_get_title;
#line 24 "../src/FolderManager/FileView.vala"
	iface->set_title = scratch_folder_manager_file_view_real_set_title;
#line 4653 "FileView.c"
}

static void
scratch_folder_manager_file_view_instance_init (ScratchFolderManagerFileView * self,
                                                gpointer klass)
{
#line 24 "../src/FolderManager/FileView.vala"
	self->priv = scratch_folder_manager_file_view_get_instance_private (self);
#line 61 "../src/FolderManager/FileView.vala"
	self->priv->_ignore_next_select = FALSE;
#line 4664 "FileView.c"
}

static void
scratch_folder_manager_file_view_finalize (GObject * obj)
{
	ScratchFolderManagerFileView * self;
#line 24 "../src/FolderManager/FileView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_FOLDER_MANAGER_TYPE_FILE_VIEW, ScratchFolderManagerFileView);
#line 52 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (self->priv->settings);
#line 53 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (self->priv->git_manager);
#line 54 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (self->priv->plugins);
#line 59 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (self->priv->_actions);
#line 60 "../src/FolderManager/FileView.vala"
	_g_object_unref0 (self->priv->_toplevel_action_group);
#line 62 "../src/FolderManager/FileView.vala"
	_g_free0 (self->priv->_icon_name);
#line 63 "../src/FolderManager/FileView.vala"
	_g_free0 (self->priv->_title);
#line 24 "../src/FolderManager/FileView.vala"
	G_OBJECT_CLASS (scratch_folder_manager_file_view_parent_class)->finalize (obj);
#line 4689 "FileView.c"
}

/**
 * SourceList that displays folders and their contents.
 */
static GType
scratch_folder_manager_file_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScratchFolderManagerFileViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scratch_folder_manager_file_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScratchFolderManagerFileView), 0, (GInstanceInitFunc) scratch_folder_manager_file_view_instance_init, NULL };
	static const GInterfaceInfo code_pane_switcher_info = { (GInterfaceInitFunc) scratch_folder_manager_file_view_code_pane_switcher_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType scratch_folder_manager_file_view_type_id;
	scratch_folder_manager_file_view_type_id = g_type_register_static (CODE_WIDGETS_TYPE_SOURCE_LIST, "ScratchFolderManagerFileView", &g_define_type_info, 0);
	g_type_add_interface_static (scratch_folder_manager_file_view_type_id, CODE_TYPE_PANE_SWITCHER, &code_pane_switcher_info);
	ScratchFolderManagerFileView_private_offset = g_type_add_instance_private (scratch_folder_manager_file_view_type_id, sizeof (ScratchFolderManagerFileViewPrivate));
	return scratch_folder_manager_file_view_type_id;
}

GType
scratch_folder_manager_file_view_get_type (void)
{
	static volatile gsize scratch_folder_manager_file_view_type_id__once = 0;
	if (g_once_init_enter (&scratch_folder_manager_file_view_type_id__once)) {
		GType scratch_folder_manager_file_view_type_id;
		scratch_folder_manager_file_view_type_id = scratch_folder_manager_file_view_get_type_once ();
		g_once_init_leave (&scratch_folder_manager_file_view_type_id__once, scratch_folder_manager_file_view_type_id);
	}
	return scratch_folder_manager_file_view_type_id__once;
}

static void
_vala_scratch_folder_manager_file_view_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec)
{
	ScratchFolderManagerFileView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_FOLDER_MANAGER_TYPE_FILE_VIEW, ScratchFolderManagerFileView);
#line 24 "../src/FolderManager/FileView.vala"
	switch (property_id) {
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTIONS_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		g_value_set_object (value, scratch_folder_manager_file_view_get_actions (self));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_TOPLEVEL_ACTION_GROUP_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		g_value_set_object (value, scratch_folder_manager_file_view_get_toplevel_action_group (self));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_IGNORE_NEXT_SELECT_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		g_value_set_boolean (value, scratch_folder_manager_file_view_get_ignore_next_select (self));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_ICON_NAME_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		g_value_set_string (value, code_pane_switcher_get_icon_name ((CodePaneSwitcher*) self));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_TITLE_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		g_value_set_string (value, code_pane_switcher_get_title ((CodePaneSwitcher*) self));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTIVE_PROJECT_PATH_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		g_value_set_string (value, scratch_folder_manager_file_view_get_active_project_path (self));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 4765 "FileView.c"
		default:
#line 24 "../src/FolderManager/FileView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 4771 "FileView.c"
	}
}

static void
_vala_scratch_folder_manager_file_view_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec)
{
	ScratchFolderManagerFileView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_FOLDER_MANAGER_TYPE_FILE_VIEW, ScratchFolderManagerFileView);
#line 24 "../src/FolderManager/FileView.vala"
	switch (property_id) {
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_ACTIONS_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		scratch_folder_manager_file_view_set_actions (self, g_value_get_object (value));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_TOPLEVEL_ACTION_GROUP_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		scratch_folder_manager_file_view_set_toplevel_action_group (self, g_value_get_object (value));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_IGNORE_NEXT_SELECT_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		scratch_folder_manager_file_view_set_ignore_next_select (self, g_value_get_boolean (value));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_ICON_NAME_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		code_pane_switcher_set_icon_name ((CodePaneSwitcher*) self, g_value_get_string (value));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 24 "../src/FolderManager/FileView.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_VIEW_TITLE_PROPERTY:
#line 24 "../src/FolderManager/FileView.vala"
		code_pane_switcher_set_title ((CodePaneSwitcher*) self, g_value_get_string (value));
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 4815 "FileView.c"
		default:
#line 24 "../src/FolderManager/FileView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/FolderManager/FileView.vala"
		break;
#line 4821 "FileView.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

