/* SourceView.c generated by valac 0.56.18, the Vala compiler
 * generated from SourceView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*
* Copyright (c) 2013 Mario Guerriero <mefrio.g@gmail.com>
*               2017–2020 elementary, Inc. <https://elementary.io>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "codecore.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <gtksourceview/gtksource.h>
#include <pango/pango.h>
#include <granite.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>

#define SCRATCH_WIDGETS_SOURCE_VIEW_THROTTLE_MS ((guint) 400)
#define SCRATCH_WIDGETS_SOURCE_VIEW_SCROLL_THRESHOLD 1.0
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SCRATCH_WIDGETS_SOURCE_VIEW_0_PROPERTY,
	SCRATCH_WIDGETS_SOURCE_VIEW_LOCATION_PROPERTY,
	SCRATCH_WIDGETS_SOURCE_VIEW_PROJECT_PROPERTY,
	SCRATCH_WIDGETS_SOURCE_VIEW_LANGUAGE_PROPERTY,
	SCRATCH_WIDGETS_SOURCE_VIEW_CURSOR_POSITION_PROPERTY,
	SCRATCH_WIDGETS_SOURCE_VIEW_NUM_PROPERTIES
};
static GParamSpec* scratch_widgets_source_view_properties[SCRATCH_WIDGETS_SOURCE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define __vala_GtkTextIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTextIter_free (var), NULL)))
typedef struct _Block38Data Block38Data;
typedef struct _Block39Data Block39Data;
typedef struct _Block40Data Block40Data;
enum  {
	SCRATCH_WIDGETS_SOURCE_VIEW_STYLE_CHANGED_SIGNAL,
	SCRATCH_WIDGETS_SOURCE_VIEW_SELECTION_CHANGED_SIGNAL,
	SCRATCH_WIDGETS_SOURCE_VIEW_DESELECTED_SIGNAL,
	SCRATCH_WIDGETS_SOURCE_VIEW_NUM_SIGNALS
};
static guint scratch_widgets_source_view_signals[SCRATCH_WIDGETS_SOURCE_VIEW_NUM_SIGNALS] = {0};

struct _ScratchWidgetsSourceViewPrivate {
	GFile* _location;
	ScratchFolderManagerProjectFolderItem* _project;
	gchar* font;
	guint selection_changed_timer;
	guint size_allocate_timer;
	GtkTextIter last_select_start_iter;
	GtkTextIter last_select_end_iter;
	gchar* selected_text;
	ScratchWidgetsSourceGutterRenderer* git_diff_gutter_renderer;
	gdouble total_delta;
	guint refresh_diff_timeout_id;
};

struct _Block38Data {
	int _ref_count_;
	ScratchWidgetsSourceView* self;
	GtkTextIter end_iter;
};

struct _Block39Data {
	int _ref_count_;
	ScratchWidgetsSourceView* self;
	GtkTextIter iter;
};

struct _Block40Data {
	int _ref_count_;
	ScratchWidgetsSourceView* self;
	GtkAllocation allocation;
};

static gint ScratchWidgetsSourceView_private_offset;
static gpointer scratch_widgets_source_view_parent_class = NULL;

static gboolean scratch_widgets_source_view_get_current_line (ScratchWidgetsSourceView* self,
                                                       GtkTextIter* start,
                                                       GtkTextIter* end);
static void scratch_widgets_source_view_restore_settings (ScratchWidgetsSourceView* self);
static void scratch_widgets_source_view_update_draw_spaces (ScratchWidgetsSourceView* self);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static gint scratch_widgets_source_view_get_selected_line_count (ScratchWidgetsSourceView* self);
static void _vala_GtkTextIter_free (GtkTextIter* self);
static GtkTextIter* _vala_GtkTextIter_copy (GtkTextIter* self);
static gint ___lambda90_ (ScratchWidgetsSourceView* self,
                   const gchar* a,
                   const gchar* b);
static gint ____lambda90__gcompare_data_func (gconstpointer a,
                                       gconstpointer b,
                                       gpointer self);
static Block38Data* block38_data_ref (Block38Data* _data38_);
static void block38_data_unref (void * _userdata_);
static gboolean __lambda31_ (Block38Data* _data38_);
static gboolean ___lambda31__gsource_func (gpointer self);
static void scratch_widgets_source_view_on_context_menu (ScratchWidgetsSourceView* self,
                                                  GtkMenu* menu);
static void _scratch_widgets_source_view_sort_selected_lines_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                              gpointer self);
static void ___lambda91_ (ScratchWidgetsSourceView* self);
static void ____lambda91__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static gint scratch_widgets_source_view_calculate_bottom_margin (gint height_in_px);
static void scratch_widgets_source_view_on_mark_set (ScratchWidgetsSourceView* self,
                                              GtkTextIter* loc,
                                              GtkTextMark* mar);
static gboolean scratch_widgets_source_view_selection_changed_event (ScratchWidgetsSourceView* self);
static gboolean _scratch_widgets_source_view_selection_changed_event_gsource_func (gpointer self);
static void scratch_widgets_source_view_schedule_refresh_diff (ScratchWidgetsSourceView* self);
static gboolean __lambda92_ (ScratchWidgetsSourceView* self);
static gboolean ___lambda92__gsource_func (gpointer self);
static Block39Data* block39_data_ref (Block39Data* _data39_);
static void block39_data_unref (void * _userdata_);
static gboolean _scratch_widgets_source_view_cursor_position___lambda33_ (Block39Data* _data39_);
static gboolean __scratch_widgets_source_view_cursor_position___lambda33__gsource_func (gpointer self);
static void g_cclosure_user_marshal_VOID__BOXED_BOXED (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static GObject * scratch_widgets_source_view_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void _scratch_widgets_source_view_on_mark_set_gtk_text_buffer_mark_set (GtkTextBuffer* _sender,
                                                                        GtkTextIter* location,
                                                                        GtkTextMark* mark,
                                                                        gpointer self);
static void _scratch_widgets_source_view_restore_settings_g_settings_changed (GSettings* _sender,
                                                                       const gchar* key,
                                                                       gpointer self);
static void _scratch_widgets_source_view_restore_settings_g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
static gboolean _scratch_widgets_source_view___lambda93_ (ScratchWidgetsSourceView* self,
                                                   GdkEventScroll* key_event);
static gboolean __scratch_widgets_source_view___lambda93__gtk_widget_scroll_event (GtkWidget* _sender,
                                                                            GdkEventScroll* event,
                                                                            gpointer self);
static void _scratch_widgets_source_view___lambda94_ (ScratchWidgetsSourceView* self);
static void __scratch_widgets_source_view___lambda94__gtk_text_view_cut_clipboard (GtkTextView* _sender,
                                                                            gpointer self);
static void _scratch_widgets_source_view___lambda95_ (ScratchWidgetsSourceView* self);
static void __scratch_widgets_source_view___lambda95__gtk_text_view_copy_clipboard (GtkTextView* _sender,
                                                                             gpointer self);
static void _scratch_widgets_source_view_on_context_menu_gtk_text_view_populate_popup (GtkTextView* _sender,
                                                                                GtkMenu* popup,
                                                                                gpointer self);
static void _scratch_widgets_source_view___lambda96_ (ScratchWidgetsSourceView* self,
                                               GtkAllocation* allocation);
static Block40Data* block40_data_ref (Block40Data* _data40_);
static void block40_data_unref (void * _userdata_);
static gboolean ___lambda97_ (Block40Data* _data40_);
static gboolean ____lambda97__gsource_func (gpointer self);
static void __scratch_widgets_source_view___lambda96__gtk_widget_size_allocate (GtkWidget* _sender,
                                                                         GtkAllocation* allocation,
                                                                         gpointer self);
static void _scratch_widgets_source_view___lambda98_ (ScratchWidgetsSourceView* self);
static void ___lambda99_ (ScratchWidgetsSourceView* self);
static void ____lambda99__scratch_services_monitored_repository_file_content_changed (ScratchServicesMonitoredRepository* _sender,
                                                                               gpointer self);
static void __scratch_widgets_source_view___lambda98__g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
static void scratch_widgets_source_view_finalize (GObject * obj);
static GType scratch_widgets_source_view_get_type_once (void);
static void _vala_scratch_widgets_source_view_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_scratch_widgets_source_view_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
scratch_widgets_source_view_get_instance_private (ScratchWidgetsSourceView* self)
{
	return G_STRUCT_MEMBER_P (self, ScratchWidgetsSourceView_private_offset);
}

ScratchWidgetsSourceView*
scratch_widgets_source_view_construct (GType object_type)
{
	ScratchWidgetsSourceView * self = NULL;
#line 77 "../src/Widgets/SourceView.vala"
	self = (ScratchWidgetsSourceView*) g_object_new (object_type, "show-line-numbers", TRUE, "smart-backspace", TRUE, "smart-home-end", GTK_SOURCE_SMART_HOME_END_BEFORE, "wrap-mode", GTK_WRAP_WORD, NULL);
#line 76 "../src/Widgets/SourceView.vala"
	return self;
#line 237 "SourceView.c"
}

ScratchWidgetsSourceView*
scratch_widgets_source_view_new (void)
{
#line 76 "../src/Widgets/SourceView.vala"
	return scratch_widgets_source_view_construct (SCRATCH_WIDGETS_TYPE_SOURCE_VIEW);
#line 245 "SourceView.c"
}

static gboolean
scratch_widgets_source_view_get_current_line (ScratchWidgetsSourceView* self,
                                              GtkTextIter* start,
                                              GtkTextIter* end)
{
	GtkTextIter _vala_start = {0};
	GtkTextIter _vala_end = {0};
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextBuffer* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GtkTextIter _tmp6_ = {0};
	GtkTextIter _tmp7_;
	GtkTextIter _tmp8_;
	gboolean result;
#line 211 "../src/Widgets/SourceView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 212 "../src/Widgets/SourceView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 212 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_;
#line 212 "../src/Widgets/SourceView.vala"
	_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 212 "../src/Widgets/SourceView.vala"
	_tmp3_ = _tmp2_;
#line 212 "../src/Widgets/SourceView.vala"
	g_object_get (_tmp3_, "cursor-position", &_tmp4_, NULL);
#line 212 "../src/Widgets/SourceView.vala"
	_tmp5_ = _tmp4_;
#line 212 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_get_iter_at_offset (_tmp1_, &_tmp6_, _tmp5_);
#line 212 "../src/Widgets/SourceView.vala"
	_vala_start = _tmp6_;
#line 213 "../src/Widgets/SourceView.vala"
	gtk_text_iter_backward_chars (&_vala_start, gtk_text_iter_get_line_offset (&_vala_start));
#line 214 "../src/Widgets/SourceView.vala"
	_tmp7_ = _vala_start;
#line 214 "../src/Widgets/SourceView.vala"
	_vala_end = _tmp7_;
#line 215 "../src/Widgets/SourceView.vala"
	gtk_text_iter_forward_line (&_vala_end);
#line 218 "../src/Widgets/SourceView.vala"
	_tmp8_ = _vala_end;
#line 218 "../src/Widgets/SourceView.vala"
	result = !gtk_text_iter_equal (&_vala_start, &_tmp8_);
#line 218 "../src/Widgets/SourceView.vala"
	if (start) {
#line 218 "../src/Widgets/SourceView.vala"
		*start = _vala_start;
#line 299 "SourceView.c"
	}
#line 218 "../src/Widgets/SourceView.vala"
	if (end) {
#line 218 "../src/Widgets/SourceView.vala"
		*end = _vala_end;
#line 305 "SourceView.c"
	}
#line 218 "../src/Widgets/SourceView.vala"
	return result;
#line 309 "SourceView.c"
}

void
scratch_widgets_source_view_change_syntax_highlight_from_file (ScratchWidgetsSourceView* self,
                                                               GFile* file)
{
	gchar* _tmp12_;
	gchar* _tmp13_;
	gboolean _tmp14_;
	GError* _inner_error0_ = NULL;
#line 221 "../src/Widgets/SourceView.vala"
	g_return_if_fail (self != NULL);
#line 221 "../src/Widgets/SourceView.vala"
	g_return_if_fail (file != NULL);
#line 324 "SourceView.c"
	{
		GFileInfo* info = NULL;
		GFileInfo* _tmp0_;
		gchar* mime_type = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GtkSourceLanguageManager* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		GtkSourceLanguage* _tmp9_;
#line 223 "../src/Widgets/SourceView.vala"
		_tmp0_ = g_file_query_info (file, "standard::*", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 223 "../src/Widgets/SourceView.vala"
		info = _tmp0_;
#line 223 "../src/Widgets/SourceView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 344 "SourceView.c"
			goto __catch0_g_error;
		}
#line 224 "../src/Widgets/SourceView.vala"
		_tmp1_ = g_file_info_get_attribute_as_string (info, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE);
#line 224 "../src/Widgets/SourceView.vala"
		_tmp2_ = _tmp1_;
#line 224 "../src/Widgets/SourceView.vala"
		_tmp3_ = g_content_type_get_mime_type (_tmp2_);
#line 224 "../src/Widgets/SourceView.vala"
		_tmp4_ = _tmp3_;
#line 224 "../src/Widgets/SourceView.vala"
		_g_free0 (_tmp2_);
#line 224 "../src/Widgets/SourceView.vala"
		mime_type = _tmp4_;
#line 227 "../src/Widgets/SourceView.vala"
		_tmp5_ = self->manager;
#line 227 "../src/Widgets/SourceView.vala"
		_tmp6_ = g_file_get_path (file);
#line 227 "../src/Widgets/SourceView.vala"
		_tmp7_ = _tmp6_;
#line 227 "../src/Widgets/SourceView.vala"
		_tmp8_ = mime_type;
#line 227 "../src/Widgets/SourceView.vala"
		_tmp9_ = gtk_source_language_manager_guess_language (_tmp5_, _tmp7_, _tmp8_);
#line 227 "../src/Widgets/SourceView.vala"
		scratch_widgets_source_view_set_language (self, _tmp9_);
#line 227 "../src/Widgets/SourceView.vala"
		_g_free0 (_tmp7_);
#line 222 "../src/Widgets/SourceView.vala"
		_g_free0 (mime_type);
#line 222 "../src/Widgets/SourceView.vala"
		_g_object_unref0 (info);
#line 377 "SourceView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 222 "../src/Widgets/SourceView.vala"
		e = _inner_error0_;
#line 222 "../src/Widgets/SourceView.vala"
		_inner_error0_ = NULL;
#line 229 "../src/Widgets/SourceView.vala"
		_tmp10_ = e;
#line 229 "../src/Widgets/SourceView.vala"
		_tmp11_ = _tmp10_->message;
#line 229 "../src/Widgets/SourceView.vala"
		g_critical ("SourceView.vala:229: %s", _tmp11_);
#line 222 "../src/Widgets/SourceView.vala"
		_g_error_free0 (e);
#line 397 "SourceView.c"
	}
	__finally0:
#line 222 "../src/Widgets/SourceView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 222 "../src/Widgets/SourceView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 222 "../src/Widgets/SourceView.vala"
		g_clear_error (&_inner_error0_);
#line 222 "../src/Widgets/SourceView.vala"
		return;
#line 408 "SourceView.c"
	}
#line 234 "../src/Widgets/SourceView.vala"
	_tmp12_ = g_file_get_basename (file);
#line 234 "../src/Widgets/SourceView.vala"
	_tmp13_ = _tmp12_;
#line 234 "../src/Widgets/SourceView.vala"
	_tmp14_ = g_strcmp0 (_tmp13_, "CMakeLists.txt") == 0;
#line 234 "../src/Widgets/SourceView.vala"
	_g_free0 (_tmp13_);
#line 234 "../src/Widgets/SourceView.vala"
	if (_tmp14_) {
#line 420 "SourceView.c"
		GtkSourceLanguageManager* _tmp15_;
		GtkSourceLanguage* _tmp16_;
#line 235 "../src/Widgets/SourceView.vala"
		_tmp15_ = self->manager;
#line 235 "../src/Widgets/SourceView.vala"
		_tmp16_ = gtk_source_language_manager_get_language (_tmp15_, "cmake");
#line 235 "../src/Widgets/SourceView.vala"
		scratch_widgets_source_view_set_language (self, _tmp16_);
#line 429 "SourceView.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 245 "../src/Widgets/SourceView.vala"
	return self ? g_object_ref (self) : NULL;
#line 438 "SourceView.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 292 "../src/Widgets/SourceView.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 446 "SourceView.c"
}

static void
scratch_widgets_source_view_restore_settings (ScratchWidgetsSourceView* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GtkSourceBuffer* source_buffer = NULL;
	GtkTextBuffer* _tmp4_;
	GtkTextBuffer* _tmp5_;
	GtkSourceBuffer* _tmp6_;
	GtkSourceBuffer* _tmp7_;
	GSettings* _tmp8_;
	GtkSourceSpaceDrawer* _tmp9_;
	GtkSourceSpaceDrawer* _tmp10_;
	GSettings* _tmp11_;
	GtkSourceSpaceDrawer* _tmp20_;
	GtkSourceSpaceDrawer* _tmp21_;
	GSettings* _tmp22_;
	GSettings* _tmp23_;
	GSettings* _tmp24_;
	gchar* font_css = NULL;
	const gchar* _tmp31_;
	PangoFontDescription* _tmp32_;
	PangoFontDescription* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	GSettings* _tmp41_;
	ScratchWidgetsSourceGutterRenderer* _tmp63_;
	GtkSourceBuffer* _tmp64_;
	GtkSourceStyleScheme* _tmp65_;
	GtkSourceStyleScheme* _tmp66_;
	GtkSourceBuffer* _tmp67_;
	GtkSourceStyleScheme* _tmp68_;
	GtkSourceStyleScheme* _tmp69_;
	GError* _inner_error0_ = NULL;
#line 240 "../src/Widgets/SourceView.vala"
	g_return_if_fail (self != NULL);
#line 241 "../src/Widgets/SourceView.vala"
	_tmp0_ = scratch_settings;
#line 241 "../src/Widgets/SourceView.vala"
	gtk_source_view_set_auto_indent ((GtkSourceView*) self, g_settings_get_boolean (_tmp0_, "auto-indent"));
#line 242 "../src/Widgets/SourceView.vala"
	_tmp1_ = scratch_settings;
#line 242 "../src/Widgets/SourceView.vala"
	gtk_source_view_set_show_right_margin ((GtkSourceView*) self, g_settings_get_boolean (_tmp1_, "show-right-margin"));
#line 243 "../src/Widgets/SourceView.vala"
	_tmp2_ = scratch_settings;
#line 243 "../src/Widgets/SourceView.vala"
	gtk_source_view_set_right_margin_position ((GtkSourceView*) self, (guint) g_settings_get_int (_tmp2_, "right-margin-position"));
#line 244 "../src/Widgets/SourceView.vala"
	_tmp3_ = scratch_settings;
#line 244 "../src/Widgets/SourceView.vala"
	gtk_source_view_set_insert_spaces_instead_of_tabs ((GtkSourceView*) self, g_settings_get_boolean (_tmp3_, "spaces-instead-of-tabs"));
#line 245 "../src/Widgets/SourceView.vala"
	_tmp4_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 245 "../src/Widgets/SourceView.vala"
	_tmp5_ = _tmp4_;
#line 245 "../src/Widgets/SourceView.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_source_buffer_get_type (), GtkSourceBuffer));
#line 245 "../src/Widgets/SourceView.vala"
	source_buffer = _tmp6_;
#line 246 "../src/Widgets/SourceView.vala"
	_tmp7_ = source_buffer;
#line 246 "../src/Widgets/SourceView.vala"
	_tmp8_ = scratch_settings;
#line 246 "../src/Widgets/SourceView.vala"
	gtk_source_buffer_set_highlight_matching_brackets (_tmp7_, g_settings_get_boolean (_tmp8_, "highlight-matching-brackets"));
#line 247 "../src/Widgets/SourceView.vala"
	_tmp9_ = gtk_source_view_get_space_drawer ((GtkSourceView*) self);
#line 247 "../src/Widgets/SourceView.vala"
	_tmp10_ = _tmp9_;
#line 247 "../src/Widgets/SourceView.vala"
	gtk_source_space_drawer_set_enable_matrix (_tmp10_, FALSE);
#line 248 "../src/Widgets/SourceView.vala"
	_tmp11_ = scratch_settings;
#line 248 "../src/Widgets/SourceView.vala"
	switch ((ScratchScratchDrawSpacesState) g_settings_get_enum (_tmp11_, "draw-spaces")) {
#line 248 "../src/Widgets/SourceView.vala"
		case SCRATCH_SCRATCH_DRAW_SPACES_STATE_ALWAYS:
#line 531 "SourceView.c"
		{
			GtkSourceSpaceDrawer* _tmp12_;
			GtkSourceSpaceDrawer* _tmp13_;
#line 250 "../src/Widgets/SourceView.vala"
			_tmp12_ = gtk_source_view_get_space_drawer ((GtkSourceView*) self);
#line 250 "../src/Widgets/SourceView.vala"
			_tmp13_ = _tmp12_;
#line 250 "../src/Widgets/SourceView.vala"
			gtk_source_space_drawer_set_types_for_locations (_tmp13_, GTK_SOURCE_SPACE_LOCATION_ALL, GTK_SOURCE_SPACE_TYPE_SPACE | GTK_SOURCE_SPACE_TYPE_TAB);
#line 254 "../src/Widgets/SourceView.vala"
			break;
#line 543 "SourceView.c"
		}
#line 248 "../src/Widgets/SourceView.vala"
		case SCRATCH_SCRATCH_DRAW_SPACES_STATE_FOR_SELECTION:
#line 248 "../src/Widgets/SourceView.vala"
		case SCRATCH_SCRATCH_DRAW_SPACES_STATE_CURRENT:
#line 549 "SourceView.c"
		{
			GtkSourceSpaceDrawer* _tmp14_;
			GtkSourceSpaceDrawer* _tmp15_;
			GtkSourceSpaceDrawer* _tmp16_;
			GtkSourceSpaceDrawer* _tmp17_;
#line 257 "../src/Widgets/SourceView.vala"
			_tmp14_ = gtk_source_view_get_space_drawer ((GtkSourceView*) self);
#line 257 "../src/Widgets/SourceView.vala"
			_tmp15_ = _tmp14_;
#line 257 "../src/Widgets/SourceView.vala"
			gtk_source_space_drawer_set_types_for_locations (_tmp15_, GTK_SOURCE_SPACE_LOCATION_ALL, GTK_SOURCE_SPACE_TYPE_NONE);
#line 261 "../src/Widgets/SourceView.vala"
			_tmp16_ = gtk_source_view_get_space_drawer ((GtkSourceView*) self);
#line 261 "../src/Widgets/SourceView.vala"
			_tmp17_ = _tmp16_;
#line 261 "../src/Widgets/SourceView.vala"
			gtk_source_space_drawer_set_types_for_locations (_tmp17_, GTK_SOURCE_SPACE_LOCATION_TRAILING, GTK_SOURCE_SPACE_TYPE_SPACE | GTK_SOURCE_SPACE_TYPE_TAB);
#line 265 "../src/Widgets/SourceView.vala"
			break;
#line 569 "SourceView.c"
		}
		default:
		{
			GtkSourceSpaceDrawer* _tmp18_;
			GtkSourceSpaceDrawer* _tmp19_;
#line 267 "../src/Widgets/SourceView.vala"
			_tmp18_ = gtk_source_view_get_space_drawer ((GtkSourceView*) self);
#line 267 "../src/Widgets/SourceView.vala"
			_tmp19_ = _tmp18_;
#line 267 "../src/Widgets/SourceView.vala"
			gtk_source_space_drawer_set_types_for_locations (_tmp19_, GTK_SOURCE_SPACE_LOCATION_ALL, GTK_SOURCE_SPACE_TYPE_NONE);
#line 271 "../src/Widgets/SourceView.vala"
			break;
#line 583 "SourceView.c"
		}
	}
#line 274 "../src/Widgets/SourceView.vala"
	_tmp20_ = gtk_source_view_get_space_drawer ((GtkSourceView*) self);
#line 274 "../src/Widgets/SourceView.vala"
	_tmp21_ = _tmp20_;
#line 274 "../src/Widgets/SourceView.vala"
	gtk_source_space_drawer_set_enable_matrix (_tmp21_, TRUE);
#line 275 "../src/Widgets/SourceView.vala"
	scratch_widgets_source_view_update_draw_spaces (self);
#line 278 "../src/Widgets/SourceView.vala"
	_tmp22_ = scratch_settings;
#line 278 "../src/Widgets/SourceView.vala"
	gtk_source_view_set_tab_width ((GtkSourceView*) self, (guint) g_settings_get_int (_tmp22_, "indent-width"));
#line 279 "../src/Widgets/SourceView.vala"
	_tmp23_ = scratch_settings;
#line 279 "../src/Widgets/SourceView.vala"
	if (g_settings_get_boolean (_tmp23_, "line-wrap")) {
#line 280 "../src/Widgets/SourceView.vala"
		gtk_text_view_set_wrap_mode ((GtkTextView*) self, GTK_WRAP_WORD);
#line 604 "SourceView.c"
	} else {
#line 282 "../src/Widgets/SourceView.vala"
		gtk_text_view_set_wrap_mode ((GtkTextView*) self, GTK_WRAP_NONE);
#line 608 "SourceView.c"
	}
#line 285 "../src/Widgets/SourceView.vala"
	_tmp24_ = scratch_settings;
#line 285 "../src/Widgets/SourceView.vala"
	if (g_settings_get_boolean (_tmp24_, "use-system-font")) {
#line 614 "SourceView.c"
		GApplication* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
#line 286 "../src/Widgets/SourceView.vala"
		_tmp25_ = g_application_get_default ();
#line 286 "../src/Widgets/SourceView.vala"
		_tmp26_ = scratch_application_get_default_font (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, SCRATCH_TYPE_APPLICATION, ScratchApplication));
#line 286 "../src/Widgets/SourceView.vala"
		_tmp27_ = _tmp26_;
#line 286 "../src/Widgets/SourceView.vala"
		_tmp28_ = g_strdup (_tmp27_);
#line 286 "../src/Widgets/SourceView.vala"
		_g_free0 (self->priv->font);
#line 286 "../src/Widgets/SourceView.vala"
		self->priv->font = _tmp28_;
#line 631 "SourceView.c"
	} else {
		GSettings* _tmp29_;
		gchar* _tmp30_;
#line 288 "../src/Widgets/SourceView.vala"
		_tmp29_ = scratch_settings;
#line 288 "../src/Widgets/SourceView.vala"
		_tmp30_ = g_settings_get_string (_tmp29_, "font");
#line 288 "../src/Widgets/SourceView.vala"
		_g_free0 (self->priv->font);
#line 288 "../src/Widgets/SourceView.vala"
		self->priv->font = _tmp30_;
#line 643 "SourceView.c"
	}
#line 292 "../src/Widgets/SourceView.vala"
	_tmp31_ = self->priv->font;
#line 292 "../src/Widgets/SourceView.vala"
	_tmp32_ = pango_font_description_from_string (_tmp31_);
#line 292 "../src/Widgets/SourceView.vala"
	_tmp33_ = _tmp32_;
#line 292 "../src/Widgets/SourceView.vala"
	_tmp34_ = scratch_utils_pango_font_description_to_css (_tmp33_);
#line 292 "../src/Widgets/SourceView.vala"
	_tmp35_ = _tmp34_;
#line 292 "../src/Widgets/SourceView.vala"
	_tmp36_ = g_strjoin (" ", ".view {", _tmp35_, "}", NULL);
#line 292 "../src/Widgets/SourceView.vala"
	_tmp37_ = _tmp36_;
#line 292 "../src/Widgets/SourceView.vala"
	_g_free0 (_tmp35_);
#line 292 "../src/Widgets/SourceView.vala"
	__vala_PangoFontDescription_free0 (_tmp33_);
#line 292 "../src/Widgets/SourceView.vala"
	font_css = _tmp37_;
#line 665 "SourceView.c"
	{
		GtkCssProvider* _tmp38_;
#line 299 "../src/Widgets/SourceView.vala"
		_tmp38_ = self->font_css_provider;
#line 299 "../src/Widgets/SourceView.vala"
		gtk_css_provider_load_from_data (_tmp38_, font_css, (gssize) -1, &_inner_error0_);
#line 299 "../src/Widgets/SourceView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 674 "SourceView.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp39_;
		const gchar* _tmp40_;
#line 298 "../src/Widgets/SourceView.vala"
		e = _inner_error0_;
#line 298 "../src/Widgets/SourceView.vala"
		_inner_error0_ = NULL;
#line 301 "../src/Widgets/SourceView.vala"
		_tmp39_ = e;
#line 301 "../src/Widgets/SourceView.vala"
		_tmp40_ = _tmp39_->message;
#line 301 "../src/Widgets/SourceView.vala"
		g_critical ("SourceView.vala:301: %s", _tmp40_);
#line 298 "../src/Widgets/SourceView.vala"
		_g_error_free0 (e);
#line 696 "SourceView.c"
	}
	__finally0:
#line 298 "../src/Widgets/SourceView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 298 "../src/Widgets/SourceView.vala"
		_g_free0 (font_css);
#line 298 "../src/Widgets/SourceView.vala"
		_g_object_unref0 (source_buffer);
#line 298 "../src/Widgets/SourceView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 298 "../src/Widgets/SourceView.vala"
		g_clear_error (&_inner_error0_);
#line 298 "../src/Widgets/SourceView.vala"
		return;
#line 711 "SourceView.c"
	}
#line 304 "../src/Widgets/SourceView.vala"
	_tmp41_ = scratch_settings;
#line 304 "../src/Widgets/SourceView.vala"
	if (g_settings_get_boolean (_tmp41_, "follow-system-style")) {
#line 717 "SourceView.c"
		gboolean system_prefers_dark = FALSE;
		GraniteSettings* _tmp42_;
		GraniteSettingsColorScheme _tmp43_;
		GraniteSettingsColorScheme _tmp44_;
#line 305 "../src/Widgets/SourceView.vala"
		_tmp42_ = granite_settings_get_default ();
#line 305 "../src/Widgets/SourceView.vala"
		_tmp43_ = granite_settings_get_prefers_color_scheme (_tmp42_);
#line 305 "../src/Widgets/SourceView.vala"
		_tmp44_ = _tmp43_;
#line 305 "../src/Widgets/SourceView.vala"
		system_prefers_dark = _tmp44_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK;
#line 306 "../src/Widgets/SourceView.vala"
		if (system_prefers_dark) {
#line 732 "SourceView.c"
			GtkSourceBuffer* _tmp45_;
			GtkSourceStyleSchemeManager* _tmp46_;
			GtkSourceStyleScheme* _tmp47_;
#line 307 "../src/Widgets/SourceView.vala"
			_tmp45_ = source_buffer;
#line 307 "../src/Widgets/SourceView.vala"
			_tmp46_ = self->style_scheme_manager;
#line 307 "../src/Widgets/SourceView.vala"
			_tmp47_ = gtk_source_style_scheme_manager_get_scheme (_tmp46_, "elementary-dark");
#line 307 "../src/Widgets/SourceView.vala"
			gtk_source_buffer_set_style_scheme (_tmp45_, _tmp47_);
#line 744 "SourceView.c"
		} else {
			GtkSourceBuffer* _tmp48_;
			GtkSourceStyleSchemeManager* _tmp49_;
			GtkSourceStyleScheme* _tmp50_;
#line 309 "../src/Widgets/SourceView.vala"
			_tmp48_ = source_buffer;
#line 309 "../src/Widgets/SourceView.vala"
			_tmp49_ = self->style_scheme_manager;
#line 309 "../src/Widgets/SourceView.vala"
			_tmp50_ = gtk_source_style_scheme_manager_get_scheme (_tmp49_, "elementary-light");
#line 309 "../src/Widgets/SourceView.vala"
			gtk_source_buffer_set_style_scheme (_tmp48_, _tmp50_);
#line 757 "SourceView.c"
		}
	} else {
		GtkSourceStyleScheme* scheme = NULL;
		GtkSourceStyleSchemeManager* _tmp51_;
		GSettings* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		GtkSourceStyleScheme* _tmp55_;
		GtkSourceStyleScheme* _tmp56_;
		GtkSourceStyleScheme* _tmp57_;
		GtkSourceStyleScheme* _tmp58_ = NULL;
		GtkSourceStyleScheme* _tmp59_;
		GtkSourceBuffer* _tmp62_;
#line 312 "../src/Widgets/SourceView.vala"
		_tmp51_ = self->style_scheme_manager;
#line 312 "../src/Widgets/SourceView.vala"
		_tmp52_ = scratch_settings;
#line 312 "../src/Widgets/SourceView.vala"
		_tmp53_ = g_settings_get_string (_tmp52_, "style-scheme");
#line 312 "../src/Widgets/SourceView.vala"
		_tmp54_ = _tmp53_;
#line 312 "../src/Widgets/SourceView.vala"
		_tmp55_ = gtk_source_style_scheme_manager_get_scheme (_tmp51_, _tmp54_);
#line 312 "../src/Widgets/SourceView.vala"
		_tmp56_ = _g_object_ref0 (_tmp55_);
#line 312 "../src/Widgets/SourceView.vala"
		_tmp57_ = _tmp56_;
#line 312 "../src/Widgets/SourceView.vala"
		_g_free0 (_tmp54_);
#line 312 "../src/Widgets/SourceView.vala"
		scheme = _tmp57_;
#line 313 "../src/Widgets/SourceView.vala"
		_tmp59_ = scheme;
#line 313 "../src/Widgets/SourceView.vala"
		_tmp58_ = _tmp59_;
#line 313 "../src/Widgets/SourceView.vala"
		if (_tmp58_ == NULL) {
#line 795 "SourceView.c"
			GtkSourceStyleSchemeManager* _tmp60_;
			GtkSourceStyleScheme* _tmp61_;
#line 313 "../src/Widgets/SourceView.vala"
			_tmp60_ = self->style_scheme_manager;
#line 313 "../src/Widgets/SourceView.vala"
			_tmp61_ = gtk_source_style_scheme_manager_get_scheme (_tmp60_, "classic");
#line 313 "../src/Widgets/SourceView.vala"
			_tmp58_ = _tmp61_;
#line 804 "SourceView.c"
		}
#line 313 "../src/Widgets/SourceView.vala"
		_tmp62_ = source_buffer;
#line 313 "../src/Widgets/SourceView.vala"
		gtk_source_buffer_set_style_scheme (_tmp62_, _tmp58_);
#line 304 "../src/Widgets/SourceView.vala"
		_g_object_unref0 (scheme);
#line 812 "SourceView.c"
	}
#line 316 "../src/Widgets/SourceView.vala"
	_tmp63_ = self->priv->git_diff_gutter_renderer;
#line 316 "../src/Widgets/SourceView.vala"
	_tmp64_ = source_buffer;
#line 316 "../src/Widgets/SourceView.vala"
	_tmp65_ = gtk_source_buffer_get_style_scheme (_tmp64_);
#line 316 "../src/Widgets/SourceView.vala"
	_tmp66_ = _tmp65_;
#line 316 "../src/Widgets/SourceView.vala"
	scratch_widgets_source_gutter_renderer_set_style_scheme (_tmp63_, _tmp66_);
#line 317 "../src/Widgets/SourceView.vala"
	_tmp67_ = source_buffer;
#line 317 "../src/Widgets/SourceView.vala"
	_tmp68_ = gtk_source_buffer_get_style_scheme (_tmp67_);
#line 317 "../src/Widgets/SourceView.vala"
	_tmp69_ = _tmp68_;
#line 317 "../src/Widgets/SourceView.vala"
	g_signal_emit (self, scratch_widgets_source_view_signals[SCRATCH_WIDGETS_SOURCE_VIEW_STYLE_CHANGED_SIGNAL], 0, _tmp69_);
#line 240 "../src/Widgets/SourceView.vala"
	_g_free0 (font_css);
#line 240 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (source_buffer);
#line 836 "SourceView.c"
}

void
scratch_widgets_source_view_go_to_line (ScratchWidgetsSourceView* self,
                                        gint line,
                                        gint offset)
{
	GtkTextIter it = {0};
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextIter _tmp2_ = {0};
	gint _tmp3_ = 0;
	GtkTextIter _tmp4_;
	GtkTextBuffer* _tmp5_;
	GtkTextBuffer* _tmp6_;
	GtkTextIter _tmp7_;
#line 320 "../src/Widgets/SourceView.vala"
	g_return_if_fail (self != NULL);
#line 322 "../src/Widgets/SourceView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 322 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_;
#line 322 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_get_iter_at_line (_tmp1_, &_tmp2_, line - 1);
#line 322 "../src/Widgets/SourceView.vala"
	it = _tmp2_;
#line 325 "../src/Widgets/SourceView.vala"
	if (offset == -1) {
#line 325 "../src/Widgets/SourceView.vala"
		_tmp3_ = 0;
#line 867 "SourceView.c"
	} else {
#line 325 "../src/Widgets/SourceView.vala"
		_tmp3_ = offset;
#line 871 "SourceView.c"
	}
#line 325 "../src/Widgets/SourceView.vala"
	gtk_text_iter_forward_chars (&it, _tmp3_);
#line 326 "../src/Widgets/SourceView.vala"
	_tmp4_ = it;
#line 326 "../src/Widgets/SourceView.vala"
	gtk_text_view_scroll_to_iter ((GtkTextView*) self, &_tmp4_, (gdouble) 0, FALSE, (gdouble) 0, (gdouble) 0);
#line 327 "../src/Widgets/SourceView.vala"
	_tmp5_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 327 "../src/Widgets/SourceView.vala"
	_tmp6_ = _tmp5_;
#line 327 "../src/Widgets/SourceView.vala"
	_tmp7_ = it;
#line 327 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_place_cursor (_tmp6_, &_tmp7_);
#line 887 "SourceView.c"
}

static gchar*
string_chomp (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1397 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1398 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1398 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1399 "glib-2.0.vapi"
	g_strchomp (_result_);
#line 1400 "glib-2.0.vapi"
	result = _result_;
#line 1400 "glib-2.0.vapi"
	return result;
#line 908 "SourceView.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 930 "SourceView.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 934 "SourceView.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 940 "SourceView.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 944 "SourceView.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 948 "SourceView.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 956 "SourceView.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 984 "SourceView.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 993 "SourceView.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1007 "SourceView.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1016 "SourceView.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1030 "SourceView.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1039 "SourceView.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1048 "SourceView.c"
}

gchar*
scratch_widgets_source_view_get_selected_text (ScratchWidgetsSourceView* self,
                                               gboolean replace_new_line)
{
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextIter _tmp2_ = {0};
	GtkTextIter _tmp3_ = {0};
	gchar* selected = NULL;
	GtkTextBuffer* _tmp4_;
	GtkTextBuffer* _tmp5_;
	GtkTextIter _tmp6_;
	GtkTextIter _tmp7_;
	gchar* _tmp8_;
	gchar* result;
#line 330 "../src/Widgets/SourceView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 332 "../src/Widgets/SourceView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 332 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_;
#line 332 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_get_selection_bounds (_tmp1_, &_tmp2_, &_tmp3_);
#line 332 "../src/Widgets/SourceView.vala"
	start = _tmp2_;
#line 332 "../src/Widgets/SourceView.vala"
	end = _tmp3_;
#line 333 "../src/Widgets/SourceView.vala"
	_tmp4_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 333 "../src/Widgets/SourceView.vala"
	_tmp5_ = _tmp4_;
#line 333 "../src/Widgets/SourceView.vala"
	_tmp6_ = start;
#line 333 "../src/Widgets/SourceView.vala"
	_tmp7_ = end;
#line 333 "../src/Widgets/SourceView.vala"
	_tmp8_ = gtk_text_buffer_get_text (_tmp5_, &_tmp6_, &_tmp7_, TRUE);
#line 333 "../src/Widgets/SourceView.vala"
	selected = _tmp8_;
#line 334 "../src/Widgets/SourceView.vala"
	if (replace_new_line) {
#line 1094 "SourceView.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 335 "../src/Widgets/SourceView.vala"
		_tmp9_ = selected;
#line 335 "../src/Widgets/SourceView.vala"
		_tmp10_ = string_chomp (_tmp9_);
#line 335 "../src/Widgets/SourceView.vala"
		_tmp11_ = _tmp10_;
#line 335 "../src/Widgets/SourceView.vala"
		_tmp12_ = string_replace (_tmp11_, "\n", " ");
#line 335 "../src/Widgets/SourceView.vala"
		_tmp13_ = _tmp12_;
#line 335 "../src/Widgets/SourceView.vala"
		_g_free0 (_tmp11_);
#line 335 "../src/Widgets/SourceView.vala"
		result = _tmp13_;
#line 335 "../src/Widgets/SourceView.vala"
		_g_free0 (selected);
#line 335 "../src/Widgets/SourceView.vala"
		return result;
#line 1118 "SourceView.c"
	}
#line 338 "../src/Widgets/SourceView.vala"
	result = selected;
#line 338 "../src/Widgets/SourceView.vala"
	return result;
#line 1124 "SourceView.c"
}

static gint
scratch_widgets_source_view_get_selected_line_count (ScratchWidgetsSourceView* self)
{
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextIter _tmp2_ = {0};
	GtkTextIter _tmp3_ = {0};
	GtkTextIter _tmp4_;
	gint result;
#line 341 "../src/Widgets/SourceView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 343 "../src/Widgets/SourceView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 343 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_;
#line 343 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_get_selection_bounds (_tmp1_, &_tmp2_, &_tmp3_);
#line 343 "../src/Widgets/SourceView.vala"
	start = _tmp2_;
#line 343 "../src/Widgets/SourceView.vala"
	end = _tmp3_;
#line 345 "../src/Widgets/SourceView.vala"
	_tmp4_ = end;
#line 345 "../src/Widgets/SourceView.vala"
	if (!gtk_text_iter_equal (&start, &_tmp4_)) {
#line 1154 "SourceView.c"
		gchar* selected = NULL;
		GtkTextBuffer* _tmp5_;
		GtkTextBuffer* _tmp6_;
		GtkTextIter _tmp7_;
		GtkTextIter _tmp8_;
		gchar* _tmp9_;
		gchar** lines = NULL;
		const gchar* _tmp10_;
		gchar** _tmp11_;
		gchar** _tmp12_;
		gint lines_length1;
		gint _lines_size_;
		gchar** _tmp13_;
		gint _tmp13__length1;
#line 346 "../src/Widgets/SourceView.vala"
		_tmp5_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 346 "../src/Widgets/SourceView.vala"
		_tmp6_ = _tmp5_;
#line 346 "../src/Widgets/SourceView.vala"
		_tmp7_ = start;
#line 346 "../src/Widgets/SourceView.vala"
		_tmp8_ = end;
#line 346 "../src/Widgets/SourceView.vala"
		_tmp9_ = gtk_text_buffer_get_text (_tmp6_, &_tmp7_, &_tmp8_, TRUE);
#line 346 "../src/Widgets/SourceView.vala"
		selected = _tmp9_;
#line 347 "../src/Widgets/SourceView.vala"
		_tmp10_ = selected;
#line 347 "../src/Widgets/SourceView.vala"
		_tmp12_ = _tmp11_ = g_regex_split_simple ("\\R", _tmp10_, 0, 0);
#line 347 "../src/Widgets/SourceView.vala"
		lines = _tmp12_;
#line 347 "../src/Widgets/SourceView.vala"
		lines_length1 = _vala_array_length (_tmp11_);
#line 347 "../src/Widgets/SourceView.vala"
		_lines_size_ = lines_length1;
#line 348 "../src/Widgets/SourceView.vala"
		_tmp13_ = lines;
#line 348 "../src/Widgets/SourceView.vala"
		_tmp13__length1 = lines_length1;
#line 348 "../src/Widgets/SourceView.vala"
		result = _tmp13__length1;
#line 348 "../src/Widgets/SourceView.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 348 "../src/Widgets/SourceView.vala"
		_g_free0 (selected);
#line 348 "../src/Widgets/SourceView.vala"
		return result;
#line 1203 "SourceView.c"
	}
#line 351 "../src/Widgets/SourceView.vala"
	result = 0;
#line 351 "../src/Widgets/SourceView.vala"
	return result;
#line 1209 "SourceView.c"
}

static void
_vala_GtkTextIter_free (GtkTextIter* self)
{
#line 366 "../src/Widgets/SourceView.vala"
	g_boxed_free (gtk_text_iter_get_type (), self);
#line 1217 "SourceView.c"
}

static GtkTextIter*
_vala_GtkTextIter_copy (GtkTextIter* self)
{
#line 366 "../src/Widgets/SourceView.vala"
	return g_boxed_copy (gtk_text_iter_get_type (), self);
#line 1225 "SourceView.c"
}

static gpointer
__vala_GtkTextIter_copy0 (gpointer self)
{
#line 366 "../src/Widgets/SourceView.vala"
	return self ? _vala_GtkTextIter_copy (self) : NULL;
#line 1233 "SourceView.c"
}

void
scratch_widgets_source_view_duplicate_selection (ScratchWidgetsSourceView* self)
{
	GtkTextIter* start = NULL;
	GtkTextIter* end = NULL;
	gint selection_start_offset = 0;
	gint selection_end_offset = 0;
	gint start_line = 0;
	gint end_line = 0;
	gchar* selection = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GtkTextBuffer* _tmp60_;
	GtkTextBuffer* _tmp61_;
	const gchar* _tmp62_;
	gboolean _tmp63_ = FALSE;
#line 357 "../src/Widgets/SourceView.vala"
	g_return_if_fail (self != NULL);
#line 358 "../src/Widgets/SourceView.vala"
	start = NULL;
#line 359 "../src/Widgets/SourceView.vala"
	end = NULL;
#line 360 "../src/Widgets/SourceView.vala"
	selection_start_offset = 0;
#line 361 "../src/Widgets/SourceView.vala"
	selection_end_offset = 0;
#line 363 "../src/Widgets/SourceView.vala"
	_tmp0_ = scratch_widgets_source_view_get_selected_text (self, TRUE);
#line 363 "../src/Widgets/SourceView.vala"
	selection = _tmp0_;
#line 365 "../src/Widgets/SourceView.vala"
	_tmp1_ = selection;
#line 365 "../src/Widgets/SourceView.vala"
	if (g_strcmp0 (_tmp1_, "") != 0) {
#line 1270 "SourceView.c"
		GtkTextBuffer* _tmp2_;
		GtkTextBuffer* _tmp3_;
		GtkTextIter _tmp4_ = {0};
		GtkTextIter _tmp5_ = {0};
		GtkTextIter _tmp6_;
		GtkTextIter* _tmp7_;
		GtkTextIter _tmp8_;
		GtkTextIter* _tmp9_;
		GtkTextIter* _tmp10_;
		GtkTextIter* _tmp11_;
		GtkTextIter* _tmp32_;
		GtkTextIter* _tmp33_;
#line 366 "../src/Widgets/SourceView.vala"
		_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 366 "../src/Widgets/SourceView.vala"
		_tmp3_ = _tmp2_;
#line 366 "../src/Widgets/SourceView.vala"
		gtk_text_buffer_get_selection_bounds (_tmp3_, &_tmp4_, &_tmp5_);
#line 366 "../src/Widgets/SourceView.vala"
		__vala_GtkTextIter_free0 (start);
#line 366 "../src/Widgets/SourceView.vala"
		_tmp6_ = _tmp4_;
#line 366 "../src/Widgets/SourceView.vala"
		_tmp7_ = __vala_GtkTextIter_copy0 (&_tmp6_);
#line 366 "../src/Widgets/SourceView.vala"
		start = _tmp7_;
#line 366 "../src/Widgets/SourceView.vala"
		__vala_GtkTextIter_free0 (end);
#line 366 "../src/Widgets/SourceView.vala"
		_tmp8_ = _tmp5_;
#line 366 "../src/Widgets/SourceView.vala"
		_tmp9_ = __vala_GtkTextIter_copy0 (&_tmp8_);
#line 366 "../src/Widgets/SourceView.vala"
		end = _tmp9_;
#line 367 "../src/Widgets/SourceView.vala"
		_tmp10_ = start;
#line 367 "../src/Widgets/SourceView.vala"
		start_line = gtk_text_iter_get_line (_tmp10_);
#line 368 "../src/Widgets/SourceView.vala"
		_tmp11_ = end;
#line 368 "../src/Widgets/SourceView.vala"
		end_line = gtk_text_iter_get_line (_tmp11_);
#line 369 "../src/Widgets/SourceView.vala"
		if (start_line != end_line) {
#line 1315 "SourceView.c"
			GtkTextBuffer* _tmp12_;
			GtkTextBuffer* _tmp13_;
			GtkTextIter _tmp14_ = {0};
			GtkTextIter _tmp15_;
			GtkTextIter* _tmp16_;
			GtkTextBuffer* _tmp17_;
			GtkTextBuffer* _tmp18_;
			GtkTextIter _tmp19_ = {0};
			GtkTextIter _tmp20_;
			GtkTextIter* _tmp21_;
			GtkTextIter* _tmp22_;
			GtkTextBuffer* _tmp23_;
			GtkTextBuffer* _tmp24_;
			GtkTextIter* _tmp25_;
			GtkTextIter* _tmp26_;
			GtkTextIter _tmp27_;
			GtkTextIter _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
#line 370 "../src/Widgets/SourceView.vala"
			_tmp12_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 370 "../src/Widgets/SourceView.vala"
			_tmp13_ = _tmp12_;
#line 370 "../src/Widgets/SourceView.vala"
			gtk_text_buffer_get_iter_at_line (_tmp13_, &_tmp14_, start_line);
#line 370 "../src/Widgets/SourceView.vala"
			__vala_GtkTextIter_free0 (start);
#line 370 "../src/Widgets/SourceView.vala"
			_tmp15_ = _tmp14_;
#line 370 "../src/Widgets/SourceView.vala"
			_tmp16_ = __vala_GtkTextIter_copy0 (&_tmp15_);
#line 370 "../src/Widgets/SourceView.vala"
			start = _tmp16_;
#line 371 "../src/Widgets/SourceView.vala"
			_tmp17_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 371 "../src/Widgets/SourceView.vala"
			_tmp18_ = _tmp17_;
#line 371 "../src/Widgets/SourceView.vala"
			gtk_text_buffer_get_iter_at_line (_tmp18_, &_tmp19_, end_line);
#line 371 "../src/Widgets/SourceView.vala"
			__vala_GtkTextIter_free0 (end);
#line 371 "../src/Widgets/SourceView.vala"
			_tmp20_ = _tmp19_;
#line 371 "../src/Widgets/SourceView.vala"
			_tmp21_ = __vala_GtkTextIter_copy0 (&_tmp20_);
#line 371 "../src/Widgets/SourceView.vala"
			end = _tmp21_;
#line 372 "../src/Widgets/SourceView.vala"
			_tmp22_ = end;
#line 372 "../src/Widgets/SourceView.vala"
			gtk_text_iter_forward_to_line_end (_tmp22_);
#line 374 "../src/Widgets/SourceView.vala"
			_tmp23_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 374 "../src/Widgets/SourceView.vala"
			_tmp24_ = _tmp23_;
#line 374 "../src/Widgets/SourceView.vala"
			_tmp25_ = start;
#line 374 "../src/Widgets/SourceView.vala"
			_tmp26_ = end;
#line 374 "../src/Widgets/SourceView.vala"
			_tmp27_ = *_tmp25_;
#line 374 "../src/Widgets/SourceView.vala"
			_tmp28_ = *_tmp26_;
#line 374 "../src/Widgets/SourceView.vala"
			_tmp29_ = gtk_text_buffer_get_text (_tmp24_, &_tmp27_, &_tmp28_, TRUE);
#line 374 "../src/Widgets/SourceView.vala"
			_tmp30_ = _tmp29_;
#line 374 "../src/Widgets/SourceView.vala"
			_tmp31_ = g_strconcat ("\n", _tmp30_, NULL);
#line 374 "../src/Widgets/SourceView.vala"
			_g_free0 (selection);
#line 374 "../src/Widgets/SourceView.vala"
			selection = _tmp31_;
#line 374 "../src/Widgets/SourceView.vala"
			_g_free0 (_tmp30_);
#line 1392 "SourceView.c"
		}
#line 377 "../src/Widgets/SourceView.vala"
		_tmp32_ = start;
#line 377 "../src/Widgets/SourceView.vala"
		selection_start_offset = gtk_text_iter_get_offset (_tmp32_);
#line 378 "../src/Widgets/SourceView.vala"
		_tmp33_ = end;
#line 378 "../src/Widgets/SourceView.vala"
		selection_end_offset = gtk_text_iter_get_offset (_tmp33_);
#line 1402 "SourceView.c"
	} else {
		GtkTextBuffer* _tmp34_;
		GtkTextBuffer* _tmp35_;
		GtkTextBuffer* _tmp36_;
		GtkTextBuffer* _tmp37_;
		GtkTextMark* _tmp38_;
		GtkTextIter _tmp39_ = {0};
		GtkTextIter _tmp40_;
		GtkTextIter* _tmp41_;
		GtkTextIter* _tmp42_;
		GtkTextIter* _tmp43_;
		GtkTextIter* _tmp44_;
		GtkTextIter* _tmp45_;
		GtkTextIter* _tmp46_;
		GtkTextIter* _tmp47_;
		GtkTextIter* _tmp48_;
		GtkTextIter* _tmp49_;
		GtkTextBuffer* _tmp51_;
		GtkTextBuffer* _tmp52_;
		GtkTextIter* _tmp53_;
		GtkTextIter* _tmp54_;
		GtkTextIter _tmp55_;
		GtkTextIter _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
		gchar* _tmp59_;
#line 380 "../src/Widgets/SourceView.vala"
		_tmp34_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 380 "../src/Widgets/SourceView.vala"
		_tmp35_ = _tmp34_;
#line 380 "../src/Widgets/SourceView.vala"
		_tmp36_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 380 "../src/Widgets/SourceView.vala"
		_tmp37_ = _tmp36_;
#line 380 "../src/Widgets/SourceView.vala"
		_tmp38_ = gtk_text_buffer_get_insert (_tmp37_);
#line 380 "../src/Widgets/SourceView.vala"
		gtk_text_buffer_get_iter_at_mark (_tmp35_, &_tmp39_, _tmp38_);
#line 380 "../src/Widgets/SourceView.vala"
		__vala_GtkTextIter_free0 (start);
#line 380 "../src/Widgets/SourceView.vala"
		_tmp40_ = _tmp39_;
#line 380 "../src/Widgets/SourceView.vala"
		_tmp41_ = __vala_GtkTextIter_copy0 (&_tmp40_);
#line 380 "../src/Widgets/SourceView.vala"
		start = _tmp41_;
#line 381 "../src/Widgets/SourceView.vala"
		_tmp42_ = start;
#line 381 "../src/Widgets/SourceView.vala"
		_tmp43_ = start;
#line 381 "../src/Widgets/SourceView.vala"
		gtk_text_iter_backward_chars (_tmp42_, gtk_text_iter_get_line_offset (_tmp43_));
#line 382 "../src/Widgets/SourceView.vala"
		_tmp44_ = start;
#line 382 "../src/Widgets/SourceView.vala"
		_tmp45_ = gtk_text_iter_copy (_tmp44_);
#line 382 "../src/Widgets/SourceView.vala"
		__vala_GtkTextIter_free0 (end);
#line 382 "../src/Widgets/SourceView.vala"
		end = _tmp45_;
#line 383 "../src/Widgets/SourceView.vala"
		_tmp46_ = end;
#line 383 "../src/Widgets/SourceView.vala"
		_tmp47_ = end;
#line 383 "../src/Widgets/SourceView.vala"
		gtk_text_iter_forward_chars (_tmp46_, gtk_text_iter_get_chars_in_line (_tmp47_));
#line 384 "../src/Widgets/SourceView.vala"
		_tmp48_ = end;
#line 384 "../src/Widgets/SourceView.vala"
		_tmp49_ = start;
#line 384 "../src/Widgets/SourceView.vala"
		if (gtk_text_iter_get_line (_tmp48_) != gtk_text_iter_get_line (_tmp49_)) {
#line 1475 "SourceView.c"
			GtkTextIter* _tmp50_;
#line 385 "../src/Widgets/SourceView.vala"
			_tmp50_ = end;
#line 385 "../src/Widgets/SourceView.vala"
			gtk_text_iter_backward_char (_tmp50_);
#line 1481 "SourceView.c"
		}
#line 388 "../src/Widgets/SourceView.vala"
		_tmp51_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 388 "../src/Widgets/SourceView.vala"
		_tmp52_ = _tmp51_;
#line 388 "../src/Widgets/SourceView.vala"
		_tmp53_ = start;
#line 388 "../src/Widgets/SourceView.vala"
		_tmp54_ = end;
#line 388 "../src/Widgets/SourceView.vala"
		_tmp55_ = *_tmp53_;
#line 388 "../src/Widgets/SourceView.vala"
		_tmp56_ = *_tmp54_;
#line 388 "../src/Widgets/SourceView.vala"
		_tmp57_ = gtk_text_buffer_get_text (_tmp52_, &_tmp55_, &_tmp56_, TRUE);
#line 388 "../src/Widgets/SourceView.vala"
		_tmp58_ = _tmp57_;
#line 388 "../src/Widgets/SourceView.vala"
		_tmp59_ = g_strconcat ("\n", _tmp58_, NULL);
#line 388 "../src/Widgets/SourceView.vala"
		_g_free0 (selection);
#line 388 "../src/Widgets/SourceView.vala"
		selection = _tmp59_;
#line 388 "../src/Widgets/SourceView.vala"
		_g_free0 (_tmp58_);
#line 1507 "SourceView.c"
	}
#line 391 "../src/Widgets/SourceView.vala"
	_tmp60_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 391 "../src/Widgets/SourceView.vala"
	_tmp61_ = _tmp60_;
#line 391 "../src/Widgets/SourceView.vala"
	_tmp62_ = selection;
#line 391 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_insert (_tmp61_, end, _tmp62_, -1);
#line 393 "../src/Widgets/SourceView.vala"
	if (selection_start_offset > 0) {
#line 393 "../src/Widgets/SourceView.vala"
		_tmp63_ = TRUE;
#line 1521 "SourceView.c"
	} else {
#line 393 "../src/Widgets/SourceView.vala"
		_tmp63_ = selection_end_offset > 0;
#line 1525 "SourceView.c"
	}
#line 393 "../src/Widgets/SourceView.vala"
	if (_tmp63_) {
#line 1529 "SourceView.c"
		GtkTextBuffer* _tmp64_;
		GtkTextBuffer* _tmp65_;
		GtkTextIter _tmp66_ = {0};
		GtkTextIter _tmp67_;
		GtkTextIter* _tmp68_;
		GtkTextBuffer* _tmp69_;
		GtkTextBuffer* _tmp70_;
		GtkTextIter _tmp71_ = {0};
		GtkTextIter _tmp72_;
		GtkTextIter* _tmp73_;
		GtkTextBuffer* _tmp74_;
		GtkTextBuffer* _tmp75_;
		GtkTextIter* _tmp76_;
		GtkTextIter* _tmp77_;
		GtkTextIter _tmp78_;
		GtkTextIter _tmp79_;
#line 394 "../src/Widgets/SourceView.vala"
		_tmp64_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 394 "../src/Widgets/SourceView.vala"
		_tmp65_ = _tmp64_;
#line 394 "../src/Widgets/SourceView.vala"
		gtk_text_buffer_get_iter_at_offset (_tmp65_, &_tmp66_, selection_start_offset);
#line 394 "../src/Widgets/SourceView.vala"
		__vala_GtkTextIter_free0 (start);
#line 394 "../src/Widgets/SourceView.vala"
		_tmp67_ = _tmp66_;
#line 394 "../src/Widgets/SourceView.vala"
		_tmp68_ = __vala_GtkTextIter_copy0 (&_tmp67_);
#line 394 "../src/Widgets/SourceView.vala"
		start = _tmp68_;
#line 395 "../src/Widgets/SourceView.vala"
		_tmp69_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 395 "../src/Widgets/SourceView.vala"
		_tmp70_ = _tmp69_;
#line 395 "../src/Widgets/SourceView.vala"
		gtk_text_buffer_get_iter_at_offset (_tmp70_, &_tmp71_, selection_end_offset);
#line 395 "../src/Widgets/SourceView.vala"
		__vala_GtkTextIter_free0 (end);
#line 395 "../src/Widgets/SourceView.vala"
		_tmp72_ = _tmp71_;
#line 395 "../src/Widgets/SourceView.vala"
		_tmp73_ = __vala_GtkTextIter_copy0 (&_tmp72_);
#line 395 "../src/Widgets/SourceView.vala"
		end = _tmp73_;
#line 396 "../src/Widgets/SourceView.vala"
		_tmp74_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 396 "../src/Widgets/SourceView.vala"
		_tmp75_ = _tmp74_;
#line 396 "../src/Widgets/SourceView.vala"
		_tmp76_ = start;
#line 396 "../src/Widgets/SourceView.vala"
		_tmp77_ = end;
#line 396 "../src/Widgets/SourceView.vala"
		_tmp78_ = *_tmp76_;
#line 396 "../src/Widgets/SourceView.vala"
		_tmp79_ = *_tmp77_;
#line 396 "../src/Widgets/SourceView.vala"
		gtk_text_buffer_select_range (_tmp75_, &_tmp78_, &_tmp79_);
#line 1588 "SourceView.c"
	}
#line 357 "../src/Widgets/SourceView.vala"
	_g_free0 (selection);
#line 357 "../src/Widgets/SourceView.vala"
	__vala_GtkTextIter_free0 (end);
#line 357 "../src/Widgets/SourceView.vala"
	__vala_GtkTextIter_free0 (start);
#line 1596 "SourceView.c"
}

static gint
___lambda90_ (ScratchWidgetsSourceView* self,
              const gchar* a,
              const gchar* b)
{
	gint result;
#line 437 "../src/Widgets/SourceView.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 437 "../src/Widgets/SourceView.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 438 "../src/Widgets/SourceView.vala"
	result = g_utf8_collate (a, b);
#line 438 "../src/Widgets/SourceView.vala"
	return result;
#line 1613 "SourceView.c"
}

static gint
____lambda90__gcompare_data_func (gconstpointer a,
                                  gconstpointer b,
                                  gpointer self)
{
	gint result;
	result = ___lambda90_ ((ScratchWidgetsSourceView*) self, (const gchar*) a, (const gchar*) b);
#line 437 "../src/Widgets/SourceView.vala"
	return result;
#line 1625 "SourceView.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 1639 "SourceView.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 1643 "SourceView.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 1649 "SourceView.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 1654 "SourceView.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 1660 "SourceView.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 1664 "SourceView.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 1668 "SourceView.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 1672 "SourceView.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1676 "SourceView.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1680 "SourceView.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 1695 "SourceView.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 1704 "SourceView.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 1711 "SourceView.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 1717 "SourceView.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 1725 "SourceView.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 1729 "SourceView.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1735 "SourceView.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1740 "SourceView.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 1746 "SourceView.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 1750 "SourceView.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 1754 "SourceView.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 1760 "SourceView.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 1766 "SourceView.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 1778 "SourceView.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 1782 "SourceView.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 1786 "SourceView.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 1791 "SourceView.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 1799 "SourceView.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 1817 "SourceView.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 1823 "SourceView.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 1827 "SourceView.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1835 "SourceView.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 1844 "SourceView.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1853 "SourceView.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1859 "SourceView.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 1867 "SourceView.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1879 "SourceView.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1885 "SourceView.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1889 "SourceView.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1897 "SourceView.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 1908 "SourceView.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 1917 "SourceView.c"
	}
}

void
scratch_widgets_source_view_sort_selected_lines (ScratchWidgetsSourceView* self)
{
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextIter _tmp2_ = {0};
	GtkTextIter _tmp3_ = {0};
	GtkTextIter _tmp4_;
#line 400 "../src/Widgets/SourceView.vala"
	g_return_if_fail (self != NULL);
#line 402 "../src/Widgets/SourceView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 402 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_;
#line 402 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_get_selection_bounds (_tmp1_, &_tmp2_, &_tmp3_);
#line 402 "../src/Widgets/SourceView.vala"
	start = _tmp2_;
#line 402 "../src/Widgets/SourceView.vala"
	end = _tmp3_;
#line 404 "../src/Widgets/SourceView.vala"
	_tmp4_ = end;
#line 404 "../src/Widgets/SourceView.vala"
	if (!gtk_text_iter_equal (&start, &_tmp4_)) {
#line 1947 "SourceView.c"
		gboolean end_included = FALSE;
		gchar* selected = NULL;
		GtkTextBuffer* _tmp5_;
		GtkTextBuffer* _tmp6_;
		GtkTextIter _tmp7_;
		GtkTextIter _tmp8_;
		gchar* _tmp9_;
		gchar** lines = NULL;
		const gchar* _tmp10_;
		gchar** _tmp11_;
		gchar** _tmp12_;
		gint lines_length1;
		gint _lines_size_;
		gchar** _tmp13_;
		gint _tmp13__length1;
		GeeArrayList* line_array = NULL;
		GeeArrayList* _tmp14_;
		GeeArrayList* _tmp34_;
		gchar* sorted = NULL;
		GeeArrayList* _tmp50_;
		gint _tmp51_ = 0;
		gpointer* _tmp52_;
		gchar** _tmp53_;
		gint _tmp53__length1;
		gchar* _tmp54_;
		gchar* _tmp55_;
		GtkTextBuffer* _tmp56_;
		GtkTextBuffer* _tmp57_;
		GtkTextBuffer* _tmp58_;
		GtkTextBuffer* _tmp59_;
		GtkTextBuffer* _tmp60_;
		GtkTextBuffer* _tmp61_;
		const gchar* _tmp62_;
		GtkTextBuffer* _tmp63_;
		GtkTextBuffer* _tmp64_;
#line 405 "../src/Widgets/SourceView.vala"
		if (!gtk_text_iter_starts_line (&start)) {
#line 406 "../src/Widgets/SourceView.vala"
			gtk_text_iter_backward_chars (&start, gtk_text_iter_get_line_offset (&start));
#line 1987 "SourceView.c"
		}
#line 410 "../src/Widgets/SourceView.vala"
		if (!gtk_text_iter_starts_line (&end)) {
#line 411 "../src/Widgets/SourceView.vala"
			gtk_text_iter_forward_line (&end);
#line 1993 "SourceView.c"
		}
#line 414 "../src/Widgets/SourceView.vala"
		end_included = gtk_text_iter_is_end (&end);
#line 415 "../src/Widgets/SourceView.vala"
		_tmp5_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 415 "../src/Widgets/SourceView.vala"
		_tmp6_ = _tmp5_;
#line 415 "../src/Widgets/SourceView.vala"
		_tmp7_ = start;
#line 415 "../src/Widgets/SourceView.vala"
		_tmp8_ = end;
#line 415 "../src/Widgets/SourceView.vala"
		_tmp9_ = gtk_text_buffer_get_text (_tmp6_, &_tmp7_, &_tmp8_, TRUE);
#line 415 "../src/Widgets/SourceView.vala"
		selected = _tmp9_;
#line 416 "../src/Widgets/SourceView.vala"
		_tmp10_ = selected;
#line 416 "../src/Widgets/SourceView.vala"
		_tmp12_ = _tmp11_ = g_regex_split_simple ("(\\R)", _tmp10_, 0, 0);
#line 416 "../src/Widgets/SourceView.vala"
		lines = _tmp12_;
#line 416 "../src/Widgets/SourceView.vala"
		lines_length1 = _vala_array_length (_tmp11_);
#line 416 "../src/Widgets/SourceView.vala"
		_lines_size_ = lines_length1;
#line 419 "../src/Widgets/SourceView.vala"
		_tmp13_ = lines;
#line 419 "../src/Widgets/SourceView.vala"
		_tmp13__length1 = lines_length1;
#line 419 "../src/Widgets/SourceView.vala"
		if (_tmp13__length1 <= 3) {
#line 420 "../src/Widgets/SourceView.vala"
			lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 420 "../src/Widgets/SourceView.vala"
			_g_free0 (selected);
#line 420 "../src/Widgets/SourceView.vala"
			return;
#line 2031 "SourceView.c"
		}
#line 425 "../src/Widgets/SourceView.vala"
		_tmp14_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 425 "../src/Widgets/SourceView.vala"
		line_array = _tmp14_;
#line 2037 "SourceView.c"
		{
			gint i = 0;
#line 426 "../src/Widgets/SourceView.vala"
			i = 0;
#line 2042 "SourceView.c"
			{
				gboolean _tmp15_ = FALSE;
#line 426 "../src/Widgets/SourceView.vala"
				_tmp15_ = TRUE;
#line 426 "../src/Widgets/SourceView.vala"
				while (TRUE) {
#line 2049 "SourceView.c"
					gchar** _tmp16_;
					gint _tmp16__length1;
					gchar** _tmp17_;
					gint _tmp17__length1;
#line 426 "../src/Widgets/SourceView.vala"
					if (!_tmp15_) {
#line 426 "../src/Widgets/SourceView.vala"
						i += 2;
#line 2058 "SourceView.c"
					}
#line 426 "../src/Widgets/SourceView.vala"
					_tmp15_ = FALSE;
#line 426 "../src/Widgets/SourceView.vala"
					_tmp16_ = lines;
#line 426 "../src/Widgets/SourceView.vala"
					_tmp16__length1 = lines_length1;
#line 426 "../src/Widgets/SourceView.vala"
					if (!(i < _tmp16__length1)) {
#line 426 "../src/Widgets/SourceView.vala"
						break;
#line 2070 "SourceView.c"
					}
#line 427 "../src/Widgets/SourceView.vala"
					_tmp17_ = lines;
#line 427 "../src/Widgets/SourceView.vala"
					_tmp17__length1 = lines_length1;
#line 427 "../src/Widgets/SourceView.vala"
					if ((i + 1) <= (_tmp17__length1 - 1)) {
#line 2078 "SourceView.c"
						GeeArrayList* _tmp18_;
						gchar** _tmp19_;
						gint _tmp19__length1;
						const gchar* _tmp20_;
						gchar** _tmp21_;
						gint _tmp21__length1;
						const gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
#line 428 "../src/Widgets/SourceView.vala"
						_tmp18_ = line_array;
#line 428 "../src/Widgets/SourceView.vala"
						_tmp19_ = lines;
#line 428 "../src/Widgets/SourceView.vala"
						_tmp19__length1 = lines_length1;
#line 428 "../src/Widgets/SourceView.vala"
						_tmp20_ = _tmp19_[i];
#line 428 "../src/Widgets/SourceView.vala"
						_tmp21_ = lines;
#line 428 "../src/Widgets/SourceView.vala"
						_tmp21__length1 = lines_length1;
#line 428 "../src/Widgets/SourceView.vala"
						_tmp22_ = _tmp21_[i + 1];
#line 428 "../src/Widgets/SourceView.vala"
						_tmp23_ = g_strconcat (_tmp20_, _tmp22_, NULL);
#line 428 "../src/Widgets/SourceView.vala"
						_tmp24_ = _tmp23_;
#line 428 "../src/Widgets/SourceView.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp24_);
#line 428 "../src/Widgets/SourceView.vala"
						_g_free0 (_tmp24_);
#line 2110 "SourceView.c"
					} else {
						gboolean _tmp25_ = FALSE;
						gchar** _tmp26_;
						gint _tmp26__length1;
#line 429 "../src/Widgets/SourceView.vala"
						_tmp26_ = lines;
#line 429 "../src/Widgets/SourceView.vala"
						_tmp26__length1 = lines_length1;
#line 429 "../src/Widgets/SourceView.vala"
						if (i == (_tmp26__length1 - 1)) {
#line 429 "../src/Widgets/SourceView.vala"
							_tmp25_ = end_included;
#line 2123 "SourceView.c"
						} else {
#line 429 "../src/Widgets/SourceView.vala"
							_tmp25_ = FALSE;
#line 2127 "SourceView.c"
						}
#line 429 "../src/Widgets/SourceView.vala"
						if (_tmp25_) {
#line 2131 "SourceView.c"
							GeeArrayList* _tmp27_;
							gchar** _tmp28_;
							gint _tmp28__length1;
							const gchar* _tmp29_;
							gchar** _tmp30_;
							gint _tmp30__length1;
							const gchar* _tmp31_;
							gchar* _tmp32_;
							gchar* _tmp33_;
#line 431 "../src/Widgets/SourceView.vala"
							_tmp27_ = line_array;
#line 431 "../src/Widgets/SourceView.vala"
							_tmp28_ = lines;
#line 431 "../src/Widgets/SourceView.vala"
							_tmp28__length1 = lines_length1;
#line 431 "../src/Widgets/SourceView.vala"
							_tmp29_ = _tmp28_[i];
#line 431 "../src/Widgets/SourceView.vala"
							_tmp30_ = lines;
#line 431 "../src/Widgets/SourceView.vala"
							_tmp30__length1 = lines_length1;
#line 431 "../src/Widgets/SourceView.vala"
							_tmp31_ = _tmp30_[i - 1];
#line 431 "../src/Widgets/SourceView.vala"
							_tmp32_ = g_strconcat (_tmp29_, _tmp31_, NULL);
#line 431 "../src/Widgets/SourceView.vala"
							_tmp33_ = _tmp32_;
#line 431 "../src/Widgets/SourceView.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, _tmp33_);
#line 431 "../src/Widgets/SourceView.vala"
							_g_free0 (_tmp33_);
#line 2163 "SourceView.c"
						} else {
#line 433 "../src/Widgets/SourceView.vala"
							break;
#line 2167 "SourceView.c"
						}
					}
				}
			}
		}
#line 437 "../src/Widgets/SourceView.vala"
		_tmp34_ = line_array;
#line 437 "../src/Widgets/SourceView.vala"
		gee_list_sort ((GeeList*) _tmp34_, ____lambda90__gcompare_data_func, g_object_ref (self), g_object_unref);
#line 442 "../src/Widgets/SourceView.vala"
		if (end_included) {
#line 2179 "SourceView.c"
			gchar* orig_end = NULL;
			GeeArrayList* _tmp35_;
			GeeArrayList* _tmp36_;
			gint _tmp37_;
			gint _tmp38_;
			gpointer _tmp39_;
			const gchar* _tmp40_;
#line 443 "../src/Widgets/SourceView.vala"
			_tmp35_ = line_array;
#line 443 "../src/Widgets/SourceView.vala"
			_tmp36_ = line_array;
#line 443 "../src/Widgets/SourceView.vala"
			_tmp37_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp36_);
#line 443 "../src/Widgets/SourceView.vala"
			_tmp38_ = _tmp37_;
#line 443 "../src/Widgets/SourceView.vala"
			_tmp39_ = gee_abstract_list_get ((GeeAbstractList*) _tmp35_, _tmp38_ - 1);
#line 443 "../src/Widgets/SourceView.vala"
			orig_end = (gchar*) _tmp39_;
#line 444 "../src/Widgets/SourceView.vala"
			_tmp40_ = orig_end;
#line 444 "../src/Widgets/SourceView.vala"
			if (g_regex_match_simple ("\\R", _tmp40_, 0, 0)) {
#line 2203 "SourceView.c"
				GeeArrayList* _tmp41_;
				GeeArrayList* _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
				const gchar* _tmp45_;
				gchar** _tmp46_;
				gchar** _tmp47_;
				gchar** _tmp48_;
				gint _tmp48__length1;
				const gchar* _tmp49_;
#line 445 "../src/Widgets/SourceView.vala"
				_tmp41_ = line_array;
#line 445 "../src/Widgets/SourceView.vala"
				_tmp42_ = line_array;
#line 445 "../src/Widgets/SourceView.vala"
				_tmp43_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp42_);
#line 445 "../src/Widgets/SourceView.vala"
				_tmp44_ = _tmp43_;
#line 445 "../src/Widgets/SourceView.vala"
				_tmp45_ = orig_end;
#line 445 "../src/Widgets/SourceView.vala"
				_tmp47_ = _tmp46_ = g_regex_split_simple ("\\R", _tmp45_, 0, 0);
#line 445 "../src/Widgets/SourceView.vala"
				_tmp48_ = _tmp47_;
#line 445 "../src/Widgets/SourceView.vala"
				_tmp48__length1 = _vala_array_length (_tmp46_);
#line 445 "../src/Widgets/SourceView.vala"
				_tmp49_ = _tmp48_[0];
#line 445 "../src/Widgets/SourceView.vala"
				gee_abstract_list_set ((GeeAbstractList*) _tmp41_, _tmp44_ - 1, _tmp49_);
#line 445 "../src/Widgets/SourceView.vala"
				_tmp48_ = (_vala_array_free (_tmp48_, _tmp48__length1, (GDestroyNotify) g_free), NULL);
#line 2236 "SourceView.c"
			}
#line 442 "../src/Widgets/SourceView.vala"
			_g_free0 (orig_end);
#line 2240 "SourceView.c"
		}
#line 449 "../src/Widgets/SourceView.vala"
		_tmp50_ = line_array;
#line 449 "../src/Widgets/SourceView.vala"
		_tmp52_ = gee_collection_to_array ((GeeCollection*) _tmp50_, &_tmp51_);
#line 449 "../src/Widgets/SourceView.vala"
		_tmp53_ = _tmp52_;
#line 449 "../src/Widgets/SourceView.vala"
		_tmp53__length1 = _tmp51_;
#line 449 "../src/Widgets/SourceView.vala"
		_tmp54_ = _vala_g_strjoinv ("", _tmp53_, (gint) _tmp51_);
#line 449 "../src/Widgets/SourceView.vala"
		_tmp55_ = _tmp54_;
#line 449 "../src/Widgets/SourceView.vala"
		_tmp53_ = (_vala_array_free (_tmp53_, _tmp53__length1, (GDestroyNotify) g_free), NULL);
#line 449 "../src/Widgets/SourceView.vala"
		sorted = _tmp55_;
#line 450 "../src/Widgets/SourceView.vala"
		_tmp56_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 450 "../src/Widgets/SourceView.vala"
		_tmp57_ = _tmp56_;
#line 450 "../src/Widgets/SourceView.vala"
		gtk_text_buffer_begin_user_action (_tmp57_);
#line 451 "../src/Widgets/SourceView.vala"
		_tmp58_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 451 "../src/Widgets/SourceView.vala"
		_tmp59_ = _tmp58_;
#line 451 "../src/Widgets/SourceView.vala"
		gtk_text_buffer_delete (_tmp59_, &start, &end);
#line 452 "../src/Widgets/SourceView.vala"
		_tmp60_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 452 "../src/Widgets/SourceView.vala"
		_tmp61_ = _tmp60_;
#line 452 "../src/Widgets/SourceView.vala"
		_tmp62_ = sorted;
#line 452 "../src/Widgets/SourceView.vala"
		gtk_text_buffer_insert_at_cursor (_tmp61_, _tmp62_, -1);
#line 453 "../src/Widgets/SourceView.vala"
		_tmp63_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 453 "../src/Widgets/SourceView.vala"
		_tmp64_ = _tmp63_;
#line 453 "../src/Widgets/SourceView.vala"
		gtk_text_buffer_end_user_action (_tmp64_);
#line 404 "../src/Widgets/SourceView.vala"
		_g_free0 (sorted);
#line 404 "../src/Widgets/SourceView.vala"
		_g_object_unref0 (line_array);
#line 404 "../src/Widgets/SourceView.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 404 "../src/Widgets/SourceView.vala"
		_g_free0 (selected);
#line 2292 "SourceView.c"
	}
}

void
scratch_widgets_source_view_clear_selected_lines (ScratchWidgetsSourceView* self)
{
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	gboolean has_selection = FALSE;
	GtkTextBuffer* _tmp2_;
	GtkTextBuffer* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextIter _tmp8_ = {0};
	GtkTextIter _tmp9_ = {0};
	gboolean _tmp10_ = FALSE;
	GtkTextBuffer* _tmp12_;
	GtkTextBuffer* _tmp13_;
	GtkTextBuffer* _tmp14_;
	GtkTextBuffer* _tmp15_;
#line 457 "../src/Widgets/SourceView.vala"
	g_return_if_fail (self != NULL);
#line 458 "../src/Widgets/SourceView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 458 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_;
#line 458 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_begin_user_action (_tmp1_);
#line 459 "../src/Widgets/SourceView.vala"
	_tmp2_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 459 "../src/Widgets/SourceView.vala"
	_tmp3_ = _tmp2_;
#line 459 "../src/Widgets/SourceView.vala"
	_tmp4_ = gtk_text_buffer_get_has_selection (_tmp3_);
#line 459 "../src/Widgets/SourceView.vala"
	_tmp5_ = _tmp4_;
#line 459 "../src/Widgets/SourceView.vala"
	has_selection = _tmp5_;
#line 461 "../src/Widgets/SourceView.vala"
	if (has_selection) {
#line 2335 "SourceView.c"
		GtkTextBuffer* _tmp6_;
		GtkTextBuffer* _tmp7_;
#line 463 "../src/Widgets/SourceView.vala"
		_tmp6_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 463 "../src/Widgets/SourceView.vala"
		_tmp7_ = _tmp6_;
#line 463 "../src/Widgets/SourceView.vala"
		gtk_text_buffer_delete_selection (_tmp7_, TRUE, TRUE);
#line 2344 "SourceView.c"
	}
#line 468 "../src/Widgets/SourceView.vala"
	scratch_widgets_source_view_get_current_line (self, &_tmp8_, &_tmp9_);
#line 468 "../src/Widgets/SourceView.vala"
	start = _tmp8_;
#line 468 "../src/Widgets/SourceView.vala"
	end = _tmp9_;
#line 469 "../src/Widgets/SourceView.vala"
	gtk_text_iter_backward_char (&end);
#line 472 "../src/Widgets/SourceView.vala"
	if (!has_selection) {
#line 2356 "SourceView.c"
		GtkTextIter _tmp11_;
#line 472 "../src/Widgets/SourceView.vala"
		_tmp11_ = start;
#line 472 "../src/Widgets/SourceView.vala"
		_tmp10_ = gtk_text_iter_equal (&end, &_tmp11_);
#line 2362 "SourceView.c"
	} else {
#line 472 "../src/Widgets/SourceView.vala"
		_tmp10_ = FALSE;
#line 2366 "SourceView.c"
	}
#line 472 "../src/Widgets/SourceView.vala"
	if (_tmp10_) {
#line 473 "../src/Widgets/SourceView.vala"
		gtk_text_iter_forward_char (&end);
#line 2372 "SourceView.c"
	}
#line 476 "../src/Widgets/SourceView.vala"
	_tmp12_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 476 "../src/Widgets/SourceView.vala"
	_tmp13_ = _tmp12_;
#line 476 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_delete (_tmp13_, &start, &end);
#line 477 "../src/Widgets/SourceView.vala"
	_tmp14_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 477 "../src/Widgets/SourceView.vala"
	_tmp15_ = _tmp14_;
#line 477 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_end_user_action (_tmp15_);
#line 2386 "SourceView.c"
}

static Block38Data*
block38_data_ref (Block38Data* _data38_)
{
#line 480 "../src/Widgets/SourceView.vala"
	g_atomic_int_inc (&_data38_->_ref_count_);
#line 480 "../src/Widgets/SourceView.vala"
	return _data38_;
#line 2396 "SourceView.c"
}

static void
block38_data_unref (void * _userdata_)
{
	Block38Data* _data38_;
	_data38_ = (Block38Data*) _userdata_;
#line 480 "../src/Widgets/SourceView.vala"
	if (g_atomic_int_dec_and_test (&_data38_->_ref_count_)) {
#line 2406 "SourceView.c"
		ScratchWidgetsSourceView* self;
#line 480 "../src/Widgets/SourceView.vala"
		self = _data38_->self;
#line 480 "../src/Widgets/SourceView.vala"
		_g_object_unref0 (self);
#line 480 "../src/Widgets/SourceView.vala"
		g_slice_free (Block38Data, _data38_);
#line 2414 "SourceView.c"
	}
}

static gboolean
__lambda31_ (Block38Data* _data38_)
{
	ScratchWidgetsSourceView* self;
	GtkTextIter _tmp0_;
	gboolean result;
#line 503 "../src/Widgets/SourceView.vala"
	self = _data38_->self;
#line 504 "../src/Widgets/SourceView.vala"
	_tmp0_ = _data38_->end_iter;
#line 504 "../src/Widgets/SourceView.vala"
	gtk_text_view_scroll_to_iter ((GtkTextView*) self, &_tmp0_, 0.25, FALSE, (gdouble) 0, (gdouble) 0);
#line 505 "../src/Widgets/SourceView.vala"
	result = G_SOURCE_REMOVE;
#line 505 "../src/Widgets/SourceView.vala"
	return result;
#line 2434 "SourceView.c"
}

static gboolean
___lambda31__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda31_ (self);
#line 503 "../src/Widgets/SourceView.vala"
	return result;
#line 2444 "SourceView.c"
}

void
scratch_widgets_source_view_select_range (ScratchWidgetsSourceView* self,
                                          SelectionRange* range)
{
	Block38Data* _data38_;
	SelectionRange _tmp0_;
	GtkTextIter start_iter = {0};
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextIter _tmp3_ = {0};
	SelectionRange _tmp4_;
	SelectionRange _tmp5_;
	GtkTextIter* _tmp7_;
	GtkTextIter* _tmp8_;
	GtkTextIter _tmp9_;
	SelectionRange _tmp10_;
	GtkTextBuffer* _tmp14_;
	GtkTextBuffer* _tmp15_;
	GtkTextIter _tmp16_;
	GtkTextIter _tmp17_;
#line 480 "../src/Widgets/SourceView.vala"
	g_return_if_fail (self != NULL);
#line 480 "../src/Widgets/SourceView.vala"
	g_return_if_fail (range != NULL);
#line 480 "../src/Widgets/SourceView.vala"
	_data38_ = g_slice_new0 (Block38Data);
#line 480 "../src/Widgets/SourceView.vala"
	_data38_->_ref_count_ = 1;
#line 480 "../src/Widgets/SourceView.vala"
	_data38_->self = g_object_ref (self);
#line 481 "../src/Widgets/SourceView.vala"
	_tmp0_ = *range;
#line 481 "../src/Widgets/SourceView.vala"
	if (_tmp0_.start_line < 0) {
#line 482 "../src/Widgets/SourceView.vala"
		block38_data_unref (_data38_);
#line 482 "../src/Widgets/SourceView.vala"
		_data38_ = NULL;
#line 482 "../src/Widgets/SourceView.vala"
		return;
#line 2487 "SourceView.c"
	}
#line 486 "../src/Widgets/SourceView.vala"
	_tmp1_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 486 "../src/Widgets/SourceView.vala"
	_tmp2_ = _tmp1_;
#line 486 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_get_start_iter (_tmp2_, &_tmp3_);
#line 486 "../src/Widgets/SourceView.vala"
	start_iter = _tmp3_;
#line 487 "../src/Widgets/SourceView.vala"
	_tmp4_ = *range;
#line 487 "../src/Widgets/SourceView.vala"
	gtk_text_iter_set_line (&start_iter, _tmp4_.start_line - 1);
#line 489 "../src/Widgets/SourceView.vala"
	_tmp5_ = *range;
#line 489 "../src/Widgets/SourceView.vala"
	if (_tmp5_.start_column > 0) {
#line 2505 "SourceView.c"
		SelectionRange _tmp6_;
#line 490 "../src/Widgets/SourceView.vala"
		_tmp6_ = *range;
#line 490 "../src/Widgets/SourceView.vala"
		gtk_text_iter_set_visible_line_offset (&start_iter, _tmp6_.start_column - 1);
#line 2511 "SourceView.c"
	}
#line 493 "../src/Widgets/SourceView.vala"
	_tmp7_ = gtk_text_iter_copy (&start_iter);
#line 493 "../src/Widgets/SourceView.vala"
	_tmp8_ = _tmp7_;
#line 493 "../src/Widgets/SourceView.vala"
	_tmp9_ = *_tmp8_;
#line 493 "../src/Widgets/SourceView.vala"
	__vala_GtkTextIter_free0 (_tmp8_);
#line 493 "../src/Widgets/SourceView.vala"
	_data38_->end_iter = _tmp9_;
#line 494 "../src/Widgets/SourceView.vala"
	_tmp10_ = *range;
#line 494 "../src/Widgets/SourceView.vala"
	if (_tmp10_.end_line > 0) {
#line 2527 "SourceView.c"
		SelectionRange _tmp11_;
		SelectionRange _tmp12_;
#line 495 "../src/Widgets/SourceView.vala"
		_tmp11_ = *range;
#line 495 "../src/Widgets/SourceView.vala"
		gtk_text_iter_set_line (&_data38_->end_iter, _tmp11_.end_line - 1);
#line 497 "../src/Widgets/SourceView.vala"
		_tmp12_ = *range;
#line 497 "../src/Widgets/SourceView.vala"
		if (_tmp12_.end_column > 0) {
#line 2538 "SourceView.c"
			SelectionRange _tmp13_;
#line 498 "../src/Widgets/SourceView.vala"
			_tmp13_ = *range;
#line 498 "../src/Widgets/SourceView.vala"
			gtk_text_iter_set_visible_line_offset (&_data38_->end_iter, _tmp13_.end_column - 1);
#line 2544 "SourceView.c"
		}
	}
#line 502 "../src/Widgets/SourceView.vala"
	_tmp14_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 502 "../src/Widgets/SourceView.vala"
	_tmp15_ = _tmp14_;
#line 502 "../src/Widgets/SourceView.vala"
	_tmp16_ = start_iter;
#line 502 "../src/Widgets/SourceView.vala"
	_tmp17_ = _data38_->end_iter;
#line 502 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_select_range (_tmp15_, &_tmp16_, &_tmp17_);
#line 503 "../src/Widgets/SourceView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda31__gsource_func, block38_data_ref (_data38_), block38_data_unref);
#line 480 "../src/Widgets/SourceView.vala"
	block38_data_unref (_data38_);
#line 480 "../src/Widgets/SourceView.vala"
	_data38_ = NULL;
#line 2563 "SourceView.c"
}

void
scratch_widgets_source_view_set_text (ScratchWidgetsSourceView* self,
                                      const gchar* text,
                                      gboolean opening)
{
	GtkSourceBuffer* source_buffer = NULL;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkSourceBuffer* _tmp2_;
	GtkSourceBuffer* _tmp4_;
	GtkTextIter* start = NULL;
	GtkTextBuffer* _tmp6_;
	GtkTextBuffer* _tmp7_;
	GtkTextIter _tmp8_ = {0};
	GtkTextIter _tmp9_;
	GtkTextIter* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextBuffer* _tmp12_;
	GtkTextIter* _tmp13_;
	GtkTextIter _tmp14_;
#line 509 "../src/Widgets/SourceView.vala"
	g_return_if_fail (self != NULL);
#line 509 "../src/Widgets/SourceView.vala"
	g_return_if_fail (text != NULL);
#line 510 "../src/Widgets/SourceView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 510 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_;
#line 510 "../src/Widgets/SourceView.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_source_buffer_get_type (), GtkSourceBuffer));
#line 510 "../src/Widgets/SourceView.vala"
	source_buffer = _tmp2_;
#line 511 "../src/Widgets/SourceView.vala"
	if (opening) {
#line 2600 "SourceView.c"
		GtkSourceBuffer* _tmp3_;
#line 512 "../src/Widgets/SourceView.vala"
		_tmp3_ = source_buffer;
#line 512 "../src/Widgets/SourceView.vala"
		gtk_source_buffer_begin_not_undoable_action (_tmp3_);
#line 2606 "SourceView.c"
	}
#line 515 "../src/Widgets/SourceView.vala"
	_tmp4_ = source_buffer;
#line 515 "../src/Widgets/SourceView.vala"
	g_object_set ((GtkTextBuffer*) _tmp4_, "text", text, NULL);
#line 517 "../src/Widgets/SourceView.vala"
	if (opening) {
#line 2614 "SourceView.c"
		GtkSourceBuffer* _tmp5_;
#line 518 "../src/Widgets/SourceView.vala"
		_tmp5_ = source_buffer;
#line 518 "../src/Widgets/SourceView.vala"
		gtk_source_buffer_end_not_undoable_action (_tmp5_);
#line 2620 "SourceView.c"
	}
#line 521 "../src/Widgets/SourceView.vala"
	start = NULL;
#line 522 "../src/Widgets/SourceView.vala"
	_tmp6_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 522 "../src/Widgets/SourceView.vala"
	_tmp7_ = _tmp6_;
#line 522 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_get_start_iter (_tmp7_, &_tmp8_);
#line 522 "../src/Widgets/SourceView.vala"
	__vala_GtkTextIter_free0 (start);
#line 522 "../src/Widgets/SourceView.vala"
	_tmp9_ = _tmp8_;
#line 522 "../src/Widgets/SourceView.vala"
	_tmp10_ = __vala_GtkTextIter_copy0 (&_tmp9_);
#line 522 "../src/Widgets/SourceView.vala"
	start = _tmp10_;
#line 523 "../src/Widgets/SourceView.vala"
	_tmp11_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 523 "../src/Widgets/SourceView.vala"
	_tmp12_ = _tmp11_;
#line 523 "../src/Widgets/SourceView.vala"
	_tmp13_ = start;
#line 523 "../src/Widgets/SourceView.vala"
	_tmp14_ = *_tmp13_;
#line 523 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_place_cursor (_tmp12_, &_tmp14_);
#line 509 "../src/Widgets/SourceView.vala"
	__vala_GtkTextIter_free0 (start);
#line 509 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (source_buffer);
#line 2652 "SourceView.c"
}

gchar*
scratch_widgets_source_view_get_text (ScratchWidgetsSourceView* self)
{
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 526 "../src/Widgets/SourceView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 527 "../src/Widgets/SourceView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 527 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_;
#line 527 "../src/Widgets/SourceView.vala"
	g_object_get (_tmp1_, "text", &_tmp2_, NULL);
#line 527 "../src/Widgets/SourceView.vala"
	_tmp3_ = _tmp2_;
#line 527 "../src/Widgets/SourceView.vala"
	result = _tmp3_;
#line 527 "../src/Widgets/SourceView.vala"
	return result;
#line 2677 "SourceView.c"
}

static void
scratch_widgets_source_view_update_draw_spaces (ScratchWidgetsSourceView* self)
{
	GtkTextIter doc_start = {0};
	GtkTextIter doc_end = {0};
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextIter _tmp2_ = {0};
	GtkTextBuffer* _tmp3_;
	GtkTextBuffer* _tmp4_;
	GtkTextIter _tmp5_ = {0};
	GtkTextBuffer* _tmp6_;
	GtkTextBuffer* _tmp7_;
	GtkTextIter _tmp8_;
	GtkTextIter _tmp9_;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	gboolean selection = FALSE;
	GtkTextBuffer* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextIter _tmp12_ = {0};
	GtkTextIter _tmp13_ = {0};
	gboolean _tmp14_;
	ScratchScratchDrawSpacesState draw_spaces_state = 0;
	GSettings* _tmp15_;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp21_ = FALSE;
#line 530 "../src/Widgets/SourceView.vala"
	g_return_if_fail (self != NULL);
#line 532 "../src/Widgets/SourceView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 532 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_;
#line 532 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_get_start_iter (_tmp1_, &_tmp2_);
#line 532 "../src/Widgets/SourceView.vala"
	doc_start = _tmp2_;
#line 533 "../src/Widgets/SourceView.vala"
	_tmp3_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 533 "../src/Widgets/SourceView.vala"
	_tmp4_ = _tmp3_;
#line 533 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_get_end_iter (_tmp4_, &_tmp5_);
#line 533 "../src/Widgets/SourceView.vala"
	doc_end = _tmp5_;
#line 534 "../src/Widgets/SourceView.vala"
	_tmp6_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 534 "../src/Widgets/SourceView.vala"
	_tmp7_ = _tmp6_;
#line 534 "../src/Widgets/SourceView.vala"
	_tmp8_ = doc_start;
#line 534 "../src/Widgets/SourceView.vala"
	_tmp9_ = doc_end;
#line 534 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_remove_tag_by_name (_tmp7_, "draw_spaces", &_tmp8_, &_tmp9_);
#line 537 "../src/Widgets/SourceView.vala"
	_tmp10_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 537 "../src/Widgets/SourceView.vala"
	_tmp11_ = _tmp10_;
#line 537 "../src/Widgets/SourceView.vala"
	_tmp14_ = gtk_text_buffer_get_selection_bounds (_tmp11_, &_tmp12_, &_tmp13_);
#line 537 "../src/Widgets/SourceView.vala"
	start = _tmp12_;
#line 537 "../src/Widgets/SourceView.vala"
	end = _tmp13_;
#line 537 "../src/Widgets/SourceView.vala"
	selection = _tmp14_;
#line 538 "../src/Widgets/SourceView.vala"
	_tmp15_ = scratch_settings;
#line 538 "../src/Widgets/SourceView.vala"
	draw_spaces_state = (ScratchScratchDrawSpacesState) g_settings_get_enum (_tmp15_, "draw-spaces");
#line 540 "../src/Widgets/SourceView.vala"
	if (selection) {
#line 541 "../src/Widgets/SourceView.vala"
		_tmp16_ = (((SCRATCH_SCRATCH_DRAW_SPACES_STATE_FOR_SELECTION | SCRATCH_SCRATCH_DRAW_SPACES_STATE_CURRENT) | SCRATCH_SCRATCH_DRAW_SPACES_STATE_ALWAYS) & draw_spaces_state) == draw_spaces_state;
#line 2755 "SourceView.c"
	} else {
#line 540 "../src/Widgets/SourceView.vala"
		_tmp16_ = FALSE;
#line 2759 "SourceView.c"
	}
#line 540 "../src/Widgets/SourceView.vala"
	if (_tmp16_) {
#line 2763 "SourceView.c"
		GtkTextBuffer* _tmp17_;
		GtkTextBuffer* _tmp18_;
		GtkTextIter _tmp19_;
		GtkTextIter _tmp20_;
#line 543 "../src/Widgets/SourceView.vala"
		_tmp17_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 543 "../src/Widgets/SourceView.vala"
		_tmp18_ = _tmp17_;
#line 543 "../src/Widgets/SourceView.vala"
		_tmp19_ = start;
#line 543 "../src/Widgets/SourceView.vala"
		_tmp20_ = end;
#line 543 "../src/Widgets/SourceView.vala"
		gtk_text_buffer_apply_tag_by_name (_tmp18_, "draw_spaces", &_tmp19_, &_tmp20_);
#line 544 "../src/Widgets/SourceView.vala"
		return;
#line 2780 "SourceView.c"
	}
#line 547 "../src/Widgets/SourceView.vala"
	if (draw_spaces_state == SCRATCH_SCRATCH_DRAW_SPACES_STATE_CURRENT) {
#line 2784 "SourceView.c"
		GtkTextIter _tmp22_ = {0};
		GtkTextIter _tmp23_ = {0};
		gboolean _tmp24_;
#line 548 "../src/Widgets/SourceView.vala"
		_tmp24_ = scratch_widgets_source_view_get_current_line (self, &_tmp22_, &_tmp23_);
#line 548 "../src/Widgets/SourceView.vala"
		start = _tmp22_;
#line 548 "../src/Widgets/SourceView.vala"
		end = _tmp23_;
#line 548 "../src/Widgets/SourceView.vala"
		_tmp21_ = _tmp24_;
#line 2796 "SourceView.c"
	} else {
#line 547 "../src/Widgets/SourceView.vala"
		_tmp21_ = FALSE;
#line 2800 "SourceView.c"
	}
#line 547 "../src/Widgets/SourceView.vala"
	if (_tmp21_) {
#line 2804 "SourceView.c"
		GtkTextBuffer* _tmp25_;
		GtkTextBuffer* _tmp26_;
		GtkTextIter _tmp27_;
		GtkTextIter _tmp28_;
#line 550 "../src/Widgets/SourceView.vala"
		_tmp25_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 550 "../src/Widgets/SourceView.vala"
		_tmp26_ = _tmp25_;
#line 550 "../src/Widgets/SourceView.vala"
		_tmp27_ = start;
#line 550 "../src/Widgets/SourceView.vala"
		_tmp28_ = end;
#line 550 "../src/Widgets/SourceView.vala"
		gtk_text_buffer_apply_tag_by_name (_tmp26_, "draw_spaces", &_tmp27_, &_tmp28_);
#line 2819 "SourceView.c"
	}
}

static void
_scratch_widgets_source_view_sort_selected_lines_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                         gpointer self)
{
#line 561 "../src/Widgets/SourceView.vala"
	scratch_widgets_source_view_sort_selected_lines ((ScratchWidgetsSourceView*) self);
#line 2829 "SourceView.c"
}

static void
___lambda91_ (ScratchWidgetsSourceView* self)
{
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
#line 575 "../src/Widgets/SourceView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 575 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_;
#line 575 "../src/Widgets/SourceView.vala"
	scratch_comment_toggler_toggle_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_source_buffer_get_type (), GtkSourceBuffer));
#line 2843 "SourceView.c"
}

static void
____lambda91__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 574 "../src/Widgets/SourceView.vala"
	___lambda91_ ((ScratchWidgetsSourceView*) self);
#line 2852 "SourceView.c"
}

static void
scratch_widgets_source_view_on_context_menu (ScratchWidgetsSourceView* self,
                                             GtkMenu* menu)
{
	GtkMenuItem* sort_item = NULL;
	GtkMenuItem* _tmp0_;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* _tmp2_;
	GraniteAccelLabel* _tmp3_;
	GraniteAccelLabel* _tmp4_;
	GtkMenuItem* _tmp5_;
	GtkMenuItem* _tmp6_;
	GtkTextBuffer* _tmp7_;
	GtkTextBuffer* _tmp8_;
#line 554 "../src/Widgets/SourceView.vala"
	g_return_if_fail (self != NULL);
#line 554 "../src/Widgets/SourceView.vala"
	g_return_if_fail (menu != NULL);
#line 555 "../src/Widgets/SourceView.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 555 "../src/Widgets/SourceView.vala"
	g_object_ref_sink (_tmp0_);
#line 555 "../src/Widgets/SourceView.vala"
	sort_item = _tmp0_;
#line 556 "../src/Widgets/SourceView.vala"
	_tmp1_ = sort_item;
#line 556 "../src/Widgets/SourceView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, scratch_widgets_source_view_get_selected_line_count (self) > 1);
#line 557 "../src/Widgets/SourceView.vala"
	_tmp2_ = sort_item;
#line 557 "../src/Widgets/SourceView.vala"
	_tmp3_ = granite_accel_label_new_from_action_name (_ ("Sort Selected Lines"), SCRATCH_MAIN_WINDOW_ACTION_PREFIX SCRATCH_MAIN_WINDOW_ACTION_SORT_LINES);
#line 557 "../src/Widgets/SourceView.vala"
	g_object_ref_sink (_tmp3_);
#line 557 "../src/Widgets/SourceView.vala"
	_tmp4_ = _tmp3_;
#line 557 "../src/Widgets/SourceView.vala"
	gtk_container_add ((GtkContainer*) _tmp2_, (GtkWidget*) _tmp4_);
#line 557 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (_tmp4_);
#line 561 "../src/Widgets/SourceView.vala"
	_tmp5_ = sort_item;
#line 561 "../src/Widgets/SourceView.vala"
	g_signal_connect_object (_tmp5_, "activate", (GCallback) _scratch_widgets_source_view_sort_selected_lines_gtk_menu_item_activate, self, 0);
#line 563 "../src/Widgets/SourceView.vala"
	_tmp6_ = sort_item;
#line 563 "../src/Widgets/SourceView.vala"
	gtk_container_add ((GtkContainer*) menu, (GtkWidget*) _tmp6_);
#line 565 "../src/Widgets/SourceView.vala"
	_tmp7_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 565 "../src/Widgets/SourceView.vala"
	_tmp8_ = _tmp7_;
#line 565 "../src/Widgets/SourceView.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, gtk_source_buffer_get_type ())) {
#line 2909 "SourceView.c"
		gboolean can_comment = FALSE;
		GtkTextBuffer* _tmp9_;
		GtkTextBuffer* _tmp10_;
		GtkSourceLanguage* _tmp11_;
		GtkMenuItem* comment_item = NULL;
		GtkMenuItem* _tmp12_;
		GtkMenuItem* _tmp13_;
		GtkMenuItem* _tmp14_;
		GraniteAccelLabel* _tmp15_;
		GraniteAccelLabel* _tmp16_;
		GtkMenuItem* _tmp17_;
		GtkMenuItem* _tmp18_;
#line 566 "../src/Widgets/SourceView.vala"
		_tmp9_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 566 "../src/Widgets/SourceView.vala"
		_tmp10_ = _tmp9_;
#line 566 "../src/Widgets/SourceView.vala"
		_tmp11_ = gtk_source_buffer_get_language (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_source_buffer_get_type (), GtkSourceBuffer));
#line 566 "../src/Widgets/SourceView.vala"
		can_comment = scratch_comment_toggler_language_has_comments (_tmp11_);
#line 568 "../src/Widgets/SourceView.vala"
		_tmp12_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 568 "../src/Widgets/SourceView.vala"
		g_object_ref_sink (_tmp12_);
#line 568 "../src/Widgets/SourceView.vala"
		comment_item = _tmp12_;
#line 569 "../src/Widgets/SourceView.vala"
		_tmp13_ = comment_item;
#line 569 "../src/Widgets/SourceView.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, can_comment);
#line 570 "../src/Widgets/SourceView.vala"
		_tmp14_ = comment_item;
#line 570 "../src/Widgets/SourceView.vala"
		_tmp15_ = granite_accel_label_new_from_action_name (_ ("Toggle Comment"), SCRATCH_MAIN_WINDOW_ACTION_PREFIX SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_COMMENT);
#line 570 "../src/Widgets/SourceView.vala"
		g_object_ref_sink (_tmp15_);
#line 570 "../src/Widgets/SourceView.vala"
		_tmp16_ = _tmp15_;
#line 570 "../src/Widgets/SourceView.vala"
		gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp16_);
#line 570 "../src/Widgets/SourceView.vala"
		_g_object_unref0 (_tmp16_);
#line 574 "../src/Widgets/SourceView.vala"
		_tmp17_ = comment_item;
#line 574 "../src/Widgets/SourceView.vala"
		g_signal_connect_object (_tmp17_, "activate", (GCallback) ____lambda91__gtk_menu_item_activate, self, 0);
#line 578 "../src/Widgets/SourceView.vala"
		_tmp18_ = comment_item;
#line 578 "../src/Widgets/SourceView.vala"
		gtk_container_add ((GtkContainer*) menu, (GtkWidget*) _tmp18_);
#line 565 "../src/Widgets/SourceView.vala"
		_g_object_unref0 (comment_item);
#line 2962 "SourceView.c"
	}
#line 581 "../src/Widgets/SourceView.vala"
	gtk_widget_show_all ((GtkWidget*) menu);
#line 554 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (sort_item);
#line 2968 "SourceView.c"
}

static gint
scratch_widgets_source_view_calculate_bottom_margin (gint height_in_px)
{
#line 585 "../src/Widgets/SourceView.vala"
	static const gint LINES_TO_KEEP = 3;
#line 586 "../src/Widgets/SourceView.vala"
	static const gdouble PT_TO_PX = 1.6667;
#line 2978 "SourceView.c"
	gdouble px_per_line = 0.0;
	ScratchMainWindow* last_window = NULL;
	GApplication* _tmp0_;
	ScratchMainWindow* _tmp1_;
	ScratchMainWindow* _tmp2_;
	gint result;
#line 589 "../src/Widgets/SourceView.vala"
	px_per_line = 10 * PT_TO_PX;
#line 591 "../src/Widgets/SourceView.vala"
	_tmp0_ = g_application_get_default ();
#line 591 "../src/Widgets/SourceView.vala"
	_tmp1_ = scratch_application_get_last_window (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, SCRATCH_TYPE_APPLICATION, ScratchApplication));
#line 591 "../src/Widgets/SourceView.vala"
	last_window = _tmp1_;
#line 592 "../src/Widgets/SourceView.vala"
	_tmp2_ = last_window;
#line 592 "../src/Widgets/SourceView.vala"
	if (_tmp2_ != NULL) {
#line 2997 "SourceView.c"
		ScratchMainWindow* _tmp3_;
#line 594 "../src/Widgets/SourceView.vala"
		_tmp3_ = last_window;
#line 594 "../src/Widgets/SourceView.vala"
		px_per_line = scratch_main_window_get_current_font_size (_tmp3_) * PT_TO_PX;
#line 3003 "SourceView.c"
	}
#line 597 "../src/Widgets/SourceView.vala"
	result = (gint) (height_in_px - (LINES_TO_KEEP * px_per_line));
#line 597 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (last_window);
#line 597 "../src/Widgets/SourceView.vala"
	return result;
#line 3011 "SourceView.c"
}

static gboolean
_scratch_widgets_source_view_selection_changed_event_gsource_func (gpointer self)
{
	gboolean result;
	result = scratch_widgets_source_view_selection_changed_event ((ScratchWidgetsSourceView*) self);
#line 623 "../src/Widgets/SourceView.vala"
	return result;
#line 3021 "SourceView.c"
}

static void
scratch_widgets_source_view_on_mark_set (ScratchWidgetsSourceView* self,
                                         GtkTextIter* loc,
                                         GtkTextMark* mar)
{
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextIter _tmp2_ = {0};
	GtkTextIter _tmp3_ = {0};
	gboolean _tmp4_ = FALSE;
	GtkTextIter _tmp5_;
	GtkTextIter _tmp7_;
	GtkTextIter _tmp8_;
	GtkTextIter _tmp9_;
#line 600 "../src/Widgets/SourceView.vala"
	g_return_if_fail (self != NULL);
#line 600 "../src/Widgets/SourceView.vala"
	g_return_if_fail (loc != NULL);
#line 600 "../src/Widgets/SourceView.vala"
	g_return_if_fail (mar != NULL);
#line 603 "../src/Widgets/SourceView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 603 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_;
#line 603 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_get_selection_bounds (_tmp1_, &_tmp2_, &_tmp3_);
#line 603 "../src/Widgets/SourceView.vala"
	start = _tmp2_;
#line 603 "../src/Widgets/SourceView.vala"
	end = _tmp3_;
#line 605 "../src/Widgets/SourceView.vala"
	_tmp5_ = self->priv->last_select_start_iter;
#line 605 "../src/Widgets/SourceView.vala"
	if (gtk_text_iter_equal (&start, &_tmp5_)) {
#line 3060 "SourceView.c"
		GtkTextIter _tmp6_;
#line 605 "../src/Widgets/SourceView.vala"
		_tmp6_ = self->priv->last_select_end_iter;
#line 605 "../src/Widgets/SourceView.vala"
		_tmp4_ = gtk_text_iter_equal (&end, &_tmp6_);
#line 3066 "SourceView.c"
	} else {
#line 605 "../src/Widgets/SourceView.vala"
		_tmp4_ = FALSE;
#line 3070 "SourceView.c"
	}
#line 605 "../src/Widgets/SourceView.vala"
	if (_tmp4_) {
#line 606 "../src/Widgets/SourceView.vala"
		return;
#line 3076 "SourceView.c"
	}
#line 609 "../src/Widgets/SourceView.vala"
	_tmp7_ = start;
#line 609 "../src/Widgets/SourceView.vala"
	gtk_text_iter_assign (&self->priv->last_select_start_iter, &_tmp7_);
#line 610 "../src/Widgets/SourceView.vala"
	_tmp8_ = end;
#line 610 "../src/Widgets/SourceView.vala"
	gtk_text_iter_assign (&self->priv->last_select_end_iter, &_tmp8_);
#line 611 "../src/Widgets/SourceView.vala"
	scratch_widgets_source_view_update_draw_spaces (self);
#line 613 "../src/Widgets/SourceView.vala"
	if (self->priv->selection_changed_timer != ((guint) 0)) {
#line 614 "../src/Widgets/SourceView.vala"
		g_source_remove (self->priv->selection_changed_timer);
#line 615 "../src/Widgets/SourceView.vala"
		self->priv->selection_changed_timer = (guint) 0;
#line 3094 "SourceView.c"
	}
#line 619 "../src/Widgets/SourceView.vala"
	_tmp9_ = end;
#line 619 "../src/Widgets/SourceView.vala"
	if (gtk_text_iter_equal (&start, &_tmp9_)) {
#line 620 "../src/Widgets/SourceView.vala"
		g_signal_emit (self, scratch_widgets_source_view_signals[SCRATCH_WIDGETS_SOURCE_VIEW_DESELECTED_SIGNAL], 0);
#line 3102 "SourceView.c"
	} else {
#line 623 "../src/Widgets/SourceView.vala"
		self->priv->selection_changed_timer = g_timeout_add_full (G_PRIORITY_DEFAULT, SCRATCH_WIDGETS_SOURCE_VIEW_THROTTLE_MS, _scratch_widgets_source_view_selection_changed_event_gsource_func, g_object_ref (self), g_object_unref);
#line 3106 "SourceView.c"
	}
}

static gboolean
scratch_widgets_source_view_selection_changed_event (ScratchWidgetsSourceView* self)
{
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	gboolean selected = FALSE;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextIter _tmp2_ = {0};
	GtkTextIter _tmp3_ = {0};
	gboolean _tmp4_;
	gboolean result;
#line 628 "../src/Widgets/SourceView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 630 "../src/Widgets/SourceView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 630 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_;
#line 630 "../src/Widgets/SourceView.vala"
	_tmp4_ = gtk_text_buffer_get_selection_bounds (_tmp1_, &_tmp2_, &_tmp3_);
#line 630 "../src/Widgets/SourceView.vala"
	start = _tmp2_;
#line 630 "../src/Widgets/SourceView.vala"
	end = _tmp3_;
#line 630 "../src/Widgets/SourceView.vala"
	selected = _tmp4_;
#line 631 "../src/Widgets/SourceView.vala"
	if (selected) {
#line 3138 "SourceView.c"
		gchar* prev_selected_text = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		GtkTextBuffer* _tmp7_;
		GtkTextBuffer* _tmp8_;
		GtkTextIter _tmp9_;
		GtkTextIter _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 632 "../src/Widgets/SourceView.vala"
		_tmp5_ = self->priv->selected_text;
#line 632 "../src/Widgets/SourceView.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 632 "../src/Widgets/SourceView.vala"
		prev_selected_text = _tmp6_;
#line 633 "../src/Widgets/SourceView.vala"
		_tmp7_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 633 "../src/Widgets/SourceView.vala"
		_tmp8_ = _tmp7_;
#line 633 "../src/Widgets/SourceView.vala"
		_tmp9_ = start;
#line 633 "../src/Widgets/SourceView.vala"
		_tmp10_ = end;
#line 633 "../src/Widgets/SourceView.vala"
		_tmp11_ = gtk_text_buffer_get_text (_tmp8_, &_tmp9_, &_tmp10_, TRUE);
#line 633 "../src/Widgets/SourceView.vala"
		_g_free0 (self->priv->selected_text);
#line 633 "../src/Widgets/SourceView.vala"
		self->priv->selected_text = _tmp11_;
#line 634 "../src/Widgets/SourceView.vala"
		_tmp12_ = self->priv->selected_text;
#line 634 "../src/Widgets/SourceView.vala"
		_tmp13_ = prev_selected_text;
#line 634 "../src/Widgets/SourceView.vala"
		if (g_strcmp0 (_tmp12_, _tmp13_) != 0) {
#line 3175 "SourceView.c"
			GtkTextIter _tmp14_;
			GtkTextIter _tmp15_;
#line 635 "../src/Widgets/SourceView.vala"
			_tmp14_ = start;
#line 635 "../src/Widgets/SourceView.vala"
			_tmp15_ = end;
#line 635 "../src/Widgets/SourceView.vala"
			g_signal_emit (self, scratch_widgets_source_view_signals[SCRATCH_WIDGETS_SOURCE_VIEW_SELECTION_CHANGED_SIGNAL], 0, &_tmp14_, &_tmp15_);
#line 3184 "SourceView.c"
		}
#line 631 "../src/Widgets/SourceView.vala"
		_g_free0 (prev_selected_text);
#line 3188 "SourceView.c"
	} else {
#line 638 "../src/Widgets/SourceView.vala"
		g_signal_emit (self, scratch_widgets_source_view_signals[SCRATCH_WIDGETS_SOURCE_VIEW_DESELECTED_SIGNAL], 0);
#line 3192 "SourceView.c"
	}
#line 641 "../src/Widgets/SourceView.vala"
	self->priv->selection_changed_timer = (guint) 0;
#line 642 "../src/Widgets/SourceView.vala"
	result = FALSE;
#line 642 "../src/Widgets/SourceView.vala"
	return result;
#line 3200 "SourceView.c"
}

static gboolean
__lambda92_ (ScratchWidgetsSourceView* self)
{
	ScratchWidgetsSourceGutterRenderer* _tmp0_;
	GeeHashMap* _tmp1_;
	ScratchFolderManagerProjectFolderItem* _tmp2_;
	ScratchWidgetsSourceGutterRenderer* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	ScratchWidgetsSourceGutterRenderer* _tmp7_;
	gboolean result;
#line 652 "../src/Widgets/SourceView.vala"
	self->priv->refresh_diff_timeout_id = (guint) 0;
#line 653 "../src/Widgets/SourceView.vala"
	_tmp0_ = self->priv->git_diff_gutter_renderer;
#line 653 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_->line_status_map;
#line 653 "../src/Widgets/SourceView.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp1_);
#line 654 "../src/Widgets/SourceView.vala"
	_tmp2_ = self->priv->_project;
#line 654 "../src/Widgets/SourceView.vala"
	_tmp3_ = self->priv->git_diff_gutter_renderer;
#line 654 "../src/Widgets/SourceView.vala"
	_tmp4_ = self->priv->_location;
#line 654 "../src/Widgets/SourceView.vala"
	_tmp5_ = g_file_get_path (_tmp4_);
#line 654 "../src/Widgets/SourceView.vala"
	_tmp6_ = _tmp5_;
#line 654 "../src/Widgets/SourceView.vala"
	scratch_folder_manager_project_folder_item_refresh_diff (_tmp2_, &_tmp3_->line_status_map, _tmp6_);
#line 654 "../src/Widgets/SourceView.vala"
	_g_free0 (_tmp6_);
#line 655 "../src/Widgets/SourceView.vala"
	_tmp7_ = self->priv->git_diff_gutter_renderer;
#line 655 "../src/Widgets/SourceView.vala"
	gtk_source_gutter_renderer_queue_draw ((GtkSourceGutterRenderer*) _tmp7_);
#line 656 "../src/Widgets/SourceView.vala"
	result = G_SOURCE_REMOVE;
#line 656 "../src/Widgets/SourceView.vala"
	return result;
#line 3245 "SourceView.c"
}

static gboolean
___lambda92__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda92_ ((ScratchWidgetsSourceView*) self);
#line 651 "../src/Widgets/SourceView.vala"
	return result;
#line 3255 "SourceView.c"
}

static void
scratch_widgets_source_view_schedule_refresh_diff (ScratchWidgetsSourceView* self)
{
#line 646 "../src/Widgets/SourceView.vala"
	g_return_if_fail (self != NULL);
#line 647 "../src/Widgets/SourceView.vala"
	if (self->priv->refresh_diff_timeout_id > ((guint) 0)) {
#line 648 "../src/Widgets/SourceView.vala"
		g_source_remove (self->priv->refresh_diff_timeout_id);
#line 3267 "SourceView.c"
	}
#line 651 "../src/Widgets/SourceView.vala"
	self->priv->refresh_diff_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 250, ___lambda92__gsource_func, g_object_ref (self), g_object_unref);
#line 3271 "SourceView.c"
}

GFile*
scratch_widgets_source_view_get_location (ScratchWidgetsSourceView* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 30 "../src/Widgets/SourceView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Widgets/SourceView.vala"
	_tmp0_ = self->priv->_location;
#line 30 "../src/Widgets/SourceView.vala"
	result = _tmp0_;
#line 30 "../src/Widgets/SourceView.vala"
	return result;
#line 3287 "SourceView.c"
}

void
scratch_widgets_source_view_set_location (ScratchWidgetsSourceView* self,
                                          GFile* value)
{
	GFile* old_value;
#line 30 "../src/Widgets/SourceView.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Widgets/SourceView.vala"
	old_value = scratch_widgets_source_view_get_location (self);
#line 30 "../src/Widgets/SourceView.vala"
	if (old_value != value) {
#line 3301 "SourceView.c"
		GFile* _tmp0_;
#line 30 "../src/Widgets/SourceView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/Widgets/SourceView.vala"
		_g_object_unref0 (self->priv->_location);
#line 30 "../src/Widgets/SourceView.vala"
		self->priv->_location = _tmp0_;
#line 30 "../src/Widgets/SourceView.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_widgets_source_view_properties[SCRATCH_WIDGETS_SOURCE_VIEW_LOCATION_PROPERTY]);
#line 3311 "SourceView.c"
	}
}

ScratchFolderManagerProjectFolderItem*
scratch_widgets_source_view_get_project (ScratchWidgetsSourceView* self)
{
	ScratchFolderManagerProjectFolderItem* result;
	ScratchFolderManagerProjectFolderItem* _tmp0_;
#line 31 "../src/Widgets/SourceView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Widgets/SourceView.vala"
	_tmp0_ = self->priv->_project;
#line 31 "../src/Widgets/SourceView.vala"
	result = _tmp0_;
#line 31 "../src/Widgets/SourceView.vala"
	return result;
#line 3328 "SourceView.c"
}

void
scratch_widgets_source_view_set_project (ScratchWidgetsSourceView* self,
                                         ScratchFolderManagerProjectFolderItem* value)
{
	ScratchFolderManagerProjectFolderItem* old_value;
#line 31 "../src/Widgets/SourceView.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Widgets/SourceView.vala"
	old_value = scratch_widgets_source_view_get_project (self);
#line 31 "../src/Widgets/SourceView.vala"
	if (old_value != value) {
#line 3342 "SourceView.c"
		ScratchFolderManagerProjectFolderItem* _tmp0_;
#line 31 "../src/Widgets/SourceView.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 31 "../src/Widgets/SourceView.vala"
		_g_object_unref0 (self->priv->_project);
#line 31 "../src/Widgets/SourceView.vala"
		self->priv->_project = _tmp0_;
#line 31 "../src/Widgets/SourceView.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_widgets_source_view_properties[SCRATCH_WIDGETS_SOURCE_VIEW_PROJECT_PROPERTY]);
#line 3352 "SourceView.c"
	}
}

GtkSourceLanguage*
scratch_widgets_source_view_get_language (ScratchWidgetsSourceView* self)
{
	GtkSourceLanguage* result;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkSourceLanguage* _tmp2_;
	GtkSourceLanguage* _tmp3_;
#line 55 "../src/Widgets/SourceView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/Widgets/SourceView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 56 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_;
#line 56 "../src/Widgets/SourceView.vala"
	_tmp2_ = gtk_source_buffer_get_language (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_source_buffer_get_type (), GtkSourceBuffer));
#line 56 "../src/Widgets/SourceView.vala"
	_tmp3_ = _tmp2_;
#line 56 "../src/Widgets/SourceView.vala"
	result = _tmp3_;
#line 56 "../src/Widgets/SourceView.vala"
	return result;
#line 3378 "SourceView.c"
}

void
scratch_widgets_source_view_set_language (ScratchWidgetsSourceView* self,
                                          GtkSourceLanguage* value)
{
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
#line 52 "../src/Widgets/SourceView.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/Widgets/SourceView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 53 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_;
#line 53 "../src/Widgets/SourceView.vala"
	gtk_source_buffer_set_language (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_source_buffer_get_type (), GtkSourceBuffer), value);
#line 52 "../src/Widgets/SourceView.vala"
	g_object_notify_by_pspec ((GObject *) self, scratch_widgets_source_view_properties[SCRATCH_WIDGETS_SOURCE_VIEW_LANGUAGE_PROPERTY]);
#line 3397 "SourceView.c"
}

gint
scratch_widgets_source_view_get_cursor_position (ScratchWidgetsSourceView* self)
{
	gint result;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 61 "../src/Widgets/SourceView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 62 "../src/Widgets/SourceView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 62 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_;
#line 62 "../src/Widgets/SourceView.vala"
	g_object_get (_tmp1_, "cursor-position", &_tmp2_, NULL);
#line 62 "../src/Widgets/SourceView.vala"
	_tmp3_ = _tmp2_;
#line 62 "../src/Widgets/SourceView.vala"
	result = _tmp3_;
#line 62 "../src/Widgets/SourceView.vala"
	return result;
#line 3422 "SourceView.c"
}

static Block39Data*
block39_data_ref (Block39Data* _data39_)
{
#line 65 "../src/Widgets/SourceView.vala"
	g_atomic_int_inc (&_data39_->_ref_count_);
#line 65 "../src/Widgets/SourceView.vala"
	return _data39_;
#line 3432 "SourceView.c"
}

static void
block39_data_unref (void * _userdata_)
{
	Block39Data* _data39_;
	_data39_ = (Block39Data*) _userdata_;
#line 65 "../src/Widgets/SourceView.vala"
	if (g_atomic_int_dec_and_test (&_data39_->_ref_count_)) {
#line 3442 "SourceView.c"
		ScratchWidgetsSourceView* self;
#line 65 "../src/Widgets/SourceView.vala"
		self = _data39_->self;
#line 65 "../src/Widgets/SourceView.vala"
		_g_object_unref0 (self);
#line 65 "../src/Widgets/SourceView.vala"
		g_slice_free (Block39Data, _data39_);
#line 3450 "SourceView.c"
	}
}

static gboolean
_scratch_widgets_source_view_cursor_position___lambda33_ (Block39Data* _data39_)
{
	ScratchWidgetsSourceView* self;
	GtkTextIter _tmp0_;
	gboolean result;
#line 69 "../src/Widgets/SourceView.vala"
	self = _data39_->self;
#line 70 "../src/Widgets/SourceView.vala"
	_tmp0_ = _data39_->iter;
#line 70 "../src/Widgets/SourceView.vala"
	gtk_text_view_scroll_to_iter ((GtkTextView*) self, &_tmp0_, 0.25, FALSE, (gdouble) 0, (gdouble) 0);
#line 71 "../src/Widgets/SourceView.vala"
	result = G_SOURCE_REMOVE;
#line 71 "../src/Widgets/SourceView.vala"
	return result;
#line 3470 "SourceView.c"
}

static gboolean
__scratch_widgets_source_view_cursor_position___lambda33__gsource_func (gpointer self)
{
	gboolean result;
	result = _scratch_widgets_source_view_cursor_position___lambda33_ (self);
#line 69 "../src/Widgets/SourceView.vala"
	return result;
#line 3480 "SourceView.c"
}

void
scratch_widgets_source_view_set_cursor_position (ScratchWidgetsSourceView* self,
                                                 gint value)
{
	Block39Data* _data39_;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextIter _tmp2_ = {0};
	GtkTextBuffer* _tmp3_;
	GtkTextBuffer* _tmp4_;
	GtkTextIter _tmp5_;
#line 65 "../src/Widgets/SourceView.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/Widgets/SourceView.vala"
	_data39_ = g_slice_new0 (Block39Data);
#line 65 "../src/Widgets/SourceView.vala"
	_data39_->_ref_count_ = 1;
#line 65 "../src/Widgets/SourceView.vala"
	_data39_->self = g_object_ref (self);
#line 67 "../src/Widgets/SourceView.vala"
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 67 "../src/Widgets/SourceView.vala"
	_tmp1_ = _tmp0_;
#line 67 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_get_iter_at_offset (_tmp1_, &_tmp2_, value);
#line 67 "../src/Widgets/SourceView.vala"
	_data39_->iter = _tmp2_;
#line 68 "../src/Widgets/SourceView.vala"
	_tmp3_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 68 "../src/Widgets/SourceView.vala"
	_tmp4_ = _tmp3_;
#line 68 "../src/Widgets/SourceView.vala"
	_tmp5_ = _data39_->iter;
#line 68 "../src/Widgets/SourceView.vala"
	gtk_text_buffer_place_cursor (_tmp4_, &_tmp5_);
#line 69 "../src/Widgets/SourceView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __scratch_widgets_source_view_cursor_position___lambda33__gsource_func, block39_data_ref (_data39_), block39_data_unref);
#line 65 "../src/Widgets/SourceView.vala"
	block39_data_unref (_data39_);
#line 65 "../src/Widgets/SourceView.vala"
	_data39_ = NULL;
#line 65 "../src/Widgets/SourceView.vala"
	g_object_notify_by_pspec ((GObject *) self, scratch_widgets_source_view_properties[SCRATCH_WIDGETS_SOURCE_VIEW_CURSOR_POSITION_PROPERTY]);
#line 3526 "SourceView.c"
}

static void
g_cclosure_user_marshal_VOID__BOXED_BOXED (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOXED_BOXED) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOXED_BOXED callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 23 "../src/Widgets/SourceView.vala"
	g_return_if_fail (n_param_values == 3);
#line 23 "../src/Widgets/SourceView.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 23 "../src/Widgets/SourceView.vala"
		data1 = closure->data;
#line 23 "../src/Widgets/SourceView.vala"
		data2 = param_values->data[0].v_pointer;
#line 3551 "SourceView.c"
	} else {
#line 23 "../src/Widgets/SourceView.vala"
		data1 = param_values->data[0].v_pointer;
#line 23 "../src/Widgets/SourceView.vala"
		data2 = closure->data;
#line 3557 "SourceView.c"
	}
#line 23 "../src/Widgets/SourceView.vala"
	callback = (GMarshalFunc_VOID__BOXED_BOXED) (marshal_data ? marshal_data : cc->callback);
#line 23 "../src/Widgets/SourceView.vala"
	callback (data1, g_value_get_boxed (param_values + 1), g_value_get_boxed (param_values + 2), data2);
#line 3563 "SourceView.c"
}

static void
_scratch_widgets_source_view_on_mark_set_gtk_text_buffer_mark_set (GtkTextBuffer* _sender,
                                                                   GtkTextIter* location,
                                                                   GtkTextMark* mark,
                                                                   gpointer self)
{
#line 102 "../src/Widgets/SourceView.vala"
	scratch_widgets_source_view_on_mark_set ((ScratchWidgetsSourceView*) self, location, mark);
#line 3574 "SourceView.c"
}

static void
_scratch_widgets_source_view_restore_settings_g_settings_changed (GSettings* _sender,
                                                                  const gchar* key,
                                                                  gpointer self)
{
#line 125 "../src/Widgets/SourceView.vala"
	scratch_widgets_source_view_restore_settings ((ScratchWidgetsSourceView*) self);
#line 3584 "SourceView.c"
}

static void
_scratch_widgets_source_view_restore_settings_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
#line 128 "../src/Widgets/SourceView.vala"
	scratch_widgets_source_view_restore_settings ((ScratchWidgetsSourceView*) self);
#line 3594 "SourceView.c"
}

static gboolean
_scratch_widgets_source_view___lambda93_ (ScratchWidgetsSourceView* self,
                                          GdkEventScroll* key_event)
{
	gboolean handled = FALSE;
	gboolean result;
#line 130 "../src/Widgets/SourceView.vala"
	g_return_val_if_fail (key_event != NULL, FALSE);
#line 131 "../src/Widgets/SourceView.vala"
	handled = FALSE;
#line 132 "../src/Widgets/SourceView.vala"
	if ((key_event->state & GDK_CONTROL_MASK) == GDK_CONTROL_MASK) {
#line 133 "../src/Widgets/SourceView.vala"
		self->priv->total_delta = self->priv->total_delta + key_event->delta_y;
#line 134 "../src/Widgets/SourceView.vala"
		if (self->priv->total_delta < (-SCRATCH_WIDGETS_SOURCE_VIEW_SCROLL_THRESHOLD)) {
#line 3613 "SourceView.c"
			GActionGroup* _tmp0_;
#line 135 "../src/Widgets/SourceView.vala"
			_tmp0_ = gtk_widget_get_action_group ((GtkWidget*) self, SCRATCH_MAIN_WINDOW_ACTION_GROUP);
#line 135 "../src/Widgets/SourceView.vala"
			g_action_group_activate_action (_tmp0_, SCRATCH_MAIN_WINDOW_ACTION_ZOOM_IN, NULL);
#line 136 "../src/Widgets/SourceView.vala"
			self->priv->total_delta = 0.0;
#line 3621 "SourceView.c"
		} else {
#line 137 "../src/Widgets/SourceView.vala"
			if (self->priv->total_delta > SCRATCH_WIDGETS_SOURCE_VIEW_SCROLL_THRESHOLD) {
#line 3625 "SourceView.c"
				GActionGroup* _tmp1_;
#line 138 "../src/Widgets/SourceView.vala"
				_tmp1_ = gtk_widget_get_action_group ((GtkWidget*) self, SCRATCH_MAIN_WINDOW_ACTION_GROUP);
#line 138 "../src/Widgets/SourceView.vala"
				g_action_group_activate_action (_tmp1_, SCRATCH_MAIN_WINDOW_ACTION_ZOOM_OUT, NULL);
#line 139 "../src/Widgets/SourceView.vala"
				self->priv->total_delta = 0.0;
#line 3633 "SourceView.c"
			}
		}
#line 142 "../src/Widgets/SourceView.vala"
		result = TRUE;
#line 142 "../src/Widgets/SourceView.vala"
		return result;
#line 3640 "SourceView.c"
	}
#line 145 "../src/Widgets/SourceView.vala"
	result = FALSE;
#line 145 "../src/Widgets/SourceView.vala"
	return result;
#line 3646 "SourceView.c"
}

static gboolean
__scratch_widgets_source_view___lambda93__gtk_widget_scroll_event (GtkWidget* _sender,
                                                                   GdkEventScroll* event,
                                                                   gpointer self)
{
	gboolean result;
	result = _scratch_widgets_source_view___lambda93_ ((ScratchWidgetsSourceView*) self, event);
#line 130 "../src/Widgets/SourceView.vala"
	return result;
#line 3658 "SourceView.c"
}

static void
_scratch_widgets_source_view___lambda94_ (ScratchWidgetsSourceView* self)
{
	GSettings* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 149 "../src/Widgets/SourceView.vala"
	_tmp0_ = scratch_settings;
#line 149 "../src/Widgets/SourceView.vala"
	if (!g_settings_get_boolean (_tmp0_, "smart-cut-copy")) {
#line 150 "../src/Widgets/SourceView.vala"
		return;
#line 3675 "SourceView.c"
	}
#line 154 "../src/Widgets/SourceView.vala"
	_tmp1_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 154 "../src/Widgets/SourceView.vala"
	_tmp2_ = _tmp1_;
#line 154 "../src/Widgets/SourceView.vala"
	_tmp3_ = gtk_text_buffer_get_has_selection (_tmp2_);
#line 154 "../src/Widgets/SourceView.vala"
	_tmp4_ = _tmp3_;
#line 154 "../src/Widgets/SourceView.vala"
	if (!_tmp4_) {
#line 3687 "SourceView.c"
		GtkTextIter iter_start = {0};
		GtkTextIter iter_end = {0};
		GtkTextIter _tmp5_ = {0};
		GtkTextIter _tmp6_ = {0};
		gboolean _tmp7_;
#line 157 "../src/Widgets/SourceView.vala"
		_tmp7_ = scratch_widgets_source_view_get_current_line (self, &_tmp5_, &_tmp6_);
#line 157 "../src/Widgets/SourceView.vala"
		iter_start = _tmp5_;
#line 157 "../src/Widgets/SourceView.vala"
		iter_end = _tmp6_;
#line 157 "../src/Widgets/SourceView.vala"
		if (_tmp7_) {
#line 3701 "SourceView.c"
			GtkClipboard* clipboard = NULL;
			GdkDisplay* _tmp8_;
			GtkClipboard* _tmp9_;
			GtkClipboard* _tmp10_;
			gchar* cut_text = NULL;
			GtkTextIter _tmp11_;
			gchar* _tmp12_;
			GtkTextBuffer* _tmp13_;
			GtkTextBuffer* _tmp14_;
			GtkClipboard* _tmp15_;
			const gchar* _tmp16_;
			GtkTextBuffer* _tmp17_;
			GtkTextBuffer* _tmp18_;
			GtkTextIter _tmp19_;
			GtkTextIter _tmp20_;
			GtkTextBuffer* _tmp21_;
			GtkTextBuffer* _tmp22_;
#line 158 "../src/Widgets/SourceView.vala"
			_tmp8_ = gtk_widget_get_display ((GtkWidget*) self);
#line 158 "../src/Widgets/SourceView.vala"
			_tmp9_ = gtk_clipboard_get_for_display (_tmp8_, GDK_SELECTION_CLIPBOARD);
#line 158 "../src/Widgets/SourceView.vala"
			_tmp10_ = _g_object_ref0 (_tmp9_);
#line 158 "../src/Widgets/SourceView.vala"
			clipboard = _tmp10_;
#line 159 "../src/Widgets/SourceView.vala"
			_tmp11_ = iter_end;
#line 159 "../src/Widgets/SourceView.vala"
			_tmp12_ = gtk_text_iter_get_slice (&iter_start, &_tmp11_);
#line 159 "../src/Widgets/SourceView.vala"
			cut_text = _tmp12_;
#line 161 "../src/Widgets/SourceView.vala"
			_tmp13_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 161 "../src/Widgets/SourceView.vala"
			_tmp14_ = _tmp13_;
#line 161 "../src/Widgets/SourceView.vala"
			gtk_text_buffer_begin_user_action (_tmp14_);
#line 162 "../src/Widgets/SourceView.vala"
			_tmp15_ = clipboard;
#line 162 "../src/Widgets/SourceView.vala"
			_tmp16_ = cut_text;
#line 162 "../src/Widgets/SourceView.vala"
			gtk_clipboard_set_text (_tmp15_, _tmp16_, -1);
#line 163 "../src/Widgets/SourceView.vala"
			_tmp17_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 163 "../src/Widgets/SourceView.vala"
			_tmp18_ = _tmp17_;
#line 163 "../src/Widgets/SourceView.vala"
			_tmp19_ = iter_start;
#line 163 "../src/Widgets/SourceView.vala"
			_tmp20_ = iter_end;
#line 163 "../src/Widgets/SourceView.vala"
			g_signal_emit_by_name (_tmp18_, "delete-range", &_tmp19_, &_tmp20_);
#line 164 "../src/Widgets/SourceView.vala"
			_tmp21_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 164 "../src/Widgets/SourceView.vala"
			_tmp22_ = _tmp21_;
#line 164 "../src/Widgets/SourceView.vala"
			gtk_text_buffer_end_user_action (_tmp22_);
#line 157 "../src/Widgets/SourceView.vala"
			_g_free0 (cut_text);
#line 157 "../src/Widgets/SourceView.vala"
			_g_object_unref0 (clipboard);
#line 3765 "SourceView.c"
		}
	}
}

static void
__scratch_widgets_source_view___lambda94__gtk_text_view_cut_clipboard (GtkTextView* _sender,
                                                                       gpointer self)
{
#line 148 "../src/Widgets/SourceView.vala"
	_scratch_widgets_source_view___lambda94_ ((ScratchWidgetsSourceView*) self);
#line 3776 "SourceView.c"
}

static void
_scratch_widgets_source_view___lambda95_ (ScratchWidgetsSourceView* self)
{
	GSettings* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 170 "../src/Widgets/SourceView.vala"
	_tmp0_ = scratch_settings;
#line 170 "../src/Widgets/SourceView.vala"
	if (!g_settings_get_boolean (_tmp0_, "smart-cut-copy")) {
#line 171 "../src/Widgets/SourceView.vala"
		return;
#line 3793 "SourceView.c"
	}
#line 175 "../src/Widgets/SourceView.vala"
	_tmp1_ = gtk_text_view_get_buffer ((GtkTextView*) self);
#line 175 "../src/Widgets/SourceView.vala"
	_tmp2_ = _tmp1_;
#line 175 "../src/Widgets/SourceView.vala"
	_tmp3_ = gtk_text_buffer_get_has_selection (_tmp2_);
#line 175 "../src/Widgets/SourceView.vala"
	_tmp4_ = _tmp3_;
#line 175 "../src/Widgets/SourceView.vala"
	if (!_tmp4_) {
#line 3805 "SourceView.c"
		GtkTextIter iter_start = {0};
		GtkTextIter iter_end = {0};
		GtkTextIter _tmp5_ = {0};
		GtkTextIter _tmp6_ = {0};
		gboolean _tmp7_;
#line 178 "../src/Widgets/SourceView.vala"
		_tmp7_ = scratch_widgets_source_view_get_current_line (self, &_tmp5_, &_tmp6_);
#line 178 "../src/Widgets/SourceView.vala"
		iter_start = _tmp5_;
#line 178 "../src/Widgets/SourceView.vala"
		iter_end = _tmp6_;
#line 178 "../src/Widgets/SourceView.vala"
		if (_tmp7_) {
#line 3819 "SourceView.c"
			GtkClipboard* clipboard = NULL;
			GdkDisplay* _tmp8_;
			GtkClipboard* _tmp9_;
			GtkClipboard* _tmp10_;
			gchar* copy_text = NULL;
			GtkTextIter _tmp11_;
			gchar* _tmp12_;
			GtkClipboard* _tmp13_;
			const gchar* _tmp14_;
#line 179 "../src/Widgets/SourceView.vala"
			_tmp8_ = gtk_widget_get_display ((GtkWidget*) self);
#line 179 "../src/Widgets/SourceView.vala"
			_tmp9_ = gtk_clipboard_get_for_display (_tmp8_, GDK_SELECTION_CLIPBOARD);
#line 179 "../src/Widgets/SourceView.vala"
			_tmp10_ = _g_object_ref0 (_tmp9_);
#line 179 "../src/Widgets/SourceView.vala"
			clipboard = _tmp10_;
#line 180 "../src/Widgets/SourceView.vala"
			_tmp11_ = iter_end;
#line 180 "../src/Widgets/SourceView.vala"
			_tmp12_ = gtk_text_iter_get_slice (&iter_start, &_tmp11_);
#line 180 "../src/Widgets/SourceView.vala"
			copy_text = _tmp12_;
#line 182 "../src/Widgets/SourceView.vala"
			_tmp13_ = clipboard;
#line 182 "../src/Widgets/SourceView.vala"
			_tmp14_ = copy_text;
#line 182 "../src/Widgets/SourceView.vala"
			gtk_clipboard_set_text (_tmp13_, _tmp14_, -1);
#line 178 "../src/Widgets/SourceView.vala"
			_g_free0 (copy_text);
#line 178 "../src/Widgets/SourceView.vala"
			_g_object_unref0 (clipboard);
#line 3853 "SourceView.c"
		}
	}
}

static void
__scratch_widgets_source_view___lambda95__gtk_text_view_copy_clipboard (GtkTextView* _sender,
                                                                        gpointer self)
{
#line 169 "../src/Widgets/SourceView.vala"
	_scratch_widgets_source_view___lambda95_ ((ScratchWidgetsSourceView*) self);
#line 3864 "SourceView.c"
}

static void
_scratch_widgets_source_view_on_context_menu_gtk_text_view_populate_popup (GtkTextView* _sender,
                                                                           GtkMenu* popup,
                                                                           gpointer self)
{
#line 187 "../src/Widgets/SourceView.vala"
	scratch_widgets_source_view_on_context_menu ((ScratchWidgetsSourceView*) self, popup);
#line 3874 "SourceView.c"
}

static Block40Data*
block40_data_ref (Block40Data* _data40_)
{
#line 189 "../src/Widgets/SourceView.vala"
	g_atomic_int_inc (&_data40_->_ref_count_);
#line 189 "../src/Widgets/SourceView.vala"
	return _data40_;
#line 3884 "SourceView.c"
}

static void
block40_data_unref (void * _userdata_)
{
	Block40Data* _data40_;
	_data40_ = (Block40Data*) _userdata_;
#line 189 "../src/Widgets/SourceView.vala"
	if (g_atomic_int_dec_and_test (&_data40_->_ref_count_)) {
#line 3894 "SourceView.c"
		ScratchWidgetsSourceView* self;
#line 189 "../src/Widgets/SourceView.vala"
		self = _data40_->self;
#line 189 "../src/Widgets/SourceView.vala"
		_g_object_unref0 (self);
#line 189 "../src/Widgets/SourceView.vala"
		g_slice_free (Block40Data, _data40_);
#line 3902 "SourceView.c"
	}
}

static gboolean
___lambda97_ (Block40Data* _data40_)
{
	ScratchWidgetsSourceView* self;
	GtkAllocation _tmp0_;
	gboolean result;
#line 192 "../src/Widgets/SourceView.vala"
	self = _data40_->self;
#line 193 "../src/Widgets/SourceView.vala"
	self->priv->size_allocate_timer = (guint) 0;
#line 194 "../src/Widgets/SourceView.vala"
	_tmp0_ = _data40_->allocation;
#line 194 "../src/Widgets/SourceView.vala"
	gtk_text_view_set_bottom_margin ((GtkTextView*) self, scratch_widgets_source_view_calculate_bottom_margin (_tmp0_.height));
#line 195 "../src/Widgets/SourceView.vala"
	result = G_SOURCE_REMOVE;
#line 195 "../src/Widgets/SourceView.vala"
	return result;
#line 3924 "SourceView.c"
}

static gboolean
____lambda97__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda97_ (self);
#line 192 "../src/Widgets/SourceView.vala"
	return result;
#line 3934 "SourceView.c"
}

static void
_scratch_widgets_source_view___lambda96_ (ScratchWidgetsSourceView* self,
                                          GtkAllocation* allocation)
{
	Block40Data* _data40_;
	GtkAllocation _tmp0_;
#line 189 "../src/Widgets/SourceView.vala"
	g_return_if_fail (allocation != NULL);
#line 189 "../src/Widgets/SourceView.vala"
	_data40_ = g_slice_new0 (Block40Data);
#line 189 "../src/Widgets/SourceView.vala"
	_data40_->_ref_count_ = 1;
#line 189 "../src/Widgets/SourceView.vala"
	_data40_->self = g_object_ref (self);
#line 189 "../src/Widgets/SourceView.vala"
	_tmp0_ = *allocation;
#line 189 "../src/Widgets/SourceView.vala"
	_data40_->allocation = _tmp0_;
#line 191 "../src/Widgets/SourceView.vala"
	if (self->priv->size_allocate_timer == ((guint) 0)) {
#line 192 "../src/Widgets/SourceView.vala"
		self->priv->size_allocate_timer = g_timeout_add_full (G_PRIORITY_DEFAULT, SCRATCH_WIDGETS_SOURCE_VIEW_THROTTLE_MS, ____lambda97__gsource_func, block40_data_ref (_data40_), block40_data_unref);
#line 3959 "SourceView.c"
	}
#line 189 "../src/Widgets/SourceView.vala"
	block40_data_unref (_data40_);
#line 189 "../src/Widgets/SourceView.vala"
	_data40_ = NULL;
#line 3965 "SourceView.c"
}

static void
__scratch_widgets_source_view___lambda96__gtk_widget_size_allocate (GtkWidget* _sender,
                                                                    GtkAllocation* allocation,
                                                                    gpointer self)
{
#line 189 "../src/Widgets/SourceView.vala"
	_scratch_widgets_source_view___lambda96_ ((ScratchWidgetsSourceView*) self, allocation);
#line 3975 "SourceView.c"
}

static void
___lambda99_ (ScratchWidgetsSourceView* self)
{
#line 205 "../src/Widgets/SourceView.vala"
	scratch_widgets_source_view_schedule_refresh_diff (self);
#line 3983 "SourceView.c"
}

static void
____lambda99__scratch_services_monitored_repository_file_content_changed (ScratchServicesMonitoredRepository* _sender,
                                                                          gpointer self)
{
#line 204 "../src/Widgets/SourceView.vala"
	___lambda99_ ((ScratchWidgetsSourceView*) self);
#line 3992 "SourceView.c"
}

static void
_scratch_widgets_source_view___lambda98_ (ScratchWidgetsSourceView* self)
{
	ScratchFolderManagerProjectFolderItem* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 202 "../src/Widgets/SourceView.vala"
	_tmp0_ = self->priv->_project;
#line 202 "../src/Widgets/SourceView.vala"
	_tmp1_ = scratch_folder_manager_project_folder_item_get_is_git_repo (_tmp0_);
#line 202 "../src/Widgets/SourceView.vala"
	_tmp2_ = _tmp1_;
#line 202 "../src/Widgets/SourceView.vala"
	if (_tmp2_) {
#line 4009 "SourceView.c"
		ScratchFolderManagerProjectFolderItem* _tmp3_;
		ScratchServicesMonitoredRepository* _tmp4_;
		ScratchServicesMonitoredRepository* _tmp5_;
#line 203 "../src/Widgets/SourceView.vala"
		scratch_widgets_source_view_schedule_refresh_diff (self);
#line 204 "../src/Widgets/SourceView.vala"
		_tmp3_ = self->priv->_project;
#line 204 "../src/Widgets/SourceView.vala"
		_tmp4_ = scratch_folder_manager_project_folder_item_get_monitored_repo (_tmp3_);
#line 204 "../src/Widgets/SourceView.vala"
		_tmp5_ = _tmp4_;
#line 204 "../src/Widgets/SourceView.vala"
		g_signal_connect_object (_tmp5_, "file-content-changed", (GCallback) ____lambda99__scratch_services_monitored_repository_file_content_changed, self, 0);
#line 4023 "SourceView.c"
	}
}

static void
__scratch_widgets_source_view___lambda98__g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
#line 200 "../src/Widgets/SourceView.vala"
	_scratch_widgets_source_view___lambda98_ ((ScratchWidgetsSourceView*) self);
#line 4034 "SourceView.c"
}

static GObject *
scratch_widgets_source_view_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ScratchWidgetsSourceView * self;
	ScratchWidgetsSourceGutterRenderer* _tmp0_;
	GtkSourceGutter* _tmp1_;
	ScratchWidgetsSourceGutterRenderer* _tmp2_;
	GtkSourceSpaceDrawer* _tmp3_;
	GtkSourceSpaceDrawer* _tmp4_;
	GtkSourceLanguageManager* _tmp5_;
	GtkSourceLanguageManager* _tmp6_;
	GtkSourceStyleSchemeManager* _tmp7_;
	GtkCssProvider* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkCssProvider* _tmp10_;
	GtkSourceBuffer* source_buffer = NULL;
	GtkSourceBuffer* _tmp11_;
	GtkSourceBuffer* _tmp12_;
	GtkSourceBuffer* _tmp13_;
	GtkSourceBuffer* _tmp14_;
	GtkSourceTag* draw_spaces_tag = NULL;
	GtkSourceTag* _tmp15_;
	GtkSourceTag* _tmp16_;
	GtkSourceBuffer* _tmp17_;
	GtkTextTagTable* _tmp18_;
	GtkTextTagTable* _tmp19_;
	GtkSourceTag* _tmp20_;
	GtkTextTag* _tmp21_;
	GtkTextTag* _tmp22_;
	GtkTextTag* _tmp23_;
	GdkRGBA _tmp24_ = {0};
	GtkTextTag* _tmp25_;
	GtkTextTag* _tmp26_;
	GtkSourceBuffer* _tmp27_;
	GtkTextTagTable* _tmp28_;
	GtkTextTagTable* _tmp29_;
	GtkTextTag* _tmp30_;
	GtkSourceBuffer* _tmp31_;
	GtkTextTagTable* _tmp32_;
	GtkTextTagTable* _tmp33_;
	GtkTextTag* _tmp34_;
	GSettings* _tmp35_;
	GraniteSettings* granite_settings = NULL;
	GraniteSettings* _tmp36_;
	GraniteSettings* _tmp37_;
	GraniteSettings* _tmp38_;
#line 85 "../src/Widgets/SourceView.vala"
	parent_class = G_OBJECT_CLASS (scratch_widgets_source_view_parent_class);
#line 85 "../src/Widgets/SourceView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 85 "../src/Widgets/SourceView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_WIDGETS_TYPE_SOURCE_VIEW, ScratchWidgetsSourceView);
#line 87 "../src/Widgets/SourceView.vala"
	_tmp0_ = scratch_widgets_source_gutter_renderer_new ();
#line 87 "../src/Widgets/SourceView.vala"
	g_object_ref_sink (_tmp0_);
#line 87 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (self->priv->git_diff_gutter_renderer);
#line 87 "../src/Widgets/SourceView.vala"
	self->priv->git_diff_gutter_renderer = _tmp0_;
#line 88 "../src/Widgets/SourceView.vala"
	_tmp1_ = gtk_source_view_get_gutter ((GtkSourceView*) self, GTK_TEXT_WINDOW_LEFT);
#line 88 "../src/Widgets/SourceView.vala"
	_tmp2_ = self->priv->git_diff_gutter_renderer;
#line 88 "../src/Widgets/SourceView.vala"
	gtk_source_gutter_insert (_tmp1_, (GtkSourceGutterRenderer*) _tmp2_, 1);
#line 90 "../src/Widgets/SourceView.vala"
	_tmp3_ = gtk_source_view_get_space_drawer ((GtkSourceView*) self);
#line 90 "../src/Widgets/SourceView.vala"
	_tmp4_ = _tmp3_;
#line 90 "../src/Widgets/SourceView.vala"
	gtk_source_space_drawer_set_enable_matrix (_tmp4_, TRUE);
#line 92 "../src/Widgets/SourceView.vala"
	g_object_set ((GtkWidget*) self, "expand", TRUE, NULL);
#line 93 "../src/Widgets/SourceView.vala"
	_tmp5_ = gtk_source_language_manager_get_default ();
#line 93 "../src/Widgets/SourceView.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 93 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (self->manager);
#line 93 "../src/Widgets/SourceView.vala"
	self->manager = _tmp6_;
#line 94 "../src/Widgets/SourceView.vala"
	_tmp7_ = gtk_source_style_scheme_manager_new ();
#line 94 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (self->style_scheme_manager);
#line 94 "../src/Widgets/SourceView.vala"
	self->style_scheme_manager = _tmp7_;
#line 96 "../src/Widgets/SourceView.vala"
	_tmp8_ = gtk_css_provider_new ();
#line 96 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (self->font_css_provider);
#line 96 "../src/Widgets/SourceView.vala"
	self->font_css_provider = _tmp8_;
#line 97 "../src/Widgets/SourceView.vala"
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 97 "../src/Widgets/SourceView.vala"
	_tmp10_ = self->font_css_provider;
#line 97 "../src/Widgets/SourceView.vala"
	gtk_style_context_add_provider (_tmp9_, (GtkStyleProvider*) _tmp10_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 99 "../src/Widgets/SourceView.vala"
	_tmp11_ = gtk_source_buffer_new (NULL);
#line 99 "../src/Widgets/SourceView.vala"
	source_buffer = _tmp11_;
#line 100 "../src/Widgets/SourceView.vala"
	_tmp12_ = source_buffer;
#line 100 "../src/Widgets/SourceView.vala"
	gtk_text_view_set_buffer ((GtkTextView*) self, (GtkTextBuffer*) _tmp12_);
#line 101 "../src/Widgets/SourceView.vala"
	_tmp13_ = source_buffer;
#line 101 "../src/Widgets/SourceView.vala"
	gtk_source_buffer_set_highlight_syntax (_tmp13_, TRUE);
#line 102 "../src/Widgets/SourceView.vala"
	_tmp14_ = source_buffer;
#line 102 "../src/Widgets/SourceView.vala"
	g_signal_connect_object ((GtkTextBuffer*) _tmp14_, "mark-set", (GCallback) _scratch_widgets_source_view_on_mark_set_gtk_text_buffer_mark_set, self, 0);
#line 103 "../src/Widgets/SourceView.vala"
	gtk_source_view_set_highlight_current_line ((GtkSourceView*) self, TRUE);
#line 105 "../src/Widgets/SourceView.vala"
	_tmp15_ = (GtkSourceTag*) gtk_source_tag_new ("draw_spaces");
#line 105 "../src/Widgets/SourceView.vala"
	draw_spaces_tag = _tmp15_;
#line 106 "../src/Widgets/SourceView.vala"
	_tmp16_ = draw_spaces_tag;
#line 106 "../src/Widgets/SourceView.vala"
	g_object_set (_tmp16_, "draw-spaces", TRUE, NULL);
#line 107 "../src/Widgets/SourceView.vala"
	_tmp17_ = source_buffer;
#line 107 "../src/Widgets/SourceView.vala"
	_tmp18_ = gtk_text_buffer_get_tag_table ((GtkTextBuffer*) _tmp17_);
#line 107 "../src/Widgets/SourceView.vala"
	_tmp19_ = _tmp18_;
#line 107 "../src/Widgets/SourceView.vala"
	_tmp20_ = draw_spaces_tag;
#line 107 "../src/Widgets/SourceView.vala"
	gtk_text_tag_table_add (_tmp19_, (GtkTextTag*) _tmp20_);
#line 109 "../src/Widgets/SourceView.vala"
	gtk_source_view_set_smart_home_end ((GtkSourceView*) self, GTK_SOURCE_SMART_HOME_END_AFTER);
#line 112 "../src/Widgets/SourceView.vala"
	_tmp21_ = gtk_text_tag_new ("warning_bg");
#line 112 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (self->warning_tag);
#line 112 "../src/Widgets/SourceView.vala"
	self->warning_tag = _tmp21_;
#line 113 "../src/Widgets/SourceView.vala"
	_tmp22_ = self->warning_tag;
#line 113 "../src/Widgets/SourceView.vala"
	g_object_set (_tmp22_, "underline", PANGO_UNDERLINE_ERROR, NULL);
#line 114 "../src/Widgets/SourceView.vala"
	_tmp23_ = self->warning_tag;
#line 114 "../src/Widgets/SourceView.vala"
	memset (&_tmp24_, 0, sizeof (GdkRGBA));
#line 114 "../src/Widgets/SourceView.vala"
	_tmp24_.red = 0.13;
#line 114 "../src/Widgets/SourceView.vala"
	_tmp24_.green = 0.55;
#line 114 "../src/Widgets/SourceView.vala"
	_tmp24_.blue = 0.13;
#line 114 "../src/Widgets/SourceView.vala"
	_tmp24_.alpha = 1.0;
#line 114 "../src/Widgets/SourceView.vala"
	g_object_set (_tmp23_, "underline-rgba", &_tmp24_, NULL);
#line 116 "../src/Widgets/SourceView.vala"
	_tmp25_ = gtk_text_tag_new ("error_bg");
#line 116 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (self->error_tag);
#line 116 "../src/Widgets/SourceView.vala"
	self->error_tag = _tmp25_;
#line 117 "../src/Widgets/SourceView.vala"
	_tmp26_ = self->error_tag;
#line 117 "../src/Widgets/SourceView.vala"
	g_object_set (_tmp26_, "underline", PANGO_UNDERLINE_ERROR, NULL);
#line 119 "../src/Widgets/SourceView.vala"
	_tmp27_ = source_buffer;
#line 119 "../src/Widgets/SourceView.vala"
	_tmp28_ = gtk_text_buffer_get_tag_table ((GtkTextBuffer*) _tmp27_);
#line 119 "../src/Widgets/SourceView.vala"
	_tmp29_ = _tmp28_;
#line 119 "../src/Widgets/SourceView.vala"
	_tmp30_ = self->error_tag;
#line 119 "../src/Widgets/SourceView.vala"
	gtk_text_tag_table_add (_tmp29_, _tmp30_);
#line 120 "../src/Widgets/SourceView.vala"
	_tmp31_ = source_buffer;
#line 120 "../src/Widgets/SourceView.vala"
	_tmp32_ = gtk_text_buffer_get_tag_table ((GtkTextBuffer*) _tmp31_);
#line 120 "../src/Widgets/SourceView.vala"
	_tmp33_ = _tmp32_;
#line 120 "../src/Widgets/SourceView.vala"
	_tmp34_ = self->warning_tag;
#line 120 "../src/Widgets/SourceView.vala"
	gtk_text_tag_table_add (_tmp33_, _tmp34_);
#line 122 "../src/Widgets/SourceView.vala"
	gtk_drag_dest_add_uri_targets ((GtkWidget*) self);
#line 124 "../src/Widgets/SourceView.vala"
	scratch_widgets_source_view_restore_settings (self);
#line 125 "../src/Widgets/SourceView.vala"
	_tmp35_ = scratch_settings;
#line 125 "../src/Widgets/SourceView.vala"
	g_signal_connect_object (_tmp35_, "changed", (GCallback) _scratch_widgets_source_view_restore_settings_g_settings_changed, self, 0);
#line 127 "../src/Widgets/SourceView.vala"
	_tmp36_ = granite_settings_get_default ();
#line 127 "../src/Widgets/SourceView.vala"
	_tmp37_ = _g_object_ref0 (_tmp36_);
#line 127 "../src/Widgets/SourceView.vala"
	granite_settings = _tmp37_;
#line 128 "../src/Widgets/SourceView.vala"
	_tmp38_ = granite_settings;
#line 128 "../src/Widgets/SourceView.vala"
	g_signal_connect_object ((GObject*) _tmp38_, "notify::prefers-color-scheme", (GCallback) _scratch_widgets_source_view_restore_settings_g_object_notify, self, 0);
#line 130 "../src/Widgets/SourceView.vala"
	g_signal_connect_object ((GtkWidget*) self, "scroll-event", (GCallback) __scratch_widgets_source_view___lambda93__gtk_widget_scroll_event, self, 0);
#line 148 "../src/Widgets/SourceView.vala"
	g_signal_connect_object ((GtkTextView*) self, "cut-clipboard", (GCallback) __scratch_widgets_source_view___lambda94__gtk_text_view_cut_clipboard, self, 0);
#line 169 "../src/Widgets/SourceView.vala"
	g_signal_connect_object ((GtkTextView*) self, "copy-clipboard", (GCallback) __scratch_widgets_source_view___lambda95__gtk_text_view_copy_clipboard, self, 0);
#line 187 "../src/Widgets/SourceView.vala"
	g_signal_connect_object ((GtkTextView*) self, "populate-popup", (GCallback) _scratch_widgets_source_view_on_context_menu_gtk_text_view_populate_popup, self, G_CONNECT_AFTER);
#line 189 "../src/Widgets/SourceView.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) __scratch_widgets_source_view___lambda96__gtk_widget_size_allocate, self, 0);
#line 200 "../src/Widgets/SourceView.vala"
	g_signal_connect_object ((GObject*) self, "notify::project", (GCallback) __scratch_widgets_source_view___lambda98__g_object_notify, self, 0);
#line 85 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (granite_settings);
#line 85 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (draw_spaces_tag);
#line 85 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (source_buffer);
#line 85 "../src/Widgets/SourceView.vala"
	return obj;
#line 4271 "SourceView.c"
}

static void
scratch_widgets_source_view_class_init (ScratchWidgetsSourceViewClass * klass,
                                        gpointer klass_data)
{
#line 23 "../src/Widgets/SourceView.vala"
	scratch_widgets_source_view_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Widgets/SourceView.vala"
	g_type_class_adjust_private_offset (klass, &ScratchWidgetsSourceView_private_offset);
#line 23 "../src/Widgets/SourceView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_scratch_widgets_source_view_get_property;
#line 23 "../src/Widgets/SourceView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_scratch_widgets_source_view_set_property;
#line 23 "../src/Widgets/SourceView.vala"
	G_OBJECT_CLASS (klass)->constructor = scratch_widgets_source_view_constructor;
#line 23 "../src/Widgets/SourceView.vala"
	G_OBJECT_CLASS (klass)->finalize = scratch_widgets_source_view_finalize;
#line 23 "../src/Widgets/SourceView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_WIDGETS_SOURCE_VIEW_LOCATION_PROPERTY, scratch_widgets_source_view_properties[SCRATCH_WIDGETS_SOURCE_VIEW_LOCATION_PROPERTY] = g_param_spec_object ("location", "location", "location", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Widgets/SourceView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_WIDGETS_SOURCE_VIEW_PROJECT_PROPERTY, scratch_widgets_source_view_properties[SCRATCH_WIDGETS_SOURCE_VIEW_PROJECT_PROPERTY] = g_param_spec_object ("project", "project", "project", SCRATCH_FOLDER_MANAGER_TYPE_PROJECT_FOLDER_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Widgets/SourceView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_WIDGETS_SOURCE_VIEW_LANGUAGE_PROPERTY, scratch_widgets_source_view_properties[SCRATCH_WIDGETS_SOURCE_VIEW_LANGUAGE_PROPERTY] = g_param_spec_object ("language", "language", "language", gtk_source_language_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Widgets/SourceView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_WIDGETS_SOURCE_VIEW_CURSOR_POSITION_PROPERTY, scratch_widgets_source_view_properties[SCRATCH_WIDGETS_SOURCE_VIEW_CURSOR_POSITION_PROPERTY] = g_param_spec_int ("cursor-position", "cursor-position", "cursor-position", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Widgets/SourceView.vala"
	scratch_widgets_source_view_signals[SCRATCH_WIDGETS_SOURCE_VIEW_STYLE_CHANGED_SIGNAL] = g_signal_new ("style-changed", SCRATCH_WIDGETS_TYPE_SOURCE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_source_style_scheme_get_type ());
#line 23 "../src/Widgets/SourceView.vala"
	scratch_widgets_source_view_signals[SCRATCH_WIDGETS_SOURCE_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", SCRATCH_WIDGETS_TYPE_SOURCE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED_BOXED, G_TYPE_NONE, 2, gtk_text_iter_get_type (), gtk_text_iter_get_type ());
#line 23 "../src/Widgets/SourceView.vala"
	scratch_widgets_source_view_signals[SCRATCH_WIDGETS_SOURCE_VIEW_DESELECTED_SIGNAL] = g_signal_new ("deselected", SCRATCH_WIDGETS_TYPE_SOURCE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4304 "SourceView.c"
}

static void
scratch_widgets_source_view_instance_init (ScratchWidgetsSourceView * self,
                                           gpointer klass)
{
	gchar* _tmp0_;
#line 23 "../src/Widgets/SourceView.vala"
	self->priv = scratch_widgets_source_view_get_instance_private (self);
#line 31 "../src/Widgets/SourceView.vala"
	self->priv->_project = NULL;
#line 34 "../src/Widgets/SourceView.vala"
	self->priv->selection_changed_timer = (guint) 0;
#line 35 "../src/Widgets/SourceView.vala"
	self->priv->size_allocate_timer = (guint) 0;
#line 38 "../src/Widgets/SourceView.vala"
	_tmp0_ = g_strdup ("");
#line 38 "../src/Widgets/SourceView.vala"
	self->priv->selected_text = _tmp0_;
#line 42 "../src/Widgets/SourceView.vala"
	self->priv->total_delta = (gdouble) 0;
#line 645 "../src/Widgets/SourceView.vala"
	self->priv->refresh_diff_timeout_id = (guint) 0;
#line 4328 "SourceView.c"
}

static void
scratch_widgets_source_view_finalize (GObject * obj)
{
	ScratchWidgetsSourceView * self;
#line 23 "../src/Widgets/SourceView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_WIDGETS_TYPE_SOURCE_VIEW, ScratchWidgetsSourceView);
#line 24 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (self->manager);
#line 25 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (self->style_scheme_manager);
#line 26 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (self->font_css_provider);
#line 27 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (self->warning_tag);
#line 28 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (self->error_tag);
#line 30 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (self->priv->_location);
#line 31 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (self->priv->_project);
#line 33 "../src/Widgets/SourceView.vala"
	_g_free0 (self->priv->font);
#line 38 "../src/Widgets/SourceView.vala"
	_g_free0 (self->priv->selected_text);
#line 39 "../src/Widgets/SourceView.vala"
	_g_object_unref0 (self->priv->git_diff_gutter_renderer);
#line 23 "../src/Widgets/SourceView.vala"
	G_OBJECT_CLASS (scratch_widgets_source_view_parent_class)->finalize (obj);
#line 4359 "SourceView.c"
}

static GType
scratch_widgets_source_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScratchWidgetsSourceViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scratch_widgets_source_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScratchWidgetsSourceView), 0, (GInstanceInitFunc) scratch_widgets_source_view_instance_init, NULL };
	GType scratch_widgets_source_view_type_id;
	scratch_widgets_source_view_type_id = g_type_register_static (gtk_source_view_get_type (), "ScratchWidgetsSourceView", &g_define_type_info, 0);
	ScratchWidgetsSourceView_private_offset = g_type_add_instance_private (scratch_widgets_source_view_type_id, sizeof (ScratchWidgetsSourceViewPrivate));
	return scratch_widgets_source_view_type_id;
}

GType
scratch_widgets_source_view_get_type (void)
{
	static volatile gsize scratch_widgets_source_view_type_id__once = 0;
	if (g_once_init_enter (&scratch_widgets_source_view_type_id__once)) {
		GType scratch_widgets_source_view_type_id;
		scratch_widgets_source_view_type_id = scratch_widgets_source_view_get_type_once ();
		g_once_init_leave (&scratch_widgets_source_view_type_id__once, scratch_widgets_source_view_type_id);
	}
	return scratch_widgets_source_view_type_id__once;
}

static void
_vala_scratch_widgets_source_view_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	ScratchWidgetsSourceView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_WIDGETS_TYPE_SOURCE_VIEW, ScratchWidgetsSourceView);
#line 23 "../src/Widgets/SourceView.vala"
	switch (property_id) {
#line 23 "../src/Widgets/SourceView.vala"
		case SCRATCH_WIDGETS_SOURCE_VIEW_LOCATION_PROPERTY:
#line 23 "../src/Widgets/SourceView.vala"
		g_value_set_object (value, scratch_widgets_source_view_get_location (self));
#line 23 "../src/Widgets/SourceView.vala"
		break;
#line 23 "../src/Widgets/SourceView.vala"
		case SCRATCH_WIDGETS_SOURCE_VIEW_PROJECT_PROPERTY:
#line 23 "../src/Widgets/SourceView.vala"
		g_value_set_object (value, scratch_widgets_source_view_get_project (self));
#line 23 "../src/Widgets/SourceView.vala"
		break;
#line 23 "../src/Widgets/SourceView.vala"
		case SCRATCH_WIDGETS_SOURCE_VIEW_LANGUAGE_PROPERTY:
#line 23 "../src/Widgets/SourceView.vala"
		g_value_set_object (value, scratch_widgets_source_view_get_language (self));
#line 23 "../src/Widgets/SourceView.vala"
		break;
#line 23 "../src/Widgets/SourceView.vala"
		case SCRATCH_WIDGETS_SOURCE_VIEW_CURSOR_POSITION_PROPERTY:
#line 23 "../src/Widgets/SourceView.vala"
		g_value_set_int (value, scratch_widgets_source_view_get_cursor_position (self));
#line 23 "../src/Widgets/SourceView.vala"
		break;
#line 4418 "SourceView.c"
		default:
#line 23 "../src/Widgets/SourceView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Widgets/SourceView.vala"
		break;
#line 4424 "SourceView.c"
	}
}

static void
_vala_scratch_widgets_source_view_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	ScratchWidgetsSourceView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_WIDGETS_TYPE_SOURCE_VIEW, ScratchWidgetsSourceView);
#line 23 "../src/Widgets/SourceView.vala"
	switch (property_id) {
#line 23 "../src/Widgets/SourceView.vala"
		case SCRATCH_WIDGETS_SOURCE_VIEW_LOCATION_PROPERTY:
#line 23 "../src/Widgets/SourceView.vala"
		scratch_widgets_source_view_set_location (self, g_value_get_object (value));
#line 23 "../src/Widgets/SourceView.vala"
		break;
#line 23 "../src/Widgets/SourceView.vala"
		case SCRATCH_WIDGETS_SOURCE_VIEW_PROJECT_PROPERTY:
#line 23 "../src/Widgets/SourceView.vala"
		scratch_widgets_source_view_set_project (self, g_value_get_object (value));
#line 23 "../src/Widgets/SourceView.vala"
		break;
#line 23 "../src/Widgets/SourceView.vala"
		case SCRATCH_WIDGETS_SOURCE_VIEW_LANGUAGE_PROPERTY:
#line 23 "../src/Widgets/SourceView.vala"
		scratch_widgets_source_view_set_language (self, g_value_get_object (value));
#line 23 "../src/Widgets/SourceView.vala"
		break;
#line 23 "../src/Widgets/SourceView.vala"
		case SCRATCH_WIDGETS_SOURCE_VIEW_CURSOR_POSITION_PROPERTY:
#line 23 "../src/Widgets/SourceView.vala"
		scratch_widgets_source_view_set_cursor_position (self, g_value_get_int (value));
#line 23 "../src/Widgets/SourceView.vala"
		break;
#line 4462 "SourceView.c"
		default:
#line 23 "../src/Widgets/SourceView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Widgets/SourceView.vala"
		break;
#line 4468 "SourceView.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 181 "../src/Services/TemplateManager.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 4479 "SourceView.c"
		gssize i;
#line 181 "../src/Services/TemplateManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 181 "../src/Services/TemplateManager.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 181 "../src/Services/TemplateManager.vala"
				destroy_func (((gpointer*) array)[i]);
#line 4487 "SourceView.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 181 "../src/Services/TemplateManager.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 181 "../src/Services/TemplateManager.vala"
	g_free (array);
#line 4502 "SourceView.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 181 "../src/Services/TemplateManager.vala"
	if (array) {
#line 181 "../src/Services/TemplateManager.vala"
		while (((gpointer*) array)[length]) {
#line 181 "../src/Services/TemplateManager.vala"
			length++;
#line 4516 "SourceView.c"
		}
	}
#line 181 "../src/Services/TemplateManager.vala"
	return length;
#line 4521 "SourceView.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
#line 181 "../src/Services/TemplateManager.vala"
	if (mem && byte_size != 0) {
#line 181 "../src/Services/TemplateManager.vala"
		new_mem = g_malloc (byte_size);
#line 181 "../src/Services/TemplateManager.vala"
		memcpy (new_mem, mem, byte_size);
#line 4535 "SourceView.c"
	} else {
#line 181 "../src/Services/TemplateManager.vala"
		new_mem = NULL;
#line 4539 "SourceView.c"
	}
#line 181 "../src/Services/TemplateManager.vala"
	return new_mem;
#line 4543 "SourceView.c"
}

